<?php

require_once 'ArkeiaAction.php';

class AlertController extends ArkeiaAction
{

    public function jsonGetResultAllModifyAction()
    {
        require_once 'Zend/Json.php';
	//DEBUG error_log('getResultAll Alert param: '.Zend_Json::encode($this->_request->getPost()));
	$post_info = $this->_request->getPost();
        $context = $this->view->context;
	
	$params = array('listobj' => 0); 

	if (isset($post_info['objlist'])) {
	    $params['listobj'] = array();
	    $objlist = split(';', $post_info['objlist']);
	    foreach ($objlist as $obj)
	        if ($obj != '')
		    array_push($params['listobj'], array('NAME' => $obj));
	}

        $data = $this->_getResultAll($context, false, $params);
        $res = $this->_get_result($data, $context);
      
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        //DEBUG error_log('jsonGetResultAllAction Alert res: '.$result);
        return;
    }

    public function jsonGetResultAllAlertRaisedAction()
    {
        require_once 'Zend/Json.php';
	//DEBUG error_log('getResultAll Alert param: '.Zend_Json::encode($this->_request->getPost()));
	$post_info = $this->_request->getPost();
        $context = $this->view->context;
	
	$params = array('listobj' => 0, 'mode' => 1); 

	if (isset($post_info['objlist'])) {
	    $params['listobj'] = array();
	    $objlist = split(';', $post_info['objlist']);
	    foreach ($objlist as $obj)
	        if ($obj != '')
		    array_push($params['listobj'], array('NAME' => $obj));
	}

        $data = $this->_getResultAll($context, false, $params);
        $res = $this->_get_result($data, $context);
      
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        //DEBUG error_log('jsonGetResultAllAction Alert res: '.$result);
        return;
    }

    public function jsonGetResultAllAlertListAction()
    {
        require_once 'Zend/Json.php';
	//DEBUG error_log('getResultAll Alert param: '.Zend_Json::encode($this->_request->getPost()));
	$post_info = $this->_request->getPost();
        $context = $this->view->context;
	
	$params = array('listobj' => 0, 'mode' => 0); 

	if (isset($post_info['objlist']) && $post_info['objlist'] != '') {
	    $params['listobj'] = array();
	    $objlist = split(';', $post_info['objlist']);
	    foreach ($objlist as $obj)
	        if ($obj != '')
		    array_push($params['listobj'], array('NAME' => $obj));
	}

        $data = $this->_getResultAll($context, false, $params);
        $res = $this->_get_result($data, $context);
      
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        //DEBUG error_log('jsonGetResultAllAction Alert res: '.$result);
        return;
    }

    public function jsonGetResultAllAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);

        $appids = array();
        if ($context) {
            foreach ($res as $key => $data)
                $appids[] = $key;
        } else {
            $appids[] = 'local';
        }

        foreach ($appids as $appid) {
            $tItem = $res[$appid]['PARAM2'][0]->item;
            if ($tItem) {
                if (!is_array($tItem))
                    $tItem = array($tItem);
                $tDestItem = Array();
                for ($s = 0 ; $s < count($tItem) ; $s++) {
                    $oDst = new StdClass();
                    $oDst->MSG = $tItem[$s]->MSG;
                    $oDst->RAISED_DATE = $tItem[$s]->RAISED_DATE;
		    $oDst->PBNUM = $tItem[$s]->PBNUM;
                    $oDst->ALID_PBNUM = $tItem[$s]->ALID.'_'.$oDst->PBNUM;
                    $oDst->APPID_ALID_PBNUM = $appid.'_'.$oDst->ALID_PBNUM;
                    $tDestItem[] = $oDst;
                }
                $res[$appid]['PARAM2'][0]->item = $tDestItem;
            }
        }
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        //DEBUG error_log('jsonGetResultAllAction Alert res: '.$result);
        return;
    }

    public function jsonGetNextAlertResultAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getNext($context);

        $res = $this->_get_result($data, $this->view->context);

        $appids = array();
        if ($context) {
            foreach ($res as $key => $data)
                $appids[] = $key;
        } else {
            $appids[] = 'local';
        }

        foreach ($appids as $appid) {
            $tItem = $res[$appid]['PARAM2'][0]->item;
            if ($tItem) {
                if (!is_array($tItem))
                    $tItem = array($tItem);
                $tDestItem = Array();
                for ($s = 0 ; $s < count($tItem) ; $s++) {
                    $oDst = new StdClass();
                    $oDst->MSG = $tItem[$s]->MSG;
                    $oDst->RAISED_DATE = $tItem[$s]->RAISED_DATE;
		    $oDst->PBNUM = $tItem[$s]->PBNUM;
                    $oDst->ALID_PBNUM = $tItem[$s]->ALID.'_'.$oDst->PBNUM;
                    $oDst->APPID_ALID_PBNUM = $appid.'_'.$oDst->ALID_PBNUM;
                    $tDestItem[] = $oDst;
                }
                $res[$appid]['PARAM2'][0]->item = $tDestItem;
            }
        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonAlertCheckAction()
      {
	//DEBUG error_log('jsonAlertCheckAction');
        $context = $this->view->context;
	$ctrlcfg = $this->_getCtrlCfg();
	$model = $this->_getModel($ctrlcfg);

	require_once 'Zend/Json.php';
	$data = $model->checkAlert($context);
	$res = $this->_get_result($data, $context);
	$result = Zend_Json::encode($res);
	$this->getResponse()->appendBody($result);
	return;
      }

    public function jsonAlertUnraiseAction()
      {
	//DEBUG error_log('jsonAlertUnraiseAction');
	$ctrlcfg = $this->_getCtrlCfg();
	$model = $this->_getModel($ctrlcfg);
	$array_context = $this->view->context;
	list($id, $context) = $this->_getIdContext($array_context, 'ALID_PBNUM');
	
	require_once 'Zend/Json.php';
	$data = $model->unraiseAlert($id, $context);
	$res = $this->_get_result($data, $context);
	$result = Zend_Json::encode($res);
	$this->getResponse()->appendBody($result);
	return;
      }

  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      $info_alert = $this->_getOne();
      $info_alert = Zend_Json::decode(Zend_Json::encode($info_alert), Zend_Json::TYPE_ARRAY); 

      //DEBUG error_log('jsonModifyObjectAction post: '.Zend_Json::encode($params));
      //DEBUG error_log('jsonModifyObjectAction info_alert: '.Zend_Json::encode($info_alert));

      if (isset($params['EMAIL']))
	$info_alert['EMAIL'] = $params['EMAIL'];
      else
	$info_alert['EMAIL'] = '';
      $info_alert['USER'] = $params['USER'];
      $info_alert['ENABLE'] = $params['ENABLE'];
      if (isset($params['DO_EMAIL']))
	$info_alert['DO_EMAIL'] = 'YES';
      else
	$info_alert['DO_EMAIL'] = 'NO';
	  
      switch ($info_alert['TYPE'])
	{
	case 'SYS':
	  {
	    $info_alert['DISK_SPACE_RATE'] = $params['DISK_SPACE_RATE'];
	    $info_alert['DISK_SPACE_PATH'] = $params['DISK_SPACE_PATH'];
	    $info_alert['DISK_INODE_RATE'] = $params['DISK_INODE_RATE'];
	    $info_alert['DISK_INODE_PATH'] = $params['DISK_INODE_PATH'];
	    break ;
	  }
	case 'POOL':
	  {
	    $info_alert['RATE'] = $params['RATE'];
	    $info_alert['NB_TAPES'] = $params['NB_TAPES'];
	    break ;
	  }
	case 'VTL':
	  {
	    $info_alert['RATE_REMAIN'] = $params['RATE_REMAIN'];
	    $info_alert['RATE_USED'] = $params['RATE_USED'];
	    $info_alert['RATE_FS_FREE'] = $params['RATE_FS_FREE'];
	    break ;
	  }

	}

    if(isset($info_alert['item'])) {

        if(!is_object($info_alert['item']) && isset($info_alert['item'][0])) {

            foreach($info_alert['item'] as $key=>$val) {

                $info_alert[$key] = $val;

            }

            unset($info_alert['item']);

        }

    }

      $data = $model->modifyObject($info_alert, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

    public function viewallHelpAction()
    {
    	echo $this->view->render('alert/viewall.html');
    }

    public function viewraisedHelpAction()
    {
    	echo $this->view->render('alert/viewraised.html');
    }

    public function confalertsHelpAction()
    {
    	echo $this->view->render('alert/confalerts.html');
    }
}

?>
