<?php

define('STATUS', 'STATUS');
define('MESSAGE', 'MESSAGE');
define('VIEW', 'VIEW');
define('DATA', 'DATA');
define('LAST', 'LAST');
define('PARAM2', 'PARAM2');
define('PARAM3', 'PARAM3');
define('FORCE_ALERT', 'FORCE_ALERT');
define('FORCE_RECONNECT', 'FORCE_RECONNECT');
define('LICENSE_ERROR', 'LICENSE_ERROR');
define('SESSNUM', 'sessnum');
define('TRANSNUM', 'transnum');
define('APPLIANCE_NAME', 'APPLIANCE_NAME');
define('APPLIANCE_GUID', 'APPLIANCE_GUID');
define('ASK_USER', 'ASK_USER');
define('ASK_USER_ID', 'ASK_USER_ID');
define('ASK_USER_MSG', 'ASK_USER_MSG');

require_once 'Zend/Controller/Action.php';

class ArkeiaAction extends Zend_Controller_Action
{
    public function init()
    {
        $this->view = $this->getInvokeArg('view');
        $this->viewdir = $this->getInvokeArg('viewdir');
        $this->mvc = $this->getInvokeArg('mvc');
        $this->lang = $this->getInvokeArg('lang');
        $this->view->title = $this->lang['arkeia_product'];
        $this->view->context = $this->_getContext();
        require_once 'Zend/Json.php';
        $this->view->jsonContext = Zend_Json::encode($this->view->context);
    }

    /* check if we are in multisite mode and return an array
       of the appliances name, id and IP
     */
    protected function _getContext()
    {
        if ($this->view->auth->hasIdentity() && 
            ($id=$this->view->auth->getIdentity())) {
            $session_arkeia = Zend_Registry::get('session_arkeia');
            if (!isset($session_arkeia->context)) {
                if (isset($id['appliances'])) {
                    /*
                    $session_arkeia->context= (object) NULL;
                    We temporarily set context to list id.
                    */
                    $session_arkeia->context= $id['appliances'];
                }
                else  {
                    $session_arkeia->context=null;
                }
            }
            $context = $session_arkeia->context;
        } else {
            $context = null;
        }
        if (isset($context)) {
            $array_context = array();

	  if (isset($context->NOT_ENOUGH_LICENSE) || isset($context->NO_APPLIANCE_CONFIGURED)) return $context;
	  if (!isset($context->item)) return $array_context;
            if (is_array($context->item)) $items = $context->item;
            else $items = array($context->item);
            foreach ($items as $item) {
                $sub = array();
                foreach ($item as $key => $val) {
                    $sub[$key] = $val;
                }
                array_push($array_context, $sub);
            }
        }
        else $array_context = null;
        return $array_context;
    }

    protected function _setContext($new_context)
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $session_arkeia->context=$new_context;
        $this->view->context = $new_context;
        return $this->view->context;
    }

    public function indexAction()
    {
        //$this->view->subaction = $this->getRequest()->getControllerName() . "/summary";
        //echo $this->view->render('layout.phtml');
        $this->summaryAction();
    }

    public function displayFromScreenIni($action, $print_res = true, $options = false)
    {
        // On recupere le nom du controleur.
        if ($options && isset($options['controller'])) {
            $ctrl = $options['controller'];
        } else {
            $ctrl = $this->getRequest()->getControllerName();
        }
        // Lecture du screen.ini pour la section [$action]
        $this->view->screen = new Zend_Config_Ini($this->viewdir . '/'.$ctrl.'/screen.ini', $action);
        if ($print_res) {
            echo $this->view->render('content.phtml');
        } else {
            return ($this->view->render('content.phtml'));
        }

    }

    public function summaryAction()
    {
        $this->displayFromScreenIni('summary');
    }

    public function addAction()
    {
        $this->displayFromScreenIni('add');
    }

    public function jsonAddAction()
    {
        $res = $this->displayFromScreenIni('add', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function updateAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('update', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonUpdateAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('update', FALSE);
        $this->_render_json_view($res);
        return;
    }

    protected function showHelp($filehelpname = "help")
    {
        $this->viewSuffix = "html";
        try {
            echo $this->render();
        }
        catch (Zend_View_Exception $e) {
            echo $this->view->render('index/help.html');
        }
    }

    public function help01Action()
    {
        $this->showHelp("help01");
    }

    public function help00Action()
    {
        $this->showHelp("help00");
    }

    public function help02Action()
    {
        $this->showHelp("help02");
    }

    public function helpAction()
    {
        $this->showHelp();
    }

    protected function _getCtrlCfg()
    {
        $ctrl = $this->getRequest()->getControllerName();
        return $this->mvc->controller->$ctrl;
    }

    protected function _getModel($ctrlcfg)
    {
        $modelName = $modelClass = $ctrlcfg->model;
        try {
            Zend_Loader::loadClass($modelClass);
        } catch (Zend_Exception $e) {
            $modelClass = "ArkObject";
            Zend_Loader::loadClass($modelClass);
        }
        $model = new $modelClass($this->mvc, $modelName);
        return $model;
    }

    protected function _getNext($context = null)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
        $sessnum = $this->_request->getPost(SESSNUM);
        $transnum = $this->_request->getPost(TRANSNUM);

        require_once 'Zend/Json.php';
        $result = $model->getNext($transnum, $sessnum, $context);
        return $result;
    }

    public function jsonGetNextAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getNext($context);

        $res = $this->_get_result($data, $this->view->context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetNextResultAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getNext($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonAbortTransAction()
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $sessnum = $this->_request->getPost(SESSNUM);
        $transnum = $this->_request->getPost(TRANSNUM);
        $context = $this->view->context;
        $data = $model->abortTrans($transnum, $sessnum, $context);
        $res = $this->_get_result($data);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _get_appliance_from_id($appid, $context)
    {
        if (is_array($context)) {
            foreach($context as $app) {
                if ($app[APPLIANCE_GUID] == $appid) {
                    return $app;
                }
            }
        } else if ($context && $context[APPLIANCE_GUID] == $appid) return $context;
        return null;
    }

    protected function _getResultAll($array_context, $intersect = false, $params = false)
    {
        // On relit les info dans le fichier config concernant le controleur.[controleur name]
        $ctrlcfg = $this->_getCtrlCfg();
        // On recupère une instance d'objet portant le nom du modele.
        $model = $this->_getModel($ctrlcfg);
        $appid = $this->_request->getPost(APPLIANCE_GUID);
        $context = null;
        require_once 'Zend/Json.php';

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
        }
	if ($intersect)
	    $result = $model->getResultAllIntersect($context, $params);
	else
	    $result = $model->getResultAll($context, $params);
	//DEBUG error_log('_getResultAll: '.Zend_Json::encode($result));
        return $result;
    }

    protected function _getAll()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        $appid = $this->_request->getPost(APPLIANCE_GUID);
        $context = null;
        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
        }

        if ($context) {
            $result = $this->_getResultAll($context);
            $data = null;
            $res = $this->_get_result($result, $context);
            $params = $res[$appid][PARAM2];
            if ($params) {
                foreach ($params as $param) {
                     if (is_array($param->item)) {
                        $data = $param->item;
                        break;
                    } else if ($param->item){
                        $data = array($param->item);
                        break;
                    }
                }
            }
        } else {
            $data = $model->getAll($context);
        }

        $arkobjects = $ctrlcfg->objects;
        $this->view->$arkobjects = $data;
        return $data;
    }

    public function jsonGetAllAction()
    {
        require_once 'Zend/Json.php';
        $data = $this->_getAll();
        $result = Zend_Json::encode($data);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function _getResultAllName()
    {
      return $this->_getResultAllNameId('NAME');
    }
    public function _getResultAllNameId($idname = false)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
	if ($idname == false)
	  $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) $appid = "local";
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else $context = $array_context;
        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);
        $data = $res[$appid][PARAM2];
        $newres = array();
        if ($data) {
            foreach ($data as $param) {
                 if (is_array($param->item)) {
                    foreach ($param->item as $obj) {
                        $newres[$obj->$idname] = $obj->NAME;
                    }
                } else if ($param->item){
                        $newres[$param->item->$idname] = $param->item->NAME;
                }
            }
            $res[$appid][PARAM2] = array($newres);
        }
        return $res;
    }

    public function _getResultAllNameIntersect($combobox = true)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
	$idname = 'NAME';
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) $appid = "local";
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else $context = $array_context;
        $res = $this->_getResultAll($context, true);
	if (is_array($res->param2->item)) {
	  foreach ($res->param2->item as $obj) {
	    if ($combobox)
	      $newres[$obj->$idname] = $obj->NAME;
	    else
	      $newres[] = array($idname => $obj->NAME);
	  }
	} else if ($res->param2->item){
	  if ($combobox)
	    $newres[$res->param2->item->$idname] = $res->param2->item->NAME;
	  else
	    $newres[] = array($idname => $res->param2->item->NAME);
	}
	return $newres;
    }

    public function jsonGetResultAllNameIdAction()
    {
        $res = $this->_getResultAllNameId();
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllNameIntersectAction()
    {
        $res = $this->_getResultAllNameIntersect();
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllIntersectAction()
    {
        $res = $this->_getResultAllNameIntersect(false);
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function getAllNameId($idname = false)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
	if ($idname == false)
	  $idname = $ctrlcfg->id;

        if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }

        $res = $this->_getResultAll($context);
        if (!is_array($res)) $res = array($res);
        foreach ($res as $key => $val) {
            if ($context) {
                $data = $res[$key]->param3->item;
            } else {
                $data = $res[$key]->param2->item;
            }
            if ($data) break ; 
        }
        $res = array();
        if ($data) {
            if (is_array($data)) {
                foreach ($data as $obj) {
                    $res[$obj->$idname] = (string) $obj->NAME;
                }
            } else {
                    $res[$data->$idname] = (string) $data->NAME;
            }
        }
        natcasesort($res);

        return $res;
    }

    public function jsonGetAllNameAction()
    {
        $res = $this->getAllNameId('NAME');
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetAllNameIdAction()
    {
        $res = $this->getAllNameId();
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _getOne()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOne($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->$appidname = $this->view->appid_id;
	    if (($idname = $ctrlcfg->id) && !isset($data->$idname))
                $data->$idname = $id;
            $data->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;
        return $data;
    }


    public function jsonGetOneAction()
    {
        require_once 'Zend/Json.php';
        $data = $this->_getOne();
        $result = Zend_Json::encode($data);
        $this->getResponse()->appendBody($result);
        return;
    }

    /* _get_filtered_context
       Return a context for a specific appliance id.
       Usefull to access one component in mutisite mode.
    */
    protected function _get_filtered_context($appid, $array_context)
    {
        $context = null;
        if ($array_context) {
            $context = array();
            foreach ($array_context as $app) {
                if ($app[APPLIANCE_GUID] == $appid) {
                    array_push($context,
                        array(APPLIANCE_GUID => $appid,
                              APPLIANCE_NAME => $app[APPLIANCE_NAME]
                          ));
                }
            }
        }
        return $context;
    }

    /* _getIdContext
       Return the id from a post.
       Return also the associated context (for multisite)
       Set $this->view->appid_id and $this->view->appidname if any.
    */
    protected function _getIdContext($array_context, $idname=null)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        if (!$idname) $idname = $ctrlcfg->id;
        $appidname = "APPID_" . $idname;
        $appidname_datatype = 'APPID_'.$idname.'_datatype';
        $appid_id = $this->_request->getParam($appidname);
        $context = null;
        if ($appid_id) {
            $this->view->appid_id = $appid_id;
            $appid_datatype = ($this->_request->getPost($appidname_datatype) ?
                   $this->_request->getPost($appidname_datatype) : '');
            if ($appid_datatype == 'json_array') {
                require_once 'Zend/Json.php';
		if(!preg_match('`^\[`', $appid_id)) {
			$appid_id = '[' . $appid_id . ']';
		}
                $this->view->appidname = Zend_Json::decode($appid_id);
                $appid = array();
                $id = array();
		if(!is_array($this->view->appidname)) {
			$this->view->appidname = array($this->view->appidname);
		}
                foreach ($this->view->appidname as $elm) {
                    if ($array_context) {
                        list($appid[]) = split("_", $elm, 1);
                        $id[] = $elm;
                    } else {
                        list($appid[], $id[]) = split("_", $elm, 2);
                    }
                }
            } else {
                $this->view->appidname = $appidname;
                list($appid, $id) = split("_", $appid_id,2);
            }
            if ($array_context && !is_array($appid)) {
                $context = $this->_get_filtered_context($appid, $array_context);
            } else {
                $context = $array_context;
            }
            $this->view->appid = $appid;
        } else {
            $id = $this->_request->getPost($idname);
        }
        return array($id, $context);
    }

    /* _doModelResultOne
       generic function for getOne, and removeOne.
       $method is the method from the model (getResultOne or removeObject)
    */
    protected function _doModelResultOne($method, $array_context = null, $extra_params=null)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        list($id, $context) = $this->_getIdContext($array_context);
        if ($extra_params) {
            $result = $model->$method($id, $extra_params, $context);
        } else {
            $result = $model->$method($id, $context);
        }
        return $result;
    }

    /* _getResultOne 
       get data for one object.
       Id is in Post
    */
    protected function _getResultOne($array_context = null)
    {
        return $this->_doModelResultOne('getResultOne', $array_context);
    }

    public function jsonGetResultOneAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOne($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
	//DEBUG error_log('jsonGetOneAction: '.$result);
        return;
    }

    public function jsonGetOneNameIdAction()
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $context = $this->view->context;
        $res = $this->_getResultOne($context);
        if (!is_array($res)) $res = array($res);
        foreach ($res as $key => $val) {
            if ($context) {
                $data = $res[$key]->param3;
            } else {
                $data = $res[$key]->param2;
            }
            if ($data) break ;
        }
        $res = array();
        $res['ID'] = $data->$idname;
        $res['NAME'] = $data->NAME;
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _removeObject($array_context = null)
    {
        return $this->_doModelResultOne('removeObject', $array_context);
    }

    public function jsonRemoveObjectAction()
    {
        $data = $this->_removeObject($this->view->context);
        $res = $this->_get_result($data, $this->view->context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonRemoveOneAction()
    {
        $this->jsonRemoveObjectAction();
        return;
    }

    public function jsonCreateObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $model->createObject($params, $context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
    

    protected function _clean_POST($params)
    {
        foreach ($params as $key => $val) {
            if ($val != '') {
                $newparams[$key] = $val;
            }
        }
        return ($newparams);
    }

    protected function _clean_select_POST($params, $val_select = FALSE)
    {
        if ($val_select) {
            foreach ($val_select as $val) {
                if (isset($params[$val.'_selected'])) {
                    $params[$val] = $params[$val.'_selected'];
                    unset($params[$val.'_selected']);
                }
            }
        } else {
            foreach ($params as $key => $val) {
                if (preg_match('/^(.*)_selected$/', $key, $march)) {
                    $params[$march[1]] = $val;
                    unset($params[$key]);
                }
            }
        }
        return ($params);
    }

    protected function _set_error_message($msg)
    {
        $res["local"][STATUS][] = "1";
        $res["local"][MESSAGE][] = $msg;
        $res["local"][LAST][] = 1;
        $res["local"][FORCE_ALERT] = 1;
        $res["local"][SESSNUM][] = null;
        $res["local"][TRANSNUM][] = null;
        return ($res);
    }

    protected function _set_ask_user_message($msg, $id = 0)
    {
        $res["local"][STATUS][] = "0";
        $res["local"][MESSAGE][] = null;
        $res["local"][PARAM2][] = null;
        $res["local"][PARAM3][] = null;
        $res["local"][LAST][] = 1;
        $res["local"][ASK_USER] = 1;
        $res["local"][ASK_USER_ID] = $id;
        $res["local"][ASK_USER_MSG][] = $msg;
        $res["local"][SESSNUM][] = null;
        $res["local"][TRANSNUM][] = null;
        return ($res);
    }

    protected function _render_json_view($view_result, $context=null)
    {
        $data[STATUS] = 0;
        $data[VIEW] = $view_result;
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($data);
        $this->getResponse()->appendBody($result);
        return ;
    }

    protected function _get_result($orig_data, $context=null, $docharsets=false)
    {
        if(!$context && is_object($orig_data) && isset($orig_data->force_alert)) {
            return $this->_set_error_message($orig_data->force_alert);
        }
        $res = FALSE;
        if ($context) {
            $param0 = 'param1';
            $param1 = 'param2';
            $param2 = 'param3';
            $param3 = 'param4';
        } else {
            $param0 = 'param0';
            $param1 = 'param1';
            $param2 = 'param2';
            $param3 = 'param3';
        }
        if (null == $orig_data) {
            $id = "local";
            $res[$id][LAST][] = 1;
            $res[$id][STATUS][] = "12";
            $res[$id][MESSAGE][] = "3";
            $res[$id][SESSNUM][] = 0;
            $res[$id][TRANSNUM][] = 0;
            return $res;
        }
        if (!is_array($orig_data)) {
            $data = array($orig_data);
            $data["local"]->sessnum = $orig_data->sessnum;
            $data["local"]->transnum = $orig_data->transnum;
        }
        else $data = $orig_data;
        foreach ($data as $key => $val) {

            if (is_string($key) && $key == "local") {
                continue;
            }
            if ($context) {
                $id = $data[$key]->param0;
/**
The following code make ARKDISPATCH messages in multisite works for the wui in a decent way
basically it propagate the last information incase there is more than one element in the $res array and
then strip the ARKDISPATCH message OR if there is no previous element it changes the data so it becomes
some kind of success message, this is of course a very weird way to fix it but i'm afraid there is no other
solution.
**/
                //if (is_numeric($id) && (int)$id == 0) continue;
                if (is_numeric($id) && (int)$id != 12) {

                    if(isset($lastid)) {

                        $res[$lastid][LAST] = array();
                        $res[$lastid][LAST][] = $data[$key]->last;

                    } else {

                        $res[$id][SESSNUM][] = $data["local"]->sessnum;
                        $res[$id][TRANSNUM][] = $data["local"]->transnum;
                        $res[$id][LAST][] = $data[$key]->last;
                        $res[$id][STATUS][] = '0';
                        $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $data[$key]->param1);
                        $res[$id][PARAM2][] = 0;
                        $res[$id][PARAM3][] = 0;

                    }

                    continue;
                }

                $lastid = $id;

/**
End of previously explained patch
**/

                if (is_numeric($id) && (int)$id == 12) {
                    $id = "local";
                    $param1 =$data[$key]->param1;
                    $status = 0;
                    $message = $data[$key]->param2;
                    $last = (int)($data[$key]->last);
                    if ((int)$param1 == 2) { /* GetNext */
                        $message = "2";
                        $status = "12";
                        $last = 0;
                    } else if ((int)$param1 == 3) {
                    // Transaction error
                        $message = "3";
                        $status = "12";
                    } else if ((int)$param1 == 4) {
                        // License error
			$errmsg = $this->lang['license_error'];
			$session_arkeia = new Zend_Session_Namespace('arkeia');
			if(isset($session_arkeia->status) && is_array($session_arkeia->status) && isset($session_arkeia->status['anblicense'])) {
				$errmsg =str_replace('$[ANBLICENSE]', $session_arkeia->status['anblicense'], $errmsg);
			} else {
				$errmsg =str_replace(' $[ANBLICENSE]', '', $errmsg);
			}
                        $res[$id][SESSNUM][] = $data["local"]->sessnum;
                        $res[$id][TRANSNUM][] = $data["local"]->transnum;
                        $res[$id][LAST][] = 0;
                        $res[$id][STATUS][] = "1";
                        $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $errmsg);
                        $res[$id][PARAM2][] = $data[$key]->param3;
                        $res[$id][PARAM3][] = $data[$key]->param4;
		        $res[$id][LICENSE_ERROR] = 1;
                        $message = "4";
                        $status = "12";
                    }
		    if (isset($data['local']->force_reconnect)
			&& $data['local']->force_reconnect) {
		      $res[$id][FORCE_RECONNECT] = 1;
		    }
                    $res[$id][SESSNUM][] = $data["local"]->sessnum;
                    $res[$id][TRANSNUM][] = $data["local"]->transnum;
                    $res[$id][LAST][] = $last;
                    $res[$id][STATUS][] = $status;
                    $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $message);
                    $res[$id][PARAM2][] = $data[$key]->param3;
                    $res[$id][PARAM3][] = $data[$key]->param4;
                    continue;
                }
                $app = $this->_get_appliance_from_id($id, $context);
                if ($app) {
                    $res[$id][APPLIANCE_NAME] = $app[APPLIANCE_NAME];
                }
            } else {
                $id = "local";
            }
            $res[$id][SESSNUM][] = $data["local"]->sessnum;
            $res[$id][TRANSNUM][] = $data["local"]->transnum;
            if (isset($data[$key]->$param1)) {
                if (is_numeric($data[$key]->$param0) && 
                    (int)$data[$key]->$param0 == 12 &&
                    (int)$data[$key]->$param1 == 4) {
			$errmsg = $this->lang['license_error'];
			$session_arkeia = new Zend_Session_Namespace('arkeia');
			if(isset($session_arkeia->status) && is_array($session_arkeia->status) && isset($session_arkeia->status['anblicense'])) {
				$errmsg = str_replace('$[ANBLICENSE]', $session_arkeia->status['anblicense'], $errmsg);
			} else {
				$errmsg = str_replace(' $[ANBLICENSE]', '', $errmsg);
			}
                    $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $errmsg);
                    $res[$id][FORCE_ALERT] = 1;
                    $res[$id][STATUS][] = null;
                    $res[$id][PARAM2][] = null;
                    $res[$id][PARAM3][] = null;
                    $res[$id][LAST][] = 0;
		    $res[$id][LICENSE_ERROR] = 1;

                }
		if (isset($data[$key]->force_reconnect)
		    && $data[$key]->force_reconnect) {
		    $res[$id][FORCE_RECONNECT] = 1;
		}
                $res[$id][STATUS][] = $data[$key]->$param0;
                $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $data[$key]->$param1);
                $res[$id][PARAM2][] = $data[$key]->$param2;
                $res[$id][PARAM3][] = $data[$key]->$param3;
            } else {
                $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $data[$key]->$param0);
                $res[$id][STATUS][] = null;
                $res[$id][PARAM2][] = null;
                $res[$id][PARAM3][] = null;
            }
            $res[$id][LAST][] = (int)($data[$key]->last);
        }
        if (!$res) {
            $id = "local";
            $res[$id][LAST][] = 1;
            $res[$id][SESSNUM][] = $data["local"]->sessnum;
            $res[$id][TRANSNUM][] = $data["local"]->transnum;
            $res[$id][STATUS][] = $data["local"]->param0;
            $res[$id][MESSAGE][] = arkphp_conv_charset('UTF-8', $data["local"]->param1);
            $res[$id][PARAM2][] = $data["local"]->param2;
            $res[$id][PARAM3][] = $data["local"]->param3;
        } else {
            /* put the result at the end of list */
            if (sizeof($res[$id][PARAM2]) > 1) {
                $idx_result = -1;
                foreach ($res[$id][PARAM2] as $key => $item) {
                    if ($item) {
                        $idx_result = $key;
                    }
                }
                $nb_elm = sizeof($res[$id][PARAM2]) - 1;
                if (!($res[$id][PARAM2][$nb_elm]) && $idx_result != -1) {
                    $res[$id][PARAM2][$nb_elm] = $res[$id][PARAM2][$idx_result];
                    $res[$id][PARAM2][$idx_result] = null;

                    $status_sauv = $res[$id][STATUS][$idx_result];
                    $res[$id][STATUS][$nb_elm] = $res[$id][STATUS][$idx_result];
                    $res[$id][STATUS][$idx_result] = $status_sauv;

                    $param3_sauv = $res[$id][PARAM3][$idx_result];
                    $res[$id][PARAM3][$nb_elm] = $res[$id][PARAM3][$idx_result];
                    $res[$id][PARAM3][$idx_result] = $param3_sauv;
                }
            }
        }
	if($docharsets) {
		$res = $this->fixcharseteverywhere($res);
	}
	$res = $this->handleerrormessages($res);
        return $res;
    }

	private function fixcharseteverywhere($res, $caller='main') {
		switch(gettype($res)) {
			case 'array':
				$keys = array_keys($res);
				$ct = count($keys);
				for($i=0; $i<$ct; $i++) {
					$res[$keys[$i]] = $this->fixcharseteverywhere($res[$keys[$i]], $keys[$i]);
				}
			break;
			case 'object':
				$props = array_keys(get_object_vars($res));
				$ct = count($props);
				if($ct > 0) {
					for($i=0; $i<$ct; $i++) {
						$curprop = $props[$i];
						$res->{$curprop} = $this->fixcharseteverywhere($res->{$curprop}, $curprop);
					}
				}
			break;
			case 'string':
				$res = arkphp_conv_charset('UTF-8', $res);
			break;
			case 'int':
			default:
		}
		return $res;
	}

	private function handleerrormessages($res) {
		$url = 'http://www.arkeia.com/errorcodes';
		$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
		if(!file_exists($cachedir . 'errorcodes')) {
			return $res;
		} else {
			if(!file_exists($cachedir . 'errorcodes.lock')) {
				$content = explode("\n", file_get_contents($cachedir . 'errorcodes'));
			} else {
				return $res;
			}
		}
		$list = array();
		for($i=0; $i<count($content); $i++) {
			if(substr($content[$i], 0, 1) != '#') {
				array_push($list, $content[$i]);
			}
		}
		if(is_array($content) && count($content)>0) {
			$keys = array_keys($res);
			$ct = count($keys);
			for($i=0; $i<$ct; $i++) {
				if(isset($res[$keys[$i]]['MESSAGE'])) {
					for($j=0; $j<count($res[$keys[$i]]['MESSAGE']); $j++) {
						if(!is_numeric($res[$keys[$i]]['MESSAGE'][$j])) {
							if(preg_match('`^\d{4}/\d{2}/\d{2}\s\d{2}:\d{2}:\d{2}\s(\w[^\s]+)\s[^:]+:\s?(.*)$`', $res[$keys[$i]]['MESSAGE'][$j], $reg)) {
								if(in_array($reg[1], $list)) {
									switch(substr($reg[1], 0, 1)) {
										case 'W':
											$color = 'orange';
										break;
										case 'E':
											$color = 'red';
										break;
										case 'I':
										default:
											$color = 'green';
										break;
									}
									$res[$keys[$i]]['MESSAGE'][$j] = str_replace($reg[2], '<a style="color: '.$color.';" href="http://wiki.arkeia.com/mediawiki/index.php/'.$reg[1].'" target="_blank">'.$reg[2].'</a>', $res[$keys[$i]]['MESSAGE'][$j]);
								}
							}
						}
					}
				}
			}
		}
		return $res;
	}

    protected function _get_message($data, $context = null) 
    { 
        $res = FALSE;
        if ($context) {
            $param0 = 'param1';
            $param1 = 'param2';
            $param2 = 'param3';
            $param3 = 'param4';
        } else {
            $param0 = 'param0';
            $param1 = 'param1';
            $param2 = 'param2';
            $param3 = 'param3';
        }

        if (is_array($data)) {
            foreach ($data as $key => $val) {
                if ($key == "local") continue;
                if ($context) {
                    $id = $data[$key]->param0;
                    if ($id == 0) continue;
                }
                if (isset($data[$key]->$param1)) {
                    $res[STATUS] = $data[$key]->$param0;
                    $res[MESSAGE][] = $data[$key]->$param1;
                    if (isset($data[$key]->$param2)) {
                        $res[PARAM2][] = $data[$key]->$param2;
                        if (isset($data[$key]->$param3)) {
                            $res[PARAM3][] = $data[$key]->$param3;
                        }
                    }
                    $res[LAST] = (int)($data[$key]->last);
                } else {
                    $res[MESSAGE][] = $data[$key]->$param0;
                    $res[LAST] = (int)($data[$key]->last);
                }
            }
            $res[SESSNUM] = $data["local"]->sessnum;
            $res[TRANSNUM] = $data["local"]->transnum;
        } else {
            $res[LAST] = (int)($data->last);
            $res[SESSNUM] = $data->sessnum;
            $res[TRANSNUM] = $data->transnum;
            $res[STATUS] = $data->param0;
            $res[MESSAGE][] = $data->param1;
            if (isset($data->param2)) {
                $res[PARAM2][] = $data->param2;
                if (isset($data->param3)) {
                    $res[PARAM3][] = $data->param3;
                }
            }
        }
        return $res;
    }

    public function testAction()
    {
        $this->displayFromScreenIni('test');
    }

    public function jsonTestAction()
    {
        $this->view->params = array();
        $this->view->params['TEST'] = "é";
        $params = $this->_request->getPost();
        if ($params) {
            foreach($params as $key => $val) {
                $this->view->params[$key] = $val;
                $this->view->params['utf8_encoded_'.$key] = utf8_encode($val);
            }
        }
        $res = $this->displayFromScreenIni('test', FALSE);
        $this->_render_json_view($res);
    }

    protected function navpath_base64_decode($var) {

        $delimiter = '/';
        $pat = array('-', '!');
        $rep = array('/', '+');

        if(strstr($var, $delimiter)) {

            $parts = explode($delimiter, $var);

            $tmp = array();

            foreach($parts as $num=>$p) {

                if($num > 0) {

			$newp = $p;

			if($p != '') {

                    for($i=0; $i<count($pat); $i++) {

                        $newp = str_replace($pat[$i], $rep[$i], $newp);

                    }

                    $newp = base64_decode($newp);

			}

                    array_push($tmp, $newp);

                } else {

                    array_push($tmp, $p);

                }

            }

            $var = implode($delimiter, $tmp);

        }

	if(preg_match('`/$`', $var)) {
		$var = preg_replace('`/+$`', '/', $var);
	}

        return $var;

    }

    protected function navpath_base64_encode($var) {

        $delimiter = '/';
        $pat = array('/', '+');
        $rep = array('-', '!');

        if(strstr($var, $delimiter)) {

            $endWith = '';

            if(preg_match('`'.$delimiter.'$`', $var)) {

                $endWith = $delimiter;
                preg_replace('`'.$delimiter.'$`', '', $var);

            }

            $parts = explode($delimiter, $var);

            $tmp = array();

            foreach($parts as $num=>$p) {

                if($num > 0) {

                    $newp = base64_encode($p);

                    for($i=0; $i<count($pat); $i++) {

                        $newp = str_replace($pat[$i], $rep[$i], $newp);

                    }

                    array_push($tmp, $newp);

                } else {

                    array_push($tmp, $p);

                }

            }

            $var = implode($delimiter, $tmp) . $endWith;

        }

        return $var;

    }

    protected function navpath_make_fullpath($var) {

        if(isset($_SESSION['charset'])) {

            $charset = $_SESSION['charset'];

        } else {

            $charset = 'UTF-8';

        }

        return htmlspecialchars(arkphp_conv_charset($charset, $var), ENT_COMPAT, 'UTF-8');

    }

    protected function navpathlist_fix($list) {

        foreach($list as $key=>$val) {
            if(isset($list[$key]->FULLNAME)) {

                $list[$key]->FULLPATH = $this->navpath_make_fullpath($list[$key]->FULLNAME);
                $list[$key]->FULLNAME = $this->navpath_base64_encode($list[$key]->FULLNAME);

            }
        }

        return $list;

    }

    protected function makecolumnjson($text, $html=false) {
        if($html) {
            return str_replace('</div>', "</div>\n", $this->makecolumnjson($text));
        } else {
            return str_replace('},', "},\n", str_replace('],', "],\n", $text));
        }
    }

}

