<?php

require_once 'ArkeiaAction.php';

class BackupController extends ArkeiaAction
{
    public function whatAction()
    {
            $this->displayFromScreenIni('what');
    }

    public function whereAction()
    {
            $this->displayFromScreenIni('where');
    }

    public function whenAction()
    {
	    if ($this->view->context) {
            $this->displayFromScreenIni('when_multisite');
		} else {
            $this->displayFromScreenIni('when');
	        }
    }

    public function bkptodiskAction()
    {
            $this->displayFromScreenIni('bkp_to_disk');
    }

    public function bkptotapeAction()
    {
	    if ($this->view->context) {
            $this->displayFromScreenIni('bkp_to_tape_multisite');
		} else {
            $this->displayFromScreenIni('bkp_to_tape');
	        }
    }

    public function disktotapeAction()
    {
	    if ($this->view->context) {
            $this->displayFromScreenIni('disk_to_tape_multisite');
		} else {
            $this->displayFromScreenIni('disk_to_tape');
	        }
    }

    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }

    public function doStartAction()
    {
        $skid = $this->_request->getPost('SKID');
        $dkid = $this->_request->getPost('DKID');
        $plid = $this->_request->getPost('PLID');
        $comment = $this->_request->getPost('COMMENT');
        $msg = "Hello there \nSKID:$skid\nDKID:$dkid\nPLID:$plid\nComment:$comment";
        $this->getResponse()->appendBody($msg);
        return;
    }
  public function jsonStartAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      $params = $this->_request->getPost();
      $val_select = array('SKID', 'DKID', 'PLID', 'TYPE', 'NEW_TAPE', 'INC_I', 'RET_TIME_UNIT', 'DO_EMAIL', 
			  'NB_FLOWS', 'KEEP_ALIVE', 'SCHID_D2T', 'SCHID_REP');
      $params = $this->_clean_select_POST($params, $val_select);

      unset($params['advparam_name']);
      unset($params['advparam_val']);
      unset($params['advparam_submit']);
      
      if (isset($params['BKP_END']) && $params['BKP_END'] != '') {
	      $params['BKP_END'] = $params['BKP_END'] * 60;
      }
      if (isset($params['BKP_END']) && ($params['BKP_END'] == '' ||
					$params['BKP_END'] <= 0)) {
	      unset($params['BKP_END']);
      }

      if (isset($params['chained']) && $params['chained'] == '1') {
	      if ($params['radio_chained'] == "0" && $params['SCHID_D2T'] == '') {
		      $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_SCHID']);
		      $result = Zend_Json::encode($res);
		      $this->getResponse()->appendBody($result);
		      return ;    
	      }
	      if ($params['radio_chained'] == "1" && $params['SCHID_REP'] == '') {
		      $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_REP_SCHID']);
		      $result = Zend_Json::encode($res);
		      $this->getResponse()->appendBody($result);
		      return ;
	      }
      }

      if (isset($params['chained']) && $params['chained'] == '1' && isset($params['SCHID_D2T']) && isset($params['SCHID_REP'])) {
	      if ($params['radio_chained'] == "0") {
		      $params['item0'] = array('SCHID' => $params['SCHID_D2T'], 'DELAY' => $params['DELAY'], 'CMDAFT'=> 'by wui');
	      }
	      else {
		      $params['item0'] = array('SCHID' => $params['SCHID_REP'], 'DELAY' => $params['DELAY'], 'CMDAFT'=> 'by wui');
	      }
      }
      unset($params['SCHID_REP']);
      unset($params['SCHID_D2T']);
      unset($params['DELAY']);
      unset($params['chained']);
      unset($params['radio_chained']);
      unset($params['SUBMIT']);

      if ($params['TYPE'] == 'TOTAL_A') {
	      $params['RET_TIME'] = '1';
	      $params['RET_TIME_UNIT'] = 'A';
      }

      require_once 'Zend/Json.php';
      //error_log('jsonStartAction, params: '.Zend_Json::encode($params));

	foreach($params as $k=>$v) {
		if(preg_match('`^moreadv_param_(.*)`', $k, $reg)) {
			$params['adv_param_' . $reg[1]] = $v;
			unset($params[$k]);
		}
	}

	if(isset($params['TYPE']) && (isset($params['adv_param_VSS_COPY']) || isset($params['adv_param_VSS_DIFF']))) {
		if(isset($params['adv_param_VSS_COPY']) && ($params['TYPE'] == 'TOTAL' || $params['TYPE'] == 'TOTAL_A')) {
			unset($params['adv_param_VSS_DIFF']);
			$params['adv_param_ARKPEXCHANGE_DONT_TRUNCATE'] = 1;
		} else {
			unset($params['adv_param_VSS_COPY']);
		}
		if(isset($params['adv_param_VSS_DIFF']) && $params['TYPE'] == 'INCREMENTAL') {
			unset($params['adv_param_VSS_COPY']);
			$params['adv_param_ARKPEXCHANGE_DONT_TRUNCATE'] = 1;
			$params['adv_param_ARKPMSSQL_DIFFERENTIAL_BACKUP'] = 1;
		} else {
			unset($params['adv_param_VSS_DIFF']);
		}
	}

      if ($params['SKID'] == '' ||
          $params['DKID'] == '' ||
          $params['PLID'] == '') {
          $res = $this->_set_error_message($this->lang['bkp_start_error_SK_DK_PL_require']);
      } else {
          $data = $model->startBackup($params, $this->view->context);
          error_log('jsonStartAction, data: '.Zend_Json::encode($data));
          $res = $this->_get_result($data, $this->view->context);
      }
      //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }


  public function jsonAnswerAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = "ID_PORT";

      require_once 'Zend/Json.php';

      $array_context = $this->view->context;
      list($id_port, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $id_port, 2);
      $params = $this->_request->getPost();
      $params = $this->_clean_select_POST($params);
      $bksid = $params['BKSID'];
      $tcp_port = $params['TCP_PORT'];
      $dest = $params['DRV_ASK'];
      $drvid = (isset($params['DRVID']) ? $params['DRVID'] : false);
      //error_log("jsonAnswerAction bksid: $bksid, tcp_port: $tcp_port, dest: $dest POST: ".Zend_Json::encode($this->_request->getPost()));

      $result = $model->answer($bksid, $tcp_port, $dest, $drvid, $context);

      if ($result == null) {
          error_log("Answer is null");
          return null;
      }

      $data = $this->_get_result($result);
      //error_log("jsonAnswerAction data: ".Zend_Json::encode($data));

      $result = Zend_Json::encode($data);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonStatAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = "ID_PORT";

      require_once 'Zend/Json.php';

      $array_context = $this->view->context;
      list($id_port, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $id_port, 2);
      //error_log("jsonStatAction id_port: $id_port, bksid: $bksid, tcp_port: $tcp_port, POST: ".Zend_Json::encode($this->_request->getPost()));

      $result = $model->getStat($bksid, $tcp_port, $context);
      if ($result == null) {
          error_log("get Stat is null");
          return null;
      }

      //error_log("jsonStatAction data: ".Zend_Json::encode($result));
      $data = $this->_get_result($result, $context, true);
      //error_log("jsonStatAction data: ".Zend_Json::encode($data));

      $result = Zend_Json::encode($data);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonContinuousModeAction()
    {
      $this->_ContinuousOrStandardMode('keepAlive');
    }

  public function jsonStandardModeAction()
    {
      $this->_ContinuousOrStandardMode('stopAlive');
    }

  private function _ContinuousOrStandardMode($type)
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);

      $array_context = $this->view->context;
      list($id_port, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $id_port, 2);

      $data = $model->getOneActive($bksid, $context);

      //error_log("_ContinuousOrStandardMode getOneActive data:". Zend_Json::encode($data)." id_port: $id_port, bksid: $bksid, tcp_port: $tcp_port, POST: ".Zend_Json::encode($this->_request->getPost()));

      if ($context) {
	if (is_array($data))
	  foreach ($data as $elm)
	    if ($pid = $elm->param3->PID)
	      break ;
      } else {
	  $pid = $data->param2->PID;
      }

      if ($pid)
	$data = $model->{$type}($bksid, $tcp_port, $pid, $context);


      $res = $this->_get_result($data);

      require_once 'Zend/Json.php';
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }
  

  /* called by showBackup screen */
  public function jsonAbortBackupAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);

      $params = $this->_request->getPost();

      require_once 'Zend/Json.php';

      //error_log("jsonAbortBackupAction: post: ".Zend_Json::encode($params));
      $array_context = $this->view->context;
      list($idport, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $idport, 2);

      //error_log("jsonAbortBackupAction: bksid: $bksid, tcp_port: $tcp_port");

      $data = $model->abortBackup($bksid, $tcp_port, $context);
      $res = $this->_get_result($data);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      //error_log('jsonAbortBackupAction res: '.Zend_Json::encode($result));
      return;
    }

  public function jsonAddSavepackAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);

      $params = $this->_request->getPost();
      $val_select = array('SKID');
      $params = $this->_clean_select_POST($params, $val_select);

      $skid = $params['SKID'];

      $array_context = $this->view->context;
      list($idport, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $idport, 2);

      require_once 'Zend/Json.php';

      //error_log("jsonAddSavepackAction: skid: $skid, bksid: $bksid, tcp_port: $tcp_port");

      if ($params['SKID'] == '') {
      $res = $this->_set_error_message($this->lang['bkp_addsk_error_SK_require']);
      } else {
      $data = $model->addSavepack($bksid, $tcp_port, $skid, $context);
      $res = $this->_get_result($data);
      }
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      //error_log('jsonAddSavepackAction res: '.Zend_Json::encode($result));
      return;
    }

  public function jsonCruiseControlAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);

      $params = $this->_request->getPost();
      $val_select = array('CRUISE', 'CRUISEUNIT');
      $params = $this->_clean_select_POST($params, $val_select);

      $array_context = $this->view->context;
      list($idport, $context) = $this->_getIdContext($array_context, 'ID_PORT');

      list($bksid, $tcp_port) = split("_", $idport, 2);

      $cruise = $params['CRUISE'];
      $cruiseunit = $params['CRUISEUNIT'];
      
	switch($cruiseunit) {
		case 1: //  MB/s
			$cruise *= 1024;
		break;
		case 2: //  MB/m
			$cruise = ($cruise * 1024) * 60;
		break;
		case 3: //  MB/h
			$cruise = (($cruise * 1024) * 60) * 60;
		break;
		case 0: //  KB/s
		default:
			//do nothing
		break;
	}

      require_once 'Zend/Json.php';

      //error_log("jsonCruiseControlAction: cruise: $cruise, bksid: $bksid, tcp_port: $tcp_port");

      $data = $model->cruiseControl($bksid, $tcp_port, $cruise, $context);
      $res = $this->_get_result($data);
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      //error_log('jsonCruiseControlAction res: '.Zend_Json::encode($result));
      return;
    }

  
  public function jsonOneActiveAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = "BKSID";

      require_once 'Zend/Json.php';

      $array_context = $this->view->context;
      //error_log('jsonOneActiveAction post:'.Zend_Json::encode($this->_request->getPost()));
      //error_log('jsonOneActiveAction array_context:'.Zend_Json::encode($array_context));
      list($bksid, $context) = $this->_getIdContext($array_context, $idname);
      //error_log("jsonOneActiveAction bksid: $bksid");
      //error_log('jsonOneActiveAction context:'.Zend_Json::encode($context));

      $result = $model->getOneActive($bksid, $context);

      //error_log("jsonOneActive result:".Zend_Json::encode($result));
      $data = $this->_get_result($result, $context);

      //error_log("jsonOneActive data:".Zend_Json::encode($data));
      $result = Zend_Json::encode($data);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonGetSomeOnDiskNameIdAction()
    {
      $this->jsonGetSomeNameIdAction(true);
    }

  public function jsonGetSomeNameIdAction($on_disk = false)
    {
      require_once 'Zend/Json.php';
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $context = $this->_getContext();
      $nb_bkp = $this->_request->getPost('NB_BKP');
      if (!$nb_bkp) $nb_bkp = 0;
      $res = $model->getResultSome($nb_bkp, $on_disk, $context);
      if (!is_array($res)) $res = array($res);
      $idname = 'BKSID';
      foreach ($res as $key => $val) {
      if ($context) {
          $data = $res[$key]->param3->item;
      } else {
          $data = $res[$key]->param2->item;
      }
      }
      $res = array();
      if ($data) {
          if (isset($data->DATE))
              $data = array($data);
          foreach ($data as $obj) {
              $data_date = $obj->DATE;
              if (!$data_date) continue;
              $disp_date = date("Y/m/d H:i",$data_date);

              if (!isset($obj->SK_NAME) || !($skname = $obj->SK_NAME)) $skname = "unknown";
              $display = $disp_date . " (". $skname . ")";
              $res[$obj->$idname] = $display;
          }
      }
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    } 

  public function jsonGetSomeAction()
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $context = $this->_getContext();
        $nb_bkp = $this->_request->getPost('NB_BKP');
        if (!$nb_bkp) $nb_bkp = 0;
        $res = $model->getResultSome($nb_bkp, false, $context);
        $idname = 'BKSID';

        $data = $this->_get_result($res, $context);

        $result = Zend_Json::encode($data);
        $this->getResponse()->appendBody($result);
        return;
    }

    private function _abortBackup()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $array_context = $this->view->context;
        list($id_port, $context) = $this->_getIdContext($array_context, 'ID_PORT');

        if (!$id_port) {
            return null;
        }

        list($bksid, $tcp_port) = split("_", $id_port, 2);

        $result = $model->abortBackup($bksid, $tcp_port, $context);
        return $result;
    }


    /* called by job menu */
    public function jsonAbortAction()
    {
        $data = $this->_abortBackup();
        $res = $this->_get_result($data, $this->view->context);
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function configurationAction()
    {
        $this->displayFromScreenIni('configuration');
    }

    public function jobAction()
    {
        $this->displayFromScreenIni('job');
    }

    public function interactivetapeAction()
    {
        $this->displayFromScreenIni('interactivetape');
    }

    public function interactivevtlAction()
    {
        $this->displayFromScreenIni('interactivevtl');
    }

    public function scheduledAction()
    {
        $this->displayFromScreenIni('scheduled');
    }

    public function showBackupAction()
    {
        $this->displayFromScreenIni('showbackup');
    }

    public function jsonShowBackupAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

		if(isset($_GET['TYPE'])) {
			$params['TYPE'] = $_GET['TYPE'];
		}

	//error_log("jsonShowBackupAction POST: ".Zend_Json::encode($this->_request->getPost()));
    
        if (!$params['PARAM2']) {
            $array_context = $this->view->context;
            list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
            if ($id) {
                list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
            }
	    //error_log("jsonShowBackupAction context: ".Zend_Json::encode($context));
	    if ($context)
	      list($params[APPLIANCE_GUID]) = $context[0]->APPLIANCE_GUID;
        }

        $this->view->showBackup = $params;

	$options = false;
	$screen = 'showbackup';
	if (isset($params['TYPE'])) {
	    if ($params['TYPE'] == 'RST') {
	        $options = array('controller' => 'restoration');
		$screen = 'showrestoration';
	    } else if ($params['TYPE'] == 'D2T') {
	        $options = array('controller' => 'd2d2t');
		$screen = 'showd2d2t';
	    }
	}
        $res = $this->displayFromScreenIni($screen, FALSE, $options);
        $this->_render_json_view($res);
        return;
    }

    public function interactivevtlHelpAction()
    {
        echo $this->view->render('interactivebackup/vtlhelp.html');
    }
    public function interactivetapeHelpAction()
    {
        echo $this->view->render('interactivebackup/tapehelp.html');
    }
    public function interactivetapeHelp01Action()
    {
        echo $this->view->render('interactivebackup/tapehelp01.html');
    }
    public function interactivevtlHelp01Action()
    {
        echo $this->view->render('interactivebackup/vtlhelp01.html');
    }
    public function scheduledHelpAction()
    {
        echo $this->view->render('scheduledbackup/help.html');
    }
    public function scheduledHelp01Action()
    {
        echo $this->view->render('scheduledbackup/help01.html');
    }
    public function showbackupHelpAction()
    {
        echo $this->view->render('showbackup/help.html');
    }
    public function whatHelpAction()
    {
        echo $this->view->render('what/help.html');
    }
    public function whereHelpAction()
    {
        echo $this->view->render('where/help.html');
    }
    public function whenHelpAction()
    {
        echo $this->view->render('when/help.html');
    }
    public function bkptodiskHelpAction()
    {
        echo $this->view->render('where/bkp_to_disk_help.html');
    }
    public function bkptotapeHelpAction()
    {
        echo $this->view->render('where/bkp_to_tape_help.html');
    }
    public function disktotapeHelpAction()
    {
        echo $this->view->render('where/disk_to_tape_help.html');
    }
}

?>
