<?php

require_once 'ArkeiaAction.php';

class DriveController extends ArkeiaAction
{

    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }

  public function jsonListTypeAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      require_once 'Zend/Json.php';
      $data = $model->listType(null, $this->view->context);

      $res = array();
      foreach ($data as $obj) {
	$res[$obj->NAME] = $obj->NAME;
      }
      ksort($res);
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  private function get_right($params)
    {
      $list_key = array('DRV_DENY_READ', 'DRV_DENY_DELETE', 'DRV_DENY_WRITE', 'DRV_DENY_CLEAN');
      $right = 15;
      foreach ($list_key as $key)
	if (isset($params[$key]))
	  $right -= $params[$key];
      return ($right);
    }

  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      $params = $this->_request->getPost();

	  $params['MEDIASERVER'] = $params['MEDIA_SERVER_selected'];
	  
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);

	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);

      if ($params['NAME'] == '' || $params['DRV_TYPE'] == '') {
	  $res = $this->_set_error_message($this->lang['drv_create_error_name_and_type_require']);
      } else if ($params['DRV_TYPE'] != 'FILE' && ($params['REWIND_DEV'] == '' /*|| $params['MEDIA_SERVER'] == ''*/)) {
          $res = $this->_set_error_message($this->lang['drv_mediaserver_error_rewind_dev_require']);
      } else {
          $params['DRV_DENY'] = $this->get_right($params);
          $tmp = array('REWIND_DEV' => $params['REWIND_DEV'], 'DEFAULT' => '');

            $parts = explode(':', $params['MEDIA_SERVER']);

            if(count($parts) == 2) {

                if($parts[0] == 'NDMP') {

                    $tmp['NDMPID'] = $parts[1];

                } else {

                    $tmp['MEDIA_SERVER'] = $parts[1];

                }

            } else {

                $tmp['MEDIA_SERVER'] = $params['MEDIA_SERVER'];

            }

            $params[] = $tmp;

          $context = $this->view->context;
		  
		  unset($params['MEDIA_SERVER']);
		  unset($params['REWIND_DEV']);
		  
          $data = $model->createObject($params, $context);
          $res = $this->_get_result($data, $context);
      }

      require_once 'Zend/Json.php';
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
	  
	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];
	  
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
	  
	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);

      $params['DRV_DENY'] = $this->get_right($params);

        if ($params['DRIVE_MEDIASERVER_ENCODE'] != '') {

            require_once 'Zend/Json.php';

            $Elems = Zend_Json::decode($params['DRIVE_MEDIASERVER_ENCODE']);

            foreach($Elems as $num => $val) {

                $params[$num] = array();

                if(isset($val['DEFAULT'])) {

                    $params[$num]['DEFAULT'] = '';

                }

                if($val['MEDIA_SERVER'] == $params['MEDIA_SERVER']) {

                    if(preg_match('`\(NDMP\)$`', $val['MEDIA_SERVER'])) {

                        $params[$num]['NDMPID'] = $this->_getIDFromNDMP($val['MEDIA_SERVER']);
                        $params[$num]['REWIND_DEV'] = $params['REWIND_DEV'];

                    } else {

                        $params[$num]['MEDIA_SERVER'] = $val['MEDIA_SERVER'];
                        $params[$num]['REWIND_DEV'] = $params['REWIND_DEV'];

                    }

                } else {

                    if(preg_match('`\(NDMP\)$`', $val['MEDIA_SERVER'])) {

                        $params[$num]['NDMPID'] = $this->_getIDFromNDMP($val['MEDIA_SERVER']);
                        $params[$num]['REWIND_DEV'] = $val['REWIND_DEV'];

                    } else {

                        $params[$num]['MEDIA_SERVER'] = $val['MEDIA_SERVER'];
                        $params[$num]['REWIND_DEV'] = $val['REWIND_DEV'];

                    }

                }

            }

            unset($params['DRIVE_MEDIASERVER_ENCODE']);

        } else {

            $tmp = array('REWIND_DEV' => $params['REWIND_DEV'], 'DEFAULT' => '');

            if(preg_match('`\(NDMP\)$`', $params['MEDIA_SERVER'])) {

                $tmp['NDMPID'] = $this->_getIDFromNDMP($params['MEDIA_SERVER']);

            } else {

                $tmp['MEDIA_SERVER'] = $params['MEDIA_SERVER'];

            }

            $params[] = $tmp;

        }
	  
	  unset($params['MEDIA_SERVER']);
	  unset($params['REWIND_DEV']);
	  unset($params['APPID_DRVID']);

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonReadDriveAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);
      require_once 'Zend/Json.php';

      $data = $model->hasCart($id, $context);
      while ($data->param0 == '12' && $data->param1 == '2') {
	  sleep(1);
	  $data = $model->getNext($data->transnum, $data->sessnum, $context);
      }
      $res = $this->_get_result($data, $context);

      if (!$context)
	$status_list = $res['local'][STATUS];
      else
	$status_list = $res[$context[0][APPLIANCE_GUID]][STATUS];
      $success = true;
      foreach ($status_list as $status)
	if ($status != "0" && $status != 0)
	  $success = false;

      if ($success) {
	 $data = $model->readDrive($id, $context);
	 $res = $this->_get_result($data, $context);
      }

      if (!$context)
	$res['local'][FORCE_ALERT] = 1;
      else
	$res[$context[0][APPLIANCE_GUID]][FORCE_ALERT] = 1;
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonHasCartAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;

      list($id, $context) = $this->_getIdContext($array_context);

      require_once 'Zend/Json.php';
      //error_log('jsonHasCartAction : id '.$id);
      $data = $model->hasCart($id, $context);
      $res = $this->_get_result($data, $context);
      $res["local"][FORCE_ALERT] = 1;
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonWriteLabelAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($tpid, $context) = $this->_getIdContext($array_context, 'TPID');

      require_once 'Zend/Json.php';

      //error_log('jsonWriteLabelAction POST:'.Zend_Json::encode($this->_request->getPost()));
      
      $param = $this->_request->getPost();
      
      if (isset($param['DRVID_selected']))
          $drvid = $param['DRVID_selected'];
      else
          $drvid = $param['DRVID'];
      
      if ($drvid == '' || $tpid == '') {
          $res = $this->_set_error_message($this->lang['drv_writelabel_error_drvid_and_tpid_require']);
      } else {
	  $data = $model->writeLabel($drvid, $tpid, $context);
          //error_log('jsonWriteLabelAction data:'.Zend_Json::encode($data));
          $res = $this->_get_result($data, $context);
      }
      
      //error_log('jsonWriteLabelAction res:'.Zend_Json::encode($res));
      $result = Zend_Json::encode($res);
      
      $this->getResponse()->appendBody($result);
      return;
    }

  public function sharelistAction()
    {
    	$info = $this->_getOneAndNDMP();
		
		if (isset($info->DRV_TYPE) && $info->DRV_TYPE == 'FILE') {
			$res = $this->_set_error_message($this->lang['drv_mediaserver_error_drvtype_file']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	  	}
		
        $res = $this->displayFromScreenIni('sharelist', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	private function _create_DRIVE_MEDIASERVER_ENCODE($info, $view = true)
	{
		require_once 'Zend/Json.php';
		$media_server = array();
		if (isset($info->item)) {
			if (!is_array($info->item)) {
				$media_server[0] = $info->item;
				$info->DRIVE_MEDIASERVER_ENCODE = Zend_Json::encode($media_server);
				return ;
			}
			for ($i = 0; $i < count($info->item); $i++) {
				if (isset($info->item[$i]->MEDIA_SERVER) || isset($info->item[$i]->NDMPID)) {
					array_push($media_server, $info->item[$i]);
				}
			}
			if ($view == true) {
				$this->view->drive->DRIVE_MEDIASERVER_ENCODE = Zend_Json::encode($media_server);
			}
			else {
				$info->DRIVE_MEDIASERVER_ENCODE = Zend_Json::encode($media_server);
			}
		}
		return ;
	}
	
	public function updateAction()
    {
        $info = $this->_getOneAndNDMP();

		$this->_create_DRIVE_MEDIASERVER_ENCODE($info);
		
        $res = $this->displayFromScreenIni('update', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	public function addonemediaserverAction()
    {
    	$info = $this->_getOneAndNDMP();

		$this->_create_DRIVE_MEDIASERVER_ENCODE($info);
		
        $res = $this->displayFromScreenIni('addonemediaserver', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	public function updateonemediaserverAction()
    {
    	$info = $this->_getOneAndNDMP();
		
		$this->_create_DRIVE_MEDIASERVER_ENCODE($info);
		
		$media_server = $this->_request->getPost();
		$info->MEDIA_SERVER = $media_server['MEDIA_SERVER'];
		
		if (is_array($info->item)) {
			for ($i = 0; isset($info->item[$i]); $i++) {
				if ($info->item[$i]->MEDIA_SERVER == 
					$media_server['MEDIA_SERVER']) {
						$info->REWIND_DEV = $info->item[$i]->REWIND_DEV;
						if (isset($info->item[$i]->DEFAULT))
							$info->DEFAULT = "<checked>";
				}
			}
		}
		else {
			$info->REWIND_DEV = $info->item->REWIND_DEV;
			if (isset($info->item->DEFAULT))
				$info->DEFAULT = "<checked>";
		}
		unset($info->item);
		
        $res = $this->displayFromScreenIni('updateonemediaserver', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	public function jsonGetResultOneWithDefaultAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);
	  
		require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $model->getResultOneWithDefault($id, $context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
		return;
	}
	
	public function jsonAddOneMediaserverAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
	  
	  if ($params['MEDIA_SERVER'] == '') {
			$res = $this->_set_error_message($this->lang['drv_mediaserver_error_mediaserver_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	  }
  	  if ($params['REWIND_DEV'] == '') {
			$res = $this->_set_error_message($this->lang['drv_mediaserver_error_rewind_dev_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	  }
	  
	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];
	  
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
	  
	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);

      require_once 'Zend/Json.php';

	  if ($params['DRIVE_MEDIASERVER_ENCODE'] != '') {
			$Elems = Zend_Json::decode($params['DRIVE_MEDIASERVER_ENCODE']);
			
			for ($i = 0; $i < count($Elems); $i++) {
				$params[$i] = array();
				foreach ($Elems[$i] as $name => $value) {
					if ($name == 'MEDIA_SERVER' && $value == $params['MEDIA_SERVER']) {
						$res = $this->_set_error_message($this->lang['drv_mediaserver_already_exist']);
						$result = Zend_Json::encode($res);
						$this->getResponse()->appendBody($result);
						return;
					}
					elseif ($name != '__className') {
							if (!isset($params['DEFAULT'])) {
								$params[$i][$name] = $value;
							}
							elseif ($name != 'DEFAULT') {
									$params[$i][$name] = $value;
							}
					}
				}
			}
			if (isset($params['DEFAULT'])) {
				$params[$i] = array('MEDIA_SERVER' => $params['MEDIA_SERVER'], 'REWIND_DEV' => $params['REWIND_DEV'], 'DEFAULT' => '');
			}
			else {
				$params[$i] = array('MEDIA_SERVER' => $params['MEDIA_SERVER'], 'REWIND_DEV' => $params['REWIND_DEV']);
			}
			unset($params['DRIVE_MEDIASERVER_ENCODE']);

            foreach($params as $num=>$var) {

                if(is_numeric($num)) {

                    if(isset($var['MEDIA_SERVER']) && preg_match('`\(NDMP\)$`', $var['MEDIA_SERVER'])) {

                        $params[$num]['NDMPID'] = $this->_getIDFromNDMP($var['MEDIA_SERVER']);
                        unset($params[$num]['MEDIA_SERVER']);

                    }

                }

            }

	  }
	  else {

            $tmp = array('REWIND_DEV' => $params['REWIND_DEV'], 'DEFAULT' => '');

            if(preg_match('`\(NDMP\)$`', $params['MEDIA_SERVER'])) {

                $tmp['NDMPID'] = $this->_getIDFromNDMP($params['MEDIA_SERVER']);

            } else {

                $tmp['MEDIA_SERVER'] = $params['MEDIA_SERVER'];

            }

            $params[] = $tmp;

	  }
	  
	  unset($params['MEDIA_SERVER']);
	  unset($params['REWIND_DEV']);
	  unset($params['DEFAULT']);
	  unset($params['APPID_DRVID']);

	  //error_log("params:".Zend_Json::encode($params));

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }
	
	public function jsonRemoveMediaserverAction()
    {

      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $media_server = $this->_request->getPost();
	  
	  $params = $model->getResultOneAndNDMP($id, $context);

        if($context) {

            if(is_array($params)) {

                $params = $params['list1']->param3;

            } else {

                if(isset($params->param3)) {

                    $params = $params->param3;

                } else {

                    $params = $params->param2;

                }

            }

        } else {

            $params = $params->param2;

        }

	  if (isset($params->item)) {
	  	if (!is_array($params->item))
			unset($params->item);
		else {
		  	for ($i = 0; isset($params->item[$i]); $i++) {
		  		if (isset($params->item[$i]->MEDIA_SERVER) &&
					$params->item[$i]->MEDIA_SERVER == $media_server['MEDIA_SERVER']) {
		  			array_splice($params->item, $i, 1);
					$i--;
		  		}
		  	}
	  	}
	  }
	  else return ;
	 
	  $params = $this->_clean_POST($params);
	  unset($params['APPID_DRVID']);
	  unset($params['APPID']);
	  
	  $array_params = array();
	  foreach ($params as $name => $value) {
	  		if ($name == 'item') {
				for ($i = 0; isset($params['item'][$i]); $i++) {
					$array_params[$i] = array();
					foreach($params['item'][$i] as $item_name => $item_value) {
						$array_params[$i][$item_name] = $item_value;
					}
				}
	  		}
			else {
				$array_params[$name] = $value;
			}
	  }

        foreach($array_params as $key => $val) {

            if(is_int($key) && isset($val['NDMPID'])) {

                unset($array_params[$key]['MEDIA_SERVER']);

            }

        }

      $data = $model->modifyObject($array_params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }
	
	public function jsonUpdateOneMediaserverAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
	  
  	  if ($params['REWIND_DEV'] == '') {
			$res = $this->_set_error_message($this->lang['drv_mediaserver_error_rewind_dev_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	  }
	  
	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];
	  
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
	  
	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);

        if ($params['DRIVE_MEDIASERVER_ENCODE'] != '') {

            require_once 'Zend/Json.php';

            $Elems = Zend_Json::decode($params['DRIVE_MEDIASERVER_ENCODE']);

            foreach($Elems as $num => $val) {

                if($val['MEDIA_SERVER'] == $params['MEDIA_SERVER'] && isset($params['DEFAULT'])) {

                    $default = $num;

                }

            }

            foreach($Elems as $num => $val) {

                $params[$num] = array();

                if($num == $default) {

                    $params[$num]['DEFAULT'] = '';

                }

                if($val['MEDIA_SERVER'] == $params['MEDIA_SERVER']) {

                    if(preg_match('`\(NDMP\)$`', $val['MEDIA_SERVER'])) {

                        $params[$num]['NDMPID'] = $this->_getIDFromNDMP($val['MEDIA_SERVER']);
                        $params[$num]['REWIND_DEV'] = $params['REWIND_DEV'];

                    } else {

                        $params[$num]['MEDIA_SERVER'] = $val['MEDIA_SERVER'];
                        $params[$num]['REWIND_DEV'] = $params['REWIND_DEV'];

                    }

                } else {

                    if(preg_match('`\(NDMP\)$`', $val['MEDIA_SERVER'])) {

                        $params[$num]['NDMPID'] = $this->_getIDFromNDMP($val['MEDIA_SERVER']);
                        $params[$num]['REWIND_DEV'] = $val['REWIND_DEV'];

                    } else {

                        $params[$num]['MEDIA_SERVER'] = $val['MEDIA_SERVER'];
                        $params[$num]['REWIND_DEV'] = $val['REWIND_DEV'];

                    }

                }

            }

            unset($params['DRIVE_MEDIASERVER_ENCODE']);

        } else {

            $tmp = array('REWIND_DEV' => $params['REWIND_DEV'], 'DEFAULT' => '');

            if(preg_match('`\(NDMP\)$`', $params['MEDIA_SERVER'])) {

                $tmp['NDMPID'] = $this->_getIDFromNDMP($params['MEDIA_SERVER']);

            } else {

                $tmp['MEDIA_SERVER'] = $params['MEDIA_SERVER'];

            }

            $params[] = $tmp;

        }

        unset($params['MEDIA_SERVER']);
        unset($params['REWIND_DEV']);
        unset($params['DEFAULT']);
        unset($params['APPID_DRVID']);

	  //error_log("params:".Zend_Json::encode($params));

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

	public function drivemediaserverHelpAction()
    {
        echo $this->view->render('drive/share.html');
    }


    public function jsonAutoDetectAction()
      {
	//DEBUG error_log('jsonAutoDetectAction');
        $context = $this->view->context;
	$ctrlcfg = $this->_getCtrlCfg();
	$model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
	//DEBUG error_log('jsonAutoDetectAction POST:'.Zend_Json::encode($params));
	if (!isset($params['MEDIA_SERVER']) || $params['MEDIA_SERVER'] == '') {
	  $res = $this->_set_error_message($this->lang['drv_detect_error_media_server_require']);
	} else {
	    $id = $params['MEDIA_SERVER'];

	    require_once 'Zend/Json.php';
	    $data = $model->autoDetect($id, $context);
	    $res = $this->_get_result($data, $context);
	}
	$result = Zend_Json::encode($res);
	//DEBUG error_log('jsonAutoDetectAction result:'.$result);
        $this->getResponse()->appendBody($result);
        return;
      }


  public function jsonGetAllDrvLibAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $context = $this->view->context;

      require_once 'Zend/Json.php';
      $data = $model->getDrvLibAll($context);
      $res = $this->_get_result($data, $context);

        if(isset($res['local']) && isset($res['local']['PARAM2']) && isset($res['local']['PARAM2'][0]->item)) {

            foreach($res['local']['PARAM2'][0]->item as $key=>$val) {

                if  (
                        isset($val->LIB_TYPE) && $val->LIB_TYPE == 'TAPE_AUTOMATION' &&
                        isset($val->FORM_FACTOR) &&
                        isset($val->NB_DRV) &&
                        isset($val->NB_SLOTS)
                    ) {

                    $res['local']['PARAM2'][0]->item[$key]->LIB_TYPE = $val->NB_DRV . 'drv, ' . $val->NB_SLOTS . 'slots, ' . $val->FORM_FACTOR;
                    unset($res['local']['PARAM2'][0]->item[$key]->FORM_FACTOR);
                    unset($res['local']['PARAM2'][0]->item[$key]->NB_DRV);
                    unset($res['local']['PARAM2'][0]->item[$key]->NB_SLOTS);

                }

            }

        }

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

   private function _getIDFromNDMP($name='') {

        $result = '';

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $context = null;
        $appid = null;

        if ($appidraw = $this->_request->getPost('APPID_DRVID')) {
            $tmp = explode('_', $appidraw);
            $appid = $tmp[0];
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }

        $res = $model->_getAllNDMP($context);

        if($context && $appid) {

            foreach($res as $list => $val) {

                if(isset($val->param0) && $val->param0 == $appid) {

			if(!is_array($res->param3->item)) {
				$res->param3->item = array($res->param3->item);
			}

                    foreach($val->param3->item as $subval) {

                        if($subval->NAME == $name || preg_match('`^'.$subval->NAME.' \(NDMP\)$`', $name)) {

                            $result = $subval->NDMPID;
                            break;

                        }

                    }

                    break;

                }

            }

        } else {

            if(isset($res->param2) && isset($res->param2->item)) {

		if(!is_array($res->param2->item)) {
			$res->param2->item = array($res->param2->item);
		}

                foreach($res->param2->item as $num=>$val) {

                    if($val->NAME == $name || preg_match('`^'.$val->NAME.' \(NDMP\)$`', $name)) {

                        $result = $val->NDMPID;
                        break;

                    }

                }

            }

        }

        return $result;

    }

    private function _getResultOneAndNDMP($array_context = null)
    {
        return $this->_doModelResultOne('getResultOneAndNDMP', $array_context);
    }

    public function jsonGetResultOneAndNDMPAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOneAndNDMP($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
	//DEBUG error_log('jsonGetOneAction: '.$result);
        return;
    }

    private function _getOneAndNDMP()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOneAndNDMP($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->$appidname = $this->view->appid_id;
	    if (($idname = $ctrlcfg->id) && !isset($data->$idname))
                $data->$idname = $id;
            $data->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;
        return $data;
    }
}

?>
