<?php
/**
 * 
 * Created on June 1st 2007
 *   
 * PHP version 5
 * 
 * @author    Quentin Labadens <qlabadens@arkeia.com>
 * @copyright 2008, Arkeia Software
 * @version   CVS: $Id: NavigatorController.php,v 1.40 2010/06/10 16:23:50 fdaniel Exp $
 * 
 **/
 
define('CSET_CLASSID_WE', 1);
define('CSET_CLASSID_EE', 2);
define('CSET_CLASSID_EA', 3);
define('CSET_CLASSID_SA', 4);
define('CSET_CLASSID_ME', 5);
define('CSET_CLASSID_UTF', 6);
define('CSET_CLASSID_SHORTLIST', 7);
 
require_once 'ArkeiaAction.php';

function get_date($obj, $utime) {
    return ($obj->lang['month_short_'. date('m', $utime)].date(' d Y H:i', $utime));
}

function get_mode($mode) {
    if (($mode & 0xC000) == 0xC000) { // Socket
        $info = 's';
    } elseif (($mode & 0xA000) == 0xA000) { // Symbolic Link
        $info = 'l';
    } elseif (($mode & 0x8000) == 0x8000) { // Regular
        $info = '-';
    } elseif (($mode & 0x6000) == 0x6000) { // Block special
        $info = 'b';
    } elseif (($mode & 0x4000) == 0x4000) { // Directory
        $info = 'd';
    } elseif (($mode & 0x2000) == 0x2000) { // Character special
        $info = 'c';
    } elseif (($mode & 0x1000) == 0x1000) { // FIFO pipe
        $info = 'p';
    } else { // Unknown
        $info = 'u';
    }
    // Owner
    $info .= (($mode & 0x0100) ? 'r' : '-');
    $info .= (($mode & 0x0080) ? 'w' : '-');
    $info .= (($mode & 0x0040) ? (($mode & 0x0800) ? 's' : 'x' ) : (($mode & 0x0800) ? 'S' : '-'));
    // Group
    $info .= (($mode & 0x0020) ? 'r' : '-'); 
    $info .= (($mode & 0x0010) ? 'w' : '-');
    $info .= (($mode & 0x0008) ? (($mode & 0x0400) ? 's' : 'x' ) : (($mode & 0x0400) ? 'S' : '-'));
    // World
    $info .= (($mode & 0x0004) ? 'r' : '-');
    $info .= (($mode & 0x0002) ? 'w' : '-');
    $info .= (($mode & 0x0001) ? (($mode & 0x0200) ? 't' : 'x' ) : (($mode & 0x0200) ? 'T' : '-'));
    return $info;
}


class NavigatorController extends ArkeiaAction
{

    public function jsonListBaseAction() {

        require_once 'Zend/Json.php';

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getParams();

        if (isset($params['APPID'])) {

            $context = $this->_get_filtered_context($params['APPID'], $this->view->context);

        } else {

            $context = null;

        }

        $result = $model->listBase($context);

        $result = $this->_get_result($result, $context);

        if($context) {

            $data = $result['local']['PARAM3'][0]->item;

        } else {

            $data = $result['local']['PARAM2'][0]->item;

        }

        $result = array();

        if(is_object($data) || (is_array($data) && count($data)>0)) {

                $result['thisisafake'] = $this->lang['rst_base_default'];

                if(is_object($data)) {

                        $result[$data->REP_CLIENT_ID] = (isset($data->REP_CLIENT_NAME))?$data->REP_CLIENT_NAME:$this->lang['rst_base_error_no_repname'];

                } else {

                        foreach($data as $tmp) {

                                $result[$tmp->REP_CLIENT_ID] = (isset($tmp->REP_CLIENT_NAME))?$tmp->REP_CLIENT_NAME:$this->lang['rst_base_error_no_repname'];

                        }

                }

        }

        $result = Zend_Json::encode($result);

        $this->getResponse()->appendBody($result);

        return;

    }

/*
List ALL
*/

    //old way
    public function jsonOldListAllAction() {
        return $this->jsonListDirOrFileAction('all');
    }

    //list all using cache
    public function jsonCurListAllAction() {
        return $this->jsonListAllAction(true);
    }

    //list all not using cache
    public function jsonListAllAction($cur=false) {
        if($cur) {
            $type = 'curall';
        } else {
            $type='all';
        }
        return $this->jsonListDirOrFileAction2($type);
    }

    //list all on db using cache
    public function jsonCurListDbAllAction() {
        return $this->jsonListDbAllAction(true);
    }

    //list all on db not using cache
    public function jsonListDbAllAction($cur=false) {
        if($cur) {
            $type = 'curall';
        } else {
            $type='all';
        }
        return $this->jsonListDirOrFileAction2($type, true);
    }

/*
List DIR
*/

    //old way
    public function jsonOldListDirAction() {
        return $this->jsonListDirOrFileAction('dir');
    }

    //list dir using cache
    public function jsonCurListDirAction() {
        return $this->jsonListDirAction(true);
    }

    //list dir not using cache
    public function jsonListDirAction($cur=false) {
        if($cur) {
            $type = 'curdir';
        } else {
            $type='dir';
        }
        return $this->jsonListDirOrFileAction2($type);
    }

    //list dir on db using cache
    public function jsonCurListDbDirAction() {
        return $this->jsonListDbDirAction(true);
    }

    //list dir on db not using cache
    public function jsonListDbDirAction($cur=false) {
        if($cur) {
            $type = 'curdir';
        } else {
            $type='dir';
        }
        return $this->jsonListDirOrFileAction2($type, true);
    }

/*
List FILE
*/

    //old way
    public function jsonOldListFileAction() {
        return $this->jsonListDirOrFileAction('file');
    }

    //list file using cache
    public function jsonCurListFileAction() {
        return $this->jsonListFileAction(true);
    }

    //list file not using cache
    public function jsonListFileAction($cur=false) {
        if($cur) {
            $type = 'curfile';
        } else {
            $type='file';
        }
        return $this->jsonListDirOrFileAction2($type);
    }

    //list file on db using cache
    public function jsonCurListDbFileAction() {
        return $this->jsonListDbFileAction(true);
    }

    //list file on db not using cache
    public function jsonListDbFileAction($cur=false) {
        if($cur) {
            $type = 'curfile';
        } else {
            $type='file';
        }
        return $this->jsonListDirOrFileAction2($type, true);
    }

/*
List EXCLUDE
*/

    public function jsonCurListExcludeDirAction() {
        return $this->jsonListExcludeDirAction(true);
    }

    public function jsonListExcludeDirAction($cur=false) {
        if($cur) {
            $type = 'curexcludedir';
        } else {
            $type='excludedir';
        }
        return $this->jsonListDirOrFileAction2($type);
    }

    public function jsonListDirOrFileAction2($type, $dbnav=false) {

        require_once 'Zend/Json.php';

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getParams();

        if (isset($params['APPID'])) {
            $context = $this->_get_filtered_context($params['APPID'], $this->view->context);
        } else {
            $context = null;
        }

        $prefix = '';

        if(isset($params['PREFIX'])) {
            $prefix = $params['PREFIX'] . '@';
            $_SESSION['prefix'] = $prefix;
        } else {
            if(isset($_SESSION['prefix'])) {
                unset($_SESSION['prefix']);
            }
        }

        $dbprefix = '';

        if($dbnav) {
            $dbprefix = 'db';
        }

        $data = Zend_Json::decode($params['data']);
        $path = $this->navpath_base64_decode($data['node']['widgetId']);
        $objectId = $this->navpath_base64_decode($data['node']['objectId']);

        if ($type != 'all' && $type != 'curall' && $type != 'alldir' && $type != 'curalldir') {
            if($prefix != '') {
                $path = preg_replace('/^'.str_replace(array("'", "/"), array("\\'", "\\/"), $objectId).'(.*)$/', '$1', preg_replace('`^'.$prefix.'`', '', $path));
            } else {
                $path = preg_replace('/^'.str_replace(array("'", "/"), array("\\'", "\\/"), $objectId).'(.*)$/', '$1', $path);
            }
        } else {
            if($type == 'alldir' || $type == 'curalldir') {
                if($type == 'curalldir') {
                    $type = 'curdir';
                } else {
                    $type = 'dir';
                }
            }

            if($prefix != '') {

                $path = preg_replace('`^'.$prefix.'`', '', $objectId);

            } else {

                $path = $objectId;

            }

        }

        if ($path == "Root") {
            $path = ':';
        }

        if ($type == 'excludedir') {

            list($startdir) = split(':', $path);

            $plist = array('DISPLAY_ONLY_DIRS' => '1', 'STARTDIR' => $startdir.':', 'SHOWLINKS' => '1', 'COMM_NUM' => '11');

        } else {

            $plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');

        }

        if(!isset($_SESSION['navigatorCur'])) {

            $_SESSION['navigatorCur'] = array();

        }

        if  (
                isset($params['START_BKID']) ||
                isset($params['END_BKID'])
            ) {

            if (isset($params['START_BKID'])) {
                $plist['START_BKID'] = $params['START_BKID'];
            }

            if (isset($params['END_BKID'])) {
                $plist['END_BKID'] = $params['END_BKID'];
            }

            if(isset($_SESSION['navigatorCur'][$prefix.$dbprefix.$path])) {
                unset($_SESSION['navigatorCur'][$prefix.$dbprefix.$path]);
            }

        }

        if(preg_match('`^cur`', $type)) {

            if(!isset($_SESSION['navigatorCur'][$prefix.$dbprefix.$path])) {

                $data = $model->listDir(($dbnav ? 2 : 1), $path, $plist, $type, $context);
                $_SESSION['navigatorCur'][$prefix.$dbprefix.$path] = base64_encode(serialize($data));
                $type = preg_replace('`^cur(.*)`', '\\1', $type);

            } else {

                $data = unserialize(base64_decode($_SESSION['navigatorCur'][$prefix.$dbprefix.$path]));
                $type = preg_replace('`^cur(.*)`', '\\1', $type);

            }

        } else {

            $data = $model->listDir(($dbnav ? 2 : 1), $path, $plist, $type, $context);
            $_SESSION['navigatorCur'][$prefix.$dbprefix.$path] = base64_encode(serialize($data));

        }

        $data = $this->_get_result($data, $context);

        foreach($data as $cont=>$r) {

            if(isset($r['MESSAGE'])) {

                foreach($r['MESSAGE'] as $num=>$m) {

                    if($num == (count($r['MESSAGE']) - 1) && preg_match('`^..../../.. ..:..:.. E.{7,8} [^ ]*\: (.*)$`', $m, $reg)) {

                        $data[$cont]['PARAM2'] = array();
                        $data[$cont]['PARAM2'][0] = new stdclass;
                        $data[$cont]['PARAM2'][0]->item = array();
                        $data[$cont]['PARAM2'][0]->item[0] = new stdclass;
                        $data[$cont]['PARAM2'][0]->item[0]->NOM = $reg[1];
                        $data[$cont]['PARAM2'][0]->item[0]->ISDIR = 'E';

                    }

                }

            }

        }

        $result = Zend_Json::encode($this->parseListDirOrFile2($data, $type, $dbnav, $path, $objectId, $context));
        $this->getResponse()->appendBody($result);
        return;

    }

//todo finish this for #bug 2487
    public function jsonGetNextResultAction() {

        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $res = $this->_getNext($context);

        if(is_object($res)) {
        
            if(($res->param0 == 12 && ($res->param1 == 2 || $res->param1 == 3)) || ($res->param0 != 12 && $res->last == 0)) {
                //getNext
            } else {

                $res = $this->_parseReplist($res, $context);

            }

        } else {

            if(isset($res['list0'])) {

                foreach($res as $key=>$list) {

                    if(isset($list->param2)) {

                        $res[$key] = $this->_parseReplist($res[$key], $context);

                    }

                }

            }

        }

    }

	private function crop($text, $nbchar, $nbline) {
		if(strlen($text)>$nbchar) {
			$parts = explode(' ', $text);
			if(count($parts) == 1) {
				$text = substr($parts[0], 0, $nbchar) . '...';
			} else {
				$newparts = array();
				$tmp = 0;
				for($i=0; $i<($nbline); $i++) {
					$newparts[$i] = array();
					while(strlen(implode('', $newparts[$i])) < $nbchar) {
						if(strlen($parts[$tmp]) > $nbchar) {
							if($i == $nbline-1) {
								$parts[$tmp] = substr($parts[$tmp], 0, ($nbchar-2)).'...';
							} else {
								$parts[$tmp] = substr($parts[$tmp], 0, $nbchar);
							}
						}
						array_push($newparts[$i], $parts[$tmp]);
						$tmp++;
						if(!isset($parts[$tmp]) || (strlen(implode('', $newparts[$i]) . $parts[$tmp]) > $nbchar)) {
							if(isset($parts[$tmp]) && (strlen(implode('', $newparts[$i]) . $parts[$tmp]) > $nbchar) && $i == $nbline-1) {
								array_push($newparts[$i], substr($parts[$tmp], 0, ($nbchar - strlen(implode('', $newparts[$i])) - 2)).'...');
							}
							break;
						}
					}
					if(!isset($parts[$tmp])) {
						break;
					}
				}
				foreach($newparts as $in=>$n) {
					$newparts[$in] = implode(' ', $newparts[$in]);
				}
				$text = implode(' ', $newparts);
			}
		}
		return $text;
	}

    private function parseListDirOrFile2($data, $type, $dbnav, $path, $objectId, $context) {

        $result = array_shift($data);

        if(isset($result['PARAM2'])) {

            foreach ($result['PARAM2'] as $item) {

                if ($item) {

                    $data = $item->item;

                }

            }

        }

        if (!$data) {

            $data = array();

        }

        if (!is_array($data)) {

            $data =  array($data);

        }

        $res = array();
        $res1 = array();

        $tmp1 = array();

        foreach ($data as $item) {

            if(isset($item->NOM)) {

                array_push($tmp1, $item->NOM);

            }

        }

        if(isset($_SESSION['charset'])) {

            $charset = $_SESSION['charset'];

        } else {

            $charset = 'UTF-8';

        }

        $tmp = arkphp_conv_charset($charset, $tmp1);


//todo reactivate this code for release
        /*if(is_null($tmp2) {

            $tmp = $tmp1;

        }*/

        if($type == 'all') {

            //reordering with dirs first
            $dirs = array();
            $rest = array();

            $dir_type = array('d', 'D', 'p', 'h', 'v', 'n', 'm');

            foreach($data as $v) {

                if(isset($v->ISDIR) && in_array($v->ISDIR, $dir_type)) {

                    $dirs[$v->NOM] = $v;

                } else {

                    $rest[$v->NOM] = $v;

                }

            }

            ksort($dirs);
            ksort($rest);

            $data = array();

            foreach($dirs as $v) {

                array_push($data, $v);

            }

            foreach($rest as $v) {

                array_push($data, $v);

            }

        }

        foreach ($data as $item) {

            if (isset($item->NOM) && $item->NOM != '..') {
    
                $dir_type = array('d', 'D', 'p', 'h', 'v', 'n', 'm');

                if  (
                        $type == 'all' || 
                        (($type == 'excludedir' || $type == 'dir') && in_array($item->ISDIR, $dir_type)) ||
                        ($type == 'file' && !in_array($item->ISDIR, $dir_type))
                    ) {

                    $new1 = array();

                    if (in_array($item->ISDIR, $dir_type)) {

                        $new1['isFolder'] = 'true';

                    }

                    $new1['objectId'] = $this->navpath_base64_encode($objectId);

                    if ($path == ':') {

                        $new1['widgetId'] = $item->NOM;
                        $new1['typeIcon'] = 'machine';

                    } else {

                        if (preg_match('/^[^!]*$/', $path)) {

                            $new1['widgetId'] = $path.'!'.$item->NOM;
                            $new1['typeIcon'] = 'plugin';

                        } else {

                            if (preg_match('/^[^:]*![^:]*$/', $path)) {

                                if ($item->ISDIR == 'v') {

                                    $new1['widgetId'] = $path.':'.$item->NOM;
                                    $new1['typeIcon'] = 'filesystem';

                                } else {

                                    $new1['widgetId'] = $path.':/'.$item->NOM;
                                    if (in_array($item->ISDIR, $dir_type)) {
					if($item->ISDIR == 'v') {
						$new1['typeIcon'] = 'filesystem';
					} else {
						$new1['typeIcon'] = 'folder';
					}
                                    } else {
                                        $new1['typeIcon'] = 'file';
                                    }

                                }

                            } else {

                                $new1['widgetId'] = $path.'/'.$item->NOM;
                                if (in_array($item->ISDIR, $dir_type)) {
                                    if($item->ISDIR == 'D') {
                                        $new1['typeIcon'] = 'symfolder';
                                    } else {
					if($item->ISDIR == 'v') {
						$new1['typeIcon'] = 'filesystem';
					} else {
						$new1['typeIcon'] = 'folder';
					}
                                    }
                                } else {
                                    if($item->ISDIR == 'S') {
                                        $new1['typeIcon'] = 'symfile';
                                    } else {
                                        $new1['typeIcon'] = 'file';
                                    }
                                }
                            }

                        }

                    }

			if(isset($item->OBJ_TYPE)) {
				switch($item->OBJ_TYPE) {
					case 'MSSQL':
						$new1['typeIcon'] = 'mssql';
					break;
					case 'MSEXCHANGE':
						$new1['typeIcon'] = 'exchange';
					break;
					case 'MSSHAREPOINT':
						$new1['typeIcon'] = 'sharepoint';
					break;
					case 'VirtualMachine':
						$new1['typeIcon'] = 'vstvm';
					break;
					case 'Datacenter':
						$new1['typeIcon'] = 'vstdatacenter';
					break;
					case 'vSphere':
						$new1['typeIcon'] = 'vsthost';
					break;
					case 'VirtualApp':
						$new1['typeIcon'] = 'vstvapp';
					break;
					case 'ResourcePool':
						$new1['typeIcon'] = 'vstpool';
					break;
					case 'VirtualDisk':
						$new1['typeIcon'] = 'vstdisk';
					break;
				}
			}

                    $new1['treeIcon'] = '<img class="nav3_tree_icon_'.$new1['typeIcon'].'" src="' . $GLOBALS['baseurl'] . '/scripts/arkeia/widget/specTree/icon-'.$new1['typeIcon'].'-16x16.png" />';
                    $titletmp = '<span class="nav3_tree_label type_'.$item->ISDIR.'">'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'</span>';
                    $new1['title'] = $new1['treeIcon'] . $titletmp;
                    $new1['type'] = $item->ISDIR;
                    $new1['titleRight'] = '<span class="nav3_tree_label type_'.$item->ISDIR.'" title="'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'">'.$this->crop(htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8'), 12, 2).'</span>';
                    $new1['titleRightLong'] = '<span class="nav3_tree_label type_'.$item->ISDIR.'" title="'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'">'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'</span>';

                    $new1['fullTitle'] = htmlspecialchars(arkphp_conv_charset($charset, $new1['widgetId']), ENT_COMPAT, 'UTF-8');

                    if(isset($_SESSION['prefix'])) {

                        $new1['widgetId'] = $_SESSION['prefix'] . $this->navpath_base64_encode($new1['widgetId']);

                    } else {

                        $new1['widgetId'] = $this->navpath_base64_encode($new1['widgetId']);

                    }

                    if(isset($item->MODE)) {
                        $new1['MODE'] = get_mode($item->MODE);
                    }

                    if(isset($item->UID)) {
                        $new1['UID'] = $item->UID;
                    }

                    if(isset($item->GID)) {
                        $new1['GID'] = $item->GID;
                    }

                    if(isset($item->FSIZE)) {
                        if($dbnav) {
                            $new1['FSIZE'] = hexdec($item->FSIZE);
                        } else {
                            $new1['FSIZE'] = $item->FSIZE;
                        }
                    }

                    if(isset($item->MDATE)) {
                        $new1['MDATE'] = get_date($this, $item->MDATE);
                    }

                    if ($dbnav) {

                        $new1['BKDATE_DISP'] = '';

                        if (isset($item->BKDATE) && $item->BKDATE && $item->BKDATE != '') {

                            $new1['BKDATE_DISP'] = get_date($this, $item->BKDATE);

                        }

                        $new1['FILEINFO'] = '';

                        if (isset($item->MODE) && $item->MODE && $item->MODE != '') {

                            $new1['FILEINFO'] = get_mode($item->MODE).' '.$item->UID.'/'.$item->GID.' '.hexdec($item->FSIZE).' '.get_date($this, $item->MDATE);

                        }

                        $new1['BKDATE'] = $item->BKDATE;
                        $new1['ISPOPUPED'] = 'no';
                        $new1['BKSID'] = $item->BKSID;

                    }

                    $res1[$new1['widgetId']] = $new1;

                }

            }

        }

        if($type != 'all') {

            ksort($res1);

        }

        $res = array_values($res1);

        return $res;

    }

    public function jsonListDirOrFileAction($type, $dbnav = false)
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getParams();
	//DEBUG error_log('jsonListDirOrFileAction (type='.$type.') Params: '.Zend_Json::encode($params['data']));
        if (isset($params['APPID'])) {
            $context = $this->_get_filtered_context($params['APPID'], $this->view->context);
        } else {
            $context = null;
        }
        $data = Zend_Json::decode($params['data']);
        $path = $data['node']['widgetId'];
	$objectId = $data['node']['objectId'];

	/* $data['node']['objectId'];
	 * use when we have two navigator in the same page 
	 * it's the widgetId prefix, else we have widgetId
	 * colision
	 */
	if ($type != 'file') {
	    $path = preg_replace('/^'.str_replace(array("'", "/"), array("\\'", "\\/"), $objectId).'(.*)$/', '$1', $path);
	} else {
            $path = $data['node']['objectId'];
	}
        if ($path == "Root") {
            $path = ':';
	}

	if ($type == 'excludedir') {
	  list($startdir) = split(':', $path);
	  $plist = array('DISPLAY_ONLY_DIRS' => '1',
			 'STARTDIR' => $startdir.':',
			 'SHOWLINKS' => '1',
			 'COMM_NUM' => '11');
	} else {
	  $plist = array('SHOWMOUNTPOINTS' => '0',
			 'SHOWLINKS' => '1',
			 'STARTDIR' => ':',
			 'COMM_NUM' => '11');
	}

        if (isset($params['START_BKID'])) {
            $plist['START_BKID'] = $params['START_BKID'];
        }
        if (isset($params['END_BKID'])) {
            $plist['END_BKID'] = $params['END_BKID'];
        }

        $data = $model->listDir(($dbnav ? 2 : 1), $path, $plist, $type, $context);

        $result = $this->_get_result($data, $context);
        $result = array_shift($result);
        foreach ($result['PARAM2'] as $item) {
            if ($item) {
                $data = $item->item;
            }
        }
        if (!$data) {
            $data = array();
        }
        if (!is_array($data)) {
            $data =  array($data);
        }
        if (!$data) {
            $res = $this->_set_error_message('Transaction error');
        } else {
            $res = array();
            $res1 = array();
            foreach ($data as $item) {
                if (isset($item->NOM) && $item->NOM != '..') {
		    $dir_type = array('d', 'D', 'p', 'h', 'v', 'n', 'm');
 		    if ($type == 'all' || ($type == 'excludedir' || $type == 'dir') && in_array($item->ISDIR, $dir_type) || $type == 'file' && !in_array($item->ISDIR, $dir_type)) {
                        $new1 = array();
		        $new1['title'] = '<span style="display: none;">'.$item->NOM.'</span><span class="type_'.$item->ISDIR.'">'.$item->NOM.'</span>';
                        $new1['type'] = $item->ISDIR;
		        if (in_array($item->ISDIR, $dir_type)) {
                            $new1['isFolder'] = 'true';
                        }
			$new1['objectId'] = $objectId;
			if ($path == ':') {
			    $new1['widgetId'] = htmlspecialchars($item->NOM);
			} else {
			    if (preg_match('/^[^!]*$/', $path)) {
			        $new1['widgetId'] = htmlspecialchars($path.'!'.$item->NOM);
			    } else {
			        if (preg_match('/^[^:]*![^:]*$/', $path)) {
				    if ($item->ISDIR == 'v') {
				        $new1['widgetId'] = htmlspecialchars($path.':'.$item->NOM);
				    } else {
				        $new1['widgetId'] = htmlspecialchars($path.':/'.$item->NOM);
				    }
				} else {
				    $new1['widgetId'] = htmlspecialchars($path.'/'.$item->NOM);
				}
			    }
			}
			if ($dbnav) {
                            $new1['BKDATE_DISP'] = '';
                            if (isset($item->BKDATE) && $item->BKDATE && $item->BKDATE != '') {
                                $new1['BKDATE_DISP'] = get_date($this, $item->BKDATE);
                            }
                            $new1['FILEINFO'] = '';
                            if (isset($item->MODE) && $item->MODE && $item->MODE != '') {
                                $new1['FILEINFO'] = get_mode($item->MODE).' '.$item->UID.'/'.$item->GID.' '.hexdec($item->FSIZE).' '.get_date($this, $item->MDATE);
                            }
                            $new1['BKDATE'] = $item->BKDATE;
                            $new1['ISPOPUPED'] = 'no';
                            $new1['BKSID'] = $item->BKSID;
                        }
                        $res1[$new1['widgetId']] = $new1;
                    }
                }
            }
            ksort($res1);
            $res = array_values($res1);
        }
        $result = Zend_Json::encode($res);
        //DEBUG error_log("Nav result:".$result);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetNextSearchAction() {

        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getNext($context);

        $res = $this->_get_result($data);

        foreach($res as $k=>$v) {
            if(is_array($v) && isset($res[$k]['PARAM2']) && is_array($res[$k]['PARAM2'])) {

                foreach($res[$k]['PARAM2'] as $kv=>$vv) {

                    if(is_object($vv) && isset($vv->item)) {

                        if(is_object($vv->item) && isset($vv->item->FULLNAME)) {

                            $res[$k]['PARAM2'][$kv]->item->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item->FULLNAME);
                            $res[$k]['PARAM2'][$kv]->item->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item->FULLNAME);

                        } else {

                            foreach($vv->item as $kvv=>$vvv) {

                                if(isset($vvv->FULLNAME)) {

                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);
                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);

                                }

                            }

                        }

                    }

                }

            }
        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonSearchAction()
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
        //error_log('jsonSearchAction params: '.Zend_Json::encode($params));
        if (isset($params['NDMP'])) {
            if (isset($params['start_search']) && $params['start_search'] != '') {
                require_once 'NdmprestorationController.php';
                $start_path = NdmprestorationController::NDMPsearch_arkndmp($params['start_search']);
            } else {
                $start_path = '!arkndmp:';
            }
        } else {
            if (isset($params['start_search']) && $params['start_search'] != '') {
                $start_path = $params['start_search'];
            } else {
                $start_path = ':';
            }
        }
        $reg = '';
        if (isset($params['match_exact_on']) && $params['match_exact_on']
            && isset($params['match_exact']) && $params['match_exact'] != '') {
            $reg .= ($reg != '' ? '|' : '') . '(^' . $params['match_exact'] . '$)';
        }
        if (isset($params['match_contain_on']) && $params['match_contain_on']
            && isset($params['match_contain']) && $params['match_contain'] != '') {
            $reg .= ($reg != '' ? '|' : '') . '(' . $params['match_contain'] . ')';
        }
        if (isset($params['match_starting_on']) && $params['match_starting_on'] 
            && isset($params['match_starting']) && $params['match_starting'] != '') {
            $reg .= ($reg != '' ? '|' : '') . '(^' . $params['match_starting'] . ')';
        }
        if (isset($params['match_ending_on'])   && $params['match_ending_on']
              && isset($params['match_ending']) && $params['match_ending'] != '') {
            $reg .= ($reg != '' ? '|' : '') . '(' . $params['match_ending'] . '$)';
        }
        //error_log('jsonSearchAction reg: '.$reg.' start_search:'.$start_path);
        $data = $model->listRegexp($reg, $start_path, array());
        $res = $this->_get_result($data);

        foreach($res as $k=>$v) {
            if(is_array($v) && isset($res[$k]['PARAM2']) && is_array($res[$k]['PARAM2'])) {

                foreach($res[$k]['PARAM2'] as $kv=>$vv) {

                    if(is_object($vv) && isset($vv->item)) {

                        if(is_object($vv->item) && isset($vv->item->FULLNAME)) {

                            $res[$k]['PARAM2'][$kv]->item->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item->FULLNAME);
                            $res[$k]['PARAM2'][$kv]->item->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item->FULLNAME);

                        } else {

                            foreach($vv->item as $kvv=>$vvv) {

                                if(isset($vvv->FULLNAME)) {

                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);
                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);

                                }

                            }

                        }

                    }

                }

            }
        }

        //error_log('jsonSearchAction res: '.$reg.' start_search:'.$start_path);
        $result = Zend_Json::encode($res);
        //error_log('jsonSearchAction RETURN !!! : '.$result);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonListOneAction()
    {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
	//DEBUG error_log('jsonListOneAction params: '.Zend_Json::encode($params));
        $path = $this->navpath_base64_decode($params['PATHNAME']);
        $list = array("MAINPROP"    => "DISP_BKDATE",
		      "NOSORT"      => "OUI",
		      "MODE"        => "2",
		      "KEEP_SELECT" => "1",
		      "VERTI"       => "1");
        $data = $model->listOne($path, $list);
	//DEBUG error_log('jsonListOneAction res: '.$path.' data:'.Zend_Json::encode($res));
        $res = $this->_get_result($data);

        foreach($res as $k=>$v) {
            if(is_array($v) && isset($res[$k]['PARAM2']) && is_array($res[$k]['PARAM2'])) {

                foreach($res[$k]['PARAM2'] as $kv=>$vv) {

                    if(is_object($vv) && isset($vv->item)) {

                        if(is_object($vv->item) && isset($vv->item->FULLNAME)) {

                            $res[$k]['PARAM2'][$kv]->item->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item->FULLNAME);
                            $res[$k]['PARAM2'][$kv]->item->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item->FULLNAME);

                        } else {

                            foreach($vv->item as $kvv=>$vvv) {

                                if(isset($vvv->FULLNAME)) {

                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLPATH = $this->navpath_make_fullpath($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);
                                    $res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME = $this->navpath_base64_encode($res[$k]['PARAM2'][$kv]->item[$kvv]->FULLNAME);

                                }

                            }

                        }

                    }

                }

            }
        }

        $result = Zend_Json::encode($res);
	//DEBUG error_log('jsonListOneAction RETURN !!! : '.$result);
        $this->getResponse()->appendBody($result);
        return;
    }

    private function ListCharsetTable($tblid=null) {

        if(!is_null) {

            $res = arkphp_get_charset_table($tblid);

        } else {

            $tmp = arkphp_get_charset_table();

            $res = array();

            $res['HEADER'] = array();

            if(isset($_SESSION['charset'])) {

                array_push($res['HEADER'], 'Current: ' . $_SESSION['charset']);

            } else {

                array_push($res['HEADER'], 'Current: UTF-8');

            }

            $res['MORE_ENCODINGS'] = array();
            $res['MORE_ENCODINGS']['WE'] = $tmp[CSET_CLASSID_WE];
            $res['MORE_ENCODINGS']['EE'] = $tmp[CSET_CLASSID_EE];
            $res['MORE_ENCODINGS']['EA'] = $tmp[CSET_CLASSID_EA];
            $res['MORE_ENCODINGS']['SA'] = $tmp[CSET_CLASSID_SA];
            $res['MORE_ENCODINGS']['ME'] = $tmp[CSET_CLASSID_ME];
            $res['SHORTLIST'] = $tmp[CSET_CLASSID_SHORTLIST];

        }

        return $res;

    }

    public function jsonSetCharsetAction() {

        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getParams();

        if(isset($params['charset'])) {
            $charset = $params['charset'];
        } else {
            $charset = 'UTF-8';
        }

        $_SESSION['charset'] = $charset;

        $finalres = array();
        $finalres['local'] = array();

        $finalres['local']['sessnum'] = array(); $finalres['local']['sessnum'][0] = -1;
        $finalres['local']['transnum'] = array(); $finalres['local']['transnum'][0] = -1;
        $finalres['local']['STATUS'] = array(); $finalres['local']['STATUS'][0] = '0';
        $finalres['local']['MESSAGE'] = array(); $finalres['local']['MESSAGE'][0] = date('Y').'/'.date('m').'/'.date('d').' '.date('H').':'.date('i').':'.date('s').' I99999999 02ARKPHP_SET_CHARSET_TABLE: You have successfully set the charset to \''.$charset.'\'!';
        $finalres['local']['PARAM2'] = array(); $finalres['local']['PARAM2'][0] = null;
        $finalres['local']['PARAM3'] = array(); $finalres['local']['PARAM3'][0] = null;
        $finalres['local']['LAST'] = array(); $finalres['local']['LAST'][0] = 1;

        $result = Zend_Json::encode($finalres);
        $this->getResponse()->appendBody($result);
        return;

    }

    public function jsonListCharsetTableAction() {

        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();

        if(isset($params['tblid'])) {

            $res = $this->ListCharsetTable($params['tblid']);

        } else {

            $res = $this->ListCharsetTable();

        }

        $finalres = array();
        $finalres['local'] = array();

        $finalres['local']['sessnum'] = array(); $finalres['local']['sessnum'][0] = -1;
        $finalres['local']['transnum'] = array(); $finalres['local']['transnum'][0] = -1;
        $finalres['local']['STATUS'] = array(); $finalres['local']['STATUS'][0] = '0';
        $finalres['local']['MESSAGE'] = array(); $finalres['local']['MESSAGE'][0] = date('Y').'/'.date('m').'/'.date('d').' '.date('H').':'.date('i').':'.date('s').' I99999999 02ARKPHP_GET_CHARSET_TABLE: You have successfully loaded the list of Charsets Tables!';
        $finalres['local']['PARAM2'] = array(); $finalres['local']['PARAM2'][0] = array(); $finalres['local']['PARAM2'][0]['item'] = array(); $finalres['local']['PARAM2'][0]['item'][0] = $res;
        $finalres['local']['PARAM3'] = array(); $finalres['local']['PARAM3'][0] = null;
        $finalres['local']['LAST'] = array(); $finalres['local']['LAST'][0] = 1;

        $result = Zend_Json::encode($finalres);
        $this->getResponse()->appendBody($result);
        return;

    }

    public function refreshTreeBuildData($array) {

        $newarray = array();

        foreach($array as $widgetId=>$a) {

            $encwidgetId = $this->navpath_base64_encode($widgetId);

            $newarray[$encwidgetId] = array();

            $newarray[$encwidgetId]['isFolder'] = true;

            if($widgetId == 'Root') {

                $newarray[$encwidgetId]['widgetId'] = $widgetId;
                $newarray[$encwidgetId]['objectId'] = '';
                $newarray[$encwidgetId]['type'] = $a['isdir'];
                $newarray[$encwidgetId]['noCbox'] = 'true';
                $newarray[$encwidgetId]['autoload'] = 'true';
                $newarray[$encwidgetId]['hasRight'] = 'true';

            } else {

                $newarray[$encwidgetId]['widgetId'] = $encwidgetId;
                $newarray[$encwidgetId]['fullTitle'] = htmlspecialchars(arkphp_conv_charset($charset, $widgetId), ENT_COMPAT, 'UTF-8');
                $newarray[$encwidgetId]['objectId'] = '';
                $newarray[$encwidgetId]['type'] = $a['isdir'];
                $newarray[$encwidgetId]['title'] = '<img class="nav3_tree_icon_'.$a['typeicon'].'" src="/scripts/arkeia/widget/specTree/icon-'.$a['typeicon'].'-16x16.png" /><span class="nav3_tree_label type_'.$a['isdir'].'">'.htmlspecialchars($a['nom'], ENT_COMPAT, 'UTF-8').'</span>';

                if(isset($array[$widgetId]['properties']['MODE'])) {
                    $newarray[$encwidgetId]['MODE'] = get_mode($array[$widgetId]['properties']['MODE']);
                }

                if(isset($array[$widgetId]['properties']['UID'])) {
                    $newarray[$encwidgetId]['UID'] = $array[$widgetId]['properties']['UID'];
                }

                if(isset($array[$widgetId]['properties']['GID'])) {
                    $newarray[$encwidgetId]['GID'] = $array[$widgetId]['properties']['GID'];
                }

                if(isset($array[$widgetId]['properties']['FSIZE'])) {
                    if (isset($array[$widgetId]['properties']['MODE']) && $array[$widgetId]['properties']['MODE'] && $array[$widgetId]['properties']['MODE'] != '') {
                        $newarray[$encwidgetId]['FSIZE'] = hexdec($array[$widgetId]['properties']['FSIZE']);
                    } else {
                        $newarray[$encwidgetId]['FSIZE'] = $array[$widgetId]['properties']['FSIZE'];
                    }
                }

                if(isset($array[$widgetId]['properties']['MDATE'])) {
                    $newarray[$encwidgetId]['MDATE'] = get_date($this, $array[$widgetId]['properties']['MDATE']);
                }

                $newarray[$encwidgetId]['BKDATE_DISP'] = '';

                if (isset($array[$widgetId]['properties']['BKDATE']) && $array[$widgetId]['properties']['BKDATE'] && $array[$widgetId]['properties']['BKDATE'] != '') {
                    $newarray[$encwidgetId]['BKDATE_DISP'] = get_date($this, $array[$widgetId]['properties']['BKDATE']);
                }

                $newarray[$encwidgetId]['FILEINFO'] = '';

                if (isset($array[$widgetId]['properties']['MODE']) && $array[$widgetId]['properties']['MODE'] && $array[$widgetId]['properties']['MODE'] != '') {
                    $newarray[$encwidgetId]['FILEINFO'] = get_mode($array[$widgetId]['properties']['MODE']).' '.$array[$widgetId]['properties']['UID'].'/'.$array[$widgetId]['properties']['GID'].' '.hexdec($array[$widgetId]['properties']['FSIZE']).' '.get_date($this, $array[$widgetId]['properties']['MDATE']);
                }

                $newarray[$encwidgetId]['BKDATE'] = $array[$widgetId]['properties']['BKDATE'];
                $newarray[$encwidgetId]['ISPOPUPED'] = $array[$widgetId]['properties']['ISPOPUPED'];
                $newarray[$encwidgetId]['BKSID'] = $array[$widgetId]['properties']['BKSID'];

            }

            $newarray[$encwidgetId]['isExpanded'] = false;

            if(isset($array[$widgetId]['doexpanded'])) {
                $newarray[$encwidgetId]['doexpanded'] = $array[$widgetId]['doexpanded'];
            }

            if(isset($array[$widgetId]['children']) && count($array[$widgetId]['children']) > 0) {
                $newarray[$encwidgetId]['children'] = $this->refreshTreeBuildData($array[$widgetId]['children']);
            }

            unset($array[$widgetId]);

        }

        return $newarray;

    }

    public function refreshTree($pathlist, $plist) {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $context = $this->view->context;

        $data = $model->refresh_tree    (
                                                                2, 
                                                                $pathlist, 
                                                                $plist, 
                                                                $context
                                                            );

        $isexpanded = array();
        $isdir = array();

        $properties = array();

        if(is_array($data)) {

            foreach($data as $d) {

                if(isset($d->param2->item)) {

                    if(!is_array($d->param2->item)) {
                        $d->param2->item = (array)$d->param2->item;

                        if(preg_match('`/$`', $d->param2->item['PATH'])) {

                            $d->param2->item['PATH'] = preg_replace('`^(.*)/$`', '$1', $d->param2->item['PATH']);

                        }

                        $isdir[$d->param2->item['PATH']] = $d->param2->item['ISDIR']?$d->param2->item['ISDIR']:'d';
                        $properties[$d->param2->item['PATH']] = $d->param2->item;

                        if($d->param2->item['IS_EXPANDED']) {
                            array_push($isexpanded, $d->param2->item['PATH']);
                        }

                        $newdata = array($d->param2->item['PATH']);
                    } else {
                        $newdata = array();
                        foreach($d->param2->item as $i) {
                            $i = (array)$i;

                            if(preg_match('`/$`', $i['PATH'])) {

                                $i['PATH'] = preg_replace('`^(.*)/$`', '$1', $i['PATH']);

                            }

                            $isdir[$i['PATH']] = $i['ISDIR']?$i['ISDIR']:'r';
                            $properties[$i['PATH']] = $i;

                            if($i['IS_EXPANDED']) {
                                array_push($isexpanded, $i['PATH']);
                            }

                            array_push($newdata, $i['PATH']);
                        }
                    }

                }

            }

        } else {

            if(isset($data->param2->item)) {

                if(!is_array($data->param2->item)) {
                    $data->param2->item = (array)$data->param2->item;

                    if(preg_match('`/$`', $data->param2->item['PATH'])) {

                        $data->param2->item['PATH'] = preg_replace('`^(.*)/$`', '$1', $data->param2->item['PATH']);

                    }

                    $isdir[$data->param2->item['PATH']] = $data->param2->item['ISDIR']?$data->param2->item['ISDIR']:'d';
                    $properties[$data->param2->item['PATH']] = $data->param2->item;

                    if($data->param2->item['IS_EXPANDED']) {
                        array_push($isexpanded, $data->param2->item['PATH']);
                    }

                    $newdata = array($data->param2->item['PATH']);
                } else {
                    $newdata = array();
                    foreach($data->param2->item as $i) {
                        $i = (array)$i;

                        if(preg_match('`/$`', $i['PATH'])) {

                            $i['PATH'] = preg_replace('`^(.*)/$`', '$1', $i['PATH']);

                        }

                        $isdir[$i['PATH']] = $i['ISDIR']?$i['ISDIR']:'r';
                        $properties[$i['PATH']] = $i;

                        if($i['IS_EXPANDED']) {
                            array_push($isexpanded, $i['PATH']);
                        }

                        array_push($newdata, $i['PATH']);
                    }
                }

            }

        }

        sort($newdata, SORT_STRING);

        $finaldata = array();

        foreach($newdata as $d) {

            if($d == ':') {

                $finaldata['Root'] = array();

                if(in_array($d, $isexpanded)) { $finaldata['Root']['doexpanded'] = true; }
                $finaldata['Root']['isdir'] = $isdir[$d];
                $finaldata['Root']['properties'] = $properties[$d];

                $finaldata['Root']['children'] = array();

            } else {

                if(preg_match('`^[^!]*$`', $d)) { //machine

                    $finaldata['Root']['children'][$d] = array();

                    if(in_array($d, $isexpanded)) {$finaldata['Root']['children'][$d]['doexpanded'] = true; }
                    $finaldata['Root']['children'][$d]['isdir'] = $isdir[$d];
                    $finaldata['Root']['children'][$d]['properties'] = $properties[$d];
                    $finaldata['Root']['children'][$d]['nom'] = $d;
                    $finaldata['Root']['children'][$d]['typeicon'] = 'machine';

                    $finaldata['Root']['children'][$d]['children'] = array();

                } else {

                    if(preg_match('`^([^:]*)!([^:]*)$`', $d, $reg)) { //plugin

                        $finaldata['Root']['children'][$reg[1]]['children'][$d] = array();

                        if(in_array($d, $isexpanded)) {$finaldata['Root']['children'][$reg[1]]['children'][$d]['doexpanded'] = true; }
                        $finaldata['Root']['children'][$reg[1]]['children'][$d]['isdir'] = $isdir[$d];
                        $finaldata['Root']['children'][$reg[1]]['children'][$d]['properties'] = $properties[$d];
                        $finaldata['Root']['children'][$reg[1]]['children'][$d]['nom'] = $reg[2];
                        $finaldata['Root']['children'][$reg[1]]['children'][$d]['typeicon'] = 'plugin';

                        $finaldata['Root']['children'][$reg[1]]['children'][$d]['children'] = array();

                    } else {

                        if(preg_match('`^([^:]*)(![^:]*):(.*)$`', $d, $reg)) {

                            $machine = $reg[1];
                            $plugin = $reg[1].$reg[2];
                            $actual = $reg[1].$reg[2].':'.$reg[3];

                            if(preg_match('`^([^:]*:)(.*)?$`', $reg[3], $volreg)) { //volume

                                if($volreg[2] == '' || $volreg[2] == '/') {

                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d] = array();

                                    if(in_array($d, $isexpanded)) {$finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['doexpanded'] = true; }
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['isdir'] = $isdir[$d];
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['properties'] = $properties[$d];
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['nom'] = $volreg[1];
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['typeicon'] = 'filesystem';

                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['children'] = array();

                                } else {

                                    $volume = $reg[1].$reg[2].':'.$volreg[1];

                                    if(preg_match('`^/([^/]*)$`', $volreg[2], $subreg)) {

                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d] = array();

                                        if(in_array($d, $isexpanded)) {$finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['doexpanded'] = true; }
                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['isdir'] = $isdir[$d];
                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['properties'] = $properties[$d];
                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['nom'] = $subreg[1];
                                        if($isdir[$d] == 'D') {
                                            $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['typeicon'] = 'symfolder';
                                        } else {
                                            $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['typeicon'] = 'folder';
                                        }

                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$volume]['children'][$d]['children'] = array();

                                    } else {

                                        preg_match('`^/([^/]*)/(.*)$`', $volreg[2], $subreg);

                                        $tmp = explode('/', $subreg[2]);

                                        $cur = $reg[1].$reg[2].':'.$volreg[1].'/'.$subreg[1];

                                        $dir = '';

                                        if(count($tmp) > 1) {

                                            foreach($tmp as $i=>$t) {
                                                $part = array_slice($tmp, 0, ($i+1), true);
                                                if(count($part) > 1) {
                                                    $dir .= '[\'children\'][$cur . \'/'.implode('/', $part).'\']';
                                                } else {
                                                    $dir .= '[\'children\'][$cur . \'/'.$part[0].'\']';
                                                }
                                            }

                                        } else {

                                            $dir .= '[\'children\'][$cur . \'/'.$tmp[0].'\']';

                                        }

                                        eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.' = array();');

                                        eval('if(in_array($d, $isexpanded)) {$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'doexpanded\'] = true; }');
                                        eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'isdir\'] = $isdir[$d];');
                                        eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'properties\'] = $properties[$d];');
                                        eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'nom\'] = $tmp[count($tmp)-1];');
                                        eval('if($isdir[$d] == \'D\'){$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'typeicon\'] = \'symfolder\';} else {$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'typeicon\'] = \'folder\';}');
                                        eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$volume][\'children\'][$cur]'.$dir.'[\'children\'] = array();');

                                    }

                                }

                            } else { //directory

                                if(preg_match('`^/([^/]*)$`', $reg[3], $subreg)) {

                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d] = array();

                                    if(in_array($d, $isexpanded)) {$finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['doexpanded'] = true; }
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['isdir'] = $isdir[$d];
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['properties'] = $properties[$d];
                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['nom'] = $subreg[1];
                                    if($isdir[$d] == 'D') {
                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['typeicon'] = 'symfolder';
                                    } else {
                                        $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['typeicon'] = 'folder';
                                    }

                                    $finaldata['Root']['children'][$machine]['children'][$plugin]['children'][$d]['children'] = array();

                                } else {

                                    preg_match('`^/([^/]*)/(.*)$`', $reg[3], $subreg);

                                    $tmp = explode('/', $subreg[2]);

                                    $cur = $reg[1].$reg[2].':/'.$subreg[1];

                                    $dir = '';

                                    if(count($tmp) > 1) {

                                        foreach($tmp as $i=>$t) {
                                            $part = array_slice($tmp, 0, ($i+1), true);
                                            if(count($part) > 1) {
                                                $dir .= '[\'children\'][$cur . \'/'.implode('/', $part).'\']';
                                            } else {
                                                $dir .= '[\'children\'][$cur . \'/'.$part[0].'\']';
                                            }
                                        }

                                    } else {

                                        $dir .= '[\'children\'][$cur . \'/'.$tmp[0].'\']';

                                    }

                                    eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.' = array();');

                                    eval('if(in_array($d, $isexpanded)) {$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'doexpanded\'] = true; }');
                                    eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'isdir\'] = $isdir[$d];');
                                    eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'properties\'] = $properties[$d];');
                                    eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'nom\'] = $tmp[count($tmp)-1];');
                                    eval('if($isdir[$d] == \'D\'){$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'typeicon\'] = \'symfolder\';} else {$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'typeicon\'] = \'folder\';}');
                                    eval('$finaldata[\'Root\'][\'children\'][$machine][\'children\'][$plugin][\'children\'][$cur]'.$dir.'[\'children\'] = array();');

                                }

                            }

                        }

                    }

                }

            }

        }

        $finaldata = $this->refreshTreeBuildData($finaldata);

        if(is_array($data)) {

            foreach($data as $d) {

                if(isset($d->param2->item)) {

                    $d->param2->item = $finaldata['Root']['children'];

                }

            }

        } else {

            if(isset($data->param2->item)) {

                $data->param2->item = $finaldata['Root']['children'];

            }

        }

        return $data;

    }

    public function jsonRefreshTreeAction() {

        require_once 'Zend/Json.php';

        $params = $this->_request->getPost();

        $pathlist = array();

        if(isset($params['EXPANDED']) && isset($params['CURRENT'])) {

            foreach(Zend_Json::decode($params['EXPANDED']) as $p) {

                $tmp = array();

                if($p == $params['CURRENT']) {

                    $tmp['IS_CURRENT'] = 1;

                }

                if($p == 'Root') {
                    $p = ':';
                } else {
                    $p = $this->navpath_base64_decode($p);
                }

                $tmp['PATH'] = $p;

                array_push($pathlist, $tmp);

            }

        }

        $plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');

        if  (
                isset($params['START_BKID']) ||
                isset($params['END_BKID'])
            ) {

            if (isset($params['START_BKID'])) {
                $plist['START_BKID'] = $params['START_BKID'];
            }

            if (isset($params['END_BKID'])) {
                $plist['END_BKID'] = $params['END_BKID'];
            }

        }

        $data = $this->refreshTree($pathlist, $plist);

        $res = $this->_get_result($data);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;

    }

}