<?php

require_once 'ArkeiaAction.php';

class NdmpdrivepackController extends ArkeiaAction
{

    public function listtapeAction() {
        $this->displayFromScreenIni('listtape');
    }

    public function listvtlAction() {
        $this->displayFromScreenIni('listvtl');
    }

    public function addtapeAction() {
        $this->displayFromScreenIni('addtape');
    }

    public function addvtlAction() {
        $this->displayFromScreenIni('addvtl');
    }

    public function updatetapeAction() {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updatetape', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function updatevtlAction() {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updatevtl', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonGetResultAllTapeAction() {
        require_once 'Zend/Json.php';
        $array_context = $this->view->context;

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $appid = $this->_request->getPost(APPLIANCE_GUID);

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
        }

        $data = $model->getResultAllTape($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllVtlAction() {
        require_once 'Zend/Json.php';
        $array_context = $this->view->context;

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $appid = $this->_request->getPost(APPLIANCE_GUID);

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
        }

        $data = $model->getResultAllVtl($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllTapeNameIntersectAction() {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) {
            $appid = "local";
        }
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else {
            $context = $array_context;
        }
        if ($intersect) {
            $data = $model->getResultAllTape($context, $params);
        } else {
            $data = $model->getResultAllTape($context);
        }
        $res = $this->_get_result($data, $context);

        $newres = array();

        if($context && $appid == 'local') { //multisite but no appid so let's get them all
            foreach($res as $appid=>$appiddata) {
                $data = $res[$appid]['PARAM2'];
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        } else {
            $data = $res[$appid]['PARAM2'];
            if ($data) {
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        }
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetAllTapeNameIdAction() {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) {
            $appid = "local";
        }
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else {
            $context = $array_context;
        }
        if ($intersect) {
            $data = $model->getResultAllTape($context, $params);
        } else {
            $data = $model->getResultAllTape($context);
        }
        $res = $this->_get_result($data, $context);

        $newres = array();

        if($context && $appid == 'local') { //multisite but no appid so let's get them all
            foreach($res as $appid=>$appiddata) {
                $data = $res[$appid]['PARAM2'];
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        } else {
            $data = $res[$appid]['PARAM2'];
            if ($data) {
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        }
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultAllVtlNameIntersectAction() {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) {
            $appid = "local";
        }
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else {
            $context = $array_context;
        }
        if ($intersect) {
            $data = $model->getResultAllVtl($context, $params);
        } else {
            $data = $model->getResultAllVtl($context);
        }
        $res = $this->_get_result($data, $context);
        if($context) {
            $data = $res[$appid]['PARAM3'];
        } else {
            $data = $res[$appid]['PARAM2'];
        }
        $newres = array();
        if($context && $appid == 'local') { //multisite but no appid so let's get them all
            foreach($res as $appid=>$appiddata) {
                $data = $res[$appid]['PARAM2'];
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        } else {
            $data = $res[$appid]['PARAM2'];
            if ($data) {
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        }
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetAllVtlNameIdAction() {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        $appid = $this->_request->getParam(APPLIANCE_GUID);
        if (!$appid) {
            $appid = "local";
        }
        if ($appid != "local") {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else {
            $context = $array_context;
        }
        if ($intersect) {
            $data = $model->getResultAllVtl($context, $params);
        } else {
            $data = $model->getResultAllVtl($context);
        }
        $res = $this->_get_result($data, $context);
        if($context) {
            $data = $res[$appid]['PARAM3'];
        } else {
            $data = $res[$appid]['PARAM2'];
        }
        $newres = array();
        if($context && $appid == 'local') { //multisite but no appid so let's get them all
            foreach($res as $appid=>$appiddata) {
                $data = $res[$appid]['PARAM2'];
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        } else {
            $data = $res[$appid]['PARAM2'];
            if ($data) {
                foreach ($data as $param) {
                     if (is_array($param->item)) {
                        foreach ($param->item as $obj) {
                            $newres[$obj->$idname] = $obj->NAME;
                        }
                    } else if ($param->item){
                            $newres[$param->item->$idname] = $param->item->NAME;
                    }
                }
            }
        }
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      require_once 'Zend/Json.php';
      $params = $this->_request->getPost();
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      unset($params['APPID_DKID']);

      //DEBUG error_log('jsonCreateObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));

      foreach ($params as $key => $val) {
	  if (preg_match('/^check_DRVID_.*/', $key)) {
	      $params[] = array('DRVID' => $val, 'PRIORITY' => $params['priority_DRVID_'.$val]);
	      unset($params[$key]);
	  } else if (preg_match('/^check_VTLID_.*/', $key)) {
              $params[] = array('VTLID' => $val, 'PRIORITY' => $params['priority_VTLID_'.$val]);
	      unset($params[$key]);
	  }
      }
      foreach ($params as $key => $val) {
          if (preg_match('/^priority_.*/', $key)) {
              unset($params[$key]);
          }
      }

      //DEBUG error_log('jsonCreateObjectAction param : '.Zend_Json::encode($params));

      $context = $this->view->context;
      $data = $model->createObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      require_once 'Zend/Json.php';
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      unset($params['APPID_DKID']);

      foreach ($params as $key => $val) {
	  if (preg_match('/^check_DRVID_.*/', $key)) {
	      $params[] = array('DRVID' => $val, 'PRIORITY' => $params['priority_DRVID_'.$val]);
	      unset($params[$key]);
	  } else if (preg_match('/^check_VTLID_.*/', $key)) {
              $params[] = array('VTLID' => $val, 'PRIORITY' => $params['priority_VTLID_'.$val]);
	      unset($params[$key]);
	  }
      }
      foreach ($params as $key => $val) {
          if (preg_match('/^priority_.*/', $key)) {
              unset($params[$key]);
          }
      }

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }
}

?>
