<?php

require_once 'ArkeiaAction.php';

class NdmpsavepackController extends ArkeiaAction
{
    public function managetreeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('managetree', FALSE);
        $this->_render_json_view($res);
        return;
    }
 
    public function managetreeHelpAction()
    {
        echo $this->view->render('managetree/ndmpspk_help.html');
    }
	
	public function jsonAddObjectAction()
	{
		 $ctrlcfg = $this->_getCtrlCfg();
	     $model = $this->_getModel($ctrlcfg);
	     $array_context = $this->view->context;
	     list($id, $context) = $this->_getIdContext($array_context);

	     require_once 'Zend/Json.php';

	     $idname = $ctrlcfg->id;
	     $params = $this->_request->getPost();

		 if (isset($params['NDMPID_selected'])) {
		 	$params['NDMPID'] = $params['NDMPID_selected'];
			unset($params['NDMPID_selected']);
		 }
	     unset($params['ADD']);

		 if ($params['NAME'] == '' || $params['NDMPID'] == '') {
          	$res = $this->_set_error_message($this->lang['ndmp_spk_create_error_fields_required']);
	     } else {
		    $data = $model->addObject($params, $context);
			$res = $this->_get_result($data, $context);
		 }
	     $result = Zend_Json::encode($res);
	     $this->getResponse()->appendBody($result);
	      
	     return;
	}
	
	public function jsonUpdateAction()
    {
		$info = $this->_getOne();
       
		$this->_create_NDMP_TREES_ENCODE($info);
        $res = $this->displayFromScreenIni('update', FALSE);
		$this->_render_json_view($res);
		return ;
    }
	
	private function _create_NDMP_TREES_ENCODE($info, $view = true)
	{
		require_once 'Zend/Json.php';
		if (isset($info->item)) {
			$trees = array();
			for ($i = 0; $i < count($info->item); $i++) {
				if (isset($info->item[$i]->FULLNAME)) {
					array_push($trees, $info->item[$i]);
				}
			}
			if ($view == true) {
				$this->view->ndmpsavepack->NDMP_TREES_ENCODE = Zend_Json::encode($trees);
			}
			else {
				$info->NDMP_TREES_ENCODE = Zend_Json::encode($trees);
			}
		}
		return ;
	}
	
	private function _create_NDMP_VAR_ENV_ENCODE($info, $view = true)
	{
		require_once 'Zend/Json.php';
		if (isset($info->item)) {
			$env = array();
			for ($i = 0; $i < count($info->item); $i++) {
				if (isset($info->item[$i]->NAME) &&
					isset($info->item[$i]->VALUE)) {
					$name = '';
					$name = "var_env_".$info->item[$i]->NAME;
					$env[$name] = $info->item[$i]->VALUE;
				}
			}
			if ($view == true) {
				$this->view->ndmpsavepack->NDMP_VAR_ENV_ENCODE = Zend_Json::encode($env);
			}
			else {
				$info->NDMP_VAR_ENV_ENCODE = Zend_Json::encode($env);
			}
		}
	}
	
	public function jsonModifyObjectAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      require_once 'Zend/Json.php';
	      //error_log('jsonModifyObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));
	      //error_log('jsonModifyObjectAction array_context: '.Zend_Json::encode($array_context));
	      //error_log('jsonModifyObjectAction context: '.Zend_Json::encode($context));
	      //error_log('jsonModifyObjectAction id : '.Zend_Json::encode($id));

	      $idname = $ctrlcfg->id;
	      $params = $this->_request->getPost();

		  if ($params['NDMPID'] == '') {
				$res = $this->_set_error_message($this->lang['ndmp_spk_create_ndmp_server_required']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
		  }
		  if ($params['DISPLAY_NOINDEX_selected'] == '') {
				$res = $this->_set_error_message($this->lang['ndmp_spk_create_ndmp_noindex_required']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
		  }
		  if ($params['BUTYPE_selected'] == '') {
				$res = $this->_set_error_message($this->lang['ndmp_spk_create_ndmp_backup_type_required']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
		  }


	      unset($params['UPDATE']);
	      unset($params['APPID_NDMPID']);
		  unset($params['NAME_submit']);
		  unset($params['NAME_val']);
		  unset($params['NAME_name']);
		  unset($params['DISPLAY_NOINDEX']);
		  unset($params['BUTYPE']);
		  unset($params['NDMPID']);
		  unset($params['APPID_NDMPSKID']);

		  if ($params['DISPLAY_NOINDEX_selected'] ==
		  	  $this->lang['ndmp_info_direct_access_disable']) {
		  	  	$params['NOINDEX'] = '1';
		  }
		  else {
		  		$params['NOINDEX'] = '0';
		  }
		  unset($params['DISPLAY_NOINDEX_selected']);
		  
		  $params['BUTYPE'] = $params['BUTYPE_selected'];
		  unset($params['BUTYPE_selected']);
		  $params['NDMPID'] = $params['NDMPID_selected'];
		  unset($params['NDMPID_selected']);

		  if (isset($params['NDMP_TREES_ENCODE'])) {
				$Elems = Zend_Json::decode($params['NDMP_TREES_ENCODE']);
				
				for ($i = 0; $i < count($Elems); $i++) {
					$params[$i] = array();
					foreach ($Elems[$i] as $name => $value) {
						$params[$i][$name] = $value;
					}
				}				
				unset($params['NDMP_TREES_ENCODE']);
		  }
		  foreach ($params as $key => $value) {
		  	if (!strncmp($key, 'adv_param_', 10)) {
		  		$cut = substr($key, 10);
		  		$params['var_env_'.$cut] = $value;
				unset($params[$key]);
		  	}
		  }


		  //error_log("PARAMS:".Zend_Json::encode($params));
	      $data = $model->modifyObject($params, $context);
	      $res = $this->_get_result($data, $context);
	      
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);

	      return;
	}
	
	public function addonetreeAction()
    {
        $info = $this->_getOne();
		$this->_create_NDMP_TREES_ENCODE($info);
		$this->_create_NDMP_VAR_ENV_ENCODE($info);
		
        $res = $this->displayFromScreenIni('addonetree', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	public function jsonAddTreeObjectAction()
    {
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);
		
		  $idname = $ctrlcfg->id;
	      $params = $this->_request->getPost();
		  
		  if ($params['FULLNAME'] == '') {
			$res = $this->_set_error_message($this->lang['spk_create_tree_error_fullname_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	      }
		  
		  unset($params['SUBMIT']);
		  unset($params['APPID_NDMPSKID']);
		  
		  if ($params['DISPLAY_NOINDEX'] == $this->lang['ndmp_info_direct_access_disable']) {
		  		$params['NOINDEX'] = '1';
		  }
		  else {
		  		$params['NOINDEX'] = '0';
		  }
		  unset($params['DISPLAY_NOINDEX']);
		  
		  require_once 'Zend/Json.php';
    	  
		
		  if (isset($params['NDMP_TREES_ENCODE'])) {
			$Elems = Zend_Json::decode($params['NDMP_TREES_ENCODE']);
				
			for ($i = 0; $i < count($Elems); $i++) {
				$params[$i] = array();
				foreach ($Elems[$i] as $name => $value) {
					$params[$i][$name] = $value;
				}
			}				
			unset($params['NDMP_TREES_ENCODE']);
		  }
		  
		  $params[$i] = array();
		  $params[$i]['FULLNAME'] = $params['FULLNAME'];
		  unset($params['FULLNAME']);
		  
		  if (isset($params['NDMP_VAR_ENV_ENCODE'])) {
			$Elems = Zend_Json::decode($params['NDMP_VAR_ENV_ENCODE']);

				foreach ($Elems as $name => $value) {
					$params[$name] = $value;
				}
				unset($params['NDMP_VAR_ENV_ENCODE']);
			}

		  //error_log("PARAMS:".Zend_Json::encode($params));
	
		  $data = $model->modifyObject($params, $context);
	      $res = $this->_get_result($data, $context);
	      
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);
		  
		  return ;
    }
	
	public function jsonRemoveTreeObjectAction()
    {
          $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);
		
		  $idname = $ctrlcfg->id; 

	      $params = $model->getResultOne($id, $context);
		  
		  $fullname = $this->_request->getPost();
		  $params = $params->param2;

		  if (isset($params->item)) {
			  for ($i = 0; isset($params->item[$i]); $i++) {
			  	if (isset($params->item[$i]->FULLNAME) &&
					$params->item[$i]->FULLNAME == $fullname['FULLNAME']) {
						array_splice($params->item, $i, 1);
						$i--;
				}
			  }
		  }
		  
		  require_once 'Zend/Json.php';
		  if ($params->DISPLAY_NOINDEX == $this->lang['ndmp_info_direct_access_disable']) {
		  		$params->NOINDEX = '1';
		  }
		  else {
		  		$params->NOINDEX = '0';
		  }
		  unset($params->DISPLAY_NOINDEX);
		  
		  $array_params = array();
		  //error_log("NEW 3 PARAMS_DELETE:".Zend_Json::encode($params));
		  foreach ($params as $name => $value) {
		  		if ($name == 'item') {
		  			foreach ($params->item as $item => $item_array) {
		  				$array_params[$i] = array();
							foreach($params->item[$item] as $item_name => $item_value) {
								$array_params[$item][$item_name] = $item_value;
							}
		  			}
		  		}
				else {
					$array_params[$name] = $value;
				}
		  }
		  
		  //error_log("ARRAY_PARAMS_DELETE:".Zend_Json::encode($array_params));
		  
		  $data = $model->modifyObject($array_params, $context);
	      $res = $this->_get_result($data, $context);
	      
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);

		  return ;
    }
	
	public function updateonetreeAction()
    {
        $info = $this->_getOne();
		$this->_create_NDMP_TREES_ENCODE($info);
		$this->_create_NDMP_VAR_ENV_ENCODE($info);

        $res = $this->displayFromScreenIni('updateonetree', FALSE);
        $this->_render_json_view($res);
        return;
    }
	
	public function jsonUpdateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $idname = $ctrlcfg->id;
	  $params = $this->_request->getPost();
	  
	  if ($params['DISPLAY_NOINDEX'] == '') {
				$res = $this->_set_error_message($this->lang['ndmp_spk_create_ndmp_noindex_required']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
		  }
	  if ($params['BUTYPE'] == '') {
			$res = $this->_set_error_message($this->lang['ndmp_spk_create_ndmp_backup_type_required']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
	  }

	  //error_log("PARAMS:".Zend_Json::encode($params));
	  
	  $array_params = array();
	  $array_params['NDMPID'] = $params['NDMPID'];
	  $array_params['NDMPSKID'] = $params['NDMPSKID'];
	  $array_params['NAME'] = $params['NAME'];
	  $tmp_var = Zend_Json::decode($params['NDMP_VAR_ENV_ENCODE']);
	  foreach ($tmp_var as $key => $val) {
	  		$array_params[$key] = $val;
	  }
	  $Elems = Zend_Json::decode($params['NDMP_TREES_ENCODE']);
   	  for ($i = 0; $i < count($Elems); $i++) {
			foreach ($Elems[$i] as $name => $value) {
				if ($name == 'FULLNAME' && $value == $params['FULLNAME']) {
					$tree = &$Elems[$i];
				}
			}
	  }
	  foreach ($tree as $tree_var_name => $tree_var_value) {
	  		if (!strncmp($tree_var_name, 'var_env_', 8)) {
	  			$ok = false;
	  			foreach ($params as $var_name => $var_value) {
	  				if ($tree_var_name == $var_name) {
	  					$ok = true;
						break;
	  				}
	  			}
				if ($ok == false) {
					unset($tree[$tree_var_name]);
				}
	  		}
	  }
    
	  $one = $this->_getOne();
      $one = Zend_Json::decode(Zend_Json::encode($one), Zend_Json::TYPE_ARRAY);

	  if (isset($tree)) {
		  foreach ($params as $key => $value) {
			  if (!strncmp($key, 'adv_param_', 10)) {
			  		$cut = substr($key, 10);
			  		$tree['var_env_'.$cut] = $value;
			  }
		  }
		  if ($params['DISPLAY_NOINDEX'] != $this->lang['spk_infotree_as_spk_option']) {
	  	      if ($params['DISPLAY_NOINDEX_selected'] == $this->lang['ndmp_info_direct_access_disable']) {
			  		$tree['NOINDEX'] = '1';
					unset($tree['DISPLAY_NOINDEX']);
			  }
			  else {
			  		$tree['NOINDEX'] = '0';
					unset($tree['DISPLAY_NOINDEX']);
			  }
		  }
		  else {
		  	if (isset($one['NOINDEX'])) {
			  	$tree['NOINDEX'] = $one['NOINDEX'];
			}
		  	unset($tree['DISPLAY_NOINDEX']);
		  }
		  if ($params['BUTYPE'] != $this->lang['spk_infotree_as_spk_option']) {
			  $tree['BUTYPE'] = $params['BUTYPE_selected'];
		  }
		  else {
		  	  $tree['BUTYPE'] = $one['BUTYPE'];
		  }
	  }
	  for ($i = 0; $i < count($Elems); $i++) {
			$array_params[$i] = array();
			foreach ($Elems[$i] as $name => $value) {
				if ($name == 'DISPLAY_NOINDEX') {
					if ($value == $this->lang['ndmp_info_direct_access_disable']) {
						$name = 'NOINDEX';
						$value = '1';
					}
					else {
						$name = 'NOINDEX';
						$value = '0';
					}
				}
				if ($name != 'DISPLAY_NOINDEX') {
					$array_params[$i][$name] = $value;
				}
			}
	  }

	  $array_params['BUTYPE'] = $one['BUTYPE'];
	  if (isset($one['NOINDEX'])) {
	  		$array_params['NOINDEX'] = $one['NOINDEX'];
	  }
	  
	  //error_log("ARRAY_PARAMS:".Zend_Json::encode($array_params));
	  
	  $data = $model->modifyObject($array_params, $context);
	  $res = $this->_get_result($data, $context);
	      
	  $result = Zend_Json::encode($res);
	  $this->getResponse()->appendBody($result);

	  return ;
    }
}

?>
