<?php

require_once 'ArkeiaAction.php';

class NdmpserverController extends ArkeiaAction
{
	public function jsonNDMPHostInfoAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $idname = $ctrlcfg->id;
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      $params = $this->_request->getPost();

	      $params['NDMPID'] = $id;
	      $params['INT4'] = 48;
	      require_once 'Zend/Json.php';
	      $result = $model->ndmp_get_info($params, $context);

		if ($context) $param = param3;
		else $param = param2;
		if (is_array($result)) {
			foreach ($result as $key => $val) {
				if ($context && $key == "local") continue;
				$data = $result[$key]->$param->item;
				if (!$data) continue;
				if (is_array($data)) {
					foreach ($data as $item) {
						foreach ($item as $item_key => $item_val) {
							$result[$key]->$param->$item_key = $item_val;
						}
					}
				} else { /* only one item */
					foreach ($item as $item_key => $item_val) {
						$result[$key]->$param->$item_key = $item_val;
					}
				}
				unset($result[$key]->$param->item);
			}
		} else {
			$data = $result->$param->item;
			if (!$data) return $result;
			if (is_array($data)) {
				foreach ($data as $item) {
					foreach ($item as $item_key => $item_val) {
						$result->$param->$item_key = $item_val;
					}
			}
			} else { /* only one item */
				foreach ($item as $item_key => $item_val) {
					$result->$param->$item_key = $item_val;
				}
			}
			unset($result->$param->item);
		}
	      $res = $this->_get_result($result, $context);
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);
	      return;
	}
	
	private function _convert_size($val) {
		if ($val > 1073741824) {
		    $val = round($val / 1073741824, 2) . ' TB';
		} else if ($val > 1048576) {
		    $val = round($val / 1048576, 2) . ' GB';
		} else if ($val > 1024) {
		    $val = round($val / 1024, 2) . ' MB';
		} else {
		    $val = round($val, 2) . ' KB';
		}
		return ($val);
	}
	
	public function jsonNDMPFileSystemsAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $idname = $ctrlcfg->id;
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      $params = $this->_request->getPost();

	      $params['NDMPID'] = $id;
	      $params['INT4'] = 8;
	      require_once 'Zend/Json.php';
	      $result = $model->ndmp_get_info($params, $context);
	     

		  $param2 = &$result->param2->item;
		  //error_log("PARAZM2->item:".Zend_Json::encode($param2));
		  if (is_array($param2)) {
		  		for ($i = 0; isset($param2[$i]); $i++) {
		  			foreach ($param2[$i] as $key => $val) {
		  				if ($key == 'FS_USED_SIZE' || $key == 'FS_TOTAL_SIZE') {
		  					$param2[$i]->$key = $this->_convert_size($val / 1024);
		  				}
		  			}
		  		}
		  }
		  else {
		  		$param2->FS_USED_SIZE = $this->_convert_size($param2->FS_USED_SIZE / 1024);
				$param2->FS_TOTAL_SIZE = $this->_convert_size($param2->FS_TOTAL_SIZE / 1024);
		  }
		  $res = $this->_get_result($result, $context);
	      $result = Zend_Json::encode($res);

		  //error_log("RESULT:".$result);

	      $this->getResponse()->appendBody($result);
	      return;
	}
	
	public function jsonNDMPScsiInfoAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $idname = $ctrlcfg->id;
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      $params = $this->_request->getPost();

	      $params['NDMPID'] = $id;
	      $params['INT4'] = 7;
	      require_once 'Zend/Json.php';
	      $result = $model->ndmp_get_info($params, $context);
	      $res = $this->_get_result($result, $context);
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);
	      return;
	}
	
	public function jsonModifyObjectAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      require_once 'Zend/Json.php';
	      //error_log('jsonModifyObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));
	      //error_log('jsonModifyObjectAction array_context: '.Zend_Json::encode($array_context));
	      //error_log('jsonModifyObjectAction context: '.Zend_Json::encode($context));
	      //error_log('jsonModifyObjectAction id : '.Zend_Json::encode($id));

	      $idname = $ctrlcfg->id;
	      $params = $this->_request->getPost();

	      unset($params['UPDATE']);
	      unset($params['APPID_NDMPID']);

	      $data = $model->modifyObject($params, $context);

	      $res = $this->_get_result($data, $context);
	      
	      //error_log('jsonModifyObjectAction res: '.Zend_Json::encode($res));
	      $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);
	      
	      return;
	}
	
	public function jsonAddObjectAction()
	{
	      $ctrlcfg = $this->_getCtrlCfg();
	      $model = $this->_getModel($ctrlcfg);
	      $array_context = $this->view->context;
	      list($id, $context) = $this->_getIdContext($array_context);

	      require_once 'Zend/Json.php';
	      //error_log('jsonModifyObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));
	      //error_log('jsonModifyObjectAction array_context: '.Zend_Json::encode($array_context));
	      //error_log('jsonModifyObjectAction context: '.Zend_Json::encode($context));
	      //error_log('jsonModifyObjectAction id : '.Zend_Json::encode($id));

	      $idname = $ctrlcfg->id;
	      $params = $this->_request->getPost();

	      unset($params['ADD']);

		  if ($params['NAME'] == '') {
          	$res = $this->_set_error_message($this->lang['spk_create_error_name_require']);
	      } else {
		      $data = $model->addObject($params, $context);
		      $res = $this->_get_result($data, $context);
	      }
	      //error_log('jsonModifyObjectAction res: '.Zend_Json::encode($res));
	   	  $result = Zend_Json::encode($res);
	      $this->getResponse()->appendBody($result);      
	      return;
	}
	
	public function getAllBUTYPE()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }
		if (!($ndmpid = $this->_request->getParam(NDMPID))) {
			return (null);
        }
		$res = $model->getResultOne($ndmpid, $context);
		
		if (!is_array($res)) $res = array($res);
		
        foreach ($res as $key => $val) {
	    	if ($context) {
    	    	$data = $res[$key]->param3->item;
        	} else {
            	$data = $res[$key]->param2->item;
	        }
    	    if ($data) break ;
        }
		$res = array();
		$j = 0;
		for ($i = 0; isset($data[$i]); $i++) {
			foreach ($data[$i] as $key => $val) {
				if ($key == 'BUTYPE') {
					$res[$val] = $val;
					$j++;
				}
			}
		}
        return $res;
    }

    public function jsonGetAllBUTYPEAction()
    {
        $res = $this->getAllBUTYPE();

        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
}

?>
