<?php

require_once 'ArkeiaAction.php';

define('CSET_CLASSID_WE', 1);
define('CSET_CLASSID_EE', 2);
define('CSET_CLASSID_EA', 3);
define('CSET_CLASSID_SA', 4);
define('CSET_CLASSID_ME', 5);
define('CSET_CLASSID_UTF', 6);
define('CSET_CLASSID_SHORTLIST', 7);

class NewnavigatorController extends ArkeiaAction {
	public function jsonNavigateAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			if(substr($path, 0, 4) != 'clr:') {
				$path = base64_decode(urldecode($path));
			} else {
				$path = substr($path, 4);
			}
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');
		$data = $model->listDir(1, $path, $plist, $context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextNavigateAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonRstNavigateAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			$path = base64_decode(urldecode($path));
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');
		$data = $model->listDir(2, $path, $plist, $context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res, true);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextRstNavigateAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res, true);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonVmhostRstNavigateAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			$path = base64_decode(urldecode($path));
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');
		$data = $model->vmHostListDir($path, $plist, $context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res, true);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextVmhostRstNavigateAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res, true);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonNavigateVstCTAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			if(substr($path, 0, 4) != 'clr:') {
				$path = base64_decode(urldecode($path));
			} else {
				$path = substr($path, 4);
			}
		}
		if($path == ':') {
			$data = $model->listRootVstCTDir($context);
		} else {
			$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11', 'PLUG_NAV_MODE' => 'CONTAINER');
			$data = $model->listDir(1, $path, $plist, $context);
		}
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextNavigateVstCTAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonNavigateVstCPAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			if(substr($path, 0, 4) != 'clr:') {
				$path = base64_decode(urldecode($path));
			} else {
				$path = substr($path, 4);
			}
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11', 'PLUG_NAV_MODE' => 'COMPUTER');
		$data = $model->listDir(1, $path, $plist, $context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextNavigateVstCPAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonNavigateVstPLAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$path = $_REQUEST['PATH'];
		if(strtolower($path) == 'root') {
			$path = ':';
		} else {
			if(substr($path, 0, 4) != 'clr:') {
				$path = base64_decode(urldecode($path));
			} else {
				$path = substr($path, 4);
			}
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11', 'PLUG_NAV_MODE' => 'POOL');
		$data = $model->listDir(1, $path, $plist, $context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonGetNextNavigateVstPLAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseNavigate($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	private function parseNavigate($res, $isdb=false) {
		$dir_type = array('d', 'D', 'p', 'h', 'v', 'n', 'm');
		$dirs = array();
		$rest = array();
		if(isset($_SESSION['charset'])) {
			$charset = $_SESSION['charset'];
		} else {
			$charset = 'UTF-8';
		}
		$tmp = arkphp_conv_charset($charset, $tmp1);
		foreach ($res as $appid=>$data) {
			if (isset($res[$appid]['PARAM2'])) {
				if (!is_array($res[$appid]['PARAM2'])) {
					$res[$appid]['PARAM2'] = array($res[$appid]['PARAM2']);
				}
				foreach ($res[$appid]['PARAM2'] as $key=>$val) {
					if (isset($res[$appid]['PARAM2'][$key]->item)) {
						if(!is_array($res[$appid]['PARAM2'][$key]->item)) {
							$res[$appid]['PARAM2'][$key]->item = array($res[$appid]['PARAM2'][$key]->item);
						}
						foreach($res[$appid]['PARAM2'][$key]->item as $subkey=>$subval) {
							if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->NOM)) {
								$res[$appid]['PARAM2'][$key]->item[$subkey]->NOM = arkphp_conv_charset($charset, $res[$appid]['PARAM2'][$key]->item[$subkey]->NOM);
								$limit = 10;
								$res[$appid]['PARAM2'][$key]->item[$subkey]->SHORTNOM = ((strlen(($res[$appid]['PARAM2'][$key]->item[$subkey]->NOM)) > ($limit+1))?substr(($res[$appid]['PARAM2'][$key]->item[$subkey]->NOM), 0, $limit).'...':($res[$appid]['PARAM2'][$key]->item[$subkey]->NOM));
							}
							if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->FULLNAME)) {
								if(isset($_POST['FORCE_PLUGIN']) && isset($res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR) && $res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR == 'h') {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->FULLNAME .= '!' . $_POST['FORCE_PLUGIN'];
								}
								$res[$appid]['PARAM2'][$key]->item[$subkey]->FULLPATH = arkphp_conv_charset($charset, $res[$appid]['PARAM2'][$key]->item[$subkey]->FULLNAME);
								$res[$appid]['PARAM2'][$key]->item[$subkey]->FULLNAME = urlencode(base64_encode($res[$appid]['PARAM2'][$key]->item[$subkey]->FULLNAME));
							}
							if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR) && $res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR == 'h') {
								if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->OSNAME)) {
									if(preg_match('`windows`i', $res[$appid]['PARAM2'][$key]->item[$subkey]->OSNAME)) {
										$res[$appid]['PARAM2'][$key]->item[$subkey]->OSFAMILLY = 'WINDOWS';
									} else {
										$res[$appid]['PARAM2'][$key]->item[$subkey]->OSFAMILLY = 'UNIX';
									}
								} else {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->OSFAMILLY = 'UNKNOWN';
								}
							}
							if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR)) {
								if(in_array($res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR, $dir_type)) {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->BROWSEABLE = true;
								}
								if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->OBJ_TYPE)) {
									switch($res[$appid]['PARAM2'][$key]->item[$subkey]->OBJ_TYPE) {
										case 'MSSQL':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'mssql';
										break;
										case 'MSEXCHANGE':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'exchange';
										break;
										case 'MSSHAREPOINT':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'sharepoint';
										break;
										case 'VirtualMachine':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstvm';
										break;
										case 'Datacenter':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstdatacenter';
										break;
										case 'vSphere':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vsthost';
										break;
										case 'VirtualApp':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstvapp';
										break;
										case 'ResourcePool':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstpool';
										break;
										case 'VirtualDisk':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstdisk';
										break;
										case 'Host':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstvmhost';
										break;
										case 'Cluster':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstcluster';
										break;
										case 'Folder':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstfolder';
										break;
										case 'VmFolder':
											$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'vstvmfolder';
										break;
									}
								}
								if(!isset($res[$appid]['PARAM2'][$key]->item[$subkey]->ICON)) {
									switch($res[$appid]['PARAM2'][$key]->item[$subkey]->ISDIR) {
										case 'h':
											$icon = 'machine';
										break;
										case 'p':
											$icon = 'plugin';
										break;
										case 'v':
											$icon = 'filesystem';
										break;
										case 'D':
											$icon = 'symfolder';
										break;
										case 'S':
											$icon = 'symfile';
										break;
										case 'd':
											$icon = 'folder';
										break;
										case 's':
										default:
											$icon = 'file';
										break;
									}
									$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = $icon;
								}
								$cur = $res[$appid]['PARAM2'][$key]->item[$subkey];
								if(isset($cur->BKDATE) && $cur->BKDATE && $cur->BKDATE != '') {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->BKDATE_DISP = $this->lang['month_short_'. date('m', $cur->BKDATE)].date(' d Y H:i', $cur->BKDATE);
								} else {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->BKDATE_DISP = '';
								}
								if(isset($cur->FSIZE)) {
									if($isdb) {
										$cur->FSIZE = hexdec($cur->FSIZE);
									}
									$res[$appid]['PARAM2'][$key]->item[$subkey]->FSIZE = $cur->FSIZE;
								} else {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->FSIZE = '';
								}
								if(isset($cur->MDATE)) {
									$cur->MDATE = $this->lang['month_short_'. date('m', $cur->MDATE)].date(' d Y H:i', $cur->MDATE);
									$res[$appid]['PARAM2'][$key]->item[$subkey]->MDATE = $cur->MDATE;
								} else {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->MDATE = '';
								}
								if(isset($cur->MODE)) {
									$cur->MODE = $this->getMode($cur->MODE);
									$res[$appid]['PARAM2'][$key]->item[$subkey]->MODE = $cur->MODE;
									$res[$appid]['PARAM2'][$key]->item[$subkey]->FILEINFO = $cur->MODE.' '.$cur->UID.'/'.$cur->GID.' '.$cur->FSIZE.' '.$cur->MDATE;
								} else {
									$res[$appid]['PARAM2'][$key]->item[$subkey]->FILEINFO = '';
								}
							} else {
								$res[$appid]['PARAM2'][$key]->item[$subkey]->ICON = 'file';
							}
							if(isset($res[$appid]['PARAM2'][$key]->item[$subkey]->BROWSEABLE)) {
								array_push($dirs, $res[$appid]['PARAM2'][$key]->item[$subkey]);
							} else {
								array_push($rest, $res[$appid]['PARAM2'][$key]->item[$subkey]);
							}
						}
						break;
						break;
					}
				}
			}
		}
		usort($dirs, array($this, 'sortNavigate'));
		usort($rest, array($this, 'sortNavigate'));
		foreach($rest as $val) {
			array_push($dirs, $val);
		}
		$res[$appid]['PARAM2'][$key]->item = $dirs;
		return $res;
	}
	private function sortNavigate($a, $b) {
		if(strtolower($a->NOM) == strtolower($b->NOM)) {
			return 0;
		} else {
			return (strtolower($a->NOM) < strtolower($b->NOM)) ? -1 : +1;
		}
	}
	private function ListCharsetTable($tblid=null) {
		if(!is_null) {
			$res = arkphp_get_charset_table($tblid);
		} else {
			$tmp = arkphp_get_charset_table();
			$res = array();
			$res['HEADER'] = array();
			if(isset($_SESSION['charset'])) {
				array_push($res['HEADER'], 'Current: ' . $_SESSION['charset']);
			} else {
				array_push($res['HEADER'], 'Current: UTF-8');
			}
			$res['MORE_ENCODINGS'] = array();
			$res['MORE_ENCODINGS']['WE'] = $tmp[CSET_CLASSID_WE];
			$res['MORE_ENCODINGS']['EE'] = $tmp[CSET_CLASSID_EE];
			$res['MORE_ENCODINGS']['EA'] = $tmp[CSET_CLASSID_EA];
			$res['MORE_ENCODINGS']['SA'] = $tmp[CSET_CLASSID_SA];
			$res['MORE_ENCODINGS']['ME'] = $tmp[CSET_CLASSID_ME];
			$res['SHORTLIST'] = $tmp[CSET_CLASSID_SHORTLIST];
		}
		return $res;
	}
	public function jsonSetCharsetAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['charset'])) {
			$charset = $params['charset'];
		} else {
			$charset = 'UTF-8';
		}
		$_SESSION['charset'] = $charset;
		$finalres = array();
		$finalres['local'] = array();
		$finalres['local']['sessnum'] = array(); $finalres['local']['sessnum'][0] = -1;
		$finalres['local']['transnum'] = array(); $finalres['local']['transnum'][0] = -1;
		$finalres['local']['STATUS'] = array(); $finalres['local']['STATUS'][0] = '0';
		$finalres['local']['MESSAGE'] = array(); $finalres['local']['MESSAGE'][0] = date('Y').'/'.date('m').'/'.date('d').' '.date('H').':'.date('i').':'.date('s').' I99999999 02ARKPHP_SET_CHARSET_TABLE: You have successfully set the charset to \''.$charset.'\'!';
		$finalres['local']['PARAM2'] = array(); $finalres['local']['PARAM2'][0] = null;
		$finalres['local']['PARAM3'] = array(); $finalres['local']['PARAM3'][0] = null;
		$finalres['local']['LAST'] = array(); $finalres['local']['LAST'][0] = 1;
		$result = Zend_Json::encode($finalres);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonListCharsetTableAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();
		if(isset($params['tblid'])) {
			$res = $this->ListCharsetTable($params['tblid']);
		} else {
			$res = $this->ListCharsetTable();
		}
		$finalres = array();
		$finalres['local'] = array();
		$finalres['local']['sessnum'] = array(); $finalres['local']['sessnum'][0] = -1;
		$finalres['local']['transnum'] = array(); $finalres['local']['transnum'][0] = -1;
		$finalres['local']['STATUS'] = array(); $finalres['local']['STATUS'][0] = '0';
		$finalres['local']['MESSAGE'] = array(); $finalres['local']['MESSAGE'][0] = date('Y').'/'.date('m').'/'.date('d').' '.date('H').':'.date('i').':'.date('s').' I99999999 02ARKPHP_GET_CHARSET_TABLE: You have successfully loaded the list of Charsets Tables!';
		$finalres['local']['PARAM2'] = array(); $finalres['local']['PARAM2'][0] = array(); $finalres['local']['PARAM2'][0]['item'] = array(); $finalres['local']['PARAM2'][0]['item'][0] = $res;
		$finalres['local']['PARAM3'] = array(); $finalres['local']['PARAM3'][0] = null;
		$finalres['local']['LAST'] = array(); $finalres['local']['LAST'][0] = 1;
		$result = Zend_Json::encode($finalres);
		$this->getResponse()->appendBody($result);
		return;
	}
	private function getMode($mode) {
		if (($mode & 0xC000) == 0xC000) { // Socket
			$info = 's';
		} elseif (($mode & 0xA000) == 0xA000) { // Symbolic Link
			$info = 'l';
		} elseif (($mode & 0x8000) == 0x8000) { // Regular
			$info = '-';
		} elseif (($mode & 0x6000) == 0x6000) { // Block special
			$info = 'b';
		} elseif (($mode & 0x4000) == 0x4000) { // Directory
			$info = 'd';
		} elseif (($mode & 0x2000) == 0x2000) { // Character special
			$info = 'c';
		} elseif (($mode & 0x1000) == 0x1000) { // FIFO pipe
			$info = 'p';
		} else { // Unknown
			$info = 'u';
		}
		// Owner
		$info .= (($mode & 0x0100) ? 'r' : '-');
		$info .= (($mode & 0x0080) ? 'w' : '-');
		$info .= (($mode & 0x0040) ? (($mode & 0x0800) ? 's' : 'x' ) : (($mode & 0x0800) ? 'S' : '-'));
		// Group
		$info .= (($mode & 0x0020) ? 'r' : '-'); 
		$info .= (($mode & 0x0010) ? 'w' : '-');
		$info .= (($mode & 0x0008) ? (($mode & 0x0400) ? 's' : 'x' ) : (($mode & 0x0400) ? 'S' : '-'));
		// World
		$info .= (($mode & 0x0004) ? 'r' : '-');
		$info .= (($mode & 0x0002) ? 'w' : '-');
		$info .= (($mode & 0x0001) ? (($mode & 0x0200) ? 't' : 'x' ) : (($mode & 0x0200) ? 'T' : '-'));
		return $info;
	}
}
