<?php

require_once 'ArkeiaAction.php';

 define('REPORT_GET_ALL', 0);
 define('REPORT_GET_BKP', 1);
define('REPORT_GET_D2T', 2);
define('REPORT_GET_RST', 3);
define('REPORT_GET_REP', 4);

class ReportController extends ArkeiaAction
{
	/* New way */
    public function jsonGetResultOneProfileAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
	$ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        list($id, $context) = $this->_getIdContext($array_context);
	$result = $model->reportListProfOne($id);
        $res = $this->_get_result($result, $context);

	foreach ($res as $appid=>$data) {
		if (isset($data['PARAM2'])) {
			if (!is_array($data['PARAM2'])) {
				$data['PARAM2'] = array($data['PARAM2']);
			}
			foreach ($data['PARAM2'] as $key=>$val) {
				if ($data['PARAM2'][$key]->NAME == 
				    'DEFAULT_BKP_REPORT_PROFILE' || 
				    $data['PARAM2'][$key]->NAME == 
				    'DEFAULT_D2T_REPORT_PROFILE') {
					$data['PARAM2'][$key]->NAME = 
						$this->lang['report_profile_default_profile'];
				}
			}
		}
	}

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
    public function profileCancelAction() {
	    switch ($_SESSION['report_jobtype']) {
	    case REPORT_GET_D2T:
		    return ($this->reportd2tAction());
	    case REPORT_GET_RST:
		    return ($this->reportrestorationAction());
	    case REPORT_GET_REP:
		    return ($this->reportreplicationAction());
	    case REPORT_GET_BKP:
	    default:
		    return ($this->reportbackupAction());
	    }
    }
    public function profileAddScreenAction() {
	    switch ($_SESSION['report_jobtype']) {
	    case REPORT_GET_D2T:
		    $this->displayFromScreenIni('profileaddd2t');
		    break ;
	    case REPORT_GET_RST:
		    $this->displayFromScreenIni('profileaddrst');
		    break ;
	    case REPORT_GET_REP:
		    $this->displayFromScreenIni('profileaddrep');
		    break ;
	    case REPORT_GET_BKP:
	    default:
		    $this->displayFromScreenIni('profileaddbkp');
		    break ;
	    }
    }
    public function profileModifyScreenAction() {
	    $this->view->profile_id = $_POST['APPID_REPROFID'];
	    switch ($_SESSION['report_jobtype']) {
	    case REPORT_GET_D2T:
		    $res = $this->displayFromScreenIni('profilemodifyd2t', FALSE);
		    break ;
	    case REPORT_GET_RST:
		    $res = $this->displayFromScreenIni('profilemodifyrst', FALSE);
		    break ;
	    case REPORT_GET_REP:
		    $res = $this->displayFromScreenIni('profilemodifyrep', FALSE);
		    break ;
	    case REPORT_GET_BKP:
	    default:
		    $res = $this->displayFromScreenIni('profilemodifybkp', FALSE);
		    break ;
	    }
	    $this->_render_json_view($res);
	    return ;
    }
    public function profileAddAction() {
	    $this->listProfilesFiltersAction();
	    $this->view->profile_screen = 'add';
	    
	    //Default values
	    switch ($_SESSION['report_jobtype']) {
	    case REPORT_GET_D2T:
		    $this->view->default_columns = array(0, 1, 2, 3, 4, 7, 12);
		    break ;
	    case REPORT_GET_RST:
		    $this->view->default_columns = array(0, 1, 2, 3, 6, 9);
		    break ;
	    case REPORT_GET_REP:
		    $this->view->default_columns = array(0, 1, 2, 3, 7, 8);
		    break ;
	    case REPORT_GET_BKP:
		    $this->view->default_columns = array(0, 1, 2, 4, 5, 8, 13);
		    break ;
	    default:
		    break ;
	    }

	    echo $this->view->render('report/showreportsprofile.phtml');
    }
    public function profileModifyAction() {
	    $profile_id = split('_', $_GET['profile_id']);
	    $profile_id = $profile_id[1];
	    $this->listProfileOneAction($profile_id);
	    $this->listProfilesFiltersAction();
	    $this->view->profile_screen = 'modify';
	    echo $this->view->render('report/showreportsprofile.phtml');
    }
    public function jsonReportProfileCommitAction() {
	    $ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
	    $array_context = $this->view->context;
	    list($id, $context) = $this->_getIdContext($array_context);
	    $idname = $ctrlcfg->id;
	    $params = $this->_request->getPost();

	    $filters = array();
	    $columns = array();
	    
	    foreach ($params as $prop=>$val) {
		    //Filters
		    if (!strncmp($prop, 'value_static_', 13)) {
			    $prop = str_replace('value_static_', '', $prop);
			    $tmp = split('_', $prop);
			    $f_type = $tmp[0];
			    $filter = $tmp[1];
			    unset($tmp);
			    if ($f_type == 'int' && !is_numeric($val)) {
				    continue ;
			    }
			    $prop = str_replace($f_type.'_'.$filter.'_', '', $prop);
			    if (isset($params['ENABLED_'.$filter]) &&
				$params['ENABLED_'.$filter] == '1') {
				    $filters[$filter][$prop] = $val;
			    }
		    }
		    if (!strncmp($prop, 'value_multi_', 12)) {
			    $prop = str_replace('value_multi_', '', $prop);
			    $tmp = split('_', $prop);
			    $num_multi = $tmp[0];
			    $f_type = $tmp[1];
			    $filter = $tmp[2];
			    unset($tmp);
			    if ($f_type == 'int' && !is_numeric($val)) {
				    continue ;
			    }
			    $prop = str_replace($num_multi.'_'.$f_type.'_'.$filter.'_', '', $prop);
			    if (isset($params['ENABLED_'.$filter]) &&
				$params['ENABLED_'.$filter] == '1') {
				    $filters[$filter][$prop][] = $val;
			    }
		    }
		    if (!strncmp($prop, 'value_dynamic_', 14)) {
			    $prop = str_replace('value_dynamic_', '', $prop);
			    $tmp = split('_', $prop);
			    $f_type = $tmp[0];
			    $f_value = $tmp[1];
			    unset($tmp);
			    if ($f_type == 'INT' && !is_numeric($val)) {
				    continue ;
			    }
			    $prop = str_replace($f_type.'_'.$f_value.'_', '', $prop);
			    if (isset($params['ENABLED_'.$prop]) &&
				$params['ENABLED_'.$prop] == '1') {
				    $filters[$prop][$f_value] = $val;
			    }
		    }
		    // Columns
		    if (!strncmp($prop, 'profile_selected_', 17)) {
			    $prop = str_replace('profile_selected_', '', $prop);
			    if (strstr($prop, '_order')) {
				    $prop = str_replace('_order', '', $prop);
				    if (isset($params['profile_selected_'.$prop.'_checkbox']) &&
					$params['profile_selected_'.$prop.'_checkbox'] == '1') {
					    $columns[$val] = $prop;
				    }
			    }
		    }
	    }

	    if (!count($columns)) {
		    $res = $this->_set_error_message($this->lang['report_profile_column_required']);
		    $result = Zend_Json::encode($res);
		    $this->getResponse()->appendBody($result);
		    return ;
	    }

	    $tmp = array();
	    ksort($columns);
	    $i = 0;
	    foreach ((array)$columns as $num=>$val) {
		    $tmp['MAIN_PROP_'.$i] = $val;
		    $i++;
	    }

	    $columns = $tmp;
	    
	    if (isset($params['REPROFID'])) {
		    $columns['REPROFID'] = $params['REPROFID'];
	    }
	    $name = trim($params['NAME']);
	    if (!isset($params['NAME']) || empty($params['NAME']) ||
		empty($name)) {
		    $res = $this->_set_error_message($this->lang['report_profile_name_required']);
		    $result = Zend_Json::encode($res);
		    $this->getResponse()->appendBody($result);
		    return ;
	    }
	    $columns['NAME'] = $params['NAME'];
	    $columns['REPROF_TYPE'] = $params['REPROF_TYPE'];
	    $columns['NB_MAIN_PROP'] = $i;
	    if (isset($params['COMMENT']) && !empty($params['COMMENT'])) {
		    $columns['COMMENT'] = $params['COMMENT'];
	    }

	    //Add filters to columns array

	    $i = 0;
	    foreach ($filters as $f_num=>$f_val) {
		    $columns[$i]['FILTER'] = $f_num;
		    foreach ($filters[$f_num] as $prop=>$val) {
			    if (!empty($val) || $val == '0') {
				    if (is_array($val)) {
					    $is_empty = true;
					    foreach ($val as $val_array) {
						    if (!empty($val_array) || $val_array == '0') {
							    $is_empty = false;
							    break ;
						    }
					    }
					    if ($is_empty == true) {
						    continue ;
					    }
				    }
				    if (strstr($prop, "DATE") != false) {
					    $date = split('-', $val);
					    $val = mktime(0, 0, 0, (int)$date[1], (int)$date[2], (int)$date[0]);
				    }
				    $columns[$i][$prop] = $val;
				    if (!isset($columns[$i]['ENABLED'])) {
					    $columns[$i]['ENABLED'] = '1';
				    }
			    }
		    }
		    $i++;
	    }

	    if (isset($columns['REPROFID'])) {
		    $data = $model->profileModifyObject($columns, $context);
	    }
	    else {
		    $data = $model->profileAddObject($columns, $context);
	    }
 	    $res = $this->_get_result($data, $context);
	    
 	    $result = Zend_Json::encode($res);
 	    $this->getResponse()->appendBody($result);
	    
	    return;
    }
    public function profilesAction()
    {
	    switch ($_SESSION['report_jobtype']) {
	    case REPORT_GET_D2T:
		    $this->displayFromScreenIni('profilesd2t');
		    break ;
	    case REPORT_GET_RST:
		    $this->displayFromScreenIni('profilesrst');
		    break ;
	    case REPORT_GET_REP:
		    $this->displayFromScreenIni('profilesrep');
		    break ;
	    case REPORT_GET_BKP:
	    default:
		    $this->displayFromScreenIni('profilesbkp');
		    break ;
	    }
    }
    public function listProfilesFiltersAction() {
	    if (isset($_SESSION['report_jobtype'])) {
		    $report_jobtype = $_SESSION['report_jobtype'];
	    }
	    else {
		    $report_jobtype = REPORT_GET_BKP;
	    }

	    if (isset($_SESSION['allcolumnres'][$report_jobtype]) &&
		isset($_SESSION['allprofileres'][$report_jobtype])) {
		    return ;
	    }

	    $ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
	    $array_context = $this->_getContext();
	    $tmp = $model->reportListProfFilters($report_jobtype, $array_context);
	    $tmp = $this->_get_result($tmp);
	    $res = array();
	    foreach($tmp as $appid=>$data) {
		    if(isset($data['PARAM2'])) {
			    if(!is_array($data['PARAM2'])) {
				    $data['PARAM2'] = array($data['PARAM2']);
			    }
			    foreach($data['PARAM2'] as $key=>$val) {
				    if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
					    continue;
				    }
				    foreach((array)$data['PARAM2'][$key] as $prop=>$val) {
					    if($prop != 'item' && preg_match('`^MAIN_PROP_(\d+)$`', $prop, $reg)) {
						    $resultcolumn[$reg[1]] = $val;
					    }
					    if ($prop == 'COMMENT') {
						    $this->view->profile_comment = $val;
					    }
				    }
				    ksort($resultcolumn);
				    if(!is_array($data['PARAM2'][$key]->item)) {
					    $data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
				    }
				    foreach((array)$data['PARAM2'][$key]->item as $num=>$val) {
					    $filter = array();  
					    foreach((array)$val as $prop=>$propval) {
						    $filter[$prop] = $propval;
					    }
					    array_push($res, $filter);
				    }
			    }
		    }
	    }
	    $_SESSION['allcolumnres'][$report_jobtype] = $resultcolumn;
	    $_SESSION['allprofileres'][$report_jobtype] = $res;
    }
    public function jsonListProfilesAction() {
	    if (isset($_SESSION['report_jobtype'])) {
		    $report_jobtype = $_SESSION['report_jobtype'];
	    }
	    else {
		    $report_jobtype = REPORT_GET_BKP;
	    }
	    $ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
	    $array_context = $this->_getContext();
	    $tmp = $model->reportListProfLoad($report_jobtype, $array_context);
	    $tmp = $this->_get_result($tmp);

	    foreach ($tmp as $appid=>$data) {
		    if (isset($data['PARAM2'])) {
			    if (!is_array($data['PARAM2'])) {
				    $data['PARAM2'] = array($data['PARAM2']);
			    }
			    foreach ($data['PARAM2'] as $key=>$val) {
				    if (!is_array($data['PARAM2'][$key]->item)) {
					    $data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
				    }
				    foreach ((array)$data['PARAM2'][$key]->item as $num=>$val) {
					    if ($data['PARAM2'][$key]->item[$num]->NAME == 
						'DEFAULT_BKP_REPORT_PROFILE' || 
						$data['PARAM2'][$key]->item[$num]->NAME == 
						'DEFAULT_D2T_REPORT_PROFILE') {
						    $data['PARAM2'][$key]->item[$num]->NAME = 
							    $this->lang['report_profile_default_profile'];
					    }
				    }
			    }
		    }
	    }
	    
	    $result = Zend_Json::encode($tmp);
	    $this->getResponse()->appendBody($result);
	    return ;
    }
    public function listProfileOneAction($id = false) {
	    $ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
	    $array_context = $this->_getContext();
	    if ($id == false) {
		    $id = $_GET['profile_id'];
	    }
	    $tmp = $model->reportListProfOne($id);
	    $tmp = $this->_get_result($tmp);
	    $res = array();
	    foreach($tmp as $appid=>$data) {
		    if(isset($data['PARAM2'])) {
			    if(!is_array($data['PARAM2'])) {
				    $data['PARAM2'] = array($data['PARAM2']);
			    }
			    foreach($data['PARAM2'] as $key=>$val) {
				    if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
					    continue;
				    }
				    foreach((array)$data['PARAM2'][$key] as $prop=>$val) {
					    if($prop != 'item' && preg_match('`^MAIN_PROP_(\d+)$`', $prop, $reg)) {
						    $resultcolumn[$reg[1]] = $val;
					    }
					    if ($prop == 'NAME') {
						    $this->view->profile_name = $val;
					    }
					    if ($prop == 'COMMENT') {
						    $this->view->profile_comment = $val;
					    }
				    }
				    ksort($resultcolumn);
				    if(!is_array($data['PARAM2'][$key]->item)) {
					    $data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
				    }
				    foreach((array)$data['PARAM2'][$key]->item as $num=>$val) {
					    $filter = array();  
					    foreach((array)$val as $prop=>$propval) {
						    if (strstr($prop, 'DATE') != false) {
							    $propval = date('Y-m-d', $propval);
						    }
						    $filter[$prop] = $propval;
					    }
					    array_push($res, $filter);
				    }
			    }
		    }
	    }
	    $this->view->columnres = $resultcolumn;
	    $this->view->profileres = $res;
	    $this->view->profile_id = $id;
	    $this->listProfilesFiltersAction();
    }
    public function profilesResultsAction() {
	    $this->listProfileOneAction();
	    echo $this->view->render('report/showreportsprofile.phtml');
    }
/* backup */
	//listing
	public function reportbackupAction() {
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->view->default_profileid = '2d';
		$this->jsonReportListProf(REPORT_GET_BKP);
	        $_SESSION['report_jobtype'] = REPORT_GET_BKP;
		$this->view->has2level = true;
		$this->view->reportaction = 'backupresult';
		$this->displayFromScreenIni('reportbackup');
	}
	//listing graph
	public function reportbackupgraphAction() {
		if(isset($_SESSION['reportlastsvpks'])) {
			$_SESSION['reportlastsvpks'] = null;
			unset($_SESSION['reportlastsvpks']);
		}
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->view->default_profileid = '2d';
		$this->jsonReportListProf(REPORT_GET_BKP);
		$this->view->reportaction = 'backupgraphresult';
		$this->displayFromScreenIni('reportbackupgraph');
	}
	//listing result
	public function backupresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->view->default_profileid = '2d';
		$this->view->has2level = true;
		$this->jsonReportListLog(REPORT_GET_BKP);
		$this->view->monitor_controller = 'backup';
		$this->view->monitor_action = 'jsonShowBackup';
		$this->view->monitor_type = 'BKP';
		$this->view->detailaction = 'backupresultdetail';
		$this->view->syntheticaction = 'backupresultsynthetic';
		echo $this->view->render('report/showreports.phtml');
	}
	//listing graph result
	public function backupgraphresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->view->default_profileid = '2d';
		$this->backupGraphGetData();
		echo $this->view->render('report/showreportsgraph.phtml');
	}
	//listing detail
	public function backupresultdetailAction() {
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->jsonReportListOneDetailLog(REPORT_GET_BKP, $_GET['JOBID']);
		$this->view->detailaction = 'backupresultdetail';
		echo $this->view->render('report/showreportsdetail.phtml');
	}
	//listing synthetic
	public function backupresultsyntheticAction() {
		$this->view->JOB_TYPE = REPORT_GET_BKP;
		$this->jsonReportListOneSyntheticLog(REPORT_GET_BKP, $_GET['JOBID']);
		echo $this->view->render('report/showreportssynthetic.phtml');
	}
	//listing synthetic download
	public function backupresultsyntheticDownloadAction() {
		$tmppath = dirname(__FILE__) . '/../../tmp';
		$file = $tmppath . '/lastreportdetail';
		if(file_exists($file)) {
			$taille=filesize($file);
			header('Content-Type: application/force-download; name=lastreportdetail.txt');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.$taille);
			header('Content-Disposition: attachment; filename=lastreportdetail.txt');
			header('Expires: 0');
			header('Cache-Control: no-cache, must-revalidate');
			header('Pragma: no-cache');
			readfile($file);
			exit();
		}
	}
/* D2T */
	//listing
	public function reportd2tAction() {
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->view->default_profileid = '2e';
		$this->jsonReportListProf(REPORT_GET_D2T);
	        $_SESSION['report_jobtype'] = REPORT_GET_D2T;
		$this->view->has2level = false;
		$this->view->reportaction = 'd2tresult';
		$this->displayFromScreenIni('reportd2t');
	}
	//listing graph
	public function reportd2tgraphAction() {
		if(isset($_SESSION['reportlastsvpks'])) {
			$_SESSION['reportlastsvpks'] = null;
			unset($_SESSION['reportlastsvpks']);
		}
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->view->default_profileid = '2e';
		$this->jsonReportListProf(REPORT_GET_D2T);
		$this->view->reportaction = 'd2tgraphresult';
		$this->displayFromScreenIni('reportd2tgraph');
	}
	//listing result
	public function d2tresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->view->default_profileid = '2e';
		$this->view->has2level = false;
		$this->jsonReportListLog(REPORT_GET_D2T);
		$this->view->monitor_controller = 'backup';
		$this->view->monitor_action = 'jsonShowBackup';
		$this->view->monitor_type = 'D2T';
		$this->view->detailaction = 'd2tresultdetail';
		$this->view->syntheticaction = 'd2tresultsynthetic';
		echo $this->view->render('report/showreports.phtml');
	}
	//listing graph result
	public function d2tgraphresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->view->default_profileid = '2e';
		$this->backupGraphGetData();
		echo $this->view->render('report/showreportsgraph.phtml');
	}
	//listing detail
	public function d2tresultdetailAction() {
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->jsonReportListOneDetailLog(REPORT_GET_D2T, $_GET['JOBID']);
		$this->view->detailaction = 'd2tresultdetail';
		echo $this->view->render('report/showreportsdetail.phtml');
	}
	//listing synthetic
	public function d2tresultsyntheticAction() {
		$this->view->JOB_TYPE = REPORT_GET_D2T;
		$this->jsonReportListOneSyntheticLog(REPORT_GET_D2T, $_GET['JOBID']);
		echo $this->view->render('report/showreportssynthetic.phtml');
	}
	//listing synthetic download
	public function d2tresultsyntheticDownloadAction() {
		$tmppath = dirname(__FILE__) . '/../../tmp';
		$file = $tmppath . '/lastreportdetail';
		if(file_exists($file)) {
			$taille=filesize($file);
			header('Content-Type: application/force-download; name=lastreportdetail.txt');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.$taille);
			header('Content-Disposition: attachment; filename=lastreportdetail.txt');
			header('Expires: 0');
			header('Cache-Control: no-cache, must-revalidate');
			header('Pragma: no-cache');
			readfile($file);
			exit();
		}
	}
/* restoration */
	//listing
	public function reportrestorationAction() {
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->view->default_profileid = '2f';
	        $_SESSION['report_jobtype'] = REPORT_GET_RST;
		$this->jsonReportListProf(REPORT_GET_RST);
		$this->view->has2level = true;
		$this->view->reportaction = 'restoreresult';
		$this->displayFromScreenIni('reportrestoration');
	}
	//listing graph
	public function reportrestorationgraphAction() {
		if(isset($_SESSION['reportlastsvpks'])) {
			$_SESSION['reportlastsvpks'] = null;
			unset($_SESSION['reportlastsvpks']);
		}
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->view->default_profileid = '2f';
		$this->jsonReportListProf(REPORT_GET_RST);
		$this->view->reportaction = 'restorationgraphresult';
		$this->displayFromScreenIni('reportrestorationgraph');
	}
	//listing result
	public function restoreresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->view->default_profileid = '2f';
		$this->view->has2level = true;
		$this->jsonReportListLog(REPORT_GET_RST);
		$this->view->monitor_controller = 'backup';
		$this->view->monitor_action = 'jsonShowBackup';
		$this->view->monitor_type = 'BKP';
		$this->view->detailaction = 'restoreresultdetail';
		$this->view->syntheticaction = 'restoreresultsynthetic';
		echo $this->view->render('report/showreports.phtml');
	}
	//listing graph result
	public function restorationgraphresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->view->default_profileid = '2f';
		$this->backupGraphGetData();
		echo $this->view->render('report/showreportsgraph.phtml');
	}
	//listing detail
	public function restoreresultdetailAction() {
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->jsonReportListOneDetailLog(REPORT_GET_RST, $_GET['JOBID']);
		$this->view->detailaction = 'restoreresultdetail';
		echo $this->view->render('report/showreportsdetail.phtml');
	}
	//listing synthetic
	public function restoreresultsyntheticAction() {
		$this->view->JOB_TYPE = REPORT_GET_RST;
		$this->jsonReportListOneSyntheticLog(REPORT_GET_RST, $_GET['JOBID']);
		echo $this->view->render('report/showreportssynthetic.phtml');
	}
	//listing synthetic download
	public function restoreresultsyntheticDownloadAction() {
		$tmppath = dirname(__FILE__) . '/../../tmp';
		$file = $tmppath . '/lastreportdetail';
		if(file_exists($file)) {
			$taille=filesize($file);
			header('Content-Type: application/force-download; name=lastreportdetail.txt');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.$taille);
			header('Content-Disposition: attachment; filename=lastreportdetail.txt');
			header('Expires: 0');
			header('Cache-Control: no-cache, must-revalidate');
			header('Pragma: no-cache');
			readfile($file);
			exit();
		}
	}
/* replication */
	//listing
	public function reportreplicationAction() {
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->view->default_profileid = '31';
		$this->jsonReportListProf(REPORT_GET_REP);
	        $_SESSION['report_jobtype'] = REPORT_GET_REP;
		$this->view->has2level = true;
		$this->view->reportaction = 'replicationresult';
		$this->displayFromScreenIni('reportreplication');
	}
	//listing graph
	public function reportreplicationgraphAction() {
		if(isset($_SESSION['reportlastsvpks'])) {
			$_SESSION['reportlastsvpks'] = null;
			unset($_SESSION['reportlastsvpks']);
		}
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->view->default_profileid = '31';
		$this->jsonReportListProf(REPORT_GET_REP);
		$this->view->reportaction = 'replicationgraphresult';
		$this->displayFromScreenIni('reportreplicationgraph');
	}
	//listing result
	public function replicationresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->view->default_profileid = '31';
		$this->view->has2level = true;
		$this->jsonReportListLog(REPORT_GET_REP);
		$this->view->monitor_controller = 'backup';
		$this->view->monitor_action = 'jsonShowBackup';
		$this->view->monitor_type = 'REP';
		$this->view->detailaction = 'replicationresultdetail';
		$this->view->syntheticaction = 'replicationresultsynthetic';
		echo $this->view->render('report/showreports.phtml');
	}
	//listing graph result
	public function replicationgraphresultAction() {
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->view->default_profileid = '31';
		$this->backupGraphGetData();
		echo $this->view->render('report/showreportsgraph.phtml');
	}
	//listing detail
	public function replicationresultdetailAction() {
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->jsonReportListOneDetailLog(REPORT_GET_REP, $_GET['JOBID']);
		$this->view->detailaction = 'replicationresultdetail';
		echo $this->view->render('report/showreportsdetail.phtml');
	}
	//listing synthetic
	public function replicationresultsyntheticAction() {
		$this->view->JOB_TYPE = REPORT_GET_REP;
		$this->jsonReportListOneSyntheticLog(REPORT_GET_REP, $_GET['JOBID']);
		echo $this->view->render('report/showreportssynthetic.phtml');
	}
	//listing synthetic download
	public function replicationresultsyntheticDownloadAction() {
		$tmppath = dirname(__FILE__) . '/../../tmp';
		$file = $tmppath . '/lastreportdetail';
		if(file_exists($file)) {
			$taille=filesize($file);
			header('Content-Type: application/force-download; name=lastreportdetail.txt');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.$taille);
			header('Content-Disposition: attachment; filename=lastreportdetail.txt');
			header('Expires: 0');
			header('Cache-Control: no-cache, must-revalidate');
			header('Pragma: no-cache');
			readfile($file);
			exit();
		}
	}
	/* Old way */
    public function backupAction()
    {
        $this->displayFromScreenIni('backup');
    }
    public function restorationAction()
    {
        $this->displayFromScreenIni('restoration');
    }
    public function completeLogAction()
    {
        $this->displayFromScreenIni('completeLog');
    }
    public function driveLogAction()
    {
        $this->displayFromScreenIni('driveLog');
    }
    public function tapeLogAction()
    {
        $this->displayFromScreenIni('tapeLog');
    }
    public function replicationLogAction()
    {
        $this->displayFromScreenIni('replicationLog');
    }
    public function profilesBkpHelpAction()
    {
	    echo $this->view->render('reportprofiles/help_bkp.html');
    }
    public function profilesRstHelpAction()
    {
	    echo $this->view->render('reportprofiles/help_rst.html');
    }
    public function profilesRepHelpAction()
    {
	    echo $this->view->render('reportprofiles/help_rep.html');
    }
    public function profilesD2tHelpAction()
    {
	    echo $this->view->render('reportprofiles/help_d2t.html');
    }
    public function backupHelpAction()
    {
        echo $this->view->render('reportbackup/help.html');
    }
    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }
    public function multisiteHelpAction()
    {
        echo $this->view->render('report/help_multisite.html');
    }
    public function backupmultisiteHelpAction()
    {
        echo $this->view->render('reportbackup/help_multisite.html');
    }
    public function d2tHelpAction()
    {
        echo $this->view->render('reportd2t/help.html');
    }
    public function restorationHelpAction()
    {
        echo $this->view->render('reportrestoration/help.html');
    }
    public function replicationHelpAction()
    {
        echo $this->view->render('reportreplication/help.html');
    }
    public function appliancesStatusAction()
    {
        $this->displayFromScreenIni('appliancesStatus');
    }
    public function alertAction()
    {
        $this->displayFromScreenIni('alert');
    }
    public function alertconfAction()
    {
        $this->displayFromScreenIni('alertconf');
    }
    public function alertraisedlistAction()
    {
        $this->displayFromScreenIni('alertraisedlist');
    }
    public function alertmodifyAction()
    {
        $this->displayFromScreenIni('alertmodify');
    }
    public function mediausageAction()
    {
    	$this->displayFromScreenIni('mediausage');
    }
	/* New way logics */
    public function backupGraphGetData() {
		set_time_limit(60);
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
	$array_context = $this->_getContext();
	$this->view->changeset = '';
	if(isset($_GET['profile'])) {
		$this->view->profile = $_GET['profile'];
	} else {
		$this->view->profile = $this->view->default_profileid;
	}
	$this->view->changeset .= $this->view->profile;
	if(isset($_GET['period'])) {
		$this->view->period = (int)$_GET['period'];
	} else {
		$this->view->period = 0;
	}
	$this->view->changeset .= $this->view->period;
	switch($this->view->period) {
		case 1: //weeks
			$this->view->currentYear = (isset($_GET['currentYear']))?$_GET['currentYear']:date('Y');
			$this->view->currentMonth = (isset($_GET['currentMonth']))?$_GET['currentMonth']:date('n');
			switch(true) {
				case in_array($this->view->currentMonth, array(1, 2, 3)):
					$this->view->month_in = 1;
					$this->view->month_out = 3;
				break;
				case in_array($this->view->currentMonth, array(4, 5, 6)):
					$this->view->month_in = 4;
					$this->view->month_out = 6;
				break;
				case in_array($this->view->currentMonth, array(7, 8, 9)):
					$this->view->month_in = 7;
					$this->view->month_out = 9;
				break;
				case in_array($this->view->currentMonth, array(10, 11, 12)):
					$this->view->month_in = 10;
					$this->view->month_out = 12;
				break;
			}
			$this->view->year_in = date('Y', mktime(23, 59, 59, $this->view->month_in, 1, $this->view->currentYear));
			$this->view->year_out = date('Y', mktime(23, 59, 59, $this->view->month_out, 1, $this->view->currentYear));
			$this->view->day_in = 1;
			$this->view->day_out = date('t', mktime(23, 59, 59, $this->view->month_out , 1, $this->view->year_out));
		break;
		case 2: //months
			$this->view->currentYear = (isset($_GET['currentYear']))?$_GET['currentYear']:date('Y');
			$this->view->currentMonth = (isset($_GET['currentMonth']))?$_GET['currentMonth']:date('n');
			$this->view->year_in = $this->view->currentYear;
			$this->view->year_out = $this->view->currentYear;
			$this->view->month_in = 1;
			$this->view->month_out = 12;
			$this->view->day_in = 1;
			$this->view->day_out = date('t', mktime(23, 59, 59, $this->view->month_out , 1, $this->view->year_out));
		break;
		case 3: //years
			$this->view->currentYear = (isset($_GET['currentYear']))?$_GET['currentYear']:date('Y');
			$this->view->currentMonth = (isset($_GET['currentMonth']))?$_GET['currentMonth']:date('n');
			$this->view->year_in = $this->view->currentYear-10;
			$this->view->year_out = $this->view->currentYear;
			$this->view->month_in = 1;
			$this->view->month_out = 12;
			$this->view->day_in = 1;
			$this->view->day_out = date('t', mktime(23, 59, 59, $this->view->month_out , 1, $this->view->year_out));
		break;
		default:
			$this->view->currentYear = (isset($_GET['currentYear']))?$_GET['currentYear']:date('Y');
			$this->view->currentMonth = (isset($_GET['currentMonth']))?$_GET['currentMonth']:date('n');
			$this->view->year_in = $this->view->currentYear;
			$this->view->year_out = $this->view->currentYear;
			$this->view->month_in = $this->view->currentMonth;
			$this->view->month_out = $this->view->currentMonth;
			$this->view->day_in = 1;
			$this->view->day_out = date('t', mktime(23, 59, 59, $this->view->month_out , 1, $this->view->year_out));
		break;
	}
	$this->view->changeset .= $this->view->year_in . $this->view->year_out . $this->view->month_in . $this->view->month_out . $this->view->day_in . $this->view->day_out;
	if(isset($_GET['currentY'])) {
		$this->view->col = $_GET['currentY'];
	} else {
		$this->view->col = 'SIZE';
	}
	if(isset($_GET['opt'])) {
		$this->view->opt = (int)$_GET['opt'];
	} else {
		$this->view->opt = 0;
	}
	$this->view->svpks = new stdclass;
	$i=0;
	if(isset($_GET['svpks'])) {
		foreach($_SESSION['reportcurrentsvpks'] as $svpknum=>$svpkname) {
			if(!in_array($svpknum, $_GET['svpks'])) {
				$this->view->svpks->{$i} = array('SAVEPACK'=>$svpkname);
				$i++;
			}
		}
	}
		$tmp1 = $model->backupGraphGetData($this->view->profile, mktime(0 , 0 , 0 , $this->view->month_in , $this->view->day_in, $this->view->year_in), mktime(0 , 0 , 0 , $this->view->month_out , $this->view->day_out, $this->view->year_out), $this->view->col, $this->view->opt, $this->view->period, (isset($_GET['refresh']))?1:0, $this->view->svpks, $array_context);
		$tmp1 = $this->_get_result($tmp1);
		if(isset($_GET['debug'])) {
			echo '<pre>';
			echo 'Trans'."\n";
			print_r($tmp1);
			echo '</pre>';
		}
		$tmp2 = array();
		foreach($tmp1 as $appid=>$data) {
			if(isset($data['PARAM2'])) {
				if(!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach($data['PARAM2'] as $key=>$val) {
					if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
						continue;
					}
					if(!isset($data['PARAM2'][$key]->item)) {
						continue;
					}
					if(!is_array($data['PARAM2'][$key]->item)) {
						$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
					}
					if(isset($data['PARAM2'][$key]->MAX_VALUE)) {
						$_SESSION['lastgraphmaxval'] = $data['PARAM2'][$key]->MAX_VALUE;
					}
					$keys = array_keys($data['PARAM2'][$key]->item);
					$ct = count($data['PARAM2'][$key]->item);
					for($i=0; $i<$ct; $i++) {
						if(is_object($data['PARAM2'][$key]->item[$keys[$i]])) {
							$data['PARAM2'][$key]->item[$keys[$i]] = (array)$data['PARAM2'][$key]->item[$keys[$i]];
							if(!isset($data['PARAM2'][$key]->item[$data['PARAM2'][$key]->item[$keys[$i]]['DATE']])) {
								$data['PARAM2'][$key]->item[$data['PARAM2'][$key]->item[$keys[$i]]['DATE']] = array();
							}
							$curdate = $data['PARAM2'][$key]->item[$keys[$i]]['DATE'];
							unset($data['PARAM2'][$key]->item[$keys[$i]]['DATE']);
							array_push($data['PARAM2'][$key]->item[$curdate], $data['PARAM2'][$key]->item[$keys[$i]]);
							unset($data['PARAM2'][$key]->item[$keys[$i]]);
						}
					}
					$tmp2 = $data['PARAM2'][$key]->item;
					break;
				}
			}
		}
		$keys = array_keys($tmp2);
		$ct = count($tmp2);
		for($i=0; $i<$ct; $i++) {
			usort($tmp2[$keys[$i]], array($this, '_graphdatasort'));
		}
		ksort($tmp2);
		$_SESSION['lastgraphdata'] = $tmp2;
		require_once 'Artichow/colorconvert.class.php';
		$colorconvert = new colorconvert;
		$barcolors = $colorconvert->webcolors;
		$barcolorskeys = array_keys($barcolors);
		if(!isset($_SESSION['reportlastsvpks']) || isset($_GET['refresh'])) {
			$_SESSION['reportlastsvpks'] = array();
		} else {
			$ct = count($_SESSION['reportlastsvpks']);
			for($i=0; $i<$ct; $i++) {
				array_pop($barcolorskeys);
			}
		}
		$change = false;
		if(!isset($_SESSION['report_changeset']) || $_SESSION['report_changeset'] != md5($this->view->changeset)) {
			$_SESSION['report_changeset'] = md5($this->view->changeset);
			$change = true;
		}
		if($change) {
			$_SESSION['reportcurrentsvpks'] = array();
		}
		$keys = array_keys($tmp2);
		$ct = count($tmp2);
		for($i=0; $i<$ct; $i++) {
			$subkeys = array_keys($tmp2[$keys[$i]]);
			$subct = count($tmp2[$keys[$i]]);
			for($j=0; $j<$subct; $j++) {
				if(count($barcolorskeys) == 0) {
					$barcolorskeys = array_keys($barcolors);
				}
				if(!in_array($tmp2[$keys[$i]][$subkeys[$j]]['SAVEPACK'], array_keys($_SESSION['reportlastsvpks']))) {
					$col1num = $barcolorskeys[count($barcolorskeys) - 1];
					$_SESSION['reportlastsvpks'][$tmp2[$keys[$i]][$subkeys[$j]]['SAVEPACK']] = array('col1'=>$barcolors[$col1num], 'colnum'=>$col1num);
					array_pop($barcolorskeys);
				}
				if(!in_array($tmp2[$keys[$i]][$subkeys[$j]]['SAVEPACK'], $_SESSION['reportcurrentsvpks'])) {
					array_push($_SESSION['reportcurrentsvpks'], $tmp2[$keys[$i]][$subkeys[$j]]['SAVEPACK']);
				}
			}
		}
		if(isset($_GET['debug'])) {
			echo '<pre>';
			echo 'before'."\n";
			echo 'in: ', $this->view->day_in, '/', $this->view->month_in, '/' , $this->view->year_in, ' week:', date('W',  mktime(0 , 0 , 0 , $this->view->month_in , $this->view->day_in, $this->view->year_in)), "\n";
			echo 'out: ', $this->view->day_out, '/', $this->view->month_out, '/', $this->view->year_out, ' week:', date('W',  mktime(0 , 0 , 0 , $this->view->month_out , $this->view->day_out, $this->view->year_out)), "\n";
			echo 'savepacks'."\n";
			print_r($_SESSION['reportlastsvpks']);
			echo 'after'."\n";
			print_r($_SESSION['lastgraphdata']);
			echo '</pre>';
		}
    }
	private function _graphdatasort($a, $b) {
		$sortcolumn = 'SAVEPACK';
		if ($a[$sortcolumn] == $b[$sortcolumn]) {
			return 0;
		}
		$switch1 = 1;
		$switch2 = -1;
		return ($a[$sortcolumn] < $b[$sortcolumn]) ? $switch1 : $switch2;
	}
	private function stripdata($res) {
		$stripped = false;
		foreach($res as $appid=>$data) {
			if(isset($data['PARAM2'])) {
				if(!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach($data['PARAM2'] as $key=>$val) {
					if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
						continue;
					}
					if(!isset($data['PARAM2'][$key]->item)) {
						continue;
					}
					$res[$appid]['PARAM2'][$key] = null;
				}
			}
		}
		return $res;
	}
	public function jsonReportIndexLogAction() {
		set_time_limit(60);
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
		$_SESSION['report_lastprofileid'] = $_GET['profile'];
		$tmp = $model->reportListLogIndex($_SESSION['report_lastprofileid'], 0, 20, 'START_DATE', 0, 1, 0, null, $array_context);
		$tmp = $this->_get_result($tmp);
		$tmp = $this->stripdata($tmp);
		$result = Zend_Json::encode($tmp);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonReportIndexLogGetNextResultAction() {
		set_time_limit(60);
		require_once 'Zend/Json.php';
        $context = $this->view->context;
        $tmp = $this->_getNext($context);
        $tmp = $this->_get_result($tmp, $this->view->context);
		$tmp = $this->stripdata($tmp);
        $result = Zend_Json::encode($tmp);
        $this->getResponse()->appendBody($result);
        return;
    }
	private function is_ie() {
		if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)) {
			return true;
		} else {
			return false;
		}
	}
	private function makemytime($seconds, $use = null, $zeros = false) {
		$periods = array ('years'=>31556926,'Months'=>2629743,'weeks'=>604800,'days'=>86400,'hours'=>3600,'minutes'=>60,'seconds'=>1);
		$seconds = (float) $seconds;
		foreach ($periods as $period => $value) {
			if ($use && strpos($use, $period[0]) === false) {
				continue;
			}
			$count = floor($seconds / $value);
			if ($count == 0 && !$zeros) {
				continue;
			}
			$segments[strtolower($period)] = $count;
			$seconds = $seconds % $value;
		}
		foreach ($segments as $key => $value) {
			$segment_name = strtolower(substr($key, 0, 1));
			$segment = $value . $segment_name;
			$array[] = $segment;
		}
		$str = implode(' ', $array);
		return $str;
	}
	private function makemysize($size) {
		if((float)$size<100) {
			$res = $size . ' MB';
		} else {
			if(($size % 1024 == 0) ) {
				$res = $size / 1024 . ' GB';
			} else {
				$res = number_format($size / 1024, 2) . ' GB';
			}
		}
		return $res;
	}
	private function maketransform($val, $type) {
		switch($type) {
			case 'time':
				$val = $this->makemytime($val);
			break;
			case 'size':
				$val = $this->makemysize($val);
			break;
			case 'rdate':
				if((int)$val == 1) {
					$val = 'Never';
				} else {
					$val = date('Y/m/d H:i:s', (int)$val);
				}
			break;
		}
		return $val;
	}
	public function jsonReportLoadTreesAction() {
		$result = '';
		if(isset($_GET['num'])) {
			foreach($_SESSION['lastreportdata'][$_GET['num']]['trees'] as $numtree=>$treeview) {
				if(isset($treeview['TREE_STATUS'])) {
					switch($treeview['TREE_STATUS']) {
						case 1:
							$color = 'orange';
						break;
						case 2:
							$color = 'red';
						break;
						default:
							$color = 'green';
					}
				} else {
					if(!in_array($_SESSION['report_jobtype'], array(REPORT_GET_RST, REPORT_GET_REP))) {
						$color = 'green';
					} else {
						$color = 'black';
					}
				}
				$result .= '<tr style="height: '.$mainheight.'px; color: '.$color.'; font-style: italic; font-size: 0.9em;">'."\n";
				foreach($_SESSION['lastreportrestreeviewcolumn'] as $treeheadtitle) {
					$label = '';
					if(!isset($treeview[$treeheadtitle['name']]) || $treeview[$treeheadtitle['name']] == '') {
						$label .= $treeheadtitle['emptylabel'];
					} else {
						if(!$treeheadtitle['transform']) {
							if($treeheadtitle['name'] == 'BKPTYPE') {
								$label .= $this->lang['report_bkptype_' . $treeview[$treeheadtitle['name']]];
							} else {
								$label .= $treeview[$treeheadtitle['name']];
							}
							if(!is_null($treeheadtitle['units'])) {
								$label .= ' ' . $treeheadtitle['units'];
							}
						} else {
							$label .= $this->maketransform($treeview[$treeheadtitle['name']], $treeheadtitle['transform']);
						}
					}
					if(!$this->is_ie()) {
						$width = 'width: 10px;';
					} else {
						$width = '';
					}
					if($treeheadtitle['name'] != 'DATE') {
						$result .= '<td class="contentcell" style="' . $width . 'text-align: '.$treeheadtitle['align'].';"><nobr>'.$label.'</nobr></td>'."\n";
					}
				}
				$result .= '<td></td>'."\n";
				$result .= '</tr>'."\n";
			}
		}
		$tmp = array('local'=>array	(
																'STATUS'=>array('0'),
																'MESSAGE'=>array(null),
																'sessnum'=>array('1'),
																'transnum'=>array('1'),
																'PARAM2'=>array($result),
																'PARAM3'=>array(null),
																'LAST'=>array('1')
																));
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($tmp);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function jsonReportLoadTreesGetNextResultAction() {
		$result = '';
		$tmp = array('local'=>array	(
																'LAST'=>array('1'),
																'STATUS'=>array('0'),
																'MESSAGE'=>array(''),
																'sessnum'=>array('0'),
																'transnum'=>array('0'),
																'PARAM2'=>array($result)
																));
		require_once 'Zend/Json.php';
        $result = Zend_Json::encode($tmp);
        $this->getResponse()->appendBody($result);
        return;
    }
	private function jsonReportListOneDetailLog($reportype, $jobid) {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
		$tmp = $model->reportOneLogLoad($reportype, $jobid, $array_context);
		$this->view->reportres = $this->handleerrormessages($this->_get_result($tmp));
	}

	private function handleerrormessages($res) {
		$url = 'http://www.arkeia.com/errorcodes';
		$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
		if(!file_exists($cachedir . 'errorcodes')) {
			return $res;
		} else {
			if(!file_exists($cachedir . 'errorcodes.lock')) {
				$content = explode("\n", file_get_contents($cachedir . 'errorcodes'));
			} else {
				return $res;
			}
		}
		$list = array();
		for($i=0; $i<count($content); $i++) {
			if(substr($content[$i], 0, 1) != '#') {
				array_push($list, $content[$i]);
			}
		}
		if(is_array($content) && count($content)>0) {
			$keys = array_keys($res);
			$ct = count($keys);
			for($i=0; $i<$ct; $i++) {
				if(isset($res[$keys[$i]]['PARAM2'])) {
					for($j=0; $j<count($res[$keys[$i]]['PARAM2']); $j++) {
						if(is_null($res[$keys[$i]]['PARAM2'][$j]) || !isset($res[$keys[$i]]['PARAM2'][$j]->item)) {
							continue;
						}
						for($k=0; $k<count($res[$keys[$i]]['PARAM2'][$j]->item); $k++) {
							if(preg_match('`^A\s\d{4}/\d{2}/\d{2}\s\d{2}:\d{2}:\d{2}\s(\w)(\d{3})(\d{5})\s[^\s]+\s(.*)$`', $res[$keys[$i]]['PARAM2'][$j]->item[$k]->NAME, $reg)) {
								if(in_array(($reg[1].$reg[2].$reg[3]), $list)) {
									switch(substr(($reg[1].$reg[2].$reg[3]), 0, 1)) {
										case 'W':
											$color = 'orange';
										break;
										case 'E':
											$color = 'red';
										break;
										case 'I':
										default:
											$color = 'green';
										break;
									}
									$res[$keys[$i]]['PARAM2'][$j]->item[$k]->NAME = str_replace($reg[4], '<a style="color: '.$color.';" href="http://wiki.arkeia.com/mediawiki/index.php/'.($reg[1].$this->change3x5to4x4($reg[2].$reg[3])).'" target="_blank">'.$reg[4].'</a>', $res[$keys[$i]]['PARAM2'][$j]->item[$k]->NAME);
								}
							}
						}
					}
				}
			}
		}
		return $res;
	}

	private function change3x5to4x4($num) {
		$section = (string)(int)substr($num, 0, 3);
		$code = (string)(int)substr($num, 3, 5);
		while(strlen($section)<4) {
			$section = '0' . $section;
		}
		while(strlen($code)<4) {
			$code = '0' . $code;
		}
		return $section.$code;
	}

	private function jsonReportListOneSyntheticLog($reportype, $jobid) {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
		$tmp = $model->reportOneSynthLoad($reportype, $jobid, $array_context);
		 $tmp = $this->_get_result($tmp);

		$html = array();

		foreach($tmp as $appid=>$data) {
			if(isset($data['PARAM2'])) {
				if(!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach($data['PARAM2'] as $key=>$val) {
					if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
						continue;
					}
					if(!isset($data['PARAM2'][$key]->item)) {
						continue;
					}
					if(!is_array($data['PARAM2'][$key]->item)) {
						$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
					}
					foreach((array)$data['PARAM2'][$key]->item as $num=>$val) {
						array_push($html, $val->HTML);
					}
				}
			}
		}
		 
		$this->view->reportres = implode("\n", array_reverse($html));
	}
	private function jsonReportListProf($current_profiletype) {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
		$this->view->pofileres = array();
		$tmp = $model->reportListProfLoad($current_profiletype, $array_context);
		$tmp = $this->_get_result($tmp);
		foreach($tmp as $appid=>$data) {
			if(isset($data['PARAM2']) && isset($data['PARAM2'][0]->item)) {
				if(!is_array($data['PARAM2'][0]->item)) {
					$data['PARAM2'][0]->item = array($data['PARAM2'][0]->item);
				}
				foreach($data['PARAM2'][0]->item as $item) {
					array_push($this->view->pofileres, array('id'=>$item->REPROFID, 'name'=>$item->NAME));
				}
			}
		}
		$this->view->profile = $this->view->default_profileid;
	}
	private function jsonReportListLogDataWorker($list) {
		$treeprops = array('TREE_STATUS', 'TREE_DATE', 'TREE_NB_FILES', 'TREE_SIZE', 'TREE_TIME', 'TREE_THROUGHPUT', 'TREE_NB_WARNINGS', 'TREE_NB_ERRORS', 'TREE_PATH');
		$result = array();
		$count = 1;
		$subcount = 1;
		$all = false;
		if($this->view->length == '*') {
			$all = true;
		}
		if(isset($_GET['debug'])) {
			echo '<pre>';
			echo 'before'."\n";
			print_r($list->item);
			echo '</pre>';
		}
		$keys = array_keys($list->item);
		$ct = count($keys);
		for($i=0; $i<$ct; $i++) {
		$list->item[$keys[$i]] = (array)$list->item[$keys[$i]];
		$subtmp = array('vars'=>array(), 'data'=>$list->item[$keys[$i]], 'trees'=>array());
		$subtmp['data']['COUNT'] = $count;
			if(isset($subtmp['data']['JOBTYPE'])) {
				$subtmp['vars']['JOBTYPE'] = $subtmp['data']['JOBTYPE'];
				unset($subtmp['data']['JOBTYPE']);
			}
			if(isset($subtmp['data']['JOBID'])) {
				$subtmp['vars']['JOBID'] = $subtmp['data']['JOBID'];
				unset($subtmp['data']['JOBID']);
			}
			if(isset($subtmp['data']['BKPTYPE'])) {
				switch($subtmp['data']['BKPTYPE']) {
					case 'TOT':
						$subtmp['data']['BKPTYPE'] = 'total';
					break;
					case 'ARCH':
						$subtmp['data']['BKPTYPE'] = 'archive';
					break;
					case 'DIFF':
						$subtmp['data']['BKPTYPE'] = 'differential';
					break;
					case 'INCR':
						$subtmp['data']['BKPTYPE'] = 'incremental';
					break;
				}
				$subtmp['vars']['BKPTYPE'] = $subtmp['data']['BKPTYPE'];
			}
			if(isset($subtmp['data']['REPTYPE'])) {
				switch($subtmp['data']['REPTYPE']) {
					case 'REP':
						$subtmp['data']['BKPTYPE'] = 'replication';
					break;
					case 'REC':
						$subtmp['data']['BKPTYPE'] = 'recovery';
					break;
				}
				$subtmp['vars']['BKPTYPE'] = $subtmp['data']['BKPTYPE'];
			}
			if(isset($subtmp['data']['RSTTYPE'])) {
				switch($subtmp['data']['RSTTYPE']) {
					case 'RST':
						$subtmp['data']['BKPTYPE'] = 'restoration';
					break;
					case 'VRF':
						$subtmp['data']['BKPTYPE'] = 'verification';
					break;
				}
				$subtmp['vars']['BKPTYPE'] = $subtmp['data']['BKPTYPE'];
			}
			if($this->view->showonlytree && isset($subtmp['data']['TREE_STATUS'])) {
				$subtmp['data']['JOB_STATUS'] = $subtmp['data']['TREE_STATUS'];
				unset($subtmp['data']['TREE_STATUS']);
			}
			if(isset($subtmp['data']['JOB_STATUS'])) {
				switch($subtmp['data']['JOB_STATUS']) {
					case 1:
						$subtmp['vars']['COLOR'] = 'orange';
					break;
					case 2:
						$subtmp['vars']['COLOR'] = 'red';
					break;
				}
			} else {
				if($this->view->showonlytree && in_array($_SESSION['report_jobtype'], array(REPORT_GET_RST, REPORT_GET_REP))) {
					$subtmp['vars']['COLOR'] = 'black';
				} else {
					$subtmp['vars']['COLOR'] = 'green';
				}
			}
			if(isset($subtmp['data']['NB_TREES'])) {
				unset($subtmp['data']['NB_TREES']);
			}
			if(!$this->view->showonlytree && $this->view->has2level) {
				$subkeys = array_keys($list->item[$keys[$i]]);
				$subct = count($subkeys);
				for($j=0; $j<$subct; $j++) {
					$tmpprop = explode('_', $subkeys[$j]);
					if($tmpprop[0] == 'TREE') {
						unset($subtmp['data'][$subkeys[$j]]);
						$treenum = $tmpprop[count($tmpprop) - 1];
						if(!isset($subtmp['trees'][((int)$treenum)-1])) {
							$subtmp['trees'][((int)$treenum)-1] = array();
						}
						$exp = explode(',', $list->item[$keys[$i]][$subkeys[$j]]);
						foreach($treeprops as $numprops=>$propsval) {
							$subtmp['trees'][((int)$treenum)-1][$propsval] = $exp[$numprops];
							if($propval != 'PATH') {
								unset($exp[$numprops]);
							} else {
								$exp = array_values($exp);
								if(count($exp) > 0) {
									$path = implode(',', $exp);
								} else {
									$path = $exp[0];
								}
								$subtmp['trees'][((int)$treenum)-1]['PATH'] = $path;
							}
						}
						unset($exp);
						unset($subtmp['data'][$prop]);
						unset($tmpprop);
					}
				}
				ksort($subtmp['trees']);
			}
			array_push($result, $subtmp);
			unset($subtmp);
			$count++;
		}
		if(isset($_GET['debug'])) {
			echo '<pre>';
			echo 'after'."\n";
			print_r($result);
			echo '</pre>';
		}
		return $result;
	}

	private function jsonReportListLogTreeColumnWorker($list) {
		$totals = array();
		$totals['SIZE'] = 0;
		$totals['TIME'] = 0;
		$totals['NB_FILES'] = 0;
		$totals['NB_WARNINGS'] = 0;
		$totals['NB_ERRORS'] = 0;
		if($this->view->showonlytree) {
			$this->view->reportrestotal = $list->TOTAL_NB_ELEM;
			$totals['SIZE'] = $list->SUM_SIZE;
			$totals['TIME'] = $list->SUM_TIME;
			$totals['NB_FILES'] =$list->SUM_NB_FILES;
			$totals['NB_WARNINGS'] = $list->SUM_NB_WARNINGS;
			$totals['NB_ERRORS'] = $list->SUM_NB_ERRORS;
			$this->view->begin = ($list->PAGE_NB - 1) * $this->view->length;
		}
		switch($this->view->JOB_TYPE) {
			case REPORT_GET_RST:
				$resultcolumn = array(
															array('name'=>'TREE_DATE', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left'),
															array('name'=>'TREE_PATH', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left')
														);
			break;
			case REPORT_GET_REP:
				$resultcolumn = array(
															array('name'=>'TREE_DATE', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left'),
															array('name'=>'TREE_TIME', 'total'=>$totals['TIME'], 'emptylabel'=>'-', 'transform'=>'time', 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_SIZE', 'total'=>$totals['SIZE'], 'emptylabel'=>'-', 'transform'=>'size', 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_PATH', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left')
														);
			break;
			default:
				$resultcolumn = array(
															array('name'=>'TREE_DATE', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left'),
															array('name'=>'TREE_TIME', 'total'=>$totals['TIME'], 'emptylabel'=>'-', 'transform'=>'time', 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_SIZE', 'total'=>$totals['SIZE'], 'emptylabel'=>'-', 'transform'=>'size', 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_NB_FILES', 'total'=>$totals['NB_FILES'], 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_NB_ERRORS', 'total'=>$totals['NB_ERRORS'], 'emptylabel'=>'0', 'transform'=>false, 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_NB_WARNINGS', 'total'=>$totals['NB_WARNINGS'], 'emptylabel'=>'0', 'transform'=>false, 'units'=>null, 'align'=>'right'),
															array('name'=>'TREE_PATH', 'total'=>null, 'emptylabel'=>'-', 'transform'=>false, 'units'=>null, 'align'=>'left')
														);
			break;
		}
		return $resultcolumn;
	}

	private function jsonReportListLogColumnWorker($list) {
		$resultcolumn = array();
		$keys = array_keys(get_object_vars($list));
		$ct = count($keys);
		for($i=0; $i<$ct; $i++) {
			if($keys[$i] != 'item' && preg_match('`^MAIN_PROP_(\d+)$`', $keys[$i], $reg)) {
				$resultcolumn[$reg[1]] = $list->{$keys[$i]};
			}
		}
		ksort($resultcolumn);
		$totals = array();
		$this->view->reportrestotal = $list->TOTAL_NB_ELEM;
		$totals['SIZE'] = $list->SUM_SIZE;
		$totals['TIME'] = $list->SUM_TIME;
		$totals['NB_FILES'] =$list->SUM_NB_FILES;
		$totals['NB_WARNINGS'] = $list->SUM_NB_WARNINGS;
		$totals['NB_ERRORS'] = $list->SUM_NB_ERRORS;
		$this->view->begin = ($list->PAGE_NB - 1) * $this->view->length;
		$tmpresult = array();
		$keys = array_keys($resultcolumn);
		$ct = count($keys);
		for($i=0; $i<$ct; $i++) {
			$newrc = array('name'=>$resultcolumn[$keys[$i]], 'total'=>null, 'emptylabel'=>'', 'transform'=>false, 'units'=>null, 'align'=>'center');
			switch($resultcolumn[$keys[$i]]) {
				case 'SIZE':
					$newrc['transform'] = 'size';
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
					$newrc['total'] = $totals['SIZE'];
				break;
				case 'TIME':
					$newrc['transform'] = 'time';
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
					$newrc['total'] = $totals['TIME'];
				break;
				case 'NB_FILES':
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
						$newrc['total'] = $totals['NB_FILES'];
				break;
				case 'NB_WARNINGS':
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
					$newrc['total'] = $totals['NB_WARNINGS'];
				break;
				case 'NB_ERRORS':
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
					$newrc['total'] = $totals['NB_ERRORS'];
				break;
				case 'PER_NAME':
					$newrc['emptylabel'] = '-';
				break;
				case 'PER_LEVEL':
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
				break;
				case 'THROUGHPUT':
					$newrc['transform'] = 'throughput';
					$newrc['emptylabel'] = '-';
					$newrc['align'] = 'right';
				break;
				case 'RDATE':
					$newrc['emptylabel'] = '-';
					$newrc['transform'] = 'rdate';
				break;
				default:
					$newrc['emptylabel'] = 'Unknown';
			}
			array_push($tmpresult, $newrc);
		}
		unset($resultcolumn);
		$resultcolumn = $tmpresult;
		unset($tmpresult);
		return $resultcolumn;
	}

	private function jsonReportListLog($current_profiletype, $length=null) {
		set_time_limit(60);
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
/* gui properties */
		if(isset($_SESSION['lastreportrestreeviewcolumn'])) {
			$_SESSION['lastreportrestreeviewcolumn'] = null;
			unset($_SESSION['lastreportrestreeviewcolumn']);
		}
		if(isset($_SESSION['lastreportdata'])) {
			$_SESSION['lastreportdata'] = null;
			unset($_SESSION['lastreportdata']);
		}
        $current_profile = null;
		if(isset($_GET['treefilter']) && !empty($_GET['treefilter'])) {
			$treefilter = urldecode($_GET['treefilter']);
		} else {
			$treefilter = null;
		}
		$this->view->treefilter = $treefilter;
		if(isset($_GET['showonlytree'])) {
			$showonlytree = 1;
		} else {
			$showonlytree = 0;
		}
		$this->view->showonlytree = $showonlytree;
		if(isset($_GET['sorting'])) {
			$sorting = $_GET['sorting'];
		} else {
			if(!$this->view->showonlytree) {
				$sorting = 'START_DATE';
			} else {
				$sorting = 'TREE_DATE';
			}
		}
		$this->view->sorting = $sorting;
		if(isset($_GET['order'])) {
			$order = $_GET['order'];
		} else {
			if(!$this->view->showonlytree) {
				$order = 'DESC';
			} else {
				$order = 'DESC';
			}
		}
		$this->view->order = $order;
		if(isset($_GET['begin'])) {
			$begin = $_GET['begin'];
		} else {
			$begin = 0;
		}
		$this->view->begin = $begin;
		if(isset($_GET['length'])) {
			$length = $_GET['length'];
		} else {
			if(is_null($length)) {
				$length = 20;
			}
		}
		$this->view->length = $length;
        if(isset($_GET['profile'])) {
            $current_profile = $_GET['profile'];
		} else {
			$current_profile = $this->view->default_profileid;
		}
		$this->view->profile = $current_profile;
		$reportdata = $this->_get_result($model->reportListLogWuiLoad($current_profile, $begin, $length, $sorting, ($order=='ASC')?0:1, ((isset($_GET['refresh']))?1:0), $showonlytree, $treefilter, $array_context));
		if(isset($_GET['debug'])) {
			echo '<pre>';
			echo 'fromtrans'."\n";
			print_r($reportdata);
			echo '</pre>';
		}
/* data consolidation */
		foreach($reportdata as $appid=>$data) {
			if(isset($data['PARAM2'])) {
				if(!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach($data['PARAM2'] as $key=>$val) {
					if(!is_object($data['PARAM2'][$key]) && !is_array($data['PARAM2'][$key])) {
						continue;
					}
					if(!isset($data['PARAM2'][$key]->item)) {
						continue;
					}
					if(!is_array($data['PARAM2'][$key]->item)) {
						$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
					}
					if(!$this->view->showonlytree) {
						$this->view->reportrescolumn =  $this->jsonReportListLogColumnWorker($data['PARAM2'][$key]);
						$this->view->reportrestreeviewcolumn = $this->jsonReportListLogTreeColumnWorker($data['PARAM2'][$key]);
					} else {
						$this->view->reportrescolumn = $this->jsonReportListLogTreeColumnWorker($data['PARAM2'][$key]);
						$this->view->reportrestreeviewcolumn = $this->view->reportrescolumn;
					}
					$this->view->reportres = $this->jsonReportListLogDataWorker($data['PARAM2'][$key]);
				}
			}
		}
/* end data */
		$_SESSION['reportrescolumn'] = $this->view->reportrescolumn;
		$_SESSION['lastreportrestreeviewcolumn'] = $this->view->reportrestreeviewcolumn;
		$_SESSION['lastreportdata'] = $this->view->reportres;
	}
}
