<?php 

function get_date($obj, $utime) {
	return ($obj->lang['month_short_'. date('m', $utime)].date(' d Y H:i', $utime));
}

function get_mode($mode) {
	if (($mode & 0xC000) == 0xC000) { // Socket
		$info = 's';
	} elseif (($mode & 0xA000) == 0xA000) { // Symbolic Link
		$info = 'l';
	} elseif (($mode & 0x8000) == 0x8000) { // Regular
		$info = '-';
	} elseif (($mode & 0x6000) == 0x6000) { // Block special
		$info = 'b';
	} elseif (($mode & 0x4000) == 0x4000) { // Directory
		$info = 'd';
	} elseif (($mode & 0x2000) == 0x2000) { // Character special
		$info = 'c';
	} elseif (($mode & 0x1000) == 0x1000) { // FIFO pipe
		$info = 'p';
	} else { // Unknown
		$info = 'u';
	}
	// Owner
	$info .= (($mode & 0x0100) ? 'r' : '-');
	$info .= (($mode & 0x0080) ? 'w' : '-');
	$info .= (($mode & 0x0040) ? (($mode & 0x0800) ? 's' : 'x' ) : (($mode & 0x0800) ? 'S' : '-'));
	// Group
	$info .= (($mode & 0x0020) ? 'r' : '-'); 
	$info .= (($mode & 0x0010) ? 'w' : '-');
	$info .= (($mode & 0x0008) ? (($mode & 0x0400) ? 's' : 'x' ) : (($mode & 0x0400) ? 'S' : '-'));
	// World
	$info .= (($mode & 0x0004) ? 'r' : '-');
	$info .= (($mode & 0x0002) ? 'w' : '-');
	$info .= (($mode & 0x0001) ? (($mode & 0x0200) ? 't' : 'x' ) : (($mode & 0x0200) ? 'T' : '-'));
	return $info;
}

require_once 'ArkeiaAction.php';

class RestorationpluginController extends ArkeiaAction {

	public function vssAction() {
		$this->view->plugintype = 'vss';
		$this->displayFromScreenIni('vss');
		$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
		$caches = glob($cachedir. 'restorationplugin*');
		foreach($caches as $cache) {
			unlink($cache);
		}
		$_SESSION['restorationplugincurapp'] = '';
	}

	public function vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->displayFromScreenIni('vstorage');
		$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
		$caches = glob($cachedir. 'restorationplugin*');
		foreach($caches as $cache) {
			unlink($cache);
		}
		$_SESSION['restorationplugincurapp'] = '';
	}

	public function getCurApp() {
		if(isset($_REQUEST['APP'])) {
			$curapp = $this->decodeparam($_REQUEST['APP']);
		} else {
			$curapp = null;
		}
		$_SESSION['restorationplugincurapp'] = $curapp;
		$this->curapp = $curapp;
		$this->view->curapp = $curapp;
	}

	public function step1vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss1';
		$this->view->applist = $this->GetResultAllApp();
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step2vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss2';
		$this->getCurApp();
		$this->view->machinelist = $this->GetResultAllMachine();
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step3vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss3';
		$this->getCurApp();
		$this->view->backuplist = $this->GetResultAllBackup();
		$this->view->curprops = $this->curprops;
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step4vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss4';
		$this->getCurApp();
		$this->view->componentlist = $this->GetResultAllComponent();
		$this->view->curprops = $this->curprops;
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step5vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss5';
		$this->getCurApp();
		$this->view->componentlist = $this->GetResultAllComponent();
		$this->view->curprops = $this->curprops;
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step6vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss6';
		$this->getCurApp();
		$this->view->hosts = $this->getclients();
		$this->view->backuplist = $this->GetResultAllBackup();
		$this->view->componentlist = $this->GetResultAllComponent();
		$this->view->curprops = $this->curprops;
		$cpts = array();
		foreach($this->view->componentlist as $componentkey=>$component) {
			$cptinfo = $component;
			$bkpinfo = null;
			foreach($_REQUEST['CPT'] as $key=>$val) {
				$tmp = base64_decode(urldecode($val));
				$pos = (strpos($tmp, '}') + 1);
				if($component['CPTNAME'] == substr($tmp, $pos)) {
					$cpts[$key] = array('RAW'=>$tmp, 'VSSID'=>substr($tmp, 0, $pos), 'CPT'=>substr($tmp, $pos));
					foreach($this->view->backuplist as $backupkey=>$backup) {
						if($backup['VSSID'] == substr($tmp, 0, $pos)) {
							unset($backup['CPTS']);
							$bkpinfo = $backup;
							$cpts[$key]['INFOS'] = array('BKPINFO'=>$bkpinfo, 'CPTINFO'=>$cptinfo);
							break;
						}
					}
					break;
				}
			}
		}
		$this->view->cpts = $cpts;
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step7vssAction() {
		$this->view->plugintype = 'vss';
		$this->view->step = 'vss7';
		$this->getCurApp();
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step1vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->view->bases = $this->listBase();
		$this->view->step = 'vstorage1';
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step2vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->view->componentlist = $this->GetResultAllVstComponent();
		$this->view->step = 'vstorage2';
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step3vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->view->componentlist = $this->GetResultAllVstComponent();
		$this->view->step = 'vstorage3';
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step4vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->view->step = 'vstorage4';
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function step5vstorageAction() {
		$this->view->plugintype = 'vstorage';
		$this->view->step = 'vstorage5';
		if(isset($_REQUEST['TYPE']) && $_REQUEST['TYPE'] == 'DS') {
			$this->view->datastorelist = $this->ListDataStore();
		}
		echo $this->view->render('restorationplugin/steps.phtml');
	}

	public function startjobAction() {
		if(isset($_POST['input_pluginapp']) && isset($_POST['input_pluginmachine']) && isset($_POST['input_plugincomponent'])) {
			require_once 'Zend/Json.php';
			$this->curapp = $_POST['input_pluginapp'];
			$this->curmachine = $_POST['input_pluginmachine'];
			$this->backuplist = $this->GetResultAllBackup();
			$this->componentlist = $this->GetResultAllComponent();
			$this->curcomponent = Zend_Json::decode($_POST['input_plugincomponent']);
			$params = array();
			$params['RSTPLUG_TYPE'] = 0;
			$params['WRITER'] = $this->curapp;
			if(isset($_POST['input_option_general_redirecttodisk'])) {
				$params['RESTORE_WITHOUT_VSS'] = 1;
			} else {
				$params['RESTORE_WITHOUT_VSS'] = 0;
			}
			if(isset($_POST['input_option_general_unmountdatabases'])) {
				$params['EXCHANGE_DISMOUNT_DBS'] = 1;
			}
			if(isset($_POST['input_option_general_markdatabaseoverwrite'])) {
				$params['EXCHANGE_MARK_DBS_OVERWRITE'] = 1;
			}
			$params['RESTORE_PRETEND'] = 0;
			$params['SOURCE_MACHINE'] = $this->curmachine;
			if(isset($_POST['input_option_general_destmachine_selected'])) {
				if($_POST['input_option_general_destmachine_selected'] == '') {
					$res = $this->_set_error_message($this->lang['rst_plugin_error_optiondestmachine']);
					$result = Zend_Json::encode($res);
					$this->getResponse()->appendBody($result);
					return;
				} else {
					$params['DEST_MACHINE'] = $_POST['input_option_general_destmachine_selected'];
				}
			} else {
				$params['DEST_MACHINE'] = $this->curmachine;
			}
			foreach($this->curcomponent as $comp) {
				$tmp = array();
				$tmp['VSSID'] = $comp['VSSID'];
				if(isset($_POST['input_option_general_redirecttodisk'])) {
					if(preg_match('/^([^!]*)!file:(.*)$/', $_POST['input_option_general_redirecttodisk'], $reg)) {
						$params['DEST_MACHINE'] = $reg[1];
						$tmp['DEST_REDIR'] = $reg[2];
					} else {
						$res = $this->_set_error_message($this->lang['rst_plugin_error_optionredirtodisk']);
						$result = Zend_Json::encode($res);
						$this->getResponse()->appendBody($result);
						return;
					}
				} else {
					switch($this->curapp) {
						case 'Exchange Server':
							if(isset($_POST['input_option_'.$comp['CPT'].'_rename'])) {
								if(!is_array($_POST['input_option_'.$comp['CPT'].'_rename'])) {
									$_POST['input_option_'.$comp['CPT'].'_rename'] = trim($_POST['input_option_'.$comp['CPT'].'_rename']);
									if(empty($_POST['input_option_'.$comp['CPT'].'_rename'])) {
										$res = $this->_set_error_message($this->lang['rst_plugin_error_optionrename']);
										$result = Zend_Json::encode($res);
										$this->getResponse()->appendBody($result);
										return;
									}
									$tmp['RENAME'] = $_POST['input_option_'.$comp['CPT'].'_rename'];
								} else {
									$_POST['input_option_'.$comp['CPT'].'_rename'][0] = trim($_POST['input_option_'.$comp['CPT'].'_rename'][0]);
									$_POST['input_option_'.$comp['CPT'].'_rename'][1] = trim($_POST['input_option_'.$comp['CPT'].'_rename'][1]);
									if(empty($_POST['input_option_'.$comp['CPT'].'_rename'][0]) || empty($_POST['input_option_'.$comp['CPT'].'_rename'][1]) ) {
										$res = $this->_set_error_message($this->lang['rst_plugin_error_optionrename']);
										$result = Zend_Json::encode($res);
										$this->getResponse()->appendBody($result);
										return;
									}
									if(preg_match('`/`', $_POST['input_option_'.$comp['CPT'].'_rename'][1]) || preg_match('`/`', $_POST['input_option_'.$comp['CPT'].'_rename'][0])) {
										$res = $this->_set_error_message($this->lang['rst_plugin_error_optionrenamesyntax']);
										$result = Zend_Json::encode($res);
										$this->getResponse()->appendBody($result);
										return;
									}
									$tmp['RENAME'] = $_POST['input_option_'.$comp['CPT'].'_rename'][1].'/'.$_POST['input_option_'.$comp['CPT'].'_rename'][0];
								}
							}
						break;
						case 'SQL Server':
							if(isset($_POST['input_option_'.$comp['CPT'].'_rename'])) {
								$_POST['input_option_'.$comp['CPT'].'_rename'] = trim($_POST['input_option_'.$comp['CPT'].'_rename']);
								if(empty($_POST['input_option_'.$comp['CPT'].'_rename'])) {
									$res = $this->_set_error_message($this->lang['rst_plugin_error_optionrename']);
									$result = Zend_Json::encode($res);
									$this->getResponse()->appendBody($result);
									return;
								}
								$tmp['RENAME'] = $_POST['input_option_'.$comp['CPT'].'_rename'];
							}
							if(isset($_POST['input_option_'.$comp['CPT'].'_move'])) {
								$_POST['input_option_'.$comp['CPT'].'_move'] = trim($_POST['input_option_'.$comp['CPT'].'_move']);
								if(empty($_POST['input_option_'.$comp['CPT'].'_move'])) {
									$res = $this->_set_error_message($this->lang['rst_plugin_error_optionmove']);
									$result = Zend_Json::encode($res);
									$this->getResponse()->appendBody($result);
									return;
								}
								$tmp['DEST_REDIR'] = $_POST['input_option_'.$comp['CPT'].'_move'];
							}
						break;
					}
				}
				foreach($this->backuplist as $backup) {
					if($backup['VSSID'] == $comp['VSSID']) {
						$tmp['BKPTYPE'] = $backup['BKPTYPE'];
						$tmp['SK_NAME'] = $backup['SK_NAME'];
						$tmp['BKDATE'] = $backup['BKDATE'];
						foreach($this->componentlist as $component) {
							if($component['CPTNAME'] == $comp['CPT']) {
								$tmp['CPTNAME'] = $component['REALCPTNAME'];
								break;
							}
						}
						break;
					}
				}
				array_push($params, $tmp);
			}
			$context = $this->view->context;
			$ctrlcfg = $this->_getCtrlCfg();
			$model = $this->_getModel($ctrlcfg);
//$res = $this->_set_error_message(print_r($params, true));
			$data = $model->startjob($params, $context);
			$res = $this->_get_result($data, $context);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
	}

	public function startVstjobAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = array();
		$params['RSTPLUG_TYPE'] = 1;
		foreach($_POST as $key=>$val) {
			if($key == 'item') {
				$val = Zend_Json::decode($val);
				foreach($val as $subkey=>$item) {
					foreach($item as $itemprop=>$itemval) {
						if($itemprop == 'CPTNAME') {
							$val[$subkey][$itemprop] = base64_decode(urldecode($val[$subkey][$itemprop]));
						}
						if($itemprop == 'CONTAINER') {
							$val[$subkey][$itemprop] = base64_decode(urldecode($val[$subkey][$itemprop]));
						}
						if($itemprop == 'COMPUTER') {
							$val[$subkey][$itemprop] = base64_decode(urldecode($val[$subkey][$itemprop]));
						}
						if($itemprop == 'POOL') {
							$val[$subkey][$itemprop] = base64_decode(urldecode($val[$subkey][$itemprop]));
						}
					}
					array_push($params, $val[$subkey]);
				}
			} else {
				$params[$key] = $val;
			}
		}
		if(isset($params['CONTAINER'])) {
			$params['CONTAINER'] = base64_decode(urldecode($params['CONTAINER']));
		}
		if(isset($params['COMPUTER'])) {
			$params['COMPUTER'] = base64_decode(urldecode($params['COMPUTER']));
		}
		if(isset($params['POOL'])) {
			$params['POOL'] = base64_decode(urldecode($params['POOL']));
		}
//$res = $this->_set_error_message(print_r($params, true));
		$data = $model->startjob($params, $context);
		$res = $this->_get_result($data, $context);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function abortJobAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$jobid = $_REQUEST['jobid'];
		$port = $_REQUEST['port'];
		$result = $model->abortJob($jobid, $port, $context);
		if ($result == null) {
			error_log('get Stat is null');
			return null;
		}
		$data = $this->_get_result($result, $context, true);
		$result = Zend_Json::encode($data);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function jsonGetNoneAction() {
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode(array());
		$this->getResponse()->appendBody($result);
		return;
	}

	public function answerAction(){
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$context = $this->view->context;
		$jobid = $_REQUEST['jobid'];
		$port = $_REQUEST['port'];
		$drvnum = $_REQUEST['drvnum'];
		$drvid = $_REQUEST['drvid'];
		$result = $model->answer($jobid, $port, $drvnum, $drvid, $context);
		if ($result == null) {
			error_log('Answer is null');
			return null;
		}
		$data = $this->_get_result($result);
		$result = Zend_Json::encode($data);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function getStatAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$jobid = $_REQUEST['jobid'];
		$port = $_REQUEST['port'];
		$result = $model->getStat($jobid, $port, $context);
		if ($result == null) {
			error_log('get Stat is null');
			return null;
		}
		$res = $this->_get_result($result, $context, true);

		foreach ($res as $appid=>$data) {
			if (isset($res[$appid]['PARAM2'])) {
				if (!is_array($data['PARAM2'])) {
					$res[$appid]['PARAM2'] = array($res[$appid]['PARAM2']);
				}
				foreach ($res[$appid]['PARAM2'] as $key=>$val) {
					if (isset($res[$appid]['PARAM2'][$key]->item)) {
						$props = array_keys(get_object_vars($res[$appid]['PARAM2'][$key]));
						foreach($props as $prop) {
							if(preg_match('`^STEP_(\d+)$`', $prop, $reg)) {
								if(!isset($res[$appid]['PARAM2'][$key]->STEPS)) {
									$res[$appid]['PARAM2'][$key]->STEPS = array();
								}
								array_push($res[$appid]['PARAM2'][$key]->STEPS, $res[$appid]['PARAM2'][$key]->{$prop});
								unset($res[$appid]['PARAM2'][$key]->{$prop});
							}
						}
					}
				}
			}
			if (isset($res[$appid]['PARAM3'])) {
				if (!is_array($res[$appid]['PARAM3'])) {
					$res[$appid]['PARAM3'] = array($res[$appid]['PARAM3']);
				}
				foreach ($res[$appid]['PARAM3'] as $key=>$val) {
					if (isset($res[$appid]['PARAM3'][$key]->item)) {
						if (!is_array($res[$appid]['PARAM3'][$key]->item)) {
							$res[$appid]['PARAM3'][$key]->item = array($res[$appid]['PARAM3'][$key]->item);
						}
						foreach($res[$appid]['PARAM3'][$key]->item as $subkey=>$subval) {
							foreach((array)$res[$appid]['PARAM3'][$key]->item[$subkey] as $subsubkey=>$subsubval) {
								$res[$appid]['PARAM3'][$key]->item[$subkey]->{$subsubkey} = arkphp_conv_charset('UTF-8', $res[$appid]['PARAM3'][$key]->item[$subkey]->{$subsubkey});
							}
						}
					}
				}
			}
		}

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function getVstStatAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$jobid = $_REQUEST['jobid'];
		$port = $_REQUEST['port'];
		$result = $model->getStat($jobid, $port, $context);
		if ($result == null) {
			error_log('get Stat is null');
			return null;
		}
		$res = $this->_get_result($result, $context, true);

		foreach ($res as $appid=>$data) {
			if (isset($res[$appid]['PARAM2'])) {
				if (!is_array($data['PARAM2'])) {
					$res[$appid]['PARAM2'] = array($res[$appid]['PARAM2']);
				}
				foreach ($res[$appid]['PARAM2'] as $key=>$val) {
					if (isset($res[$appid]['PARAM2'][$key]->item)) {
						$props = array_keys(get_object_vars($res[$appid]['PARAM2'][$key]));
						foreach($props as $prop) {
							if(preg_match('`^STEP_(\d+)$`', $prop, $reg)) {
								if(!isset($res[$appid]['PARAM2'][$key]->STEPS)) {
									$res[$appid]['PARAM2'][$key]->STEPS = array();
								}
								array_push($res[$appid]['PARAM2'][$key]->STEPS, $res[$appid]['PARAM2'][$key]->{$prop});
								unset($res[$appid]['PARAM2'][$key]->{$prop});
							}
						}
					}
				}
			}
			if (isset($res[$appid]['PARAM3'])) {
				if (!is_array($res[$appid]['PARAM3'])) {
					$res[$appid]['PARAM3'] = array($res[$appid]['PARAM3']);
				}
				foreach ($res[$appid]['PARAM3'] as $key=>$val) {
					if (isset($res[$appid]['PARAM3'][$key]->item)) {
						if (!is_array($res[$appid]['PARAM3'][$key]->item)) {
							$res[$appid]['PARAM3'][$key]->item = array($res[$appid]['PARAM3'][$key]->item);
						}
						foreach($res[$appid]['PARAM3'][$key]->item as $subkey=>$subval) {
							foreach((array)$res[$appid]['PARAM3'][$key]->item[$subkey] as $subsubkey=>$subsubval) {
								$res[$appid]['PARAM3'][$key]->item[$subkey]->{$subsubkey} = arkphp_conv_charset('UTF-8', $res[$appid]['PARAM3'][$key]->item[$subkey]->{$subsubkey});
							}
						}
					}
				}
			}
		}
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	private function GetResultAllAppAndMachine() {
		$context = $this->view->context;
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
		if	(
				isset($_GET['refresh']) ||
				!file_exists($cachedir . 'restorationpluginappandmachine') ||
				filemtime($cachedir . 'restorationpluginappandmachine') < (time() - (3600*24))
			) {
			$params = array();
			$data = $model->GetResultAllAppAndMachine($params, $context);
			$res = $this->_get_result($data, $context);
			foreach ($res as $appid=>$data) {
				if (isset($data['PARAM2'])) {
					if (!is_array($data['PARAM2'])) {
						$data['PARAM2'] = array($data['PARAM2']);
					}
					foreach ($data['PARAM2'] as $key=>$val) {
						if (isset($data['PARAM2'][$key]->item)) {
							if(!is_array($data['PARAM2'][$key]->item)) {
								$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
							}
							$res = $data['PARAM2'][$key]->item;
							break;
							break;
						}
					}
				}
			}
			file_put_contents($cachedir . 'restorationpluginappandmachine', serialize($res));
		} else {
			$res = unserialize(file_get_contents($cachedir . 'restorationpluginappandmachine'));
		}
		return $res;
	}

	private function GetResultAllBackupAndComponents() {
		$curapp = $this->curapp;
		if(isset($_REQUEST['MACHINE'])) {
			$curmachine = $this->decodeparam($_REQUEST['MACHINE']);
		} else {
			if(!isset($this->curmachine)) {
				$curmachine = null;
			} else {
				$curmachine = $this->curmachine;
			}
		}
		if(is_null($curapp) || is_null($curmachine)) {
			$res = null;
		} else {
			$res = array();
			$context = $this->view->context;
			$ctrlcfg = $this->_getCtrlCfg();
			$model = $this->_getModel($ctrlcfg);
			$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
			$cachefile = 'restorationpluginbackup_' . base64_encode($curapp) . '_' . base64_encode($curmachine);
			if	(
					isset($_GET['refresh']) ||
					!file_exists($cachedir . $cachefile) ||
					filemtime($cachedir . $cachefile) < (time() - (3600*24))
				) {
				$params = array('param0'=>$curmachine, 'param1'=>$curapp);
				$data = $model->GetResultAllBackup($params, $context);
				$bigres = $this->_get_result($data, $context);
				foreach ($bigres as $appid=>$data) {
					if (isset($data['PARAM2'])) {
						if (!is_array($data['PARAM2'])) {
							$data['PARAM2'] = array($data['PARAM2']);
						}
						foreach ($data['PARAM2'] as $key=>$val) {
							if (isset($data['PARAM2'][$key]->item)) {
								if(isset($data['PARAM2'][$key]->EXCH2010)) {
									if((int)$data['PARAM2'][$key]->EXCH2010) {
										$exchversion = 2010;
									} else {
										$exchversion = 2007;
									}
								}								
								if(!is_array($data['PARAM2'][$key]->item)) {
									$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
								}
								$res = $data['PARAM2'][$key]->item;
								if(isset($exchversion)) {
									foreach($res as $key=>$val) {
										$res[$key]->EXCHVERSION = $exchversion;
									}
								}
								break;
								break;
							}
						}
					}
				}
				file_put_contents($cachedir . $cachefile, serialize($res));
			} else {
				$res = unserialize(file_get_contents($cachedir . $cachefile));
			}
		}
		return $res;
	}
	public function GetResultAllBackup() {
		$curapp = $this->curapp;
		 $this->curapp = $curapp;
		if(isset($_REQUEST['MACHINE'])) {
			$curmachine = $this->decodeparam($_REQUEST['MACHINE']);
		} else {
			if(!isset($this->curmachine)) {
				$curmachine = null;
			} else {
				$curmachine = $this->curmachine;
			}
		}
		if(isset($_REQUEST['COMPONENT']) && is_array($_REQUEST['COMPONENT']) && count($_REQUEST['COMPONENT']) > 0) {
			$curcomponent = $this->decodeparam($_REQUEST['COMPONENT']);
		} else {
			$curcomponent = null;
		}
		//die($curcomponent);
		if(isset($_REQUEST['VSSID']) && $_REQUEST['VSSID'] != '') {
			$curvssid = $this->decodeparam($_REQUEST['VSSID']);
		} else {
			$curvssid = null;
		}
		if(is_null($curapp) || is_null($curmachine)) {
			$res = null;
		} else {
			$res = $this->GetResultAllBackupAndComponents();
			$this->curprops = $this->GetAppToComponentProp($curapp);
			$tmpmain = array();
			foreach($res as $backup) {
				$tmp = array();
				$bprops = get_object_vars($backup);
				foreach($bprops as $key=>$prop) {
					if(!preg_match('`^('.implode('|', $this->curprops).')_(\d+)$`', $key, $reg) && $key != 'NB_CPT') {
						$tmp[$key] = $prop;
					} else {
						if($reg[1] == $this->curprops[0]) {
							if(!isset($tmp['CPTS'])) {
								$tmp['CPTS'] = array();
							}
							array_push($tmp['CPTS'], md5($prop));
						}
					}
					if(!is_null($curvssid) && $backup->VSSID == $curvssid) {
						$tmp['SELECTED'] = 1;
					}
				}
				array_push($tmpmain, $tmp);
			}
			$res = $tmpmain;
			if(!is_null($curcomponent)) {
				$tmp = array();
				foreach($res as $backup) {
					foreach($curcomponent as $curcomp) {
						if(in_array(md5($curcomp), $backup['CPTS'])) {
							$tmp[$backup['VSSID']] = $backup;
						}
					}
				}
				$res = array_values($tmp);
			}
		}
		uasort($res, array($this, 'orderBackups'));
		$res = array_reverse($res, true);
		return $res;
	}
	private function GetAppToComponentProp($app) {
		$result = array('CPTNAME');
		switch($app) {
			case 'Hyper-V':
				array_push($result, 'VM');
				array_push($result, 'STATE');
			break;
			case 'SQL Server':
				array_push($result, 'DB');
				array_push($result, 'INSTANCE');
				array_push($result, 'SERVER');
			break;
			case 'Active Directory':
				array_push($result, 'BASE');
			break;
			case 'Exchange Server':
				array_push($result, 'DB');
				array_push($result, 'FILE_OR_DB');
				array_push($result, 'DB_OR_SG');
				array_push($result, 'IS_REPLICA');
			break;
			case 'SharePoint Server':
				array_push($result, 'DB');
				array_push($result, 'INSTANCE');
				array_push($result, 'SERVER');
			break;
			default:
		}
		return $result;
	}
	public function GetResultAllVstComponent() {
		$result = array();
		if(isset($_POST['SELECTION'])) {
			$res = array();
			$context = $this->view->context;
			$ctrlcfg = $this->_getCtrlCfg();
			$model = $this->_getModel($ctrlcfg);
			$cachedir = dirname(__FILE__) . '/../../tmp/cache/';
			if(isset($_REQUEST['BASE'])) {
				$base = $_REQUEST['BASE'];
			} else {
				$base = '';
			}
			$cachefile = 'restorationpluginbackup_'.$base.'_' . substr(implode('', $_POST['SELECTION']), 0, 231);
			if	(
					isset($_GET['refresh']) ||
					!file_exists($cachedir . $cachefile) ||
					filemtime($cachedir . $cachefile) < (time() - (3600*24))
				) {
				$sel = array();
				foreach($_POST['SELECTION'] as $path) {
					array_push($sel, array('VMPATH'=>base64_decode(urldecode($path))));
				}
				$params = array('param0'=>$sel);
				$data = $model->GetResultAllVstBackup($params, $context);
				$bigres = $this->_get_result($data, $context);
				foreach ($bigres as $appid=>$data) {
					if (isset($data['PARAM2'])) {
						if (!is_array($data['PARAM2'])) {
							$data['PARAM2'] = array($data['PARAM2']);
						}
						foreach ($data['PARAM2'] as $key=>$val) {
							if (isset($data['PARAM2'][$key]->item)) {
								if(isset($data['PARAM2'][$key]->MAX_DSKS)) {
									$maxdsks = $data['PARAM2'][$key]->MAX_DSKS;
								}								
								if(!is_array($data['PARAM2'][$key]->item)) {
									$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
								}
								$res = $data['PARAM2'][$key]->item;
								break;
								break;
							}
						}
					}
				}
				if(isset($_SESSION['charset'])) {
					$charset = $_SESSION['charset'];
				} else {
					$charset = 'UTF-8';
				}
				foreach($res as $cpt) {
					$backups = array();
					for($i=0; $i<$cpt->NB_BKSID; $i++) {
						$backups[$i] = array(
							'BKSID'=> $cpt->{'BKSID_'.$i},
							'SK_NAME'=> $cpt->{'SK_NAME_'.$i},
							'BKDATE'=> ((int)$cpt->{'BKDATE_'.$i}),
							'DISKS'=>array()
						);
						$curdisklist = explode(',', $cpt->{'DISKS_'.$i});
						for($j=0; $j<$cpt->{'NB_DISKS_'.$i}; $j++) {
							$backups[$i]['DISKS'][$j] = array(
								'ID' => $curdisklist[$j],
								'NAME' => $cpt->{'DISK_'.$i.'_'.$curdisklist[$j]}
							);
						}
					}
					usort($backups, array($this, 'orderBackups'));
					$backups = array_reverse($backups);
					array_push($result, array(
						'PATH'=>urlencode(base64_encode($cpt->VMPATH)),
						'PRINTNAME'=>substr(arkphp_conv_charset($charset, $cpt->VMPATH), strrpos(arkphp_conv_charset($charset, $cpt->VMPATH), '/')+1),
						'PRINTPATH'=>arkphp_conv_charset($charset, $cpt->VMPATH),
						'MAXDSKS' => $maxdsks,
						'BACKUPS'=>$backups
					));
				}
				file_put_contents($cachedir . $cachefile, serialize($result));
			} else {
				$result = unserialize(file_get_contents($cachedir . $cachefile));
			}
		}
		usort($result, array($this, 'orderPrintname'));
		if(isset($_POST['BACKUPS'])) {
			foreach($result as $cptnum=>$cpt) {
				foreach($cpt['BACKUPS'] as $numb=>$b) {
					if(!in_array('cpt'.$cptnum.'_'.$b['BKSID'], $_POST['BACKUPS'])) {
						unset($result[$cptnum]['BACKUPS'][$numb]);
					} else {
					}
				}
				$result[$cptnum]['BACKUPS'] = array_values($result[$cptnum]['BACKUPS']);
			}
		}
		if(isset($_POST['DISKS'])) {
			foreach($result as $cptnum=>$cpt) {
				foreach($cpt['BACKUPS'] as $numb=>$b) {
					foreach($b['DISKS'] as $numd=>$d) {
						if(in_array('cpt'.$cptnum.'_'.$b['BKSID'].'_disk'.$d['ID'], $_POST['DISKS'])) {
							unset($result[$cptnum]['BACKUPS'][$numb]['DISKS'][$numd]);
						}
					}
				}
			}
		}
		return $result;
	}
	public function GetResultAllComponent() {
		$curapp = $this->curapp;
		if(isset($_REQUEST['MACHINE'])) {
			$curmachine = $this->decodeparam($_REQUEST['MACHINE']);
		} else {
			if(!isset($this->curmachine)) {
				$curmachine = null;
			} else {
				$curmachine = $this->curmachine;
			}
		}
		if(isset($_REQUEST['COMPONENT']) && is_array($_REQUEST['COMPONENT']) && count($_REQUEST['COMPONENT']) > 0) {
			$curcomponent = $this->decodeparam($_REQUEST['COMPONENT']);
		} else {
			$curcomponent = null;
		}
		if(isset($_REQUEST['VSSID']) && $_REQUEST['VSSID'] != '') {
			$curvssid = $this->decodeparam($_REQUEST['VSSID']);
		} else {
			$curvssid = null;
		}
		if(is_null($curapp) || is_null($curmachine)) {
			$res = null;
		} else {
			$res = $this->GetResultAllBackupAndComponents();
			$this->curprops = $this->GetAppToComponentProp($curapp);
			$tmpmain = array();
			foreach($res as $backup) {
				$bprops = get_object_vars($backup);
				foreach($bprops as $key=>$prop) {
					if(preg_match('`^('.implode('|', $this->curprops).')_(\d+)$`', $key, $reg)) {
						if(!isset($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}])) {
							$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}] = array();
							$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['VSSBKP'] = array();
							$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['VSSBKP'][$backup->VSSID] = date('Y/m/d H:i', $backup->BKDATE) . ' (' . $backup->SK_NAME . ')';
						} else {
							if(!in_array($backup->VSSID, array_keys($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['VSSBKP']))) {
								$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['VSSBKP'][$backup->VSSID] = date('Y/m/d H:i', $backup->BKDATE) . ' (' . $backup->SK_NAME . ')';
							}
						}
						if(preg_match('`^('.$this->curprops[0].')_(\d+)$`', $key)) {
							$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['REALCPTNAME'] = $prop;
							$prop = md5($prop);
						}
						$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}][$reg[1]] = $prop;
						if(!is_null($curcomponent) && in_array($backup->{$this->curprops[0] . '_' . $reg[2]}, $curcomponent)) {
							$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['SELECTED'] = 1;
						}
						switch($curapp) {
							case 'SharePoint Server':
							case 'SQL Server':
								$server = $tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['SERVER'];
								$instance = 'Default';
								if	(isset($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['INSTANCE'])) {
									$tmp = trim($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['INSTANCE']);
									if(!empty($tmp)) {
										$instance = $tmp;
									} else {
										$instance = 'Default';
									}
								}
								$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATHORDER'] = $server . '\\' . $instance;
								$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATH'] = $server . '\\' . $instance;
							break;
							case 'Active Directory':
								$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['BASE'] = 'Active Directory';
							break;
							case 'Exchange Server':
								$level1 = '';
								$level2 = '';
								$path = '';
								if(isset($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['DB_OR_SG'])) {
									$level1 = $tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['DB_OR_SG'];
								}
								if(isset($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['FILE_OR_DB'])) {
									$level2 = $tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['FILE_OR_DB'];
								}
								if($level2 != '') {
									$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATHORDER'] = $level1.'02';
									$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATH'] = $level1;
									$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['DB'] = $level2;
								} else {
									if($level1 != '') {
										//$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['MAINLEVEL'] = true;
										$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['HIDEPATH'] = true;
										$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATHORDER'] = $level1.'01';
										$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['PATH'] = $level1;
										$tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]['DB'] = $level1;
									} else {
										//this shouldn't happen
										unset($tmpmain[$backup->{$this->curprops[0] . '_' . $reg[2]}]);
										continue;
									}
								}
							break;
						}
					}
				}
			}
			$res = array_values($tmpmain);
			if(!is_null($curvssid)) {
				$tmp = array();
				foreach($res as $component) {
					if(in_array($curvssid, array_keys($component['VSSBKP']))) {
						array_push($tmp, $component);
					}
				}
				$res = $tmp;
			}
			foreach($res as $key=>$component) {
				uasort($res[$key]['VSSBKP'], array($this, 'orderCptBackups'));
				$res[$key]['VSSBKP'] = array_reverse($res[$key]['VSSBKP'], true);
			}
			switch($curapp) {
				case 'SQL Server':
					usort($res, array($this, 'orderByPath'));
				break;
				case 'Exchange Server':
					usort($res, array($this, 'orderByPath'));
				break;
				case 'SharePoint Server':
					$tmp = array();
					foreach($res as $component) {
						if(isset($component['DB'])) {
							array_push($tmp, $component);
						}
					}
					$res = $tmp;
					usort($res, array($this, 'orderByPath'));
				break;
			}
		}
		return $res;
	}

	public function orderBackups($a, $b) {
		if ($a['BKDATE'] == $b['BKDATE']) {
			return 0;
		}
		return ($a['BKDATE'] < $b['BKDATE']) ? -1 : 1;
	}

	public function orderPrintname($a, $b) {
		if (strtolower($a['PRINTNAME']) == strtolower($b['PRINTNAME'])) {
			return 0;
		}
		return (strtolower($a['PRINTNAME']) < strtolower($b['PRINTNAME'])) ? -1 : 1;
	}

	public function orderCptBackups($a, $b) {
		if ($a == $b) {
			return 0;
		}
		return ($a < $b) ? -1 : 1;
	}

	public function orderByPath($a, $b) {
		if ($a['PATHORDER'] == $b['PATHORDER']) {
			switch($this->curapp) {
				case 'SQL Server':
					if($a['DB'] == $b['DB']) {
						return 0;
					} else {
						return ($a['DB'] < $b['DB']) ? -1 : 1;
					}
				break;
				case 'Exchange Server':
					if($a['DB'] == $b['DB']) {
						
						return 0;
					} else {
						return ($a['DB'] < $b['DB']) ? -1 : 1;
					}
				break;
				default:
					return 0;
			}
		}
		return ($a['PATHORDER'] < $b['PATHORDER']) ? -1 : 1;
	}

	public function GetResultAllApp() {
		$res = $this->GetResultAllAppAndMachine();
		$tmp = array();
		foreach($res as $itemkey=>$itemval) {
			if(isset($itemval->APP)) {
				if(!is_array($itemval->APP)) {
					$itemval->APP = array($itemval->APP);
				}
				foreach($itemval->APP as $app) {
					if(!in_array($app, $tmp)) {
						array_push($tmp, $app);
					}
				}
			}
		}
		$res = $tmp;
		return $res;
	}

	public function GetResultAllMachine() {
		$curapp = $this->curapp;
		$res = $this->GetResultAllAppAndMachine();
		$tmp = array();
		foreach($res as $itemkey=>$itemval) {
			if(isset($itemval->MACHINE)) {
				if(!is_array($itemval->MACHINE)) {
					$itemval->MACHINE = array($itemval->MACHINE);
				}
				if(!is_array($itemval->APP)) {
					$itemval->APP = array($itemval->APP);
				}
				foreach($itemval->MACHINE as $machine) {
					if(!in_array($machine, $tmp) && (is_null($curapp) || in_array($curapp, $itemval->APP))) {
						array_push($tmp, $machine);
					}
				}
			}
		}
		$res = $tmp;
		return $res;
	}

	private function decodeparam($param) {
		if(is_string($param)) {
			return base64_decode(urldecode($param));
		} else {
			foreach($param as $key=>$val) {
				$param[$key] = base64_decode(urldecode($param[$key]));
			}
			return $param;
		}
	}

	private function getclients() {
		$context = $this->view->context;
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$data = $model->GetResultAllHosts();
		$res = $this->_get_result($data, $context);
		foreach ($res as $appid=>$data) {
			if (isset($data['PARAM2'])) {
				if (!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach ($data['PARAM2'] as $key=>$val) {
					if (isset($data['PARAM2'][$key]->item)) {
						if(!is_array($data['PARAM2'][$key]->item)) {
							$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
						}
						$res = $data['PARAM2'][$key]->item;
						break;
						break;
					}
				}
			}
		}
		$hosts = array();
		foreach($res as $r) {
			if(isset($r->OSNAME) && $r->OSNAME == 'WINDOWS') {
				if(isset($r->VNAME)) {
					array_push($hosts, $r->VNAME);
				} else {
					if(isset($r->NOM)) {
						array_push($hosts, $r->NOM);
					} else {
						array_push($hosts, 'unknown');
					}
				}
			}
		}
		sort($hosts);
		return $hosts;
	}

	public function ListDataStore() {
		$res = array();
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$data = $model->GetResultAllDatastore(base64_decode(urldecode($_REQUEST['START'])), $context);
		$bigres = $this->_get_result($data, $context);
		foreach ($bigres as $appid=>$data) {
			if (isset($data['PARAM2'])) {
				if (!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach ($data['PARAM2'] as $key=>$val) {
					if (isset($data['PARAM2'][$key]->item)) {
						if(!is_array($data['PARAM2'][$key]->item)) {
							$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
						}
						foreach($data['PARAM2'][$key]->item as $subkey=>$subval) {
							$data['PARAM2'][$key]->item[$subkey] = (array)$data['PARAM2'][$key]->item[$subkey];
						}
						$res = $data['PARAM2'][$key]->item;
						break;
						break;
					}
				}
			}
		}
		return $res;
	}

	public function jsonVstVerifyPathAction() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$types = array(
			'CT' => 'CONTAINER',
			'CP' => 'COMPUTER',
			'PL' => 'POOL'
		);
		if	(
				isset($_REQUEST['TYPE']) && isset($_REQUEST['PATH']) &&
				in_array($_REQUEST['TYPE'], array_keys($types)) && $_REQUEST['PATH'] != ''
			) {
			$data = $model->vstVerifyPath(array($types[$_REQUEST['TYPE']]=>base64_decode(urldecode($_REQUEST['PATH']))), $context);
			$res = $this->_get_result($data, $context);
		} else {
			$res = $this->_set_error_message('Verification failed');
		}
		$res = $this->parseVstVerifyPath($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function jsonGetNextVstVerifyPathAction() {
		require_once 'Zend/Json.php';
		$context = $this->view->context;
		$data = $this->_getNext($context);
		$res = $this->_get_result($data);
		unset($data);
		$res = $this->parseVstVerifyPath($res);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	private function parseVstVerifyPath($res) {
		foreach ($res as $appid=>$data) {
			if (isset($res[$appid]['PARAM2'])) {
				if (!is_array($res[$appid]['PARAM2'])) {
					$res[$appid]['PARAM2'] = array($res[$appid]['PARAM2']);
				}
				foreach ($res[$appid]['PARAM2'] as $key=>$val) {
					foreach((array)$res[$appid]['PARAM2'][$key] as $subkey=>$subval) {
						if(preg_match('`_ROOT$`', $subkey)) {
							$res[$appid]['PARAM2'][$key]->{$subkey} = urlencode(base64_encode($res[$appid]['PARAM2'][$key]->{$subkey}));
						}
					}
				}
			}
		}
		return $res;
	}

	private function listBase() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$context = $this->view->context;
		$result = $model->listBase($context);
		$result = $this->_get_result($result, $context);
		if($context) {
			$data = $result['local']['PARAM3'][0]->item;
		} else {
			$data = $result['local']['PARAM2'][0]->item;
		}
		$result = array();
		if(is_object($data) || (is_array($data) && count($data)>0)) {
			$result['local'] = $this->lang['rst_base_default'];
			if(is_object($data)) {
				$result[$data->REP_CLIENT_ID] = (isset($data->REP_CLIENT_NAME))?$data->REP_CLIENT_NAME:$this->lang['rst_base_error_no_repname'];
			} else {
				foreach($data as $tmp) {
					$result[$tmp->REP_CLIENT_ID] = (isset($tmp->REP_CLIENT_NAME))?$tmp->REP_CLIENT_NAME:$this->lang['rst_base_error_no_repname'];
				}
			}
		}
		return $result;
	}

	public function jsonListDirAction() {
		return $this->jsonListDirOrFileAction2();
	}

	public function jsonListDirOrFileAction2() {
		require_once 'Zend/Json.php';
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getParams();
		if(isset($params['APPID'])) {
			$context = $this->_get_filtered_context($params['APPID'], $this->view->context);
		} else {
			$context = null;
		}
		$data = Zend_Json::decode($params['data']);
		$path = $this->navpath_base64_decode($data['node']['widgetId']);
		$objectId = $this->navpath_base64_decode($data['node']['objectId']);
		$path = preg_replace('/^'.str_replace(array("'", "/"), array("\\'", "\\/"), $objectId).'(.*)$/', '$1', $path);
		if ($path == "Root") {
			$path = ':';
		}
		$plist = array('SHOWMOUNTPOINTS' => '0', 'SHOWLINKS' => '1', 'STARTDIR' => ':', 'COMM_NUM' => '11');
		if (isset($params['START_BKID']) || isset($params['END_BKID'])) {
			if(isset($params['START_BKID'])) {
				$plist['START_BKID'] = $params['START_BKID'];
			}
			if(isset($params['END_BKID'])) {
				$plist['END_BKID'] = $params['END_BKID'];
			}
		}
		$data = $model->listDir(2, $path, $plist, 'dir', $context);
		$data = $this->_get_result($data, $context);
		foreach($data as $cont=>$r) {
			if(isset($r['MESSAGE'])) {
				foreach($r['MESSAGE'] as $num=>$m) {
					if($num == (count($r['MESSAGE']) - 1) && preg_match('`^..../../.. ..:..:.. E.{7,8} [^ ]*\: (.*)$`', $m, $reg)) {
						$data[$cont]['PARAM2'] = array();
						$data[$cont]['PARAM2'][0] = new stdclass;
						$data[$cont]['PARAM2'][0]->item = array();
						$data[$cont]['PARAM2'][0]->item[0] = new stdclass;
						$data[$cont]['PARAM2'][0]->item[0]->NOM = $reg[1];
						$data[$cont]['PARAM2'][0]->item[0]->ISDIR = 'E';
					}
				}
			}
		}
		$result = Zend_Json::encode($this->parseListDirOrFile2($data, 'dir', false, $path, $objectId, $context));
		$this->getResponse()->appendBody($result);
		return;
	}

	private function parseListDirOrFile2($data, $type, $dbnav, $path, $objectId, $context) {
		$result = array_shift($data);
		if(isset($result['PARAM2'])) {
			foreach ($result['PARAM2'] as $item) {
				if ($item) {
					$data = $item->item;
				}
			}
		}
		if (!$data) {
			$data = array();
		}
		if (!is_array($data)) {
			$data =  array($data);
		}
		$res = array();
		$res1 = array();
		$tmp1 = array();
		foreach ($data as $item) {
			if(isset($item->NOM)) {
				array_push($tmp1, $item->NOM);
			}
		}
		if(isset($_SESSION['charset'])) {
			$charset = $_SESSION['charset'];
		} else {
			$charset = 'UTF-8';
		}
		$tmp = arkphp_conv_charset($charset, $tmp1);
		$hostlist = $this->getclients();
		foreach ($data as $item) {
			if (isset($item->NOM) && $item->NOM != '..') {
				$dir_type = array('d', 'D', 'p', 'h', 'v', 'n', 'm');
				if(in_array($item->ISDIR, $dir_type)) {
					$new1 = array();
					if (in_array($item->ISDIR, $dir_type)) {
						$new1['isFolder'] = 'true';
					}
					$new1['objectId'] = $this->navpath_base64_encode($objectId);
					if ($path == ':') {
						if(!preg_match('`^('.implode('|', $hostlist).')`', $item->NOM)) {
							continue;
						}
						$new1['widgetId'] = $item->NOM;
						$new1['typeIcon'] = 'machine';
					} else {
						if (preg_match('/^[^!]*$/', $path)) {
							if($item->NOM != 'file') {
								continue;
							}	
							$new1['widgetId'] = $path.'!'.$item->NOM;
							$new1['typeIcon'] = 'plugin';
						} else {
							if (preg_match('/^[^:]*![^:]*$/', $path)) {
								if ($item->ISDIR == 'v') {
									$new1['widgetId'] = $path.':'.$item->NOM;
									$new1['typeIcon'] = 'filesystem';
								} else {
									$new1['widgetId'] = $path.':/'.$item->NOM;
									if (in_array($item->ISDIR, $dir_type)) {
										if($item->ISDIR == 'v') {
											$new1['typeIcon'] = 'filesystem';
										} else {
											$new1['typeIcon'] = 'folder';
										}
									} else {
										$new1['typeIcon'] = 'file';
									}
								}
							} else {
								$new1['widgetId'] = $path.'/'.$item->NOM;
								if (in_array($item->ISDIR, $dir_type)) {
									if($item->ISDIR == 'D') {
										$new1['typeIcon'] = 'symfolder';
									} else {
										if($item->ISDIR == 'v') {
											$new1['typeIcon'] = 'filesystem';
										} else {
											$new1['typeIcon'] = 'folder';
										}
									}
								} else {
									if($item->ISDIR == 'S') {
										$new1['typeIcon'] = 'symfile';
									} else {
										$new1['typeIcon'] = 'file';
									}
								}
							}
						}
					}
					$new1['treeIcon'] = '<img class="nav3_tree_icon_'.$new1['typeIcon'].'" src="' . $GLOBALS['baseurl'] . '/scripts/arkeia/widget/specTree/icon-'.$new1['typeIcon'].'-16x16.png" />';
					$titletmp = '<span class="nav3_tree_label type_'.$item->ISDIR.'">'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'</span>';
					$new1['title'] = $new1['treeIcon'] . $titletmp;
					$new1['type'] = $item->ISDIR;
					$new1['titleRight'] = '<span class="nav3_tree_label type_'.$item->ISDIR.'" title="'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'">'.$this->crop(htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8'), 12, 2).'</span>';
					$new1['titleRightLong'] = '<span class="nav3_tree_label type_'.$item->ISDIR.'" title="'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'">'.htmlspecialchars($tmp[$item->NOM], ENT_COMPAT, 'UTF-8').'</span>';
					$new1['fullTitle'] = htmlspecialchars(arkphp_conv_charset($charset, $new1['widgetId']), ENT_COMPAT, 'UTF-8');
					$new1['widgetId'] = $this->navpath_base64_encode($new1['widgetId']);
					if(isset($item->MODE)) {
						$new1['MODE'] = get_mode($item->MODE);
					}
					if(isset($item->UID)) {
						$new1['UID'] = $item->UID;
					}
					if(isset($item->GID)) {
						$new1['GID'] = $item->GID;
					}
					if(isset($item->FSIZE)) {
						$new1['FSIZE'] = $item->FSIZE;
					}
					if(isset($item->MDATE)) {
						$new1['MDATE'] = get_date($this, $item->MDATE);
					}
					$res1[$new1['widgetId']] = $new1;
				}
			}
		}
		ksort($res1);
		$res = array_values($res1);
		return $res;
	}

	private function crop($text, $nbchar, $nbline) {
		if(strlen($text)>$nbchar) {
			$parts = explode(' ', $text);
			if(count($parts) == 1) {
				$text = substr($parts[0], 0, $nbchar) . '...';
			} else {
				$newparts = array();
				$tmp = 0;
				for($i=0; $i<($nbline); $i++) {
					$newparts[$i] = array();
					while(strlen(implode('', $newparts[$i])) < $nbchar) {
						if(strlen($parts[$tmp]) > $nbchar) {
							if($i == $nbline-1) {
								$parts[$tmp] = substr($parts[$tmp], 0, ($nbchar-2)).'...';
							} else {
								$parts[$tmp] = substr($parts[$tmp], 0, $nbchar);
							}
						}
						array_push($newparts[$i], $parts[$tmp]);
						$tmp++;
						if(!isset($parts[$tmp]) || (strlen(implode('', $newparts[$i]) . $parts[$tmp]) > $nbchar)) {
							if(isset($parts[$tmp]) && (strlen(implode('', $newparts[$i]) . $parts[$tmp]) > $nbchar) && $i == $nbline-1) {
								array_push($newparts[$i], substr($parts[$tmp], 0, ($nbchar - strlen(implode('', $newparts[$i])) - 2)).'...');
							}
							break;
						}
					}
					if(!isset($parts[$tmp])) {
						break;
					}
				}
				foreach($newparts as $in=>$n) {
					$newparts[$in] = implode(' ', $newparts[$in]);
				}
				$text = implode(' ', $newparts);
			}
		}
		return $text;
	}

}
