<?php

require_once 'ArkeiaAction.php';

class UserController extends ArkeiaAction
{
    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }

    public function addAction()
    {
        $this->displayFromScreenIni('add');
    }

    public function updatepassAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updatepass', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonModifyObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);

        $params = $this->_request->getPost();

        $params['ALLOW'] = array();
        $params['DENY'] = array();

        switch($params['ALLOWDENY']) {
            case 'allow':
                array_push($params['ALLOW'], '*');
            break;
            case 'deny':
                array_push($params['DENY'], '*');
            break;
        }

        unset($params['ALLOWDENY']);

        foreach($params as $key=>$value) {
            if(preg_match('`^ALLOWDENYEXC(.*)$`', $key, $reg)) {
                $tmp = explode('_', $reg[1]);
                if($tmp[1] == 'path' && $value != '') {
                    if(isset($params['ALLOWDENYEXC' . $tmp[0] . '_type'])) {
                        array_push($params['ALLOW'], $value);
                    } else {
                        array_push($params['DENY'], $value);
                    }
                }
                unset($params[$key]);
            }
        }

        if(count($params['ALLOW']) == 0) {
            unset($params['ALLOW']);
        }

        if(count($params['DENY']) == 0 && count($params['ALLOW']) == 0) {
            array_push($params['DENY'], '*');
        }

        $info_user = $model->getOne($params[$idname])->item;

        require_once 'Zend/Json.php';
        if (isset($params['NEW_PASSWORD']) && $params['NEW_PASSWORD'] != $params['COMFIRM_PASSWORD']) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_no_match']);
        } else if (isset($params['NEW_PASSWORD']) 
            && !($info_user->PASSWORD == '' && $params['OLD_PASSWORD'] == '') 
            && $info_user->PASSWORD != crypt($params['OLD_PASSWORD'], substr($info_user->PASSWORD, 0, 2))) {
            $res = $this->_set_error_message($this->lang['user_modify_error_invalid_old_password']);
        } else { 
            if (isset($params['NEW_PASSWORD'])) {
                if (is_array($info_user->NODE))
                    $info_user->NODE = implode(" ", array_unique($info_user->NODE));
                if ($params['NEW_PASSWORD'] != '') {
                    $info_user->PASSWORD = crypt($params['NEW_PASSWORD'], "n3"); 
                } else {
                    $info_user->PASSWORD = $params['NEW_PASSWORD'];
                }
                $params = (array)$info_user;
            } else {
                $params['NODE'] = $this->_get_NODE($params);
            }

            if(isset($params['RAWNODE'])) {
                $params['RAWNODE'] = unserialize(base64_decode($params['RAWNODE']));
                if($params['RAWNODE'] == '["*"]') {
                    $params['NODE'] = '*';
                }
                unset($params['RAWNODE']);
            }

            foreach($params as $key=>$value) {
                if  (
                        preg_match('`^NODE_`', $key) ||
                        preg_match('`_selected$`', $key)
                    ) {
                    unset($params[$key]);
                }
            }
            unset($params['APPID_NAME']);
            unset($params['SUBMIT']);

            $data = $model->modifyObject($params, $context);

            $res = $this->_get_result($data, $context);
        }
      
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    private function _get_NODE($params)
    {
        $NODE = array();
        foreach ($params as $key => $val)
            if (preg_match('/^NODE\_/', $key))
                $NODE[] = $val;
        $NODE = implode(" ", array_unique($NODE));
        return ($NODE);
    }

    public function jsonCreateObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $params = $this->_request->getPost();

        $params['ALLOW'] = array();
        $params['DENY'] = array();

        switch($params['ALLOWDENY']) {
            case 'allow':
                array_push($params['ALLOW'], '*');
            break;
            case 'deny':
                array_push($params['DENY'], '*');
            break;
        }

        unset($params['ALLOWDENY']);

        foreach($params as $key=>$value) {
            if(preg_match('`^ALLOWDENYEXC(.*)$`', $key, $reg)) {
                $tmp = explode('_', $reg[1]);
                if($tmp[1] == 'path' && $value != '') {
                    if(isset($params['ALLOWDENYEXC' . $tmp[0] . '_type'])) {
                        array_push($params['ALLOW'], $value);
                    } else {
                        array_push($params['DENY'], $value);
                    }
                }
                unset($params[$key]);
            }
        }

        if(count($params['ALLOW']) == 0) {
            unset($params['ALLOW']);
        }

        if(count($params['DENY']) == 0 && count($params['ALLOW']) == 0) {
            array_push($params['DENY'], '*');
        }

        $params['NODE'] = '*';

        require_once 'Zend/Json.php';
        //error_log('create user params : '. Zend_Json::encode($params) .' NAME "'.$params['NAME'].'"' );

        if (!isset($params['NAME']) || $params['NAME'] == '') {
            $res = $this->_set_error_message($this->lang['user_create_error_name_require']);
        } else if (!isset($params['PASSWORD'])/* || $params['PASSWORD'] == ''*/) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_require']);
        } else if ($params['PASSWORD'] != $params['PASSWORD_COMFIRM']) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_no_match']);
        } else {
            if ($params['PASSWORD'] != '')
                $params['PASSWORD'] = crypt($params['PASSWORD'], "n3");
                unset($params['PASSWORD_COMFIRM']);

            foreach($params as $key=>$value) {
                if  (
                        preg_match('`^NODE_`', $key) ||
                        preg_match('`_selected$`', $key)
                    ) {
                    unset($params[$key]);
                }
            }
            unset($params['APPID_NAME']);
            unset($params['SUBMIT']);

            $data = $model->createObject($params, $this->view->context);
            //error_log('create user data : '. Zend_Json::encode($data));
            $res = $this->_get_result($data, $this->view->context);
        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetForComboboxAction()
    {
// USR_LIST_ALL ne retourne par de USERID
// on va donc utiliser le NAME qui est forcément une clé !!!
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = 'NAME';

        $array_context = $this->view->context;

        $appid = $this->_request->getParam(APPLIANCE_GUID);
        $context = null;

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
	        $appid = "local";
        }

        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);

	    $data = $res[$appid][PARAM2];
        $newres = array();
        if ($data) {
	        foreach ($data as $param) {
	            if (is_array($param->item)) {
	                foreach ($param->item as $obj) {
		                $newres[$obj->$idname] = $obj->NAME;
	                }
	            } else if ($param->item){
	                $newres[$param->item->$idname] = $param->item->NAME;
	            }
	        }
        }
	    $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultOneAction() {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOne($context);
        $res = $this->_get_result($data, $context);

        foreach($res as $appid=>$data) {
            if(isset($data['PARAM2']) && isset($data['PARAM2'][0]) && isset($data['PARAM2'][0]->item)) {
                $allowdenyexc = array();
                $allowdeny = '';
                if(isset($data['PARAM2'][0]->item->ALLOW)) {
                    if(!is_array($data['PARAM2'][0]->item->ALLOW)) {
                        $data['PARAM2'][0]->item->ALLOW = array($data['PARAM2'][0]->item->ALLOW);
                    }
                } else {
                    $data['PARAM2'][0]->item->ALLOW = array();
                }
                if(isset($data['PARAM2'][0]->item->DENY)) {
                    if(!is_array($data['PARAM2'][0]->item->DENY)) {
                        $data['PARAM2'][0]->item->DENY = array($data['PARAM2'][0]->item->DENY);
                    }
                } else {
                    $data['PARAM2'][0]->item->DENY = array();
                }
                foreach($data['PARAM2'][0]->item->ALLOW as $value) {
                    if($value != '*') {
                        array_push($allowdenyexc, array('type'=>'allow', 'value'=>$value));
                    } else {
                        $allowdeny = 'allow';
                    }
                }
                foreach($data['PARAM2'][0]->item->DENY as $value) {
                    if($value != '*') {
                        array_push($allowdenyexc, array('type'=>'deny', 'value'=>$value));
                    } else {
                        $allowdeny = 'deny';
                    }
                }
                $res[$appid]['PARAM2'][0]->item->ALLOWDENY = $allowdeny;
                $res[$appid]['PARAM2'][0]->item->ALLOWDENYEXC = $allowdenyexc;
                unset($res[$appid]['PARAM2'][0]->item->ALLOW);
                unset($res[$appid]['PARAM2'][0]->item->DENY);
            }
        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _getOne()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOne($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->item->$appidname = $this->view->appid_id;
            $data->item->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;
        return $data;
    }

	public function jsonGetAllNameIdnouserroleAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$idname = $ctrlcfg->id;
		if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
			$context = $this->_get_filtered_context($appid, $this->view->context);
		} else {
			$context = $this->view->context;
		}
		$res = $this->_getResultAll($context);
		if (!is_array($res)) $res = array($res);
		foreach($res as $key => $val) {
			if($context) {
				$data = $res[$key]->param3->item;
			} else {
				$data = $res[$key]->param2->item;
			}
			if($data){
				break;
			}
		}
		$res = array();
		if($data) {
			if(is_array($data)) {
				foreach ($data as $obj) {
					if(isset($obj->ROLE) && $obj->ROLE != 'USER') {
						$res[$obj->$idname] = (string) $obj->NAME;
					}
				}
			} else {
				if(isset($data->ROLE) && $data->ROLE != 'USER') {
					$res[$data->$idname] = (string) $data->NAME;
				}
			}
		}
		natcasesort($res);
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

}

?>
