<?php

require_once 'ArkeiaAction.php';

class VmhostController extends ArkeiaAction {
	public function addAction() {
		$this->view->hostlist = $this->getclients();
		$this->displayFromScreenIni('add');
	}
	public function jsonCreateObjectAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();
		require_once 'Zend/Json.php';
		unset($params['SUBMIT']);
		unset($params['NODE_selected']);
		unset($params['TYPE_selected']);
		if(!isset($params['NAME']) || $params['NAME'] == '') {
			$res = $this->_set_error_message($this->lang['vmhost_error_name']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		if(!isset($params['USER']) || $params['USER'] == '') {
			$res = $this->_set_error_message($this->lang['vmhost_error_user']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		if(isset($params['NODES']) && $params['NODES'] != '') {
			$nodes = Zend_Json::decode(str_replace('\'', '"', $params['NODES']));
			unset($params['NODE']);
			unset($params['NODES']);
			$params['NODE'] = array();
			foreach($nodes as $node) {
				array_push($params['NODE'], $node);
			}
		} else {
			$res = $this->_set_error_message($this->lang['vmhost_error_node']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		if(isset($params['PORT']) && (int)$params['PORT'] == 443) {
			$params['PORT'] = '';
		}
		$context = $this->view->context;
//$res = $this->_set_error_message(print_r($params, true));
		$data = $model->createObject($params, $context);
		$res = $this->_get_result($data, $context);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function updateAction() {
		$this->view->hostlist = $this->getclients();
		$info = $this->_getOne();
		$res = $this->displayFromScreenIni('update', FALSE);
		$this->_render_json_view($res);
		return;
	}
	public function jsonModifyObjectAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();
		require_once 'Zend/Json.php';
		unset($params['SUBMIT']);
		unset($params['NODE_selected']);
		unset($params['TYPE_selected']);
		if(isset($params['NEWNAME'])) {
			if($params['NEWNAME'] == $params['NAME']) {
				unset($params['NEWNAME']);
			}
		}
		if(!isset($params['USER']) || $params['USER'] == '') {
			$res = $this->_set_error_message($this->lang['vmhost_error_user']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		if(isset($params['NODES']) && $params['NODES'] != '') {
			$nodes = Zend_Json::decode(str_replace('\'', '"', $params['NODES']));
			unset($params['NODE']);
			unset($params['NODES']);
			$params['NODE'] = array();
			foreach($nodes as $node) {
				array_push($params['NODE'], $node);
			}
		} else {
			$res = $this->_set_error_message($this->lang['vmhost_error_node']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		if(isset($params['PORT']) && (int)$params['PORT'] == 443) {
			$params['PORT'] = '';
		}
		$context = $this->view->context;
//$res = $this->_set_error_message(print_r($params, true));
		$data = $model->modifyObject($params, $context);
		$res = $this->_get_result($data, $context);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	public function updatepassAction() {
		$info = $this->_getOne();
		$res = $this->displayFromScreenIni('updatepass', FALSE);
		$this->_render_json_view($res);
		return;
	}
	public function jsonModifyPasswordObjectAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();
		require_once 'Zend/Json.php';
		unset($params['SUBMIT']);
		if(!isset($params['PASSWD']) && $params['PASSWD'] != '') {
			$res = $this->_set_error_message($this->lang['vmhost_error_password']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}
		$context = $this->view->context;
//$res = $this->_set_error_message(print_r($params, true));
		$data = $model->modifyObject($params, $context);
		$res = $this->_get_result($data, $context);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}
	private function getclients() {
		$context = $this->view->context;
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$data = $model->GetResultAllHosts();
		$res = $this->_get_result($data, $context);
		foreach ($res as $appid=>$data) {
			if (isset($data['PARAM2'])) {
				if (!is_array($data['PARAM2'])) {
					$data['PARAM2'] = array($data['PARAM2']);
				}
				foreach ($data['PARAM2'] as $key=>$val) {
					if (isset($data['PARAM2'][$key]->item)) {
						if(!is_array($data['PARAM2'][$key]->item)) {
							$data['PARAM2'][$key]->item = array($data['PARAM2'][$key]->item);
						}
						$res = $data['PARAM2'][$key]->item;
						break;
						break;
					}
				}
			}
		}
		$hosts = array();
		foreach($res as $r) {
			if(isset($r->VNAME)) {
				array_push($hosts, $r->VNAME);
			} else {
				if(isset($r->NOM)) {
					array_push($hosts, $r->NOM);
				} else {
					array_push($hosts, 'unknown');
				}
			}
		}
		sort($hosts);
		return $hosts;
	}
}
