<?php

require_once 'ArkeiaAction.php';

class VtlController extends ArkeiaAction
{

  public function jsonVtlListBkpAction()
    {
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context, 'VTLID');
      $res = $this->displayFromScreenIni('vtllistbkp', FALSE);
      $this->_render_json_view($res);
      return;
    }

  public function jsonVtlBkpRemoveAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context, 'ID');

      require_once 'Zend/Json.php';
      $data = $model->vtlBkpRemove($id, $context);
      $res = $this->_get_result($data, $context);
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonVtlBckListAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);
      
      require_once 'Zend/Json.php';
      //DEBUG error_log('jsonVtlBckListAction id : '. $id);

      $data = $model->vtlBkpList($id, $context);

      $res = $this->_get_result($data, $context);
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      $params = $this->_request->getPost();

      $params['MEDIASERVER'] = $params['MEDIA_SERVER'];

      $params = $this->_clean_select_POST($params);
      $params = $this->_clean_POST($params);
      
      $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
      unset ($params['MEDIASERVER']);
	  
      require_once 'Zend/Json.php';

      //DEBUG error_log('jsonCreateObjectAction POST: '.Zend_Json::encode($params));

	switch($params['CAPACITY_unit']) {
		case $this->lang['unit_MB']:
			
		break;
		case $this->lang['unit_GB']:
			$params['CAPACITY'] *= 1024;
		break;
		case $this->lang['unit_TB']:
			$params['CAPACITY'] *= (1024*1024);
		break;
	}
	unset($params['CAPACITY_unit']);

      if (!isset($params['NAME']) || $params['NAME'] == '') {
          $res = $this->_set_error_message($this->lang['vtl_create_error_name_require']);
      } else if (!isset($params['PATH']) || $params['PATH'] == '') {
          $res = $this->_set_error_message($this->lang['vtl_create_error_path_require']);
      } else if (!isset($params['MEDIA_SERVER']) || $params['MEDIA_SERVER'] == '') {
          $res = $this->_set_error_message($this->lang['vtl_create_error_media_server_require']);
      } else {
 	  $params = $this->_transformParams($params);

      $data = $model->createObject($params, $this->view->context);
      $res = $this->_get_result($data, $this->view->context);
	  //DEBUG error_log('Create vtl res : '.Zend_Json::encode($res)); 
      }

      $result = Zend_Json::encode($res);

      $this->getResponse()->appendBody($result);
      return;
    }


  function _transformParams($params)
    {
      if ($params['D2T_AUTO'] == '0') {
	  unset($params['D2T_WHICH_BKP']);
	  unset($params['D2T_DELETE_BKP']);
	  unset($params['D2T_SIZE_AFTER']);
	  unset($params['D2T_SETUP_ID']);
	  unset($params['D2T_COND_TYPE']);
	  unset($params['D2T_COND_VAL']);
      } else {
	  switch ($params['D2T_COND_TYPE']) {
	    case 'USED_GT':
	      {
		$params['D2T_COND_VAL'] = $params['USED_GT_val'].(isset($params['USED_GT_unit']) ? $params['USED_GT_unit'] : '');
		break ;
	      }
 	    case 'AVAIL_LT':
	      {
		$params['D2T_COND_VAL'] = $params['AVAIL_LT_val'].(isset($params['AVAIL_LT_unit']) ? $params['AVAIL_LT_unit'] : '');
		break ;
	      }
	    case 'TIME_IS':
	      {
		if (preg_match('/^(\d{4})-(\d{2})-(\d{2})-(\d{2}):(\d{2}):(\d{2})/', 
			       $params['TIME_IS_date'].'-'.$params['TIME_IS_time'], $match)) {
		$params['D2T_COND_VAL'] = $match[1].$match[2].$match[3].'T'.$match[4].$match[5].$match[6];
		}
		break ;
	      }
	  }
	  $params['D2T_SIZE_AFTER'] = $params['D2T_SIZE_AFTER_val'].(isset($params['D2T_SIZE_AFTER_unit']) ? $params['D2T_SIZE_AFTER_unit'] : '');
      }

      unset($params['D2T_SIZE_AFTER_unit']);
      unset($params['D2T_SIZE_AFTER_val']);
      unset($params['TIME_IS_time']);
      unset($params['TIME_IS_date']);
      unset($params['AVAIL_LT_unit']);
      unset($params['AVAIL_LT_val']);
      unset($params['USED_GT_unit']);
      unset($params['USED_GT_val']);
      
      $params['item'] = array('DEFAULT' => '1', 'PATH' => $params['PATH'], 'MEDIA_SERVER' => $params['MEDIA_SERVER']);
      unset($params['PATH']);
      unset($params['MEDIA_SERVER']);
      return ($params);
    }


  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      require_once 'Zend/Json.php';

      $params = $this->_request->getPost();

	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];

      $params = $this->_clean_select_POST($params);
      $params = $this->_clean_POST($params);
      
	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);
	  
      require_once 'Zend/Json.php';

	switch($params['CAPACITY_unit']) {
		case $this->lang['unit_MB']:
			
		break;
		case $this->lang['unit_GB']:
			$params['CAPACITY'] *= 1024;
		break;
		case $this->lang['unit_TB']:
			$params['CAPACITY'] *= (1024*1024);
		break;
	}
	unset($params['CAPACITY_unit']);

      if ($params['MEDIA_SERVER'] == '') {
          $res = $this->_set_error_message($this->lang['vtl_create_error_media_server_require']);
      } else {
 	  $params = $this->_transformParams($params);
	  
	  unset($params['APPID_VTLID']);

      $data = $model->modifyObject($params, $context);
 	  //DEBUG error_log('Modify vtl data : '.Zend_Json::encode($data)); 
	  $res = $this->_get_result($data, $context);
	  //DEBUG error_log('Modify vtl res : '.Zend_Json::encode($res)); 
      }

      $result = Zend_Json::encode($res);

      $this->getResponse()->appendBody($result);
      return;
    }

	public function jsonGetAllnorepAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		$appid = $this->_request->getPost(APPLIANCE_GUID);
		$context = null;
		if ($appid && ($appid != "local")) {
			$context = $this->_get_filtered_context($appid, $array_context);
		} else if (!$appid){
			$context = $array_context;
		}
		if ($context) {
			$result = $this->_getResultAll($context);
			$data = null;
			$res = $this->_get_result($result, $context);
			$params = $res[$appid]['PARAM2'];
			if ($params) {
				foreach ($params as $param) {
					if (is_array($param->item)) {
						$data = $param->item;
						break;
					} else if ($param->item){
						$data = array($param->item);
						break;
					}
				}
			}
		} else {
			$data = $model->getAll($context);
		}
		$tmp = array();
		foreach($data as $obj) {
			if(!isset($obj->REP_CLIENT_ID)) {
				array_push($tmp, $obj);
			}
		}
		$data = $tmp;
		$arkobjects = $ctrlcfg->objects;
		$this->view->$arkobjects = $data;
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($data);
		$this->getResponse()->appendBody($result);
		return;
	}

}

?>
