<?php
/*
 * Created on 7 Nov. 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkAlert extends ArkObject {

  /*
 mode = 0 (no mode) -> modify screen 
 mode = 1 -> list raised screen
 mode = 2 -> root alert screen
  */

    public function getResultAll($context=null, $params = false)
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getAll;
        $trans_version = $this->_mvc->model->{$this->_model}->getAllVersion;
        if (!$trans_version) $trans_version= 1;

	$vector = array();
	if (!$params) {
	  $vector['param0'] = 0;
	  $vector['param1'] = 2;
	} else {
	  if (isset($params['listobj']) && $params['listobj'])
	    $vector['param0'] = $this->list2soap($params['listobj']);
	  else 
	    $vector['param0'] = $this->list2soap(array());
	  if (isset($params['listobj'])) {
	    if ($params['mode'])
	      $vector['param1'] = $params['mode'];
	  } else
	    $vector['param1'] = 2;
	    
	}
        $result = $this->new_trans($trans, $trans_version, 2, $vector, $context);

	// DEBUG error_log('getResultAll Alert: '.Zend_Json::encode($result));

        return $result;
    }

    public function checkAlert($context=null) {
      $trans = "ALERT_CHECK";
      $trans_version = 1;
      $vector = array();
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      //DEBUG error_log('checkAlert: '.Zend_Json::encode($result));

      return ($result);
    }

    public function unraiseAlert($id_pbnum, $context=null) {
      $trans = "ALERT_UNRAISE";
      $trans_version = 1;
      list ($id, $pbnum) = split('_', $id_pbnum);
      $vector = array("param0" => $id, "param1" => (int) $pbnum);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      //DEBUG error_log('unraiseAlert: '.Zend_Json::encode($result));

      return ($result);
    }

    public function modifyObject($list, $context=null) {
        $trans = "ALERT_MODIFY";
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	//DEBUG error_log('modifyObject Alert: '.Zend_Json::encode($result));

        return ($result);
    }

    public function getResultOne($id, $context=null)
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getOne;
        $trans_version = $this->_mvc->model->{$this->_model}->getOneVersion;

        if (!$trans_version) $trans_version= 1;
	$vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector,$context);

	//DEBUG error_log('Get One context: '.Zend_Json::encode($context));
        if ($context) {
	    $appid = $context[0]['APPLIANCE_GUID'];
            if ($result->param3) {
                $tParamsData = &$result->param3;
            } else {
                foreach ($result as $key => $val)
                    if ($result[$key]->param3)
                        $tParamsData = &$result[$key]->param3;
            }
        } else {
	    $appid = 'local';
            $tParamsData = &$result->param2;
	}

	$tParamsData->APPID_ALID = $appid.'_'.$tParamsData->ALID;
	//DEBUG error_log('Get One: '.Zend_Json::encode($result));
        return $result;
    }


}
?>
