<?php
/*
 * Created on 10 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php';


class ArkAppliance extends ArkObject {

    public function loadNetwork($context) {
        $trans = "SYS_NET_LIST";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        $result->param2->CNFID = 0;
        if (!is_array($result->param2->item))
            $result->param2->item = array($result->param2->item);

        $nhost = 0;
        for ($n = 0 ; $n < count($result->param2->item) ; $n++)
            if ($result->param2->item[$n]->IFACE == 'eth0')
            {
                $result->param2->ETH0_ADDRESS = $result->param2->item[$n]->ADDRESS;
                $result->param2->ETH0_NETMASK = $result->param2->item[$n]->NETMASK;
                $result->param2->ETH0_GATEWAY = $result->param2->item[$n]->GATEWAY;
                $result->param2->ETH0_BROADCAST = $result->param2->item[$n]->BROADCAST;
                $result->param2->ETH0_DHCP = in_array($result->param2->item[$n]->USE_DHCP, array('1', 'on')) ? '1' : '';
            }
            else if (!isset($result->param2->item[$n]->IFACE))
            {
                $hst_position = "HST{$nhost}_POSITION";
                $hst_addres = "HST{$nhost}_ADDRESS";
                $hst_hsfqdn = "HST{$nhost}_HOSTNAME_FQDN";
                $hst_alias = "HST{$nhost}_ALIAS";
                $result->param2->$hst_addres = $result->param2->item[$n]->ADDRESS;
                $result->param2->$hst_hsfqdn = $result->param2->item[$n]->HOSTNAME_FQDN;
                $result->param2->$hst_alias = $result->param2->item[$n]->ALIAS;
                $nhost++;
            }
        unset($result->param2->item);
        return ($result);
    }

    public function writeNetwork($context) {
        $result = $this->loadNetwork($context);

        $result->param2 = (array)$result->param2;
        $tUse1 = &$result->param2;
        $tUse2 = &$result->param2;
        $tUse3 = &$result->param2;
        if ($_POST['APPSHEET'] == '1') $tUse1 = &$_POST;
        if ($_POST['APPSHEET'] == '2') $tUse2 = &$_POST;
        if ($_POST['APPSHEET'] == '3') $tUse3 = &$_POST;

        $params = array();

        $params['NAMESERVER1'] = $tUse2['NAMESERVER1'];
        $params['NAMESERVER2'] = $tUse2['NAMESERVER2'];
        $params['NAMESERVER3'] = $tUse2['NAMESERVER3'];

        $params['HOSTNAME_FQDN'] = $tUse1['HOSTNAME_FQDN'];
        array_push($params, array(
            'IFACE' => "eth0",
            'USE_DHCP' => (in_array($tUse1['ETH0_DHCP'], array('on', '1')) ? '1' : ''),
            'ADDRESS' => $tUse1['ETH0_ADDRESS'],
            'NETMASK' => $tUse1['ETH0_NETMASK'],
            'GATEWAY' => $tUse1['ETH0_GATEWAY'],
            'BROADCAST' => $tUse1['ETH0_BROADCAST']
            ));

        for ($nhost = 0 ; $nhost < 100 ; $nhost++)
        {
            $hst_addres = trim($tUse3["HST{$nhost}_ADDRESS"]);
            $hst_hsfqdn = trim($tUse3["HST{$nhost}_HOSTNAME_FQDN"]);
            $hst_alias = trim($tUse3["HST{$nhost}_ALIAS"]);
            if ((!empty($hst_addres)) && (!empty($hst_hsfqdn)))
                array_push($params, array(
                    'POSITION' => $nhost,
                    'ADDRESS' => $hst_addres,
                    'HOSTNAME_FQDN' => $hst_hsfqdn,
                    'ALIAS' => $hst_alias
                ));
        }

        $list = $this->list2soap($params);

        $trans = "SYS_NET_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function loadSmtp($context) {
        $trans = "SYS_MAIL_LIST";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        $result->param2->CNFID = 0;
        list($result->param2->MAILHUB_SRV, $result->param2->MAILHUB_PORT) = split(":", $result->param2->MAILHUB, 2);
        if (empty($result->param2->MAILHUB_PORT))
            $result->param2->MAILHUB_PORT = 25;
        if (!empty($result->param2->AUTHUSER))
            $result->param2->CHECKAUTH = '1';
        if (empty($result->param2->SECURE_METHOD))
            $result->param2->SECURE_METHOD = 'NO';
        return ($result);
    }

	public function sysStatus($context) {
        $trans = "SYS_STATUS";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function writeSmtp($context) {
        $params = array();

        if (empty($_POST['MAILHUB_PORT']))
            $_POST['MAILHUB_PORT'] = 25;
        $params['MAILHUB'] = $_POST['MAILHUB_SRV'] . ':' . $_POST['MAILHUB_PORT'];
        if ($_POST['CHECKAUTH'] == 'on')
        {
            $params['AUTHUSER'] = $_POST['AUTHUSER'];
            $params['AUTHPASS'] = $_POST['AUTHPASS'];
        }
        $params['SECURE_METHOD'] = $_POST['SECURE_METHOD'];

        $list = $this->list2soap($params);

        $trans = "SYS_MAIL_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function loadTime($context) {
        $trans = "SYS_TIME_LIST";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        $result->param2->CNFID = 0;
        if (empty($result->param2->USE_NTP))
            $result->param2->USE_NTP = '0';

        $pattern = '/(\d\d\d\d)(\d\d)(\d\d)T(\d\d)(\d\d).*/i';
        if (preg_match($pattern, $result->param2->DATE, $matches))
        {
            $result->param2->PART_TIME = $matches[4] . ':' . $matches[5];
            $result->param2->PART_DATE = $matches[1] . '-' . $matches[2] . '-' . $matches[3];
        }

        return ($result);
    }

    public function writeTime($context) {
        $result = $this->loadNetwork($context);
        $result->param2 = (array)$result->param2;

        $params = array();
        if ($_POST['USE_NTP'] == '1')
        {
            $params['USE_NTP'] = '1';
            //$params['DATE'] = $result->param2->DATE;//this should not be set in case of ntp
            $params['NTPSERVER1'] = $_POST['NTPSERVER1'];
            $params['NTPSERVER2'] = $_POST['NTPSERVER2'];
            $params['NTPSERVER3'] = $_POST['NTPSERVER3'];
            $params['NTPSERVER4'] = $_POST['NTPSERVER4'];
        }
        else
        {
            $params['USE_NTP'] = '0';
            $params['DATE'] = $this->cnvDate($_POST['PART_DATE']) . 'T' . $this->cnvTime($_POST['PART_TIME']);
            $params['NTPSERVER1'] = $result->param2->NTPSERVER1;
            $params['NTPSERVER2'] = $result->param2->NTPSERVER2;
            $params['NTPSERVER3'] = $result->param2->NTPSERVER3;
            $params['NTPSERVER4'] = $result->param2->NTPSERVER4;
        }

        $list = $this->list2soap($params);

        $trans = "SYS_TIME_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function writeTimeZone($context) {
        $result = $this->loadNetwork($context);
        $result->param2 = (array)$result->param2;

        $params = array();

        $params['TIMEZONE'] = $_POST['TIMEZONE_selected'];

        $list = $this->list2soap($params);

        $trans = "SYS_TIME_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function loadSsh($context) {
        $trans = "SYS_SERVICE_LIST";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if (empty($result->param2->USE_SSH)) {
            $result->param2->USE_SSH = '0';
        }
        return ($result);
    }

    public function writeSsh($context) {
        $params = array();

        $params['USE_SSH'] = ($_POST['USE_SSH'] == 'on')?'1':'0';

        $list = $this->list2soap($params);

        $trans = "SYS_SERVICE_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

   public function loadRaid($context, $tLang) {
        $trans = "SYS_RAID_LIST";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if (!is_array($result->param2->item))
            $result->param2->item = ARRAY($result->param2->item);


        $result->param2->INFO_R0_S1_RAID = 'ARRAY 0';
        $result->param2->INFO_R0_S1_STAT = 'UNSET';
        $result->param2->INFO_R0_S1_ACTX = 'A';
        $result->param2->INFO_R0_S1_ACTN = $tLang['app_raid_action_add'];
        $result->param2->INFO_R0_S2_RAID = 'ARRAY 0';
        $result->param2->INFO_R0_S2_STAT = 'UNSET';
        $result->param2->INFO_R0_S2_ACTX = 'A';
        $result->param2->INFO_R0_S2_ACTN = $tLang['app_raid_action_add'];

        for ($n = 0 ; $n < count($result->param2->item) ; $n++)
        {
//            $result->param2->item[$n]->FAILED_DISK_LIST = '2';

            $tDiskFailed = explode(' ', trim($result->param2->item[$n]->FAILED_DISKS_LIST));
            $raidNum = $result->param2->item[$n]->ARRAY_NUM;
            $vraid = "INFO_RAID{$raidNum}";
            $status = trim(strtoupper((string)$result->param2->item[$n]->ARRAY_STATE));
            $action = trim(strtoupper((string)$result->param2->item[$n]->SYNC_ACTION));
            $percent = strtoupper($result->param2->item[$n]->SYNC_COMPLETED);
            if (isset($result->param2->item[$n]->ARRAY_DEGRADED))
                $result->param2->$vraid = 'DEGRADED';
            else if (!empty($action))
                $result->param2->$vraid = $action . ' ' . $percent . '%';
            else
                $result->param2->$vraid = $status;
// Initialisation a DETACHED

            $vs1 = "INFO_R{$raidNum}_S1_STAT";
            $vs2 = "INFO_R{$raidNum}_S2_STAT";
            $vx1 = "INFO_R{$raidNum}_S1_ACTX";
            $vx2 = "INFO_R{$raidNum}_S2_ACTX";
            $va1 = "INFO_R{$raidNum}_S1_ACTN";
            $va2 = "INFO_R{$raidNum}_S2_ACTN";

            if (isset($result->param2->item[$n]->NB_UNKNOWN_DISKS))
            {
                $result->param2->$vs1 = 'DETACHED';
                $result->param2->$vs2 = 'DETACHED';
                $result->param2->$vx1 = 'S';
                $result->param2->$vx2 = 'S';
                $result->param2->$va1 = $tLang['app_raid_action_removespe'];
                $result->param2->$va2 = $tLang['app_raid_action_removespe'];
            }

            $d1 = $result->param2->item[$n]->DISK1;
            $d2 = $result->param2->item[$n]->DISK2;
            $vs1 = "INFO_R{$raidNum}_S{$d1}_STAT";
            $vs2 = "INFO_R{$raidNum}_S{$d2}_STAT";
            $vx1 = "INFO_R{$raidNum}_S{$d1}_ACTX";
            $vx2 = "INFO_R{$raidNum}_S{$d2}_ACTX";
            $va1 = "INFO_R{$raidNum}_S{$d1}_ACTN";
            $va2 = "INFO_R{$raidNum}_S{$d2}_ACTN";


// Si les disk sont present on les met a OK !!!
            if (isset($result->param2->item[$n]->DISK1))
            {
                $result->param2->$vs1 = 'OK';
                $result->param2->$vx1 = 'R';
                $result->param2->$va1 = $tLang['app_raid_action_remove'];
            }

            if (isset($result->param2->item[$n]->DISK2))
            {
                $result->param2->$vs2 = 'OK';
                $result->param2->$vx2 = 'R';
                $result->param2->$va2 = $tLang['app_raid_action_remove'];
            }

            if (isset($result->param2->item[$n]->SYNC1))
            {
                $result->param2->$vs1 = 'SYNC';
                if ($result->param2->$vx1 != 'N')
                    $result->param2->$vx1 = 'R';
                $result->param2->$va1 = $tLang['app_raid_action_remove'];
                $result->param2->$vx2 = 'N';
                $result->param2->$va2 = '';
            }
            if (isset($result->param2->item[$n]->SYNC2))
            {
                $result->param2->$vs2 = 'SYNC';
                if ($result->param2->$vx2 != 'N')
                    $result->param2->$vx2 = 'R';
                $result->param2->$va2 = $tLang['app_raid_action_remove'];
                $result->param2->$vx1 = 'N';
                $result->param2->$va1 = '';
            }

            for ($e = 0 ; $e < count($tDiskFailed) ; $e++)
            {
                $ne = $tDiskFailed[$e];
                $vs = "INFO_R{$raidNum}_S{$ne}_STAT";
                $va = "INFO_R{$raidNum}_S{$ne}_ACTN";
                $vx = "INFO_R{$raidNum}_S{$ne}_ACTX";
                $result->param2->$vs = 'FAILED';
                $result->param2->$vx = 'R';
                $result->param2->$va = $tLang['app_raid_action_remove'];
            }
        }
        return ($result);
    }

    public function changeRaid($context, $action) {
        $nRaid = (int)$_POST['RaidNo'];
        $nDisk = (int)$_POST['DiskNo'];
        $useForce = ($_POST['USE_FORCE'] == 'on')?1:0;

        if ($action == 'A') {
            $trans = "SYS_RAID_ADD_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            if ($useForce == 1)
                $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => (int)$nDisk, "param4" => $useForce);
            else
                $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => (int)$nDisk);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        if ($action == 'R') {
            $trans = "SYS_RAID_RM_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => (int)$nDisk);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        if ($action == 'S') {
            $trans = "SYS_RAID_RM_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => -1);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        return ($result);
    }


/*
    public function writeRaid($context) {
        $params = array();

        $params['USE_SSH'] = ($_POST['USE_SSH'] == 'on')?'1':'0';

        $list = $this->list2soap($params);

        $trans = "SYS_RAID_MODIFY";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function raidChangeState($context) {
        $result = $this->loadRaid($context, array());
        $nRaid = $_GET['RaidNo'];
        $nDisk = $_GET['DiskNo'];

        $vd = "INFO_R{$nRaid}_S{$nDisk}_ACTX";
        $action = $result->param2->$vd;

        if ($action == 'A') {
            $trans = "SYS_RAID_ADD_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => (int)$nDisk);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        if ($action == 'R') {
            $trans = "SYS_RAID_RM_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => (int)$nDisk);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        if ($action == 'S') {
            $trans = "SYS_RAID_RM_DISK";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => (int)$nRaid, "param3" => -1);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
    }
*/
    public function writePassword($context) {
        $params = array();

        $session_arkeia = Zend_Registry::get('session_arkeia');
        $old = (string)$_POST['OLDROOTPASS'];
        $new = (string)$_POST['NEWROOTPASS'];
        $cnf = (string)$_POST['RNWROOTPASS'];

        if ($new != $cnf)
        {
            $result = new StdClass();
            $result->last = '1';
            $result->param0 = '2';
            $result->param1 = 'New Password and Comfirm password must be the same!';
            $result->transnum = 3;
            $result->sessnum = 2;
        }
        else if ($old != $session_arkeia->passroot)
        {
            $result = new StdClass();
            $result->last = '1';
            $result->param0 = '2';
            $result->param1 = 'Wrong password!';
            $result->transnum = 3;
            $result->sessnum = 2;
        }
        else
        {
            $list = $this->list2soap($params);
            $trans = "SYS_CHANGE_PASSWD";
            $trans_version = 2;
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => 'root', "param3" => $new);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
            if ($result->param0 == '0')
                $session_arkeia->passroot = $new;
        }
        return ($result);
    }

    public function writeRestart($context) {
        $params = array();

        if (isset($_POST['RESTART']))
        {
            $params['REBOOT'] = $_POST['RESTART'];
            $list = $this->list2soap($params);
            $trans = "SYS_SERVICE_MODIFY";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        return ($result);
    }

    public function writeShutdown($context) {
        $params = array();

        if (isset($_POST['POWEROFF']))
        {
            $params['POWEROFF'] = $_POST['POWEROFF'];
            $list = $this->list2soap($params);
            $trans = "SYS_SERVICE_MODIFY";
            $trans_version = 2;
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        }
        return ($result);
    }

    public function cnvDate($date)
    {
        return (str_replace('-', '', $date));
    }

    public function cnvTime($time)
    {
        return (substr(str_replace(':', '', $time), 0, 6));
    }

    public function SysVMDiskList($context) {

        $trans = "SYS_VMDISK_LIST";
        $trans_version = 1;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);

    }

    public function SysVMDiskExpand($context) {

        $trans = "SYS_VMDISK_EXPAND";
        $trans_version = 1;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, 'param2' => 1);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);

    }

    public function isGetNext($data) {
	    $result = new stdclass;
	    $result ->res = false;
	    if(!is_array($data)) {
		    if($data->last == '0' || ($data->param0 == '12' && $data->param1 == '2')) {
			    $result->res = true;
			    $result->transnum = $data->transnum;
			    $result->sessnum = $data->sessnum;
		    }
	    } else {
		    $tmp = $data['list'.(count($data) - 2)];
		    if($tmp->last == '0' || ($tmp->param0 == '12' && $tmp->param1 == '2')) {
			    $result->res = true;
			    $result->transnum = $data['local']->transnum;
			    $result->sessnum = $data['local']->sessnum;
		    }
	    }
	    return $result;
    }

    public function UsrListAll($context=null)
    {
	$trans = "USR_LIST_ALL";
	$trans_version = 1;
	$session_arkeia = Zend_Registry::get('session_arkeia');
	$vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	$i = 0;
	while(true) {
		$check = $this->isGetNext($result);
		if($i >= 50 || !$check->res) {
			break;
		}
		usleep(250000);
		$i++;
		$result = $this->getNext($check->transnum, $check->sessnum, $context);
	}
	return ($result);
    }

    public function RaidAlertList($context) {
        $trans = "SYS_RAIDALERT_LIST";
        $trans_version = 1;
	$session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function RaidAlertUpdate($context) {
        $trans = "SYS_RAIDALERT_UPDATE";
        $trans_version = 1;
	$session_arkeia = Zend_Registry::get('session_arkeia');

        $params = array();
	if (isset($_POST['ENABLE'])) {
	    $params['ENABLE'] = $_POST['ENABLE'];
	}
	else {
	    $params['ENABLE'] = '0';
	}
	if (isset($_POST['USER'])) {
	    $params['USER'] = $_POST['USER'];
	}
	if (isset($_POST['EMAIL'])) {
	    $params['EMAIL'] = $_POST['EMAIL'];
	}
        $list = $this->list2soap($params);
	$vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => $list);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function SysExpDiskExpand($context) {

        $trans = "SYS_RAID_EXPAND";
        $trans_version = 1;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, 'param2' => 0);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);

    }

}
?>
