<?php
/*
 * Created on 10 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

function set_item_disp_dates($model, $item)
{
	if ($item->DATE) $item->DISP_DATE = date("Y/m/d H:i",$item->DATE);
	if ($item->END_DATE) $item->DISP_END_DATE = date("Y/m/d H:i",$item->END_DATE);
}

class ArkBackup extends ArkObject {

	public function isGetNext($data) {
		$result = new stdclass;
		$result ->res = false;
		if(!is_array($data)) {
			if($data->last == '0' || ($data->param0 == '12' && $data->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data->transnum;
				$result->sessnum = $data->sessnum;
			}
		} else {
			$tmp = $data['list'.(count($data) - 2)];
			if($tmp->last == '0' || ($tmp->param0 == '12' && $tmp->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data['local']->transnum;
				$result->sessnum = $data['local']->sessnum;
			}
		}
		return $result;
	}

    public function getResultSome($number=0, $on_disk = false, $context=null) {
	$trans = $on_disk ? "BKP_LIST_ON_DISK" : "BKP_LIST_SOME";
        $trans_version = 2;
        $vector = array("param0" => (int)$number);

        if      (
                        (
                               $on_disk &&
                                isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                                isset($_COOKIE['subaction']) && ($_COOKIE['subaction'] == 'd2d2d/interactive' || $_COOKIE['subaction'] == 'd2d2t/interactive')
                        ) || (
                                !$on_disk &&
                                isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                                isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                        )
                ) {

                $vector['param1'] = $_COOKIE['base'];

        }

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	$i = 0;
	while(true) {
		$check = $this->isGetNext($result);
		if($i >= 50 || !$check->res) {
			break;
		}
		usleep(250000);
		$i++;
		$result = $this->getNext($check->transnum, $check->sessnum, $context);
	}
        if ($result == null) return null;
        return $this->_transform_items($result, $context, 'set_item_disp_dates');
    }

    public function listSome($number=0, $context=null) {
        $result = $this->getResultSome($number, $context);
        $data = $result->param2;
        return $data;
    }
    
    public function abortBackup($bksid, $tcp_port, $context=null) {
	$trans = "ARKBKP_ABORT";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function addSavepack($bksid, $tcp_port, $spkid, $context=null) {
	$trans = "ARKBKP_ADD_SAVEPACK";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port, "param2" => $spkid);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function keepAlive($bksid, $tcp_port, $pid, $context=null) {
	$trans = "ARKBKP_KEEP_ALIVE";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port, "param2" => $pid);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function stopAlive($bksid, $tcp_port, $pid, $context=null) {
	$trans = "ARKBKP_STOP_ALIVE";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port, "param2" => $pid);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function cruiseControl($bksid, $tcp_port, $cruise, $context=null) {
	$trans = "ARKBKP_CRUISE";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port, "param2" => (int)$cruise);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function answer($bksid, $tcp_port, $dest, $drvid = false, $context=null) {
	$trans = "ARKBKP_ANSWER";
	$trans_version = 2;
	if ($drvid) 
	  $vector = array("param0" => (int)hexdec($bksid), "param1" => (int)$tcp_port, "param2" => (int)$dest, 'param3' => $drvid);
	else	  
	  $vector = array("param0" => (int)hexdec($bksid), "param1" => (int)$tcp_port, "param2" => (int)$dest);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function getStat($bksid, $tcp_port, $context=null) {
	$trans = "ARKBKP_STAT";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($result == null) return null;
        $data = $result->param3;
	if ($data) {
	    $data->ID_PORT = $bksid . "_" . $tcp_port;
	}
        return ($result);
    }

    public function getListActive($context=null) {
        $trans = "BKP_LIST_ACTIVE";
	$trans_version = 2;
	$vector = array();
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($result == null) return null;
        return ($result);
    }

    public function getOneActive($bksid, $context=null) {
	$trans = "BKP_ONE_ACTIVE";
	$trans_version = 2;
	$vector = array("param0" => $bksid);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($result == null) return null;
        return ($result);
    }

    public function getOplist($bksid, $tcp_port, $context=null) {
	$trans = "ARKBKP_OPLIST";
	$trans_version = 2;
	$vector = array("param0" => $bksid, "param1" => (int)$tcp_port);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function startBackup($start_list, $context=null) {
	$trans = "ARKBKP_START";
	$trans_version = 2;
	$vector = array("param0" => $this->list2soap($start_list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

}
?>
