<?php
require_once 'ArkObject.php';

class ArkReplication extends ArkObject
{

	/**	ARKRSYNCD PART    **/

	public function isInstalled() {
		$trans = "ARKRSYNCD_IS_INSTALLED";
		$trans_version = 1;
		$vector = array();
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdInstall($path) {
		$trans = "ARKRSYNCD_INSTALL";
		$trans_version = 1;
		$vector = array("param0" => $path);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdRemove() {
		$trans = "ARKRSYNCD_REMOVE";
		$trans_version = 1;
		$vector = array();
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdStart() {
		$trans = "ARKRSYNCD_START";
		$trans_version = 1;
		$vector = array();
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdStop() {
		$trans = "ARKRSYNCD_STOP";
		$trans_version = 1;
		$vector = array();
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdgetconfig($id) {
		$trans = "ARKRSYNCD_GET_CONFIG";
		$trans_version = 1;
		if ($id == null) {
			$vector = array();
		}
		else {
			$vector = array("param0" => $id);
		}
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function getVolumes() {
		$trans = "ARKRSYNCD_GET_VOLUMES";
		$trans_version = 1;
		$vector = array();
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function createModule($params) {
		$trans = "ARKRSYNCD_CREATE_MODULE";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function RemoveModule($id) {
		$trans = "ARKRSYNCD_REMOVE_MODULE";
		$trans_version = 1;
		$vector = array("param0" => $id);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncdgethostconfig($id) {
		$trans = "ARKRSYNCD_GET_HOST_CONFIG";
		$trans_version = 1;
		if ($id == null) {
			return (null);
		}
		else {
			$vector = array("param0" => $id);
		}
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function getOneModify($id, $context=null)
	{
		$result = $this->arkrsyncdgetconfig($id);

		if ($result == null) return null;
		if (is_array($result)) {
			foreach ($result as $key => $val) {
				if ($key == "local") continue;
				if ($context && $result[$key]->param0 == "0") continue;
				if ($context) {
					$data = $result[$key]->param3;
				} else {
					$data = $result[$key]->param2;
				}
				return $data;
			}
		} else {
			if ($context) {
				$data = $result->param3;
			} else {
				$data = $result->param2;
			}
			return $data;
		}
		return null;
	}

	public function modifyModule($list, $id = null, $context = null) {
		$trans = "ARKRSYNCD_SET_CONFIG";
		$trans_version = 1;
		if ($id == null) {
			/* Modify global options */
			/* We don't have a webpage for that now */
			$vector = array("param0" => $this->list2soap($list));
		}
		else {
			$vector = array("param0" => $id, "param1" => $this->list2soap($list));
		}
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}


	/**	ARKRSYNC PART    **/

	public function arkrsyncgetconfig($id=null, $context=null) {
		if ($id == null) {
			$trans = "REP_LIST_DATACENTER";
			$vector = array();
		}
		else {
			$trans = "REP_GET_DATACENTER";
			$vector = array("param0" => $id);
		}
		$trans_version = 1;
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function arkrsyncgetconfigModify($id, $context=null) {
		$result = $this->arkrsyncgetconfig($id);

		if ($result == null) return null;
		if (is_array($result)) {
			foreach ($result as $key => $val) {
				if ($key == "local") continue;
				if ($context && $result[$key]->param0 == "0") continue;
				if ($context) {
					$data = $result[$key]->param3;
				} else {
					$data = $result[$key]->param2;
				}
				return $data;
			}
		} else {
			if ($context) {
				$data = $result->param3;
			} else {
				$data = $result->param2;
			}
			return $data;
		}
		return null;
	}

	public function declareDc($params) {
		$trans = "REP_ADD_DATACENTER";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function declareGuestDc($params) {
		$trans = "REP_ADD_GUEST_DATACENTER";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function modifyDc($params) {
		$trans = "REP_MODIFY_DATACENTER";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}


	public function RemoveDc($id) {
		$trans = "REP_RM_DATACENTER";
		$trans_version = 1;
		$vector = array("param0" => $id);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function schreplistall($context=null) {
		$trans = "SCH_REP_LIST_ALL";
		$trans_version = 1;
		$vector = array("param0" => "ARKREP_START");
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function schrepchainlistall($context=null) {
		$trans = "SCH_REP_LIST_ALL";
		$trans_version = 1;
		$vector = array("param0" => "ARKREP_CHAIN_START");
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function schreplistone($id, $context=null) {
		$trans = "SCH_REP_LIST_ONE";
		$trans_version = 1;
		$vector = array("param0" => $id);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

		if ($context) {
			if ($result->param3) {
				$tParamsData = &$result;
			} else {
				foreach ($result as $key => $val)
					if ($result[$key]->param3)
						$tParamsData = &$result[$key];
			}
			foreach(get_object_vars($tParamsData->param3) as $key => $val) {
                if($key == 'item') {
                    $key = 'svpk';
                }
				$tParamsData->param3->{$key} = $val;
			}
			unset($tParamsData->param4);
			$tParamsData = $tParamsData->param3;
		} else {
			foreach(get_object_vars($result->param3) as $key => $val) {
                if($key == 'item') {
                    $key = 'svpk';
                }
				$result->param2->{$key} = $val;
			}
			unset($result->param3);
			$tParamsData = &$result->param2;
		}

		if ($tParamsData->REP_ACTIVE == 1) {
			$tParamsData->REP_ACTIVE = '1';
		}
		else {
			$tParamsData->REP_ACTIVE = '0';
		}

		$tmp = $tParamsData->RRULE;
		$pattern = '/([A-Z]*)(\d*) (?:([^\*].*) )?((\*)(\d*)|((\d\d\d\d)(\d\d)(\d\d)T(\d\d)(\d\d)(\d\d)))/i';
		if (preg_match($pattern, $tmp, $matches)) {
			switch($matches[1]) {
			case 'D':
				$tParamsData->RRULE_PER = 'D';
				$tParamsData->RRULE_EVR = $matches[2];
				$tParamsData->RRULE_JRSWE = '1';
				break;
			case 'W':
				$tParamsData->RRULE_PER = 'W';
				$tParamsData->RRULE_EVR = $matches[2];
				$tJrs = explode(' ', trim($matches[3]));
				for ($w = 0 ; $w < count($tJrs) ; $w++) {
					$jvar = "RRULE_JRS" . $tJrs[$w];
					$tParamsData->$jvar = '1';
				}
				break;
			case 'MD':
				$tParamsData->RRULE_PER = 'M';
				$tParamsData->RRULE_EVR = $matches[2];
				if ($matches[3] > 0) {
					$tParamsData->RRULE_M_MORE = '0';
					$tParamsData->RRULE_M_FSTR = $matches[3];
				} else {
					$tParamsData->RRULE_M_MORE = '1';
					$tParamsData->RRULE_M_FEND = -$matches[3];
				}
				$tParamsData->RRULE_JRSWE = '1';
				break;
			case 'MP':
				$tParamsData->RRULE_M_MORE = '2';
				$tParamsData->RRULE_PER = 'M';
				$tParamsData->RRULE_EVR = $matches[2];
				$tInfo = explode(' ', trim($matches[3]));
				$tParamsData->RRULE_M_NUMWEEK = $tInfo[0];
				$tParamsData->RRULE_M_JRSWEEK = $tInfo[1];
				$tParamsData->RRULE_JRSWE = '1';
				break;
			case 'YD':
				$tParamsData->RRULE_PER = 'Y';
				$tParamsData->RRULE_EVR = $matches[2];
				if ($matches[3] > 0) {
					$tParamsData->RRULE_Y_MORE = '0';
					$tParamsData->RRULE_Y_FSTR = $matches[3];
					$tParamsData->RRULE_Y_FEND = 10;
				} else {
					$tParamsData->RRULE_Y_MORE = '1';
					$tParamsData->RRULE_Y_FSTR = 10;
					$tParamsData->RRULE_Y_FEND = -$matches[3];
				}
				$tParamsData->RRULE_JRSWE = '1';
				break;
			case 'YM':
				$tParamsData->RRULE_Y_MORE = '2';
				$tParamsData->RRULE_PER = 'Y';
				$tParamsData->RRULE_EVR = $matches[2];
				$tInfo = explode(' ', trim($matches[3]));
				$tParamsData->RRULE_Y_NUMMONTH = $tInfo[0];
				$tParamsData->RRULE_Y_NUMDAY = $tInfo[1];
				$tParamsData->RRULE_JRSWE = '1';
				break;
			}

			if ($matches[5] == '*') {
				if ($matches[6] == '0') {
					$tParamsData->LAST_NBREP = '1';
					$tParamsData->LAST_MORE = '2';
					$tParamsData->LAST_DATE = date('Y-m-d',  mktime());
				} else {
					$tParamsData->LAST_NBREP = $matches[6];
					$tParamsData->LAST_MORE = '1';
					$tParamsData->LAST_DATE = date('Y-m-d',  mktime());
				}
			} else {
				$tParamsData->LAST_MORE = '0';
				$tParamsData->LAST_NBREP = '0';
				$tParamsData->LAST_DATE = $matches[8] . '-' . $matches[9] . '-' . $matches[10];
			}
		}

		$tmp = $tParamsData->START_DATE;
		// 20070523T151000
		$pattern = '/(\d\d\d\d)(\d\d)(\d\d)T(\d\d)(\d\d).*/i';
		if (preg_match($pattern, $tmp, $matches)) {
			$tParamsData->FORM_TIME = $matches[4] . ':' . $matches[5];
			$tParamsData->FORM_DATE = $matches[1] . '-' . $matches[2] . '-' . $matches[3];
		}

		$tException = array();
		if (!is_array($tParamsData->item))
			$tParamsData->item = array($tParamsData->item);
		for($e = 0 ; $e < count($tParamsData->item) ; $e++) {
			if (isset($tParamsData->item[$e]->NAME)) {
				// Il s'agit d'une exception
				$edate = $tParamsData->item[$e]->NAME;
				$edate = substr($edate, 0, 4) . '-' . substr($edate, 4, 2) . '-' . substr($edate, 6, 2);
				$tException[] = $edate;
			}
		}
		$tParamsData->TEXCEPTION = implode(',', $tException);

        unset($tParamsData->item);

        if(isset($tParamsData->svpk)) {

            if (!is_array($tParamsData->svpk)) {
                $tParamsData->svpk = array($tParamsData->svpk);
            }

            $tParamsData->item = $tParamsData->svpk;
            unset($tParamsData->svpk);

        } else {
            $tParamsData->item = array();
        }

		return ($result);
	}

	public function RemoveSchRep($id) {
		$trans = "SCH_REP_REMOVE";
		$trans_version = 1;
		$vector = array("param0" => $id);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

	public function CreateSchRep($list1, $list2, $context=null)
	{
		$trans = "SCH_REP_CREATE";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($list1), "param1" => $this->list2soap($list2));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}


	public function cnvDate($date)
	{
		return (str_replace('-', '', $date));
	}

	public function cnvTime($time)
	{
		return (substr(str_replace(':', '', $time), 0, 6));
	}

	public function implodeSchInfo($params)
	{
		switch($params->RRULE_PER) {
		case 'D':
			$part1 = 'D' . $params->RRULE_EVR;
			break;
		case 'W':
			$tJ = array();
			if ($params->RRULE_JRSMO == 'on') $tJ[] = 'MO';
			if ($params->RRULE_JRSTU == 'on') $tJ[] = 'TU';
			if ($params->RRULE_JRSWE == 'on') $tJ[] = 'WE';
			if ($params->RRULE_JRSTH == 'on') $tJ[] = 'TH';
			if ($params->RRULE_JRSFR == 'on') $tJ[] = 'FR';
			if ($params->RRULE_JRSSA == 'on') $tJ[] = 'SA';
			if ($params->RRULE_JRSSU == 'on') $tJ[] = 'SU';
			$part1 = trim('W' . $params->RRULE_EVR . ' ' . implode(' ', $tJ));
			break;
		case 'M':
			switch($params->RRULE_M_MORE) {
			case '0':
				$part1 = 'MD' . $params->RRULE_EVR . ' ' . $params->RRULE_M_FSTR;
				break;
			case '1':
				$part1 = 'MD' . $params->RRULE_EVR . ' -' . $params->RRULE_M_FEND;
				break;
			case '2':
				$part1 = 'MP' . $params->RRULE_EVR . ' ' . $params->RRULE_M_NUMWEEK . ' ' . $params->RRULE_M_JRSWEEK;
				break;
			}
			break;
		case 'Y':
			switch($params->RRULE_M_MORE) {
			case '0':
				$part1 = 'YD' . $params->RRULE_EVR . ' ' . $params->RRULE_Y_FSTR;
				break;
			case '1':
				$part1 = 'YD' . $params->RRULE_EVR . ' -' . $params->RRULE_Y_FEND;
				break;
			case '2':
				$part1 = 'YM' . $params->RRULE_EVR . ' ' . $params->RRULE_Y_NUMMONTH . ' ' . $params->RRULE_Y_NUMDAY;
				break;
			}
			break;
		}
		switch($params->LAST_MORE) {
		case '0':
			$part2 = $this->cnvDate($params->LAST_DATE) . 'T000000';
			break;
		case '1':
			$part2 = '*' . $params->LAST_NBREP;
			break;
		case '2':
			$part2 = '*0';
			break;
		}
		$params->RRULE = trim($part1) . ' ' . trim($part2);
		$params->START_DATE = $this->cnvDate($params->FORM_DATE) . 'T' . $this->cnvTime($params->FORM_TIME);
		unset($params->item);
		unset($params->RRULE_PER);
		unset($params->RRULE_EVR);
		unset($params->RRULE_JRSMO);
		unset($params->RRULE_JRSTU);
		unset($params->RRULE_JRSWE);
		unset($params->RRULE_JRSTH);
		unset($params->RRULE_JRSFR);
		unset($params->RRULE_JRSSA);
		unset($params->RRULE_JRSSU);
		unset($params->RRULE_M_MORE);
		unset($params->RRULE_M_FSTR);
		unset($params->RRULE_M_FEND);
		unset($params->RRULE_M_NUMWEEK);
		unset($params->RRULE_M_JRSWEEK);
		unset($params->RRULE_Y_MORE);
		unset($params->RRULE_Y_FSTR);
		unset($params->RRULE_Y_FEND);
		unset($params->RRULE_Y_NUMMONTH);
		unset($params->RRULE_Y_NUMDAY);
		unset($params->LAST_MORE);
		unset($params->LAST_DATE);
		unset($params->LAST_NBREP);
		unset($params->FORM_TIME);
		unset($params->FORM_DATE);
		unset($params->TEXCEPTION);
		unset($params->VTLID);
		unset($params->DCID);

		$params = (array)$params;
		if (isset($_POST['TEXCEPTION'])) {
			$exceptionList = $_POST['TEXCEPTION'];
			$tException = explode(',', $exceptionList);
			for ($e = 0 ; $e < count($tException) ; $e++) {
				$edate = $this->cnvDate($tException[$e]);
				if (!empty($edate))
					array_push($params, array('NAME' => $edate));
			}
		}
		return ($params);
	}

	public function modifySchRep($list1, $list2, $context=null)
	{
		$trans = "SCH_REP_MODIFY";
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($list1), "param1" => $this->list2soap($list2));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}

    /** LISTING STUFF **/

    public function getResultAllConnection($context) {

        $trans = 'REP_LIST_DATACENTER';
        $trans_version = 1;
        $vector = array();
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function getResultOneConnection($id, $context) {

        $trans = 'REP_LIST';
        $trans_version = 1;
        $vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function startReplication($params, $context) {

        $trans = 'ARKREP_START';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function startRecover($params, $context) {

        $trans = 'ARKREC_START';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function startIntegration($params, $context) {

        if(isset($params['SRC_VTLID'])) {

            $trans = 'ARKRDB_START';

        }

        if(isset($params['MODULE_ID'])) {

            $trans = 'ARKREPSERVER_RDB_START';

        }

        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function startRemove($params, $context) {

        $trans = 'REPLICATION_REMOVE_DATA';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function startVtlCreate($params, $context) {

        if(isset($params['SHARED'])) {

            unset($params['SHARED']);
            $trans = 'CREATE_INTEGRATED_VTL_RECOVER';

        } else {

            $trans = 'CREATE_VTL_RECOVER';

        }

        $items = array('DEFAULT'=>'1', 'MEDIA_SERVER'=>$params['MEDIA_SERVER'], 'PATH'=>$params['PATH']);

        array_push($params, $items);

        unset($params['MEDIA_SERVER']);
        unset($params['PATH']);

        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function getResultAllAccount($context) {

        $trans = 'ARKRSYNCD_GET_CONFIG';
        $trans_version = 1;
        $vector = array();
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function getResultOneAccount($id, $context) {

        $trans = 'REP_SERVER_LIST';
        $trans_version = 1;
        $vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

    public function getStat($params, $context=null) {

        $trans = 'ARKBKP_STAT';
        $trans_version = 2;

        $vector = array('param0' => $params['ID'], 'param1' => (int)$params['PORT']);

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if ($result == null)
            return null;

        if ($result->param3) {
            $result->param3->jobid = $params['ID'];
            $result->param3->jobport  = $params['PORT'];
        }

        return ($result);

    }

    public function testconnect($params, $context=null) {
        $trans = 'REP_TEST_CONNECT_DATACENTER';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($params));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;

    }

	public function reportListProfLoad($current_profile_type, $context=null) {
		$trans = 'REPROF_LIST_ALL';
		$trans_version = 2;
		$vector = array("param0" => (int)$current_profile_type);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function isGetNext($data) {
		$result = new stdclass;
		$result ->res = false;
		if(!is_array($data)) {
			if($data->last == '0' || ($data->param0 == '12' && $data->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data->transnum;
				$result->sessnum = $data->sessnum;
			}
		} else {
			$tmp = $data['list'.(count($data) - 2)];
			if($tmp->last == '0' || ($tmp->param0 == '12' && $tmp->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data['local']->transnum;
				$result->sessnum = $data['local']->sessnum;
			}
		}
		return $result;
	}

}
