<?php

require_once 'ArkObject.php'; 

class ArkReport extends ArkObject {

	public function reportListLogIndex($current_profile, $begin=0, $length=20, $sort='START_DATE', $order=0, $refresh=0, $mode=0, $filter=null, $context=null) {
		$trans = 'JREP_LIST_BY_PROFILE_UI';
		$trans_version = 2;
		if(!is_numeric($begin) || $begin==0) {
			$page = 1;
		} else {
			$page = ($begin/$length)+1;
		}
		$vector = array('param0' => $current_profile, 'param1'=>$length, 'param2'=>$page, 'param3'=>$sort, 'param4'=>$order, 'param5'=>$mode, 'param6'=>$refresh);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return $result;
	}

	public function isGetNext($data) {
		$result = new stdclass;
		$result ->res = false;
		if(!is_array($data)) {
			if($data->last == '0' || ($data->param0 == '12' && $data->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data->transnum;
				$result->sessnum = $data->sessnum;
			}
		} else {
			$tmp = $data['list'.(count($data) - 2)];
			if($tmp->last == '0' || ($tmp->param0 == '12' && $tmp->param1 == '2')) {
				$result->res = true;
				$result->transnum = $data['local']->transnum;
				$result->sessnum = $data['local']->sessnum;
			}
		}
		return $result;
	}

	public function reportListLogLoad($current_profile, $context=null) {
		$trans = 'JREP_LIST_BY_PROFILE';
		$trans_version = 2;
		$vector = array('param0' => $current_profile, 'param1'=>1);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportListLogWuiLoad($current_profile, $begin=0, $length=20, $sort='START_DATE', $order=0, $refresh=0, $mode=0, $filter=null, $context=null) {
		$trans = 'JREP_LIST_BY_PROFILE_UI';
		$trans_version = 2;
		if(!is_numeric($begin) || $begin==0) {
			$page = 1;
		} else {
			$page = ($begin/$length)+1;
		}
		$vector = array('param0' => $current_profile, 'param1'=>$length, 'param2'=>$page, 'param3'=>$sort, 'param4'=>$order, 'param5'=>$mode, 'param6'=>$refresh);
		if(!is_null($filter)) {
			$vector['param7'] = $filter;
		}
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function backupGraphGetData($current_profile, $start_date, $end_date, $column, $opt=0, $period=null, $refresh=0, $svpks=array(), $context=null) {
		$trans = 'JREP_GET_CHARTS_DATA';
		$trans_version = 2;
		$vector = array('param0' => $current_profile, 'param1'=>$start_date, 'param2'=>$end_date, 'param3'=>$column, 'param4'=>$opt, 'param5'=>$period, 'param6'=>$refresh);
		if(is_object($svpks) && count(get_object_vars($svpks)) > 0) {
			$vector['param7'] = $this->list2soap($svpks);
		}
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportOneSynthLoad($reportype, $jobid, $context=null) {
		$trans = 'JREP_GET_HTML_REPORT';
		$trans_version = 2;
		$vector = array('param0'=>$reportype, 'param1' => $jobid);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportOneLogLoad($reportype, $jobid, $context=null) {
		$trans = 'JREP_LIST_ONE_JOB';
		$trans_version = 2;
		$vector = array('param0'=>$reportype, 'param1' => $jobid);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportListProfFilters($current_profile_type, $context=null) {
		$trans = 'REPROF_LIST_FILTERS';
		$trans_version = 2;
		$vector = array("param0" => (int)$current_profile_type);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportListProfLoad($current_profile_type, $context=null) {
		$trans = 'REPROF_LIST_ALL';
		$trans_version = 2;
		$vector = array("param0" => (int)$current_profile_type);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return $result;
	}

	public function reportListProfOne($profile_id) {
		$trans = 'REPROF_LIST_ONE';
		$trans_version = 2;
		$vector = array("param0" => $profile_id);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return ($result);
	}

	public function profileModifyObject($params, $context=null) {
		$trans = 'REPROF_MODIFY';
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return ($result);
	}

	public function profileAddObject($params, $context=null) {
		$trans = 'REPROF_CREATE';
		$trans_version = 1;
		$vector = array("param0" => $this->list2soap($params));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		$i = 0;
		while(true) {
			$check = $this->isGetNext($result);
			if($i >= 50 || !$check->res) {
				break;
			}
			usleep(250000);
			$i++;
			$result = $this->getNext($check->transnum, $check->sessnum, $context);
		}
		return ($result);
	}

}

?>