<?php

require_once 'init.php';

/*
echo '<pre>';
print_r($_SESSION['tmplist']);
echo '</pre>';
die();
*/

$cats = array('backup_tape', 'cleaning_tape', 'space', 'cleaning_cycles');

if(count($_GET) == 0 || !isset($_GET['cat']) || !in_array($_GET['cat'], $cats)) {

    die();

}

$data = array();

function mktitle($title, $label, $value, $unit='') {

    if(isset($GLOBALS['consolidation'][$value])) {

        $value = $GLOBALS['consolidation'][$value];

    } else {

        $value = 0;

    }

    $GLOBALS['title'] = utf8_decode($GLOBALS['arkwui_lang'][$title]) . "\n" . ' (' . utf8_decode($GLOBALS['arkwui_lang'][$label]) . ': ' . $value . $unit . ')';

}

function mkdata($label, $value, $unit='') {

    if(isset($GLOBALS['consolidation'][$value]) && isset($GLOBALS['consolidation']['raw_'.$value])) {

	$rawvalue = $GLOBALS['consolidation']['raw_'.$value];
        $value = $GLOBALS['consolidation'][$value];

    } else {

        $value = 0;
	$rawvalue = 0;

    }

    $GLOBALS['data'][utf8_decode($GLOBALS['arkwui_lang'][$label]) . ' (' . $value . $unit . ')'] = $rawvalue;

}

switch($_GET['cat']) {

    case 'backup_tape':

        $consolidation = array();
        $consolidation['nb_tapes'] = 0;
        $consolidation['free_tapes'] = 0;
        $consolidation['used_tapes'] = 0;
        $consolidation['full_tapes'] = 0;
        $consolidation['worn_out_tapes'] = 0;

        foreach($_SESSION['tmplist']['item'] as $item) {

            if(in_array($item->TPID, $_GET['tpids'])) {

                $consolidation['nb_tapes']++;

                if($item->WORN_OUT == 1) {

                    $consolidation['worn_out_tapes']++;

                } else {

                    if($item->USED_SPACE == 0) {

                        $consolidation['free_tapes']++;

                    } else {

                        if($item->USED_SPACE == $item->TOT_SPACE) {

                            $consolidation['full_tapes']++;

                        } else {

                            $consolidation['used_tapes']++;

                        }

                    }

                }

            }

        }

	$consolidation['raw_nb_tapes'] = $consolidation['nb_tapes'];
	$consolidation['raw_free_tapes'] = $consolidation['free_tapes'];
	$consolidation['raw_used_tapes'] = $consolidation['used_tapes'];
	$consolidation['raw_full_tapes'] = $consolidation['full_tapes'];
	$consolidation['raw_worn_out_tapes'] = $consolidation['worn_out_tapes'];

        mktitle('tp_stinfo_bkp_title', 'tp_stinfo_bkp_total', 'nb_tapes');
        mkdata('tp_stinfo_bkp_free', 'free_tapes');
        mkdata('tp_stinfo_bkp_in_use', 'used_tapes');
        mkdata('tp_stinfo_bkp_full', 'full_tapes');
        mkdata('tp_stinfo_bkp_worn_out', 'worn_out_tapes');

    break;

    case 'cleaning_tape':

        $consolidation = array();
        $consolidation['nb_tapes'] = 0;
        $consolidation['free_tapes'] = 0;
        $consolidation['used_tapes'] = 0;
        $consolidation['worn_out_tapes'] = 0;

        foreach($_SESSION['tmplist']['item'] as $item) {

            if(in_array($item->TPID, $_GET['tpids'])) {

                $consolidation['nb_tapes']++;

                if($item->WORN_OUT == 1) {

                    $consolidation['worn_out_tapes']++;

                } else {

                    if($item->NB_USE == 0) {

                        $consolidation['free_tapes']++;

                    } else {

                        $consolidation['used_tapes']++;

                    }

                }

            }

        }

	$consolidation['raw_nb_tapes'] = $consolidation['nb_tapes'];
	$consolidation['raw_free_tapes'] = $consolidation['free_tapes'];
	$consolidation['raw_used_tapes'] = $consolidation['used_tapes'];
	$consolidation['raw_worn_out_tapes'] = $consolidation['worn_out_tapes'];

        mktitle('tp_stinfo_clean_title', 'tp_stinfo_clean_total', 'nb_tapes');
        mkdata('tp_stinfo_clean_free', 'free_tapes');
        mkdata('tp_stinfo_bkp_in_use', 'used_tapes');
        mkdata('tp_stinfo_clean_worn_out', 'worn_out_tapes');

    break;

    case 'space':

        $consolidation = array();
        $consolidation['tot_space'] = 0;
        $consolidation['used_space'] = 0;
        $consolidation['avail_space'] = 0;

        foreach($_SESSION['tmplist']['item'] as $item) {

            if(in_array($item->TPID, $_GET['tpids'])) {

                $consolidation['tot_space'] += $item->TOT_SPACE;
                $consolidation['used_space'] += $item->USED_SPACE;
                $consolidation['avail_space'] += ($item->TOT_SPACE - $item->USED_SPACE);

            }

        }

	$consolidation['raw_tot_space'] = $consolidation['tot_space'];
	$consolidation['raw_used_space'] = $consolidation['used_space'];
	$consolidation['raw_avail_space'] = $consolidation['avail_space'];

        $unit_tot_space = 'MB';
        $unit_used_space = 'MB';
        $unit_avail_space = 'MB';
        $units = array('GB', 'TB', 'EB');

        $i = 0;

        while ($consolidation['tot_space'] > 1024) {

            $consolidation['tot_space'] /= 1024;
            $unit_tot_space = $units[$i];
            $i++;

        }

        $i = 0;

        while ($consolidation['used_space'] > 1024) {

            $consolidation['used_space'] /= 1024;
            $unit_used_space = $units[$i];
            $i++;

        }

        $i = 0;

        while ($consolidation['avail_space'] > 1024) {

            $consolidation['avail_space'] /= 1024;
            $unit_avail_space = $units[$i];
            $i++;

        }

        $consolidation['tot_space'] = round($consolidation['tot_space'], 2);
        $consolidation['used_space'] = round($consolidation['used_space'], 2);
        $consolidation['avail_space'] = round($consolidation['avail_space'], 2);

        mktitle('tp_stinfo_space_title', 'tp_stinfo_space_total', 'tot_space', $unit_tot_space);
        mkdata('tp_stinfo_space_available', 'avail_space', $unit_avail_space);
        mkdata('tp_stinfo_space_used', 'used_space', $unit_used_space);

    break;

    case 'cleaning_cycles':

        $consolidation = array();
        $consolidation['tot_max_nb_use'] = 0;
        $consolidation['tot_nb_use'] = 0;
        $consolidation['tot_avail_nb_use'] = 0;

        foreach($_SESSION['tmplist']['item'] as $item) {

            if(in_array($item->TPID, $_GET['tpids'])) {

                $consolidation['tot_max_nb_use'] += $item->MAX_NB_USE;
                $consolidation['tot_nb_use'] += $item->NB_USE;
                $consolidation['tot_avail_nb_use'] += ($item->MAX_NB_USE - $item->NB_USE);

            }

        }

	$consolidation['raw_tot_max_nb_use'] = $consolidation['tot_max_nb_use'];
	$consolidation['raw_tot_nb_use'] = $consolidation['tot_nb_use'];
	$consolidation['raw_tot_avail_nb_use'] = $consolidation['tot_avail_nb_use'];

        mktitle('tp_stinfo_clean_cycle_title', 'tp_stinfo_clean_cycle_total', 'tot_max_nb_use');
        mkdata('tp_stinfo_clean_cycle_available', 'tot_avail_nb_use');
        mkdata('tp_stinfo_clean_cycle_used', 'tot_nb_use');

    break;

}

require_once('Artichow/Pie.class.php');

$graph = new Graph(350, 170);
$graph->shadow->setSize(0);
$graph->border->hide();
$graph->setBackground(new White());
$graph->setAntiAliasing(true);

$pie = new Pie(array_values($data), awPie::ARKEIA);

$pie->setCenter(0.36, 0.58);
$pie->setSize(0.5, 0.5);

$pie->set3D(10);

/* label */

$pie->setLabelPrecision(1);
$pie->label->setFont(new PHPFont(2));

/* legend */

$pie->setLegend(array_keys($data));
$pie->legend->setPosition(1.65, 0);
$pie->legend->shadow->setSize(0);
$pie->legend->setTextFont(new PHPFont(2));

/* title */

$pie->title->set($title);
$pie->title->move(0, -30);
$pie->title->setFont(new PHPFont(2));
$pie->title->setBackgroundColor(new White());
$pie->title->setPadding(5, 5, 2, 2);

$graph->add($pie);
$graph->draw();
