<?php

require_once 'init.php';
require_once 'Artichow/colorconvert.class.php';

if(count($_GET) == 0 || !isset($_GET['currentY']) || !isset($_GET['currentX']) || !isset($_GET['title']) || !isset($_GET['titleY']) || !isset($_GET['titleX'])) {
    die();
}

$colors = array (
                    'clearest_blue'=>'#c4d4ec',
                    'clearer_blue'=>'#83bed7',
                    'clear_blue'=>'#83a0d7',
                    'blue'=>'#325baa',
                    'purple'=>'#a08cd7',
                    'red'=>'#ff0000',
                    'orange'=>'#C66B29',
                    'green'=>'#33b107',
					'white'=>'#ffffff',
					'black'=>'#000000',
					'darkblue '=> '#00497A'
                );

$colorconvert = new colorconvert();

$data = $_SESSION['lastgraphdata'];

if(isset($_GET['debug'])) {
	echo '<pre>';
	print_r($data);
	echo '</pre>';
}

function makemytime($seconds, $use = null, $zeros = false) {
	$periods = array ('years'=>31556926,'Months'=>2629743,'weeks'=>604800,'days'=>86400,'hours'=>3600,'minutes'=>60,'seconds'=>1);
	if(($seconds < 3600) && $use{strlen($use) - 1} != 's') {
		$use .= 's';
	}
	$seconds = (float) $seconds;
	$segments = array();
	foreach ($periods as $period => $value) {
		if ($use && strpos($use, $period[0]) === false) {
			continue;
		}
		$count = floor($seconds / $value);
		if ($count == 0 && !$zeros) {
			continue;
		}
		$segments[strtolower($period)] = $count;
		$seconds = $seconds % $value;
	}
	$array = array();
	foreach ($segments as $key => $value) {
		$segment_name = strtolower(substr($key, 0, 1));
		$segment = $value . $segment_name;
		$array[] = $segment;
	}
	$str = implode(' ', $array);
	return $str;
}

function makemysize($size) {
	$units = array('GB', 'TB', 'PB', 'EB');
	if((float)$size<=1024) {
		$res = $size . ' MB';
	} else {
		$i = -1;
		while($size > 1024) {
			$size/= 1024;
			$i++;
		}
		if(($size % 1024 == 0) ) {
			$res = $size . ' ' . $units[$i];
		} else {
			$res = number_format($size, 2) . ' ' . $units[$i];
		}
	}
	return $res;
}

function maketransform($val, $type) {
	switch($type) {
		case 'PERCENT':
			$val = $val . '%';
		break;
		case 'TIME':
			$val = makemytime($val, 'dhm');
		break;
		case 'SIZE':
			$val = makemysize($val);
		break;
		case 'NB_FILES':
			$val = ceil($val);
		break;
		case 'START_DATE':
		case 'END_DATE':
		case 'RDATE':
			if((int)$val == 1) {
				$val = 'Never';
			} else {
				$val = date('Y/m/d H:i:s', (int)$val);
			}
		break;
	}
	return $val;
}

function imagecolorallocatehexa($imo, $color) {
    if(substr($color,0,1) == '#') $color = substr_replace($color, '', 0, 1);
    $rgb = $GLOBALS['colorconvert']->hex2rgb($color);
    return imagecolorallocate($imo, $rgb['r'], $rgb['g'], $rgb['b']);
}

if(!isset($_GET['debug'])) {
	header('Content-type: image/png');
}

if(isset($_GET['zoom'])) {
	$zoom = $_GET['zoom'];
} else {
	$zoom = 0;
}

if(isset($_GET['3d'])) {
	$has3d = ($_GET['3d'])?true:false;
} else {
	$has3d = true;
}

$graphmax = ($_SESSION['lastgraphmaxval'] * (100-$zoom)) / 100;

$imw = 950;
$imh = 400;
$gridstartx = 70;
$gridendx = $imw-70;
$gridstarty = $imh-20;
$gridendy = 30;
$gridwidth = $gridendx - $gridstartx;
$gridheight = $gridstarty - $gridendy;
$font = 2;

if(!isset($_GET['debug'])) {
	$imo = imagecreatetruecolor($imw,$imh);
	imagefill($imo, 0, 0, imagecolorallocatehexa($imo, $colors['white']));
	if($has3d) {
		imagefilledpolygon($imo ,array		(
																			$gridstartx + 10, $gridstarty - 5,
																			$gridstartx + 10, $gridendy - 5,
																			$gridendx + 10, $gridendy - 5,
																			$gridendx + 10, $gridstarty - 5,
																		), 4, imagecolorallocatehexa($imo, '#e2eaf7'));
		imagepolygon($imo ,array		(
																			$gridstartx, $gridstarty,
																			$gridstartx, $gridendy,
																			$gridstartx+10, $gridendy - 5,
																			$gridstartx+10, $gridstarty - 5,
																		), 4, imagecolorallocatehexa($imo, $colors['clear_blue']));
		imagepolygon($imo ,array		(
																			$gridstartx, $gridstarty,
																			$gridstartx + 10, $gridstarty - 5,
																			$gridendx + 10, $gridstarty - 5,
																			$gridendx, $gridstarty,
																		), 4, imagecolorallocatehexa($imo, $colors['clear_blue']));
	} else {
		imagefilledpolygon($imo ,array		(
																			$gridstartx, $gridstarty,
																			$gridstartx, $gridendy,
																			$gridendx, $gridendy,
																			$gridendx, $gridstarty,
																		), 4, imagecolorallocatehexa($imo, '#e2eaf7'));
	}
	imageline($imo  , $gridstartx  , $gridendy  , $gridstartx, $gridstarty, imagecolorallocatehexa($imo, $colors['blue']));
	imageline($imo  , $gridstartx  ,  $gridstarty  , $gridendx  ,  $gridstarty  , imagecolorallocatehexa($imo, $colors['blue']));
	imageline($imo, $gridstartx, $gridstarty+(imagefontheight($font)/2), $gridstartx, $gridstarty, imagecolorallocatehexa($imo, $colors['clear_blue']));
}

switch($_GET['currentPer']) {
	case 1: //weeks
		switch(true) {
			case in_array($_GET['currentMonth'], array(1, 2, 3)):
				$_GET['currentMonth'] = 3;
			break;
			case in_array($_GET['currentMonth'], array(4, 5, 6)):
				$_GET['currentMonth'] = 6;
			break;
			case in_array($_GET['currentMonth'], array(7, 8, 9)):
				$_GET['currentMonth'] = 9;
			break;
			case in_array($_GET['currentMonth'], array(10, 11, 12)):
				$_GET['currentMonth'] = 12;
			break;
		}
		$weekdef = array();
		for	(	$i=mktime(23, 59, 59, $_GET['currentMonth']-2, 1, $_GET['currentYear']);
					$i<=mktime(23, 59, 59, $_GET['currentMonth'], (int)date('t', mktime(0, 0, 0, $_GET['currentMonth'], 1, $_GET['currentYear'])), $_GET['currentYear']);
					$i+= (60*60*24*7)
				) {
			array_push($weekdef, date('Y/W', $i));
		}
		$initslot = 1;
		$nbslots = count($weekdef) ;
		$permatch = 'W';
	break;
	case 2: //months
		$initslot = 1;
		$nbslots = 12;
		$permatch = 'Y/m';
	break;
	case 3: //years
		$initslot = 1;
		$nbslots = 10;
		$permatch = 'Y';
	break;
	default:
		$initslot = 1;
		$nbslots = (int)date('t', mktime(0, 0, 0, $_GET['currentMonth'], 1, $_GET['currentYear']));
		$permatch = 'Y/m/d';
	break;
}
$slotsize =$gridwidth / $nbslots;
$linesize = $gridheight / 10;

if(!isset($_GET['debug'])) {
	$max = 11;
	for($i=10; $i>=1; $i--) {
		if($has3d) {
			imageline($imo, $gridstartx + 10, $gridendy + (($linesize * (($max-$i)-1)) + $linesize) - 5, $gridendx+10, $gridendy + (($linesize * (($max-$i)-1)) + $linesize) - 5, imagecolorallocatehexa($imo, $colors['clear_blue']));
		} else {
			imageline($imo, $gridstartx, $gridendy + (($linesize * (($max-$i)-1)) + $linesize), $gridendx, $gridendy + (($linesize * (($max-$i)-1)) + $linesize), imagecolorallocatehexa($imo, $colors['clear_blue']));
		}
		$curmax = 100;
		$curcol = 'PERCENT';
		if(isset($graphmax) && $graphmax > 0) {
			$curmax = $graphmax;
			$curcol = $_GET['currentY'];
		}
		$curperc = maketransform((($i*10) * $curmax / 100), $curcol);
		imagestring($imo, $font, $gridstartx-((strlen($curperc)*imagefontwidth($font))+2), $gridendy + ($linesize * (($max-$i)-1)) - (imagefontheight(2)/2), utf8_decode($curperc), imagecolorallocatehexa($imo, $colorconvert->webcolors['navy']));
	}
}

$svpks = $_SESSION['reportlastsvpks'];

$finalitems = array();

for($i=$initslot; $i<=$nbslots; $i++) {
	switch($_GET['currentPer']) {
		case 1: //weeks
			$period = $weekdef[$i-1];
		break;
		case 2: //months
			$period = date($permatch, mktime(23, 59, 59, $i, 1, $_GET['currentYear']));
		break;
		case 3: //years
			$period = date($permatch, mktime(23, 59, 59, 1, 1, ($_GET['currentYear']-($nbslots-1))+($i-1)));
		break;
		default:
			$period = date($permatch, mktime(23, 59, 59, $_GET['currentMonth'], $i, $_GET['currentYear']));
			$daystring = date('D', mktime(23, 59, 59, $_GET['currentMonth'], $i, $_GET['currentYear']));
		break;
	}
	$curdayitems = array();
	if(isset($data[$period])) {
		$keys = array_keys($data[$period]);
		$ct = count($data[$period]);
		for($j=0; $j<$ct; $j++) {
			$data[$period][$j]['VALUE_PERC'] = (100 * $data[$period][$j]['VALUE']) / $graphmax;
			$x1 = $gridstartx + ($slotsize * ($i-1));
			$y1 = $gridstarty;
			$x2 = $gridstartx + ($slotsize * ($i-1)) + ($slotsize);
			$y2 = ($gridstarty) - (((float)$data[$period][$j]['VALUE_PERC']*$gridheight)/100);
			if($y2 > $gridstarty) {
				$y2 = $gridstarty;
			}
			$col1 = $svpks[$data[$period][$j]['SAVEPACK']]['col1'];
			$col2 = $colorconvert->getgradcolor($col1, 150, 100);
			$col2 = $colorconvert->rgb2hex($col2);
			$col3 = $colorconvert->getgradcolor($col1, 50, 100);
			$col3 = $colorconvert->rgb2hex($col3);
			$col4 = $colorconvert->getgradcolor($col1, 200, 100);
			$col4 = $colorconvert->rgb2hex($col4);
			array_push($curdayitems, array('x1'=>$x1, 'y1'=>$y1, 'x2'=>$x2, 'y2'=>$y2, 'text'=>$data[$period][$j]['VALUE'], 'svpk'=>$data[$period][$j]['SAVEPACK'], 'percent'=>(float)$data[$period][$j]['VALUE_PERC'], 'date'=>$period, 'col1'=>$col1, 'col2'=>$col2, 'col3'=>$col3, 'col4'=>$col4));
		}
	}
	$finalitems[$period] = $curdayitems;
	if(!isset($_GET['debug'])) {
		foreach($curdayitems as $num=>$toprint) {
			if($num > 0) {
				$curdayitems[$num]['percent'] += $curdayitems[$num-1]['percent'];
				$curdayitems[$num]['y2'] = $gridstarty - (($curdayitems[$num]['percent']*$gridheight)/100);
				$curdayitems[$num]['y1'] = $curdayitems[$num-1]['y2'];
			}
			$rec1x1 = $curdayitems[$num]['x1'];
			$rec1y1 = $curdayitems[$num]['y1'];
			$rec1x2 = $curdayitems[$num]['x2'];
			$rec1y2 = $curdayitems[$num]['y2'];
			$rec2x1 = $curdayitems[$num]['x1'] + 10;
			$rec2y1 = $curdayitems[$num]['y1'] - 5;
			$rec2x2 = $curdayitems[$num]['x2'] + 10;
			$rec2y2 = $curdayitems[$num]['y2'] - 5;
			if($has3d) {
				imagefilledpolygon($imo, array	(
																				$rec1x1, $rec1y1,
																				$rec2x1, $rec2y1,
																				$rec2x2, $rec2y1,
																				$rec1x2, $rec1y1
																			), 4, imagecolorallocatehexa($imo, $curdayitems[$num]['col2']));
				imagepolygon($imo, array	(
																				$rec1x1, $rec1y1,
																				$rec2x1, $rec2y1,
																				$rec2x2, $rec2y1,
																				$rec1x2, $rec1y1
																			), 4, imagecolorallocatehexa($imo, $curdayitems[$num]['col4']));
				imagefilledrectangle($imo ,$rec2x1,$rec2y1,$rec2x2,$rec2y2, imagecolorallocatehexa($imo, $curdayitems[$num]['col2']));
				imageline($imo ,$rec2x2,$rec2y1,$rec2x2,$rec2y2, imagecolorallocatehexa($imo, $curdayitems[$num]['col4']));
			}
			imagefilledrectangle($imo ,$rec1x1,$rec1y1,$rec1x2,$rec1y2, imagecolorallocatehexa($imo, $curdayitems[$num]['col1']));
			imagerectangle($imo ,$rec1x1,$rec1y1,$rec1x2,$rec1y2, imagecolorallocatehexa($imo, $curdayitems[$num]['col4']));
			if($has3d) {
				if($num == count($curdayitems)-1) {
					imagefilledpolygon($imo, array	(
																					$rec1x1, $rec1y2,
																					$rec2x1, $rec2y2,
																					$rec2x2, $rec2y2,
																					$rec1x2, $rec1y2
																				), 4, imagecolorallocatehexa($imo, $curdayitems[$num]['col3']));
					imagepolygon($imo, array	(
																					$rec1x1, $rec1y2,
																					$rec2x1, $rec2y2,
																					$rec2x2, $rec2y2,
																					$rec1x2, $rec1y2
																				), 4, imagecolorallocatehexa($imo, $curdayitems[$num]['col4']));
				}
			}
		}
		if(isset($daystring) && strtolower($daystring) == 'sun') {
			$curcol = $colorconvert->webcolors['red'];
		} else {
			$curcol = $colorconvert->webcolors['navy'];
		}
		switch($_GET['currentPer']) {
			case 1: //weeks
				$periodname = substr($weekdef[$i-1], 5);
			break;
			case 2: //months
				$periodname = $arkwui_lang['month_' . (string)date('m', mktime(23, 59, 59, $i, 1, $_GET['currentYear']))];
			break;
			case 3: //years
				$periodname = ($_GET['currentYear'] - ($nbslots - 1)) + ($i-1);
			break;
			default:
				$periodname = $i;
			break;
		}
		$stringcorrect = ((strlen($periodname) * imagefontwidth($font)) / 2) * -1;
		imagestring($imo, $font, $gridstartx + $stringcorrect + (($slotsize * ($i-1)) + $slotsize/2), $gridstarty, utf8_decode($periodname), imagecolorallocatehexa($imo, $curcol));
		imageline($imo, $gridstartx + (($slotsize * ($i-1)) + $slotsize), $gridstarty+(imagefontheight($font)/2), $gridstartx + (($slotsize * ($i-1)) + $slotsize), $gridstarty, imagecolorallocatehexa($imo, $colors['clear_blue']));
	} else {
		foreach($curdayitems as $num=>$toprint) {
			if($num > 0) {
				$curdayitems[$num]['percent'] += $curdayitems[$num-1]['percent'];
				$curdayitems[$num]['y2'] = $gridstarty - (($curdayitems[$num]['percent']*($gridstarty-$gridendy))/100);
				$curdayitems[$num]['y1'] = $curdayitems[$num-1]['y2'];
				$finalitems[$period] = $curdayitems;
			}
		}
	}
}

if(!isset($_GET['debug'])) {
	$title = utf8_decode(base64_decode($_GET['title']));
	$titlefont = 5;
	$stringcorrect = ((strlen($title) * imagefontwidth($titlefont)) / 2) * -1;
	imagestring($imo, $titlefont, $imw/2+$stringcorrect +1, 2+1, $title, imagecolorallocatehexa($imo, $colors['clearest_blue']));
	imagestring($imo, $titlefont, $imw/2+$stringcorrect, 2, $title, imagecolorallocatehexa($imo, $colors['blue']));
	$titleX = utf8_decode(base64_decode($_GET['titleX']));
	$titleY = utf8_decode(base64_decode($_GET['titleY']));

	$titleX = explode('@', $titleX);
	$stringcorrect = ((strlen($titleX[0]) * imagefontwidth($font))) * -1;
	imagestring($imo, $font, ($gridendx + (($imw-$gridendx)/2) + $stringcorrect/2), $gridstarty-imagefontheight($font), $titleX[0], imagecolorallocatehexa($imo, $colors['blue']));
	$stringcorrect = ((strlen($titleX[1]) * imagefontwidth($font))) * -1;
	imagestring($imo, $font, ($gridendx + (($imw-$gridendx)/2) + $stringcorrect/2), $gridstarty, $titleX[1], imagecolorallocatehexa($imo, $colors['blue']));

	$stringcorrect = ((strlen($titleY) * imagefontwidth($font))) * -1;
	imagestring($imo, $font, $gridstartx+$stringcorrect, 2, $titleY, imagecolorallocatehexa($imo, $colors['blue']));
	imageantialias($imo, true);
	imagepng($imo);
	imagedestroy($imo);
} else {
	echo '<pre>';
	echo $graphmax . "\n";
	//print_r($svpks);
	print_r($finalitems);
	//print_r($data);
	echo '</pre>';
}
