// New forms of dojo functions (DOJO 1.0)
// This scripts make some of the new syntax works for DOJO 0.4

dojo.provide('arkeia.dojoMigration');

dojo.require('arkeia.console');

arkeia.dojoMigration = {
    _name: '[arkeia.dojoMigration]',
    success: false
}

arkeia.group('dojoMigration');

if (dojo.version.major === 1) {

    arkeia.log('Current DOJO version is', dojo.version, '. arkeia.dojoMigration is not needed');

} else {

dojo.require('dojo.widget.ContentPane');
arkeia.log('dojo.widget : ', dojo);
window.digit = {
    _name: 'digit',
    form: {}, 
    layout: {},
    byId: dojo.widget.byId
};
arkeia.log('digit : ', digit);

var dojox = {
    _name: '[dojox]',
    image: {}, 
    layout: {}, 
    widget: {}
};
arkeia.log('[dojox]  created : ', dojox);

dojo.migration = {
    _name: '[dojo.migration]'
};
arkeia.log('[dojo.migration] created : ', dojo.migration);


// DOCUMENT
// facultative: every document call should replaced by dojo.doc
// => "Refer to dojo.doc rather than referring to 'window.document' to ensure your code runs
//     correctly in managed contexts."
// in DOJO 0.4 dojo.doc is a function we must call it as dojo.doc()
// it becomes a property in DOJO 1.0


// isIE
dojo.isIE = ((dojo.render.html.capable) && (dojo.render.html.ie)) ? {version: '?'} : false;
arkeia.log('[dojo.isIE] created : ', dojo.isIE);


// JSON
dojo.require('dojo.json');
// dojo.json.serialize() becomes dojo.toJson()
// dojo.json.evalJson() becomes dojo.fromJson()
dojo.toJson = dojo.json.serialize;
dojo.fromJson = dojo.json.evalJson;
arkeia.log('[dojo.json] migrated : ', dojo.toJson, dojo.fromJson);


// LANG
dojo.require('dojo.lang.common');
// dojo.lang.forEach() becomes dojo.forEach()
// dojo.lang.isString() becomes dojo.isString()
// dojo.lang.isArray() becomes dojo.isArray()
// dojo.lang.hitch() becomes dojo.hitch()
// dojo.lang.find() becomes dojo.indexOf()
dojo.forEach = dojo.lang.forEach;
dojo.isString = dojo.lang.isString;
dojo.isArray = dojo.lang.isArray;
dojo.hitch = dojo.lang.hitch;
dojo.indexOf = dojo.lang.find;
// TO VERIFY : dojo.lang.isUndefined() becomes dojo.isUndefined() ?
// TO REMOVE : dojo.lang.unnest()
arkeia.log('[dojo.lang] partially migrated');


// HTML
dojo.require('dojo.html.*');
// dojo.html.disableSelection(node) becomes dojo.setSelectable(node, false)
// dojo.html.hasAttribute() becomes dojo.hasAttr()
// dojo.html.getAttribute(node, attrName) becomes dojo.attr(node, attrName)
// dojo.html.setAttribute(node, attrName, value) becomes dojo.attr(node, attrName, value)
// dojo.html.getStyle(node, styleName) becomes dojo.style(node, styleName)
// dojo.html.setStyle(node, styleName, value) becomes dojo.style(node, styleName, value)
// dojo.html.hasClass() becomes dojo.hasClass()
// dojo.html.removeClass() becomes dojo.removeClass()
// dojo.html.addClass() becomes dojo.addClass()
dojo.setSelectable = function (node, status) {
    if (status) {
        return dojo.html.enableSelection(node);
    } else {
        return dojo.html.disableSelection(node);
    }
};
dojo.hasAttr = dojo.html.hasAttribute;
dojo.attr = function (node, attrName, value) {
    if (value !== undefined) {
        return dojo.html.setAttribute(node, attrName, value);
    } else {
        return dojo.html.getAttribute(node, attrName);
    }
};
dojo.style = function (node, styleName, value) {
    if (value !== undefined) {
        return dojo.html.setStyle(node, styleName, value);
    } else {
        return dojo.html.getStyle(node, styleName);
    }
};
dojo.hasClass = dojo.html.hasClass;
dojo.removeClass = dojo.html.removeClass;
dojo.addClass = dojo.html.addClass;
// TO VERIFY : dojo.html.setClass() becomes dojo.setClass() ?
// TO CHECK : prependChild(), abs(), getParentByType(), destroyNode(), copyStyle()
arkeia.log('dojo.html partially migrated');


// URI
//dojo.require('dojo.uri');
// dojo.uri.moduleUri() becomes dojo.moduleUrl
// dojo.uri.dojoUri(url) must be replaced by (dojo.baseurl + url)
dojo.moduleUrl = dojo.uri.moduleUri;
arkeia.log('dojo.uri migrated');


// IO
dojo.require('dojo.io.*');
// dojo.io.bind() becomes dojo.xhrGet()
// some properties of the object argument change
dojo.xhrGet = function (obj) {
    var newObj = {method: 'GET'};
    var propName = '';
    for (propName in obj) {
        switch (propName) {
        case 'form':
            newObj.formNode = obj.form;
            break;
        case 'handleAs':
            newObj.mimetype = 'text/' + ((obj.handleAs === 'text') ? 'plain' : obj.handleAs);
            break;
        case 'load': // break intentionally omitted
        case 'error':
            newObj[propName] = function (type, data, transportImplementation, kwArgs) {
                obj[propName](data, kwArgs);
            }
            break; 
        default:
            newObj[propName] = obj[propName];
        }
    }
    return dojo.io.bind(newObj);
};
dojo.xhrPost = function (obj) {
    var newObj = {method: 'POST'};
    var propName = '';
    for (propName in obj) {
        switch (propName) {
        case 'form':
            newObj.formNode = obj.form;
            break;
        case 'handleAs':
            newObj.mimetype = 'text/' + ((obj.handleAs === 'text') ? 'plain' : obj.handleAs);
            break;
        case 'load': // break intentionally omitted
        case 'error':
            newObj[propName] = function (type, data, transportImplementation, kwArgs) {
                obj[propName](data, kwArgs);
            }
            break; 
        default:
            newObj[propName] = obj[propName];
        }
    }
    return dojo.io.bind(newObj);
};
arkeia.log('dojo.io migrated');


// EVENT
dojo.require('dojo.event.*');

// dojo.event.connect() becomes dojo.connect()
// dojo.event.browser.stopEvent() becomes dojo.stopEvent()
dojo.connect = dojo.event.connect;
dojo.stopEvent = dojo.event.browser.stopEvent;

// dojo.event.topic.publish(eventName, {arg1Name: arg1, arg2Name: arg2, ...})
// becomes dojo.publish(eventName, [arg1, arg2, ...])
// WARNING function called when an event is published is no more waiting for one object argument
// but each argument present in the array
// Ex: in dojo 0.4 :
// ...subscribe('toto', null, function(args) { return (args.val1 + args.val2); });
// ...publish('toto', {val1: 3, val2: 9});
// becomes in dojo 1.0
// ...subscribe('toto', null, function(val1, val2) { return (val1 + val2); });
// ...publish('toto', [3, 9]);
// So publish and subscribe functions must be migrated in the same time
dojo.publish = function (eventName, args) {
    newArgs = [];
    for (name in args) {
        newArgs.push(args[name])
    }
    // {n1: 'bar', n2: foo, option: 4} => ['bar', foo, 4] or {'0': 'bar', '1': foo, '2': 4}
    return dojo.event.topic.publish(eventName, newArgs);
};

// dojo.event.topic.subscribe(event, obj, actionName) becomes handler = dojo.suscribe(event, obj, actionName)
// dojo.event.topic.unsubscribe(event, obj, actionName) becomes dojo.suscribe(handler)
// arkeia.subscribeList and a hack permit dojo.unsubscribe(event, obj, actionName) in first time
dojo.subscribe = function () {
   var handler = dojo.event.topic.subscribe(arguments[0], arguments[1], arguments[2]);
   arkeia.subscribeList.push(
       {
           event: arguments[0],
           obj: arguments[1],
           action: arguments[2],
           handler: handler
       }
   );
};
dojo.unsubscribe = function () {
    var i = 0;
    var elem = {};
    var found = false;
    if (arguments.length > 1) {
        for (i; i < arkeia.subscribeList; i += 1) {
            elem = arkeia.subscribeList[i];
            if (elem.event === arguments[0] && elem.obj === arguments[1] && elem.action === arguments[2]) {
                arkeia.subscribeList.splice(i, 1);
                found = true;
                break;
            }
        }
    } else {
        for (i; i < arkeia.subscribeList; i += 1) {
            elem = arkeia.subscribeList[i];
            if (elem.handler === arguments[0]) {
                arkeia.subscribeList.splice(i, 1);
                found = true;
                break;
            }
        }
    }
    if (!found) {
        return false;
    }
    return dojo.event.topic.unsubscribe(elem.event, elem.obj, elem.action);
};
arkeia.log('dojo.event partially migrated');



// LFX
dojo.require('dojo.lfx.html');
// dojo.lfx.html.fadeIn(node, duration) becomes dojo.fadeIn({node: node, duration: duration})
// dojo.lfx.html.fadeOut(node, duration) becomes dojo.fadeOut({node: node, duration: duration})
// dojo.lfx.wipeIn(node, duration) becomes dojo.wipeIn({node: node, duration: duration})
// dojo.lfx.wipeOut(node, duration) becomes dojo.wipeOut({node: node, duration: duration})
dojo.fadeIn = function () {
    if (arguments.length === 2) {
        return dojo.lfx.html.fadeIn(arguments[0], arguments[1]);
    } else {
        return dojo.lfx.html.fadeIn(arguments[0].node, arguments[0].duration);
    }
};
dojo.fadeOut = function () {
    if (arguments.length === 2) {
        return dojo.lfx.html.fadeOut(arguments[0], arguments[1]);
    } else {
        return dojo.lfx.html.fadeOut(arguments[0].node, arguments[0].duration);
    }
};
dojo.wipeIn = function () {
    if (arguments.length === 2) {
        return dojo.lfx.wipeIn(arguments[0], arguments[1]);
    } else {
        return dojo.lfx.wipeIn(arguments[0].node, arguments[0].duration);
    }
};
dojo.wipeOut = function () {
    if (arguments.length === 2) {
        return dojo.lfx.wipeOut(arguments[0], arguments[1]);
    } else {
        return dojo.lfx.wipeOut(arguments[0].node, arguments[0].duration);
    }
};
arkeia.log('dojo.lfx migrated');


// DATE
dojo.require('dojo.date.common');
// add, diff, compare
dojo.migration.dateAdd = dojo.date.add;
dojo.date.add = function (dt, interv, incr) {
    if (dojo.lang.isString(interv)) {
        // from DOJO 1.0 format call
        return dojo.migration.dateAdd(
            dt, 
            dojo.date.dateParts[interv.toUpperCase()],
            incr
        );
    } else {
        return dojo.migration.dateAdd(dt, interv, incr);
    }
};
dojo.migration.dateDiff = dojo.date.diff;
dojo.date.diff = function (dtA, dtB, interv) {
    if (dojo.lang.isString(interv)) {
        // from DOJO 1.0 format call
        return dojo.migration.dateDiff(
            dtA,
            dtB,
            dojo.date.dateParts[interv.toUpperCase()]
        );
    } else {
        return dojo.migration.dateDiff(dtA, dtB, interv);
    }
};
dojo.migration.dateComp = dojo.date.compare;
dojo.date.compare = function (dateA, dateB, options) {
    if (dojo.lang.isString(options)) {
        // from DOJO 1.0 format call
        return dojo.migration.dateComp(dateA, dateB, dojo.date.compareTypes[options.toUpperCase]);
    } else {
        return dojo.migration.dateComp(dateA, dateB, options);
    }
};

// format
dojo.require('dojo.date.format');
dojo.date.posix = {};
dojo.date.posix.strftime = dojo.date.strftime;
dojo.date.locale = {
    format: dojo.date.format,
    parse: dojo.date.parse,
    getNames: dojo.date.getNames
};

dojo.require("dojo.date.serialize");
dojo.date.stamp = {
    fromRfc3339: dojo.date.fromRfc3339,
    toRfc3339: function(dateObject, selector) {
        if (typeof selector !== 'undefined' && (selector === 'time' || selector === 'date')) {
            selector += 'Only';
        }
        dojo.date.toRfc3339(dateObject, selector);
    },
    fromIso8601: dojo.date.fromIso8601,
    toIso8601: dojo.date.toIso8601
};
arkeia.log('dojo.date partially migrated');


// WIDGET
dojo.migration.require = dojo.require;
dojo.require = function (widgetPath) {
    var widgetParts = widgetPath.split('.');
    if (widgetParts[0] !== 'dojo' && widgetParts[0] !== 'arkeia') {
        widgetPath = 'dojo.widget.' + widgetParts[2];
    }
    dojo.migration.require(widgetPath);
};
arkeia.log('dojo.widget partially migrated');


}

arkeia.groupEnd();
arkeia.dojoMigration.success = true;
arkeia.info('[arkeia.dojoMigration] loaded : ', arkeia.dojoMigration, ' [dojo] patched : ', dojo);