<?php
/**
 * Generate javascript lang file for dojo
 * 
 * Created on May 15th 2007
 *   
 * PHP version 5
 * 
 * @author    Quentin Labadens <qlabadens@arkeia.com>
 * @author    Alexandre Morgaut <amorgaut@arkeia.com>
 * @copyright 2007, Arkeia Software
 * @version   CVS: $Id: lang.php,v 1.5 2008/02/06 00:42:14 qlabadens Exp $
 * 
 **/

define('DEFAULT_LANGUAGE', 'en'); // default language set to english

$lang = strtolower($_REQUEST['lang']);

if (!$lang || !preg_match('/^[a-z]{2,3}$/', $lang) || !file_exists("lang_{$lang}.php")) {
    error_log("Can't load lang file, lang_{$lang}.php : No such file or directory.");
    $lang = DEFAULT_LANGUAGE; 
    if (!file_exists('lang_'.DEFAULT_LANGUAGE.'.php')) {
        error_log("Can't load lang file, lang_".DEFAULT_LANGUAGE.".php : No such file or directory.");
        die("Can't load lang file, lang_".DEFAULT_LANGUAGE.".php : No such file or directory.");
        return ;
    }
    error_log("lang_".DEFAULT_LANGUAGE.".php (english) loaded instead");
    $arkwui_lang_user = false; 
} else {
    $arkwui_lang_user = true; 
}

/**
 * Declare object to dojo
 * 
 * "enabled" property is set to false if the asked language is not enabled
 * other property values are then affected in the default language 
 */
echo <<<JS
// Javascript 1.2

dojo.provide("arkeia.lang.lang_{$lang}");

arkeia.lang.lang_{$lang} = {

JS;

/**
 * Load the properties of the object
 */
include_once("lang_{$lang}.php");

foreach ($arkwui_lang as $id => $msg) {
    $msg = str_replace('"', '\"', $msg);
    echo <<<JS
    {$id} : "{$msg}",
JS;
}
echo <<<JS
    _end_of_message_entries_ : null
};
JS;
