dojo.provide('arkeia.login');

dojo.require('arkeia.dojoMigration');
dojo.require('dojox.layout.ContentPane');

arkeia.login = {_name: '[arkeia.login]'};

arkeia.login.receiveFormResult = function () {
    var _name = '[arkeia.login.receiveFormResult]';
    var loginForm = {};
    var dataProvider = {};

    arkeia.group(_name);

    loginForm = dojo.byId('loginForm');
    if (!loginForm) {
        arkeia.error(_name, 'form "login" not found');
        arkeia.groupEnd();
        return false;
    }
    dataProvider = new dojo.xhrPost(
        {
            url: dojo.attr(loginForm, 'action'),
            form: loginForm,
            handleAs: 'text',
            load: function (data) {
                var _name = '[arkeia.login.receiveFormResult].onLoad';
                var msg = '';
                var firstChar = '';
                var reg = null;
                var i = 0;
                var pane = {};

                arkeia.group(_name);
                arkeia.log('(data: ', data, ')');

                if ('url:' == data.substr(0, 4)) {
                    // Action done. Go to next url
                    window.location.reload();
                } else {
                    // Action failed.or reload Panes individualy Show Error
                    firstChar = data.substr(0, 1);
                    if (firstChar == '{' || firstChar == '[') {
                        data = dojo.fromJson(data);
                        reg = new RegExp("^param1: ..../../.. ..:..:.. ..{8} [^ ]*\: (.*)$", "g");
                        for (i in data) {
                            switch (i) {
                            case 'LoginPane':
                            case 'TreePane':
                            case 'ResultPane':
                                pane = dijit.byId(i);
                                pane.setUrl(data[i]);
                                break;
                            default:
                                arkeia.log(_name, 'data[' + i + '] : ', data[i]);
                                msg = (data[i].match(reg)) ? data[i].replace(reg , "$1") : data[i];
                            }
                        }
                    } else {
                        msg = data;
                    }
                    if (msg) {
                        dojo.require('arkeia.popup');
                        arkeia.alert(msg);
                    }
                }
                arkeia.groupEnd();
            },
            error: function(data) {
                var _name = '[arkeia.login.receiveFormResult].onError'
                arkeia.group(_name)
                arkeia.log('(data: ', data, ')');
                arkeia.alert(data);
                arkeia.groupEnd();
            }
        }
    );
    arkeia.groupEnd();
};

arkeia.login.updateLayout = function() {
    var _name = '[arkeia.login.updateLayout]';
    var byId = {
        login: {},
        menu: {},
        content: {}
    };

    arkeia.group(_name);

    byId.login = digit.byId('LoginPane');
    if (!byId.login) {
        arkeia.error('dojo.addOnLoad : widget "LoginPane" not found');
    } else {
        byId.login.addOnLoad(arkeia.login.receiveFormResult);
        byId.login.setUrl(arkeia.baseUrl + '/index/login');
    }
    byId.menu = digit.byId('TreePane');
    if (!byId.menu) {
        arkeia.error('dojo.addOnLoad : widget "TreePane" not found');
    } else {
        byId.menu.setUrl(arkeia.baseUrl + '/index/menutree');
    }
    byId.content = digit.byId('ResultPane');
    if (!byId.content) {
        arkeia.error('[dojo.addOnLoad] widget "ResultPane" not found');
    } else {
        byId.content.setUrl(arkeia.baseUrl + '/' + arkeia.subaction);
    }
    arkeia.groupEnd();
};

arkeia.info('arkeia.login loaded : ', arkeia.login);