dojo.provide("arkeia.widget.ArkeiaDDMenu");
dojo.require("arkeia.widget.ArkeiaListener");
dojo.require("arkeia.widget.ArkeiaSpecTreeWithNode");
dojo.require("arkeia.widget.ArkeiaDataProvider");

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaDDMenuBar2",
	dojo.widget.MenuBar2,
{
    templateString: '<div class="dojoMenuBar2 charsetMenuBar" dojoAttachPoint="containerNode" style="background: none !important; padding: 0px;"></div>'
});

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaDDMenuSeparator2",
	dojo.widget.MenuSeparator2,
{
	templateString: '<tr class="dojoMenuSeparator2"><td colspan=4><div class="dojoMenuSeparator2Top"></div><div class="dojoMenuSeparator2Bottom"></div></td></tr>'
});

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaDDMenuBarItem2",
	dojo.widget.MenuItem2,
{
	templateString: '<span class="dojoMenuItem2 charsetMenu" dojoAttachEvent="onMouseOver: onHover; onMouseOut: onUnhover; onClick: _onClick;">${this.caption}</span>',
    caption: ''
});

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaDDMenuItem2",
	dojo.widget.MenuItem2,
{
    templateString: 
		 '<tr class="dojoMenuItem2" dojoAttachEvent="onMouseOver: onHover; onMouseOut: onUnhover; onClick: _onClick; onKey:onKey;">'
		+'<td>&nbsp;&nbsp;</td>'
		+'<td tabIndex="-1" class="dojoMenuItem2Label" dojoAttachPoint="caption" style="font-size: 10px;">${this.caption}</td>'
		+'<td class="dojoMenuItem2Accel">${this.accelKey}</td>'
		+'<td><div class="dojoMenuItem2Submenu" style="display:${this.arrowDisplay};" dojoAttachPoint="arrow"></div></td>'
		+'</tr>',
    isAction: false,
    charset: '',

    baseUrl: "",
    controller:'',
    action: '',
    type: '',

    getCharset: function() {

        var tmp = this.charset.split(' ');

        if(tmp[0] == 'Current:') {

            return false;

        } else {

            return tmp[0];

        }

    },

    onClick: function() {

        if(this.isAction) {

            var charset = this.getCharset();

            if(charset) {

                var charsetInfo = dojo.widget.byId('Current:');

                if(charsetInfo) {

                    charsetInfo.caption.innerHTML = charsetInfo.charset = 'Current: '+charset;

                }

                var _this = this;

                var dataUrl = this.baseUrl + '/' + this.controller + '/' + this.action + '?charset=' + charset;
                var getNext = this.baseUrl + '/' + this.controller + '/jsonGetNextResult';
                var abortUrl = this.baseUrl + '/' + this.controller + '/jsonAbortTrans';

                this._launchtrans(_this, _this.onLoadSuccess, dataUrl, getNext, abortUrl);

            }

        }

    },

    _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {

        var source = new Object;
        var DpClass = arkeia.widget.ArkeiaDataProvider;

        source.dataUrl = dataUrl;
        source.getNext = getNext;
        source.abortUrl = abortUrl;

        obj.dataProvider = new DpClass(source);
        obj.dataProvider.loadMultipleResult(obj, callback, null);

        obj.dataProvider.onLoadError = obj.onLoadError;

    },

    onLoadError: function() {
    
    },

    onLoadSuccess: function(obj) {
	if(dojo.widget.byId(obj.type)) {
		dojo.widget.byId(obj.type).reload();
	}
        if(typeof icon_manager != 'undefined') {
            icon_manager.reloadCurrentNode(obj.type);
        }
    }

});

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaDDPopupMenu2",
    dojo.widget.PopupMenu2,
{

	templateString: 
						'<table class="dojoPopupMenu2 charsetPopupMenu" border=0 cellspacing=0 cellpadding=0 style="display: none; position: absolute; background: none repeat scroll 0 0 #ffffff !important;">' +
							'<tbody dojoAttachPoint="containerNode"></tbody>'+
						'</table>' 

});

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaDDMenu",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{
    value: "",
    dataUrl: "",
    baseUrl: "",
    controller:'',
    action: '',
    itemSelectName: "",
    itemSelectValue: "",
    type: '',
    valueTypeField: "",

    _myname: "ArkeiaDDMenu",

    listenArkeiaParentEvents: ["arkeiaInfoData","arkeiaListSelect"],

    templateString: '<div dojoAttachPoint="container" class="" style="overflow: visible;"></div>',

    initialize: function()  {

        var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));

        if (isIE) {

            this.container = document.createElement('div');
            this.container.innerHTML = this.value;

        }

        this.listenedArkeiaParents = [];

        for(var name in this.eventNamesDefault) {

            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }

        }

    },

    postCreate: function(args, frag) {

        var source = this.getFragNodeRef(frag);

        if (this.listened) {
            var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
            this.listenArkeiaParent(t);
        }

        if (!source.dataUrl) source.dataUrl = this.dataUrl;
        var dpClass = arkeia.widget.ArkeiaDataProvider;
        this.dataProvider = new dpClass(source);

    },

    onArkeiaListSelect: function(message) {

        this.onArkeiaInfoData(message);

    },

    onArkeiaInfoData: function(message) {

        this._setInfoData(message);

    },

    _setInfoData: function(message) {

        if (!message.data) {
            this.container.innerHTML = ' ';
            return ;
        }

        var menu = dojo.widget.createWidget("arkeia:ArkeiaDDPopupMenu2", {widgetId: "charsetMenuPopup", contextMenuForWindow: false } );

        var i , j, k, l, m;
        var tmp,pre = '';
	var controller, action;
	if(this.controller != '') {
		controller = this.controller;
	} else {
		controller = 'navigator';
	}

	if(this.action != '') {
		action = this.action;
	} else {
		action = 'jsonSetCharset';
	}
	
        for(i=0; i<message.data.item.length; i++) {

            for(j in message.data.item[i]) {

                if(j == 'SHORTLIST' || j == 'HEADER') {

                    if(j == 'SHORTLIST') {
                        pre = 'sht_';
                    } else {
                        pre = '';
                    }

                    for(k=0; k<message.data.item[i][j].length; k++) {

                        tmp = message.data.item[i][j][k].split(' ');
                        menu.addChild(dojo.widget.createWidget("arkeia:ArkeiaDDMenuItem2", {'widgetId': pre+tmp[0], 'caption': message.data.item[i][j][k], 'isAction': true, 'charset' : message.data.item[i][j][k], 'baseUrl': baseurl, 'controller': controller, 'action': action, 'type': this.type}));

                    }

                    if(j == 'HEADER') {

                        menu.addChild(dojo.widget.createWidget("arkeia:ArkeiaDDMenuSeparator2", {'widgetId': "separator"}));

                    }

                } else {

                    menu.addChild(dojo.widget.createWidget("arkeia:ArkeiaDDMenuItem2", {'widgetId': j, 'caption': arkwui_lang_get_msg(j), 'submenuId': "submenu"+j}));

                    eval('var submenu'+j+' = dojo.widget.createWidget("arkeia:ArkeiaDDPopupMenu2", {widgetId: "submenu'+j+'"} );');

                    for(l in message.data.item[i][j]) {

                        eval('submenu'+j+'.addChild(dojo.widget.createWidget("arkeia:ArkeiaDDMenuItem2", {widgetId: l, caption: arkwui_lang_get_msg(l), submenuId: "subsubmenu'+l+'"}));');

                        eval('var subsubmenu'+l+' = dojo.widget.createWidget("arkeia:ArkeiaDDPopupMenu2", {widgetId: "subsubmenu'+l+'"} );');

                        for(m=0; m<message.data.item[i][j][l].length; m++) {

                            eval('tmp = message.data.item[i][j][l][m].split(\' \'); subsubmenu'+l+'.addChild(dojo.widget.createWidget("arkeia:ArkeiaDDMenuItem2", {widgetId: tmp[0], caption: "'+message.data.item[i][j][l][m]+'", isAction: true, charset:"'+message.data.item[i][j][l][m]+'", baseUrl: baseurl, controller: \''+controller+'\', action: \''+action+'\', type: this.type}));');

                        }

                    }

                }

            }

        }

    },

    _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {

        var source = new Object;
        var DpClass = arkeia.widget.ArkeiaDataProvider;

        source.dataUrl = dataUrl;
        source.getNext = getNext;
        source.abortUrl = abortUrl;

        obj.dataProvider = new DpClass(source);
        obj.dataProvider.loadMultipleResult(obj, callback, null);

        obj.dataProvider.onLoadError = obj.onLoadError;

    },

    onLoadError: function() {
    
    }

}
);
