dojo.provide("arkeia.widget.ArkeiaDropdownTime");
dojo.require("dojo.widget.DropdownTimePicker");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
// class
	"arkeia.widget.ArkeiaDropdownTime",

// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.DropdownTimePicker],
		
// member variables/functions
	{
		valueField: "",
		disabled: false,
        tpTitle: "Select Time",
		lang: 'en-us',
		listenArkeiaParentEvents: ["arkeiaInfoData"],

		templateString: '<div style="white-space:nowrap; height:20px;"><nobr><input type="hidden" name="" value="" dojoAttachPoint="valueNode" /><input name="" type="text" value="" style="vertical-align:middle;" dojoAttachPoint="inputNode" autocomplete="off" /><img src="${this.iconURL}" alt="${this.iconAlt}" dojoAttachEvent="onclick:onIconClick" dojoAttachPoint="buttonNode" style="float: left; position:relative; left:90px; top:-18px; vertical-align:middle; cursor:pointer; cursor:hand" /></nobr></div>',

		fillInTemplate: function(){
			// summary: see dojo.widget.DomWidget

			dojo.widget.DropdownTimePicker.superclass.fillInTemplate.apply(this, arguments);

			var value = "";
			if(this.value instanceof Date) {
				value = this.value;
			} else if(this.value) {
				var orig = this.value;
				var d = dojo.date.format(new Date(), { selector: "dateOnly", datePattern: "yyyy-MM-dd" });
				var c = orig.split(":");
				for(var i = 0; i < c.length; ++i){
					if(c[i].length == 1) c[i] = "0" + c[i];
				}
				orig = c.join(":");
				value = dojo.date.fromRfc3339(d + "T" + orig);
			}
			
			var tpArgs = { widgetContainerId: this.widgetId, lang: this.lang, value: value, title: this.tpTitle };
			if("roundupminutes" in arguments[0]){
				tpArgs.roundUpMinutes = eval("(" + arguments[0]["roundupminutes"] + ")");
			}
			this.timePicker = dojo.widget.createWidget("arkeia:ArkeiaTimePicker", tpArgs, this.containerNode, "child");
			
			dojo.event.connect(this.timePicker, "onValueChanged", this, "_updateText");
			
			if(this.value){
				this._updateText();
			}
			this.containerNode.explodeClassName = "timeContainer";
			this.valueNode.name = this.name;
		},

		initialize: function() {
			dojo.debug(this + " Initialize");
			this.listenedArkeiaParents=[];
			if (this.disabled) {
				this.disable();
			}
			dojo.debug(this + " Initialized");
		},

		postCreate: function(args, frag) {
			if (this.listened) {
				var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
				this.listenArkeiaParent(t);
			}
			if(
					((dojo.render.html.capable) && (dojo.render.html.ie)) &&
					(arkeia.layout.IsIE8Browser() && !arkeia.layout.IsIE8emuIE7Browser())
				) {
				this.buttonNode.style.left = '120px';
				this.buttonNode.style.top = '0px';
			}
			dojo.debug(this + " created");
		},

		onArkeiaInfoData: function(message) {
			if (this.valueField && message.data) {
				this.value = message.data[this.valueField];
				this.setTime(this.value);
			}
		},

		enable:function(){
			this.disabled = false;
			this.textbox.removeAttribute("disabled");
		},

		disable: function(){
			this.disabled = true;
			this.textbox.setAttribute("disabled",true);
		}
	}
);
