dojo.provide("arkeia.widget.ArkeiaFilteringTable");
dojo.require("dojo.widget.FilteringTable");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaFilteringTable",

    // superclass
    dojo.widget.FilteringTable,
    // member variables/functions
    {
    	sortColumn: "",

		createSorter: function(/* array */info){
			//	summary
			//	creates a custom function to be used for sorting.
			var self=this;
			var sortFunctions=[];	//	our function stack.

			function createSortFunction(fieldIndex, dir){
				var meta=self.columns[fieldIndex];
				if (self.sortColumn != "") {
					var field = self.sortColumn;
				}
				else {
					var field=meta.getField();
				}
				return function(rowA, rowB){
					if(dojo.html.hasAttribute(rowA,"emptyRow")){ return 1; }
					if(dojo.html.hasAttribute(rowB,"emptyRow")){ return -1; }

					var a = self.store.getField(self.getDataByRow(rowA), field);
					var b = self.store.getField(self.getDataByRow(rowB), field);
					var na = a.substr(0, a.length - 2);
					var ia = a.substr(a.length - 2, 2);
					var nb = b.substr(0, b.length - 2);
					var ib = b.substr(b.length - 2, 2);
					var wdir = dir;
//					alert(dir + '-' + na + '-' + ia + '-' + nb + '-' + ib);
					if(meta.sortFunction!=null){
						var ret = meta.sortFunction(a, b);
					} else {
						var ret = 0;
						if(na > nb) ret = 1;
						if(na < nb) ret = -1;
						if (ret == 0)
						{
							wdir = 1;
							if(ia > ib) ret = 1;
							if(ia < ib) ret = -1;
						}
					}
					return wdir * ret;
				}
			}

			var current=0;
			var max = Math.min(info.length, this.maxSortable, this.columns.length);
			while(current < max){
				var direction = (info[current].direction == 0) ? 1 : -1;
				sortFunctions.push(
					createSortFunction(info[current].index, direction)
				);
				current++;
			}

			return function(rowA, rowB){
				var idx=0;
				while(idx < sortFunctions.length){
					var ret = sortFunctions[idx++](rowA, rowB);
					if(ret != 0) return ret;
				}
				//	if we got here then we must be equal.
				return 0; 	
			};	//	function
		}
    }
);
