dojo.provide("arkeia.widget.ArkeiaIntegerSpinner");
dojo.require("dojo.widget.Spinner");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaIntegerSpinner",

    // superclass
    dojo.widget.IntegerSpinner,

    // member variables/functions
    {
        disabled: false,
        disabledarrows: true,

        initialize: function() {
            dojo.debug(this + " Initialize");
            if (this.disabled == true)
                this.disable();
        },

        enable:function(){
            this.disabled = false;
            this.textbox.removeAttribute("disabled");
        },
       
        disable: function(){
            this.disabled = true;
            this.textbox.setAttribute("disabled",true);
        },

		_arrowReleased: function(/*Event*/ evt){
			//this.textbox.focus(); //buggy ie when textbox is disabled
			if(evt != null && typeof evt == "object" && evt.keyCode && evt.keyCode != null){
				var keyCode = evt.keyCode;
				var k = dojo.event.browser.keys;

				switch(keyCode){
					case k.KEY_DOWN_ARROW:
					case k.KEY_UP_ARROW:
						dojo.event.browser.stopEvent(evt);
						break;
				}
			}
			this._releaseButton(this.upArrowNode);
			this._releaseButton(this.downArrowNode);
			this._eventCount++;
			if(this._typamaticTimer != null){
				dojo.lang.clearTimeout(this._typamaticTimer);
			}
			this._typamaticTimer = null;
			this._currentTimeout = this.defaultTimeout;
		},

		setValue: function(value){
            if(!this.disabled || (this.disabled && !this.disabledarrows)) {
			    if (this._oldValue != value) {
				    this._oldValue = value;
				    dojo.widget.wai.setAttr(this.domNode, "waiState", "valuenow", value);
				    if (this.inputWidget){
					    this.inputWidget.prototype.setValue.call(this, value);
				    }
				    this.onValueChanged(value);
			    }
            }
		}

    }
);
