dojo.provide("arkeia.widget.ArkeiaListInputDRVPK");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("arkeia.widget.ArkeiaList");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaListInputDRVPK",

    // renderer
    "html",

    // superclass
    dojo.widget.HtmlWidget,

    // init function
    function(){
    },

    // properties and methods
    {
        widgetsInTemplate: true,
        action: "jsonGetAll",
	intersectMode: false,
        baseUrl: "",
        controller: "drive",
        valueField: "",
        listened: "",
        values: false, 
        appid: "local",
        sortField: "",
        _myname: "ArkeiaList2",/*ArkeiaListInputDRVPK",*/
        columns: "[{field: \'SELECT\', label: \'Select\'},{field: \'PRIO\', label: \'Priority\'},{field: \'NAME\', label: \'Name\'},{field: \'DRV_TYPE\', label: \'Type\'}]",
        cols: "",
        templatePath: dojo.uri.moduleUri("arkeia/widget","ArkeiaListInputDRVPK.html"),
        templateCssPath: '',/*dojo.uri.moduleUri("arkeia/widget","ArkeiaListInputDRVPK.css"),*/
	printIfEmpty: '',       

        cssStyle: 'ArkeiaList',
        populateTable: function(_this, data){
            dojo.debug(_this + " populateTable");
            //DEBUG dojo.debug(_this + " data: " + dojo.json.serialize(data));
            //DEBUG dojo.debug(_this + " values: " + dojo.json.serialize(_this.values));
	    if (data == null) {
		data = dojo.json.evalJson(_this.printIfEmpty);
		_this.innertable.store.setData(data);
		return ;
	    }
	    if (_this.controller == 'vtl')
		IDNAME = ID = 'VTLID';
	    else
		IDNAME = ID = 'DRVID';
	    if (_this.intersectMode)
		IDNAME = 'NAME';
            for (var x = 0; x < data.length; x++)
              {
                data[x]['SELECT'] = '<div id="check_'+ID+'_'+data[x][IDNAME]+'" value="'+data[x][IDNAME]+'"></div>';
                data[x]['PRIO'] = '<input value="" class="priority" id="priority_'+ID+'_'+data[x][IDNAME]+'" >';
              }
            _this.innertable.store.setData(data);

            for (var x = 0; x < data.length; x++)
              {
                if (_this.values && _this.values[data[x][IDNAME]] != undefined)
                {
                    ischecked = true;
                    priority = _this.values[data[x][IDNAME]];
                }
                else
                {
                    ischecked = false;
                    priority = 1;
                }
            
                dojo.widget.createWidget("dojo:Checkbox",{checked: ischecked, name: 'check_'+ID+'_'+data[x][IDNAME], value: data[x][IDNAME]},dojo.byId("check_"+ID+'_'+data[x][IDNAME]));

                dojo.debug(_this + " populateTable "+ "priority_"+ID+'_'+data[x][IDNAME]);

                dojo.widget.createWidget("dojo:IntegerSpinner", 
                      {
                         name: "priority_"+ID+'_'+data[x][IDNAME], 
                         value: priority,
                         max: "128",
                         min: "1",
                         signed: "never",
                         maxlength: "3"
                      }, 
                      dojo.byId("priority_"+ID+'_'+data[x][IDNAME]));
              }
            dojo.debug(_this + " populateTable Finish");
            return;
        },
        clearTable: function(_this) {
            dojo.debug(_this + " clearTable");
            _this.innertable.store.clearData();
        },
        reload: function(callback) {
            var params = null;
            if (this.appid && this.appid != "local") {
                params = {};
                params["APPLIANCE_GUID"] = this.appid;
            }
            this.dataProvider.loadRemoteData(this,callback,params);
        },
        initialize: function(args, frag) {
            var source = this.getFragNodeRef(frag);
            dojo.debug(this + " Initialize");
            dojo.debug(this + " Initialize getval: " + source.innerHTML);
            if (source.innerHTML != '')
                this.values = dojo.json.evalJson(source.innerHTML);
            else
                this.values = false;
            this.dataUrl = this.baseUrl + "/" + this.controller + "/" + this.action;
            dojo.debug(this + " dataUrl: " + this.dataUrl);
            if (!source.dataUrl) source.dataUrl = this.dataUrl;
            var dpClass = arkeia.widget.ArkeiaDataProvider;
            this.dataProvider = new dpClass(source);
            dojo.debug(this + " End of Initialize");
        },
        postCreate: function() {
            dojo.debug(this + " postCreate");
            dojo.event.connect(this.innertable, "onDataToggle",this, "dataSelected" );
            if (this.columns) {
                this.setColumns(dojo.json.evalJson(this.columns));
            }
            this.reload(this.populateTable);
            dojo.debug(this + "End of postCreate");
        },
        setColumns: function(cols) {
            this.cols = cols;
            for (var x = 0; x<this.cols.length; x++) {
		this.innertable.columns.push(
                    this.innertable.createMetaData(this.cols[x]));
            }
        }
    }
);
