dojo.provide("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaListener",

    // renderer
    "html",

    // superclass
    dojo.widget.HtmlWidget,

    // init function
    function(){
        this.listened="";
    },

    // properties and methods
    {
        _myname: "arkeiaListener",
        listenArkeiaParentEvents: [],
        listenedArkeiaParents: [],
        listened: "",
        listenArkeiaParent: function(arkeiaParent) {
            var _this = this;
            if (this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId]) {
                dojo.debug(this +" already listening "+arkeiaParent);
                dojo.debug(this + this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId]);
                this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId] += 1;
                return; // already listening
            }
            dojo.lang.forEach(this.listenArkeiaParentEvents, function(event) {
                var eventHandler =  "on" + event.charAt(0).toUpperCase() + event.substr(1);
                //dojo.debug(_this + " listening "+ event + " from "+arkeiaParent+" with " + eventHandler);
                dojo.event.topic.subscribe(arkeiaParent.eventNames[event], _this, eventHandler);
            });
            dojo.event.topic.subscribe(arkeiaParent.widgetId + "/arkeiaParentDestroy", _this, "onArkeiaParentDestroy");
            this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId] = 1;
        },
        unlistenArkeiaParent: function(arkeiaParent) {
            var _this = this;
            //dojo.debug(this + " unlisten " + arkeiaParent);
            if (!this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId]) {
                dojo.debug(this + "was not listening " + arkeiaParent);
                return; // not listening to this one
            }
            dojo.lang.forEach(this.listenArkeiaParentEvents, function(event) {
                var eventHandler =  "on" + event.charAt(0).toUpperCase() + event.substr(1);
                //dojo.debug(_this + " unlistening "+ event + " with " + eventHandler);
                dojo.event.topic.unsubscribe(arkeiaParent.eventNames[event], _this, eventHandler);
            });
            dojo.event.topic.unsubscribe(arkeiaParent.widgetId + "/arkeiaParentDestroy", _this, "onArkeiaParentDestroy");
            this.listenedArkeiaParents[arkeiaParent.widgetId+'_'+this.widgetId] = 0;
        },
        onArkeiaParentDestroy: function(message) {
            var t = message.source;
            this.unlistenArkeiaParent(t);
        }
   }
);

