dojo.provide("arkeia.widget.ArkeiaMultiDatePicker");
dojo.require("arkeia.widget.ArkeiaDatePicker");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaMultiDatePicker",

    // superclass
    [arkeia.widget.ArkeiaListener, arkeia.widget.ArkeiaDatePicker],

    // member variables/functions
	{
		initvalue: "", 
		value: [], 
		multiple: true,
		valueField: "",
		listenArkeiaParentEvents: ["arkeiaInfoData"],

		initialize: function() {
			dojo.debug(this + " Initialize");
			this.listenedArkeiaParents=[];
//			if (this.disabled)
//				this.disable();
			dojo.debug(this + " Initialized");
		},

		postCreate: function(args, frag) {
			if (this.listened) {
				var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
				this.listenArkeiaParent(t);
			}
			dojo.debug(this + " created");
		},

		onArkeiaInfoData: function(message) {
			this.clearAll();
			if (this.valueField && message.data) {
				if (message.data[this.valueField]) {
					var infodata = message.data[this.valueField];
					var tDate = infodata.split(',');
                    var anchor;
					for (var d = 0 ; d < tDate.length ; d++) {
						this.setDate(tDate[d]);
                        anchor = document.getElementById('anchor_'+tDate[d]);
                        if(anchor) {
                            anchor.parentNode.className = 'selectedDate';
                        }
                    }
                }
			}
			this.fillList();
		},

		postMixInProperties: function(){
			// summary: see dojo.widget.DomWidget

			dojo.widget.DatePicker.superclass.postMixInProperties.apply(this, arguments);
			if(!this.weekStartsOn){
				this.weekStartsOn=dojo.date.getFirstDayOfWeek(this.lang);
			}
			this.today = new Date();
			this.today.setHours(0,0,0,0);
/*		
			for (var d = 0 ; d < this.value.length ; d++)
			{
				var dvalue = this.value[d];
				alert(dvalue);
				if(typeof(dvalue)=='string'&&dvalue.toLowerCase()=='today')
				{
					this.value[d] = new Date();
				} else if (dvalue && (typeof(dvalue=="string")) && (dvalue.split("-").length > 2)) {
					this.value[d] = dojo.date.fromRfc3339(this.value[d]);
					this.value[d].setHours(0,0,0,0);
				}
			}
*/
			if (typeof(this.initvalue)=='string'&&this.initvalue.toLowerCase()=='today')
			{
				this.initvalue = new Date();
			} else if (this.initvalue && (typeof(this.initvalue=="string")) && (this.initvalue.split("-").length > 2)) {
				this.initvalue = dojo.date.fromRfc3339(this.initvalue);
				this.initvalue.setHours(0,0,0,0);
			}
		},

		fillInTemplate: function(args, frag) {
			// summary: see dojo.widget.DomWidget
			dojo.widget.DatePicker.superclass.fillInTemplate.apply(this, arguments);
			// Copy style info from input node to output node
			var source = this.getFragNodeRef(frag);
			dojo.html.copyStyle(this.domNode, source);

			this.weekTemplate = dojo.dom.removeNode(this.calendarWeekTemplate);
			this._preInitUI(this.initvalue ? this.initvalue : this.today, false, true); //init UI with date selected ONLY if user supplies one

			// Insert localized day names in the template
			var dayLabels = dojo.lang.unnest(dojo.date.getNames('days', this.dayWidth, 'standAlone', this.lang)); //if we dont use unnest, we risk modifying the dayLabels array inside of dojo.date and screwing up other calendars on the page
			if(this.weekStartsOn>0){
				//adjust dayLabels for different first day of week. ie: Monday or Thursday instead of Sunday
				for(var i=0;i<this.weekStartsOn;i++){
					dayLabels.push(dayLabels.shift());
				}
			}
			var dayLabelNodes = this.dayLabelsRow.getElementsByTagName("td");
 			for(i=0; i<7; i++) {
				dayLabelNodes.item(i).innerHTML = dayLabels[i];
			}
/*
			if(this.initvalue){
				this.setValue(this.initvalue);
			}
*/
		},

		_initUI: function(days) {
			dojo.dom.removeChildren(this.calendarDatesContainerNode);
			for(var i=0;i<this.displayWeeks;i++){
				this.calendarDatesContainerNode.appendChild(this.weekTemplate.cloneNode(true));
			}
			this.tSelectedNode = [];
			var nextDate = new Date(this.firstDay);
			this._setMonthLabel(this.curMonth.getMonth());
			this._setYearLabels(this.curMonth.getFullYear());
			var calendarNodes = this.calendarDatesContainerNode.getElementsByTagName("td");
			var calendarRows = this.calendarDatesContainerNode.getElementsByTagName("tr");
			var currentCalendarNode;
            var anchor, anchorMonth, anchorYear;
			for(i=0;i<days;i++){
				//this is our new UI loop... one loop to rule them all, and in the datepicker bind them
				currentCalendarNode = calendarNodes.item(i);

                anchor = '';
                anchor += '<span id="anchor_';
                anchor += nextDate.getFullYear();
                anchor += '-';
                //anchorMonth = (nextDate.getMonth() != this.curMonth.getMonth() && Number(nextDate) < Number(this.curMonth))?(Number(nextDate.getMonth())-1):(nextDate.getMonth()==this.curMonth.getMonth())?Number(nextDate.getMonth()):Number(nextDate.getMonth())+1;
                if(nextDate.getMonth() < 9) {
                    anchor += '0' + (nextDate.getMonth()+1);
                } else {
                    anchor += (nextDate.getMonth()+1);
                }
                anchor += '-';
                if(Number(nextDate.getDate()) < 10) {
                    anchor += '0' + nextDate.getDate();
                } else {
                    anchor += nextDate.getDate();
                }
                anchor += '" style="display: none;"></span>';

				currentCalendarNode.innerHTML = nextDate.getDate() + anchor;
				currentCalendarNode.setAttribute("djDateValue",nextDate.valueOf());
				var curClass = (nextDate.getMonth() != this.curMonth.getMonth() && Number(nextDate) < Number(this.curMonth))?'previous':(nextDate.getMonth()==this.curMonth.getMonth())?'current':'next';
				var mappedClass = curClass;
				if(this._isDisabledDate(nextDate)){
					var classMap={previous:"disabledPrevious",current:"disabledCurrent",next:"disabledNext"};
					mappedClass=classMap[curClass];
				}
				dojo.html.setClass(currentCalendarNode, this._getDateClassName(nextDate, mappedClass));
				if(dojo.html.hasClass(currentCalendarNode,this.classNames.selectedDate)){
					this.tSelectedNode[Number(nextDate)] = currentCalendarNode;
				}

				nextDate = dojo.date.add(nextDate, dojo.date.dateParts.DAY, 1);
			}
			this.lastDay = dojo.date.add(nextDate,dojo.date.dateParts.DAY,-1);
			this._initControls();
		},

		getValue: function() {
			// summary: return current date in RFC 3339 format
			var tmp = [];
			for (var d = 0 ; d < this.value.length ; d++)
				tmp[tmp.length] = dojo.date.toRfc3339(new Date(this.value[d]),'dateOnly');
			return tmp;
		},

		getDate: function() {
			// summary: return current date as a Date object
			return this.value; /*Date*/
		},		

		setDate: function(/*Date|String*/dateObj) {
			//summary: set the current date and update the UI
			var d = dateObj;
			if(typeof(d)=="string" && d!=""){
				var t = dojo.date.fromRfc3339(d);			
			}else if(typeof(d)=="object"){
				var t = new Date(d);
			}else{
				t = ""
			}

			var everSelected = false;
			var valueid = 0;
			for (var d = 0 ; d < this.value.length ; d++)
			{
				if ((this.value[d]) && (Number(dateObj) == Number(this.value[d]))) {
					everSelected = true;
					valueid = d;
				}
			}

			if (everSelected)
			{
				var selectedNode;
				selectedNode = this.tSelectedNode[Number(dateObj)];
				if(selectedNode!=null){
					dojo.html.removeClass(selectedNode,this.classNames.selectedDate);
				}

				var tmp = [];
				for (var d = 0 ; d < this.value.length ; d++)
					if (d != valueid)
						tmp[tmp.length] = this.value[d];
				this.value = tmp;
			} else {
				if(this.clickedNode!=null) {
					dojo.html.addClass(this.clickedNode,this.classNames.selectedDate);
					this.tSelectedNode[Number(dateObj)] = this.clickedNode;
				}

				if(typeof(t)=="object"){
					var newdate = new Date(t);
					newdate.setHours(0,0,0,0);
					this.value[this.value.length] = newdate;
				}
			}

			if(this.clickedNode==null){
				//only call this if setDate was called by means other than clicking a date
				this._preInitUI((this.initvalue=="")?this.curMonth:this.initvalue,false,true);
			}
			else
				this.fillList();
			this.clickedNode=null;
			this.onValueChanged(this.value);
		},

		clearAll: function()
		{
			for (var d = 0 ; d < this.value.length ; d++)
			{
				var selectedNode = this.tSelectedNode[Number(this.value[d])];
				if(selectedNode!=null){
					dojo.html.removeClass(selectedNode,this.classNames.selectedDate);
				}
			}
			this.value = [];
		},

		fillList: function()
		{
			var listException = dojo.byId('list_exception');
			var returnException = dojo.byId('returnlist');
			var tDate = [];
			for (var d = 0 ; d < this.value.length ; d++)
			{
				var dvalue = dojo.date.toRfc3339(new Date(this.value[d]),'dateOnly');
				tDate[tDate.length] = dvalue;
			}
			if (returnException) {
				returnException.value = tDate.join(',');
			}
			if (listException) {
				tDate.sort(jsSortAsc);
				for (var d = 0 ; d < tDate.length ; d++)
				{
					var dvalue = tDate[d];
					var tTmp = dvalue.split('-');
					tDate[d] = tTmp[2] + '/' + tTmp[1] + '/' + tTmp[0];
				}
				listException.innerHTML = tDate.join('<br/>');
			}
		},

		_getDateClassName: function(date, monthState) {
			var currentClassName = this.classNames[monthState];
			//we use Number comparisons because 2 dateObjects never seem to equal each other otherwise
			for (var d = 0 ; d < this.value.length ; d++)
			{
				if ((this.value[d]) && (Number(date) == Number(this.value[d]))) {
					currentClassName = this.classNames.selectedDate + " " + currentClassName;
					this.selectedIsUsed = true;
				}
			}
			if((!this.currentIsUsed) && (Number(date) == Number(this.today))) {
				currentClassName = currentClassName + " "  + this.classNames.currentDate;
				this.currentIsUsed = true;
			}
			return currentClassName;
		}

	}
);
