dojo.provide('arkeia.widget.ArkeiaNewnavigator');
dojo.require('arkeia.widget.ArkeiaListener');
dojo.require('arkeia.widget.ArkeiaDataProvider');

dojo.widget.defineWidget(
	// widget name and class
	'arkeia.widget.ArkeiaNewnavigator',
	// renderer
	'html',
	// superclass
	arkeia.widget.ArkeiaListener,
	// init function
	function(){
	},
	// properties and methods
	{
		baseUrl: '',
		listenArkeiaParentEvents: ['arkeiaInfoData','beforeLoad', 'afterLoad'],
		controller: '',
		action: '',
		getNextAction: '',
		charsetAction: 'jsonListCharsetTable',
		charsetSetAction: 'jsonSetCharset',
		hasRight: false,
		hasSelection: false,
		hasBase: '',
		selParam: '',
		rootId: 'Root',
		hideRoot: false,
		autoLoad: false,
		height: '400px',
		widthLeft: '30%',
		widthRight: '70%',
		curZoom: '32x32',
		initIconSize: '32x32',
		curNodes: null,
		curSelNodes: null,
		curHistory: null,
		curHistoryPosition: -1,
		tabIndex: 0,
		initPath: '',
		labelSelection: false,
		labelSelectionId: '',
		labelSelectionFullname: false,
		showLeftFile: false,
		warnIfEmpty: '',
		warnIfEmptyTarget: '',
		restrictos: '',
		automaticplugin: '',
		style: 'border:1px #B0C1E5 solid;',
		templateString: '<div id="${this.widgetId}" style="${this.style}"></div>',
		initialize: function() {
			this.listenedArkeiaParents = [];
			this.buildBase();
		},
		postCreate: function(args, frag) {
			if (this.listened) {
				var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
				this.listenArkeiaParent(t);
			}
			this.curNodes = {};
			this.curSelNodes = {};
			this.curHistory = [];
			if(this.initPath != '') {
				document.getElementById(this.widgetId+'_'+this.rootId).path = this.initPath;
			}
			if(this.autoLoad) {
				this.click(this.widgetId+'_'+this.rootId);
			}
			if(this.hasRight) {
				var mbArgs = {'widgetId': this.widgetId+'charsetMenu_bar', 'id': this.widgetId+'charsetMenu_bar'};
				var menu = dojo.widget.createWidget('arkeia:ArkeiaDDMenuBar2', mbArgs, document.getElementById(this.widgetId+'_charsetMenu'), 'child');
				if(dojo.widget.byId(this.widgetId+'charsetMenu_bar')) {
					var mbiArgs = {'widgetId': this.widgetId+'charsetMenu_barItem', 'id': this.widgetId+'charsetMenu_barItem', 'submenuId': 'charsetMenuPopup'};
					menu.addChild(dojo.widget.createWidget('arkeia:ArkeiaDDMenuBarItem2', mbiArgs));
				}
				var infArgs = {'widgetId': this.widgetId+'charsetInfo', 'baseUrl': arkeia.baseUrl, 'controller': this.controller, 'action': this.charsetAction, 'msgmode': true, 'value': 'GO'};
				dojo.widget.createWidget('arkeia:ArkeiaInfo', infArgs, document.getElementById(this.widgetId), 'child');
				var ddArgs = {'widgetId': this.widgetId+'charsetMenu', 'listened': this.widgetId+'charsetInfo', 'type': this.widgetId, 'controller':this.controller, 'action':this.charsetSetAction};
				dojo.widget.createWidget('arkeia:ArkeiaDDMenu', ddArgs, document.getElementById(this.widgetId), 'child');
			}
		},
		onArkeiaInfoData: function(message) {
		},
		onAfterLoad: function(message) {
		},
		onBeforeLoad: function(message) {
		},
		/* css class toys */
		addClassName: function(id, className) {
			var node = document.getElementById(id);
			if(node && typeof node.className != 'undefined') {
				var list = node.className.split(' ');
				list.push(className);
				node.className = list.join(' ');
			}
		},
		removeClassName: function(id, className) {
			var node = document.getElementById(id);
			if(node && typeof node.className != 'undefined') {
				var list = node.className.split(' ');
				for(var i=0; i<list.length; i++) {
					if(list[i] == className) {
						delete list[i];
					}
				}
				node.className = list.join(' ');
			}
		},
		replaceClassName: function(id, classNameOut, classNameIn) {
			this.removeClassName(id, classNameOut);
			this.addClassName(id, classNameIn);
		},
		/* icon states handlers */
		setIconMouseOver: function(id) {
			this.addClassName(id, 'over');
		},
		setIconMouseOut: function(id) {
			this.removeClassName(id, 'over');
		},
		setIconSelected: function(id) {
			this.addClassName(id, 'selected');
		},
		setIconUnSelected: function(id) {
			this.removeClassName(id, 'selected');
		},
		/* Zoom handlers */
		incrZoom: function() {
			var comb = document.getElementById(this.widgetId+'_zoom');
			if(typeof comb.options[comb.selectedIndex+1] != 'undefined'){
				comb.selectedIndex += 1;
			}
			this.applyZoom();
		},
		decrZoom: function() {
			var comb = document.getElementById(this.widgetId+'_zoom');
			if(comb.selectedIndex-1 >= 0){
				comb.selectedIndex -= 1;
			}
			this.applyZoom();
		},
		applyZoom: function() {
			var comb = document.getElementById(this.widgetId+'_zoom');
			this.curZoom = comb.options[comb.selectedIndex].value;
			document.getElementById(this.widgetId+'_navright').className='inlineBlock navright'+this.curZoom;
		},
		/* selection handlers */
		disableChildren: function(children) {
			var i, leftSel, rightSel;
			for(i in children) {
				leftSel = document.getElementById(i+'_sel');
				rightSel = document.getElementById(i+'_rightsel');
				if(leftSel) {
					if(leftSel.checked) {
						this.switchSelection(i);
					}
					leftSel.disabled = true;
					leftSel.src = '/images/rep_li_don.gif';
				}
				if(rightSel) {
					if(rightSel.checked) {
						this.switchSelection(i);
					}
					rightSel.disabled = true;
					rightSel.src = '/images/rep_li_don.gif';
					this.setIconSelected(i+'_righticon');
				}
				if(typeof this.curNodes[i] != 'undefined' && typeof this.curNodes[i]['CHILDREN'] != 'undefined') {
					this.disableChildren(this.curNodes[i]['CHILDREN']);
				}
			}
		},
		enableChildren: function(children) {
			var i, leftSel, rightSel;
			for(i in children) {
				leftSel = document.getElementById(i+'_sel');
				rightSel = document.getElementById(i+'_rightsel');
				if(leftSel) {
					leftSel.disabled = false;
					leftSel.src = '/images/rep_li_off.gif';
				}
				if(rightSel) {
					rightSel.disabled = false;
					rightSel.src = '/images/rep_li_off.gif';
					this.setIconUnSelected(i+'_righticon');
				}
				if(typeof this.curNodes[i] != 'undefined' && typeof this.curNodes[i]['CHILDREN'] != 'undefined') {
					this.enableChildren(this.curNodes[i]['CHILDREN']);
				}
			}
		},
		highlightParents: function(id) {
			var i, j;
			if(typeof id == 'undefined') {
				for(i in this.curSelNodes) {
					if(typeof this.curNodes[i]['PARENT'] != 'undefined') {
						this.highlightParents(this.curNodes[i]['PARENT']);
					}
				}
			} else {
				if(typeof this.curNodes[id] != 'undefined') {
					var label = document.getElementById(id+'_label');
					if(label) {
						label.style.fontWeight = 'bold';
					}
					if(typeof this.curNodes[id]['PARENT'] != 'undefined') {
						this.highlightParents(this.curNodes[id]['PARENT']);
					}
				}
			}
		},
		unHighlightParents: function(id) {
			var i, j;
			if(typeof id == 'undefined') {
				for(i in this.curSelNodes) {
					if(typeof this.curNodes[i]['PARENT'] != 'undefined') {
						this.unHighlightParents(this.curNodes[i]['PARENT']);
					}
				}
			} else {
				if(typeof this.curNodes[id] != 'undefined') {
					var label = document.getElementById(id+'_label');
					if(label) {
						label.style.fontWeight = 'normal';
					}
					if(typeof this.curNodes[id]['PARENT'] != 'undefined') {
						this.unHighlightParents(this.curNodes[id]['PARENT']);
					}
				}
			}
		},
		addToSelection: function(id) {
			if(typeof this.curNodes[id] != 'undefined') {
				document.getElementById(this.widgetId+'_selectionzone').style.display = '';
				document.getElementById(this.widgetId+'_selectionnone').style.display = 'none';
				document.getElementById(this.widgetId+'_selection').innerHTML += this.buildSelection(id, this.curNodes[id]);
				this.curSelNodes[id] = true;
				this.highlightParents();
				if(typeof this.curNodes[id]['CHILDREN'] != 'undefined') {
					this.disableChildren(this.curNodes[id]['CHILDREN']);
				}
			}
		},
		delFromSelection: function(id) {
			var item = document.getElementById('selectionitem_'+id);
			if(item) {
				item.parentNode.removeChild(item);
				this.unHighlightParents();
				delete this.curSelNodes[id];
				this.highlightParents();
				if(typeof this.curNodes[id]['CHILDREN'] != 'undefined') {
					this.enableChildren(this.curNodes[id]['CHILDREN']);
				}
				var getSelection = this.getSelection();
				if(getSelection.length == 0)  {
					document.getElementById(this.widgetId+'_selectionnone').style.display = '';
					document.getElementById(this.widgetId+'_selectionzone').style.display = 'none';
				}
			}
		},
		resetSelection: function() {
			
		},
		switchSelection: function(id) {
			var leftCheck = document.getElementById(id+'_sel');
			var rightCheck = document.getElementById(id+'_rightsel');
			if(leftCheck && (typeof leftCheck.disabled == 'undefined' || !leftCheck.disabled)) {
				if(typeof leftCheck.checked == 'undefined' || !leftCheck.checked) {
					leftCheck.checked = true;
					leftCheck.src = '/images/rep_li_on.gif';
					this.addToSelection(id);
				} else {
					leftCheck.checked = false;
					leftCheck.src = '/images/rep_li_off.gif';
					this.delFromSelection(id);
				}
			}
			if(rightCheck && (typeof rightCheck.disabled == 'undefined' || !rightCheck.disabled)) {
				if(typeof rightCheck.checked == 'undefined' || !rightCheck.checked) {
					rightCheck.checked = true;
					rightCheck.src = '/images/rep_li_on.gif';
					this.setIconSelected(id+'_righticon');
					if(!leftCheck) {
						this.addToSelection(id);
					}
				} else {
					rightCheck.checked = false;
					rightCheck.src = '/images/rep_li_off.gif';
					this.setIconUnSelected(id+'_righticon');
					if(!leftCheck) {
						this.delFromSelection(id);
					}
				}
			}
			//no check means that it's a request from selection, which means we want to unselect it
			if(!leftCheck && !rightCheck) {
				this.delFromSelection(id);
			}
		},
		getSelection: function() {
			var tmp = [];
			var i, result;
			for(i in this.curSelNodes) {
				tmp.push(this.curNodes[i]['PATH']);
			}
			result = tmp;
			return result;
		},
		/* history handlers */
		makeIconActive: function(type) {
			var icon = document.getElementById(this.widgetId+'_'+type);
			if(icon) {
				icon.style.backgroundPosition = '0 0';
			}
		},
		makeIconInactive: function(type) {
			var icon = document.getElementById(this.widgetId+'_'+type);
			if(icon) {
				icon.style.backgroundPosition = '-16px 0';
			}
		},
		addToHistory: function(id) {
			this.curHistory.push(id);
			this.curHistoryPosition = this.curHistory.length-1;
			if(this.curHistoryPosition > 0) {
				this.makeIconActive('prev');
			}
		},
		sliceHistory: function() {
			var i, tmpHistory;
			tmpHistory = [];
			for(i=0; i<this.curHistoryPosition+1; i++) {
				tmpHistory.push(this.curHistory[i]);
			}
			this.curHistory = tmpHistory;
			this.makeIconInactive('next');
		},
		inHistory: function(id) {
			var result, i;
			result = false;
			for(i=0; i<this.curHistory.length; i++) {
				if(this.curHistory[i] == id) {
					result = true;
					break;
				}
			}
			return result;
		},
		prevFromHistory: function() {
			if(typeof this.curHistory[this.curHistoryPosition-1] != 'undefined') {
				this.click(this.curHistory[this.curHistoryPosition-1], true);
				this.curHistoryPosition = this.curHistoryPosition-1;
			}
			if(this.curHistoryPosition <= 0) {
				this.makeIconInactive('prev');
			}
			this.makeIconActive('next');
		},
		nextFromHistory: function() {
			if(typeof this.curHistory[this.curHistoryPosition+1] != 'undefined') {
				this.click(this.curHistory[this.curHistoryPosition+1], true);
				this.curHistoryPosition = this.curHistoryPosition+1;
			}
			if(this.curHistoryPosition > 0) {
				this.makeIconActive('prev');
			}
			if(this.curHistoryPosition == this.curHistory.length-1) {
				this.makeIconInactive('next');
			}
		},
		/* click function (which is the glue that binds it all) and reload */
		click: function(id, preserveHistory, preserveLeft) {
			var nodeLabel = document.getElementById(id+'_label');
			if(!arkeia.isIE && typeof nodeLabel.focus != 'undefined') {
				nodeLabel.focus();
				/*if(typeof document.getElementById('navleft').scrollTop != 'undefined') {
					document.getElementById('navleft').scrollTop = (nodeLabel.offsetTop - document.getElementById('navleft').offsetTop);
				}*/
			}
			var nodeChildren = document.getElementById(id+'_children');
			if(typeof preserveLeft == 'undefined') {
				if(nodeChildren.style.display == 'none' || typeof preserveHistory != 'undefined') {
					if(!this.inHistory(id)) {
						document.getElementById(id+'_img').src = '/images/expand_loading.gif';
					} else {
						document.getElementById(id+'_img').src = '/images/expand-open2.gif';
					}
					nodeChildren.style.display='';
				} else {
					document.getElementById(id+'_img').src = '/images/expand-closed2.gif';
					nodeChildren.style.display='none';
				}
			}
			if(typeof preserveHistory == 'undefined') {
				if(this.curHistory.length-1 > this.curHistoryPosition) {
					this.sliceHistory();
				}
				//if(nodeChildren.style.display == '') {
				if(!this.inHistory(id) ||  (!nodeChildren.loaded && nodeChildren.style.display=='')) {
					this.fetchChildren(id, preserveLeft);
				}
				if(id != this.curHistory[this.curHistoryPosition]) {
					this.addToHistory(id);
				}
			} else {
				this.fetchChildren(id, preserveLeft);
			}
			if(document.getElementById(this.widgetId+'_navbar')) {
				if(id==this.widgetId+'_'+this.rootId) {
					document.getElementById(this.widgetId+'_navbar').value = '';
				} else {
					document.getElementById(this.widgetId+'_navbar').value = document.getElementById(id).printpath;
				}
			}
		},
		labelClick: function(id) {
			if(!this.labelSelection) {
				this.click(id, false, true);
			} else {
				if(typeof this.labelSelectionCurId != 'undefined') {
					var oldNodeInfo = document.getElementById(this.labelSelectionCurId+'_label');
					oldNodeInfo.style.fontWeight = 'normal';
					oldNodeInfo.style.color = '#333333';
				}
				this.labelSelectionCurId = id;
				var nodeInfo = this.curNodes[id];
				var labelnode = document.getElementById(id+'_label');
				labelnode.style.fontWeight = 'bold';
				labelnode.style.color = 'red';
				var targetname = document.getElementById(this.labelSelectionId);
				var targetreal = document.getElementById(this.labelSelectionId+'real');
				if(this.labelSelectionFullname) {
					targetname.value = nodeInfo['PRINTPATH'];
				} else {
					targetname.value = nodeInfo['NAME'];
				}
				targetreal.value = nodeInfo['PATH'];
			}
		},
		reload: function(id, preserveHistory) {
			var i;
			if(typeof id == 'undefined') {
				id = this.curHistory[this.curHistoryPosition];
				preserveHistory = true;
			} else {
				for(i=0; i<this.curHistory.length; i++) {
					if(this.curHistory[i] == id) {
						this.curHistoryPosition = i;
						break;
					}
				}
			}
			if(typeof preserveHistory == 'undefined') {
				preserveHistory = false;
			}
			this.click(this.curHistory[this.curHistoryPosition], preserveHistory);
		},
		/* html building */
		buildBase: function() {
			tmp = '';
			if(this.hasSelection) {
				tmp += '<div id="'+this.widgetId+'_selection" class="inlineBlock" style="width: 100%; height: 100px; overflow: auto; border-bottom:1px #B0C1E5 solid; font-size: 1.1em;">';
				tmp += '<div id="'+this.widgetId+'_selectionnone" style="padding: 8px;">';
				tmp += arkwui_lang_get_msg('nav_rst_no_tree_selected');
				tmp += '</div>';
				tmp += '<div id="'+this.widgetId+'_selectionzone" style="display: none;">';
				tmp += '<div class="inlineBlock" style="width: 10%; font-weight: bold; text-align: center;">&nbsp;</div>';
				tmp += '<div class="inlineBlock" style="width: 39%; font-weight: bold;">'+arkwui_lang_get_msg('nav_rst_tab_title_filename')+'</div>';
				tmp += '<div class="inlineBlock" style="width: 30%; font-weight: bold; text-align: center;">'+arkwui_lang_get_msg('nav_rst_tab_title_fileinfo')+'</div>';
				tmp += '<div class="inlineBlock" style="width: 20%; font-weight: bold; text-align: center;">'+arkwui_lang_get_msg('nav_rst_tab_title_bkptime')+'</div>';
				tmp += '</div>';
				tmp += '</div>';
			}
			if(this.hasRight) {
				tmp += '<div class="inlineBlock" style="width: 100%; background-color: #D3E0EF; border-bottom:1px #B0C1E5 solid;">';
				tmp += '<table cellspacing="0" cellpadding="0" style="width: 100%; height: 35px;">';
				tmp += '<tr>';
				tmp += '<td id="'+this.widgetId+'_charsetMenu" style="width: 30px; text-align: center;"></td>';
				tmp += '<td style="width: 25px; text-align: center;">';
				tmp += '<span id="'+this.widgetId+'_prev" onclick="dojo.widget.byId(\''+this.widgetId+'\').prevFromHistory();"  title="'+arkwui_lang_get_msg('navigator_prev')+'"class="inlineBlock" style="width: 16px; height: 16px; background-image: url(/scripts/arkeia/widget/specTree/rew.png); background-position: -16px 0; cursor: pointer; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;"></span>';
				tmp += '</td>';
				tmp += '<td style="width: 25px; text-align: center;">';
				tmp += '<span id="'+this.widgetId+'_next" onclick="dojo.widget.byId(\''+this.widgetId+'\').nextFromHistory();" title="'+arkwui_lang_get_msg('navigator_frwd')+'"class="inlineBlock" style="width: 16px; height: 16px; background-image: url(/scripts/arkeia/widget/specTree/fwd.png); background-position: -16px 0; cursor: pointer; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;"></span>';
				tmp += '</td>';
				tmp += '<td><input id="'+this.widgetId+'_navbar" type="text" value="" disabled="disabled" style="background-color:#FFFFFF !important; color:#000000 !important; border-color:#76819A #B0C1E5 #B0C1E5 #76819A !important; border-right:1px solid #B0C1E5 !important; border-style:solid !important; border-width:2px 1px 1px 2px !important; font-family:Lucida Grande,Verdana; font-size:9px; height:18px !important; padding:2px; width:98% !important;" /></td>';
				tmp += '<td style="width: 200px; text-align: center;">';
				tmp += '<img onclick="dojo.widget.byId(\''+this.widgetId+'\').decrZoom();" src="/scripts/arkeia/widget/specTree/viewmagmin.png" style="float: none; cursor: pointer; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;" />';
				tmp += '<select id="'+this.widgetId+'_zoom" onchange="dojo.widget.byId(\''+this.widgetId+'\').applyZoom();" style="width: auto;">';
				tmp += '<option value="details">'+arkwui_lang_get_msg('navigator_details')+'</option>';
				tmp += '<option value="32x32"';
				if(this.initIconSize == '32x32') {
					tmp += ' selected="selected"';
				}
				tmp += '>'+arkwui_lang_get_msg('navigator_small')+'</option>';
				tmp += '<option value="48x48"';
				if(this.initIconSize == '48x48') {
					tmp += ' selected="selected"';
				}
				tmp += '>'+arkwui_lang_get_msg('navigator_bigger')+'</option>';
				tmp += '<option value="64x64"';
				if(this.initIconSize == '64x64') {
					tmp += ' selected="selected"';
				}
				tmp += '>'+arkwui_lang_get_msg('navigator_biggest')+'</option>';
				tmp += '</select>';
				tmp += '<img onclick="dojo.widget.byId(\''+this.widgetId+'\').incrZoom();" src="/scripts/arkeia/widget/specTree/viewmagmax.png" style="float: none; cursor: pointer; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;" />';
				tmp += '</td>';
				tmp += '</tr>';
				tmp += '</table>';
				tmp += '</div>';
			}
			tmp += '<nobr style="white-space: nowrap;">';
			tmp += '<div id="navleft" class="inlineBlock" style="height: '+this.height+'; width: '+this.widthLeft+'; overflow: auto;">';
			tmp += '<ul style="list-style-type: none; margin:0px; padding: 0px;">';
			tmp += '<li id="'+this.widgetId+'_'+this.rootId+'" style="cursor: pointer; margin-left: 0px;';
			if(this.hideRoot) {
				tmp += 'display: none;';
			}
			tmp += '">';
			tmp += '<img id="'+this.widgetId+'_'+this.rootId+'_img" onclick="dojo.widget.byId(\''+this.widgetId+'\').click(this.parentNode.id);" src="/images/expand-closed2.gif" style="float: none; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;" />';
			tmp += '<span id="'+this.widgetId+'_'+this.rootId+'_label">Root</span>';
			tmp += '</li>';
			tmp += '<li id="'+this.widgetId+'_'+this.rootId+'_children" style="display: none; margin-left: 0px;"><ul style="list-style-type: none; margin:0px; padding: 0px;"><li style="display: none;">&nbsp;</li></ul></li>';
			tmp += '</ul>';
			tmp += '</div>';
			if(this.hasRight) {
				tmp += '<div id="'+this.widgetId+'_navright" class="inlineBlock navright'+this.initIconSize+'" style="height: '+this.height+'; width: '+this.widthRight+'; overflow: auto; border-left: 1px #B5C6E7 solid; white-space: normal;">';
				tmp += '</div>';
			}
			tmp += '</nobr>';
			this.domNode.innerHTML=tmp;
		},
		buildSelection: function(nodeId, node) {
			var tmp = '';
			tmp += '<div id="selectionitem_'+nodeId+'">';
			tmp += '<div class="inlineBlock" style="width: 10%; text-align: center; vertical-align: top;"><a onclick="dojo.widget.byId(\''+this.widgetId+'\').switchSelection(\''+nodeId+'\');" style="cursor: pointer;">'+arkwui_lang_get_msg('nav_delete')+'</a></div>';
			tmp += '<div class="inlineBlock" style="width: 39%; vertical-align: top;">'+node['PRINTPATH']+'</div>';
			tmp += '<div class="inlineBlock" style="width: 30%; text-align: center; vertical-align: top;">'+node['FILEINFO']+'</div>';
			tmp += '<div class="inlineBlock" style="width: 20%; text-align: center; vertical-align: top;">'+node['BKDATE_DISP']+'</div>';
			tmp += '</div>';
			return tmp;
		},
		buildNode: function(nodeId, node) {
			this.tabIndex++;
			var tmp = '';
			tmp += '<li id="'+nodeId+'" style="cursor: pointer;';
			if(node['PARENT'] == this.widgetId+'_'+this.rootId && this.hideRoot) {
				tmp += 'margin-left: 0px;';
			} else {
				tmp += 'margin-left: 15px;';
			}
			tmp += '">';
			if(!this.showLeftFile || (this.showLeftFile && typeof node['BROWSE'] != 'undefined' && node['BROWSE'])) {
				tmp += '<img id="'+nodeId+'_img" src="/images/expand-closed2.gif" onclick="dojo.widget.byId(\''+this.widgetId+'\').click(\''+nodeId+'\');" style=" float: none; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;" />';
			} else {
				tmp += '<img id="'+nodeId+'_img" src="/images/expand-none.gif" style="float: none; vertical-align: bottom; margin: 0px; padding: 0px; border: 0px;" />';
			}
			if(this.hasSelection) {
				if(this.selParam == '' || typeof node[this.selParam] != 'undefined') {
					tmp += '<img id="'+nodeId+'_sel" src="/images/rep_li_off.gif" style="float: none; vertical-align: text-bottom; margin: 0px; padding: 0px; border: 0px; margin-right: 4px;" onclick="dojo.widget.byId(\''+this.widgetId+'\').switchSelection(\''+nodeId+'\');" />';
				} else {
					tmp += '<img src="/images/rep_li_doff.gif" style="float: none; vertical-align: text-bottom; margin: 0px; padding: 0px; border: 0px; margin-right: 4px;" />';
				}
			}
			tmp += '<img id="'+nodeId+'_icon" src="/scripts/arkeia/widget/specTree/icon-'+node['ICON']+'-16x16.png" onclick="dojo.widget.byId(\''+this.widgetId+'\').labelClick(\''+nodeId+'\');" style="float: none; vertical-align: text-bottom; margin: 0px; padding: 0px; border: 0px; margin-right: 4px;" />';
			tmp += '<span id="'+nodeId+'_label" onclick="dojo.widget.byId(\''+this.widgetId+'\').labelClick(\''+nodeId+'\');" tabindex="'+(this.tabIndex)+'">'+node['NAME']+'</span>';
			tmp += '</li>';
			tmp += '<li id="'+nodeId+'_children" style="display: none;';
			if(node['PARENT'] == this.widgetId+'_'+this.rootId && this.hideRoot) {
				tmp += 'margin-left: 0px;';
			} else {
				tmp += 'margin-left: 15px;';
			}
			tmp += '"><ul style="list-style-type: none; margin:0px; padding: 0px;"></ul></li>';
			return tmp;
		},
		buildRightNode: function(nodeId, node) {
			var tmp = '';
			tmp += '<span id="'+nodeId+'_right" ondblclick="dojo.widget.byId(\''+this.widgetId+'\').click(\''+nodeId+'\');" class="inlineBlock container" style="margin-left: 2px; margin-right: 2px;" title="'+node['NAME']+'">';
				//icon
				tmp += '<span class="inlineBlock" style="padding: 0px; padding-top: 8px;">';
					tmp += '<span id="'+nodeId+'_righticon" class="inlineBlock type'+node['ICON']+'" style="text-align: left;" onmouseover="dojo.widget.byId(\''+this.widgetId+'\').setIconMouseOver(\''+nodeId+'_righticon\');" onmouseout="dojo.widget.byId(\''+this.widgetId+'\').setIconMouseOut(\''+nodeId+'_righticon\');">';
						if(this.hasSelection) {
							if(this.selParam == '' || typeof node[this.selParam] != 'undefined') {
								tmp += '<img id="'+nodeId+'_rightsel" class="rightsel" src="/images/rep_li_off.gif" style="float: none; vertical-align: text-bottom; margin: 0px; padding: 0px; border: 0px; cursor: pointer;" onclick="dojo.widget.byId(\''+this.widgetId+'\').switchSelection(\''+nodeId+'\');" />';
							} else {
								tmp += '<img class="rightsel" src="/images/rep_li_doff.gif" style="float: none; vertical-align: text-bottom; margin: 0px; padding: 0px; border: 0px;" />';
							}
						}
					tmp += '</span>';
				tmp += '</span>';
				//label
				tmp += '<span class="inlineBlock shortname" style="font-size: 0.8em; height: 1.6em; overflow: hidden; white-space: nowrap;">';
					tmp += node['SHORTNAME'];
				tmp += '</span>';
				//details
				tmp += '<span style="font-size: 0.8em; width: 35%;" class="longname">&nbsp;&nbsp;'+node['NAME']+'</span>';
				tmp += '<span style="font-size: 0.8em; width: 15%;" class="mode">'+node['MODE']+'</span>';
				tmp += '<span style="font-size: 0.8em; width: 10%;" class="ownership">'+node['OWNERSHIP']+'</span>';
				tmp += '<span style="font-size: 0.8em; width: 10%;" class="size">'+node['FSIZE']+'</span>';
				tmp += '<span style="font-size: 0.8em; width: 20%;" class="date">'+node['MDATE']+'</span>';
			tmp += '</span>';
			return tmp;
		},
		/* tree expanding system */
		populateChildren: function(id, children, preserveLeft) {
			try {
				var i;
				var tmp1 = '';
				var tmp2 = '';
				var path;
				var nodeChildren = document.getElementById(id+'_children');
				//no children is not an error since we may attempt to navigate after changing screen due to getNext
				if(!nodeChildren) {
					return;
				}
				if(typeof this.curNodes[id] == 'undefined') {
					this.curNodes[id] = {};
				}
				if(typeof this.curNodes[id]['CHILDREN'] == 'undefined') {
					this.curNodes[id]['CHILDREN'] = {};
				}
				if(id == this.widgetId+'_'+this.rootId) {
					path = 'Root';
				} else {
					path = document.getElementById(id).path;
				}
				if(typeof preserveLeft == 'undefined') {
					tmp1 += '<ul style="list-style-type: none; margin:0px; padding: 0px;">';
					for(i=0; i<children.length; i++) {
						children[i].PARENT = id;
						if(this.showLeftFile || (typeof children[i]['BROWSE'] != 'undefined' && children[i]['BROWSE']>0)) {
							tmp1 += this.buildNode(id+'_'+i, children[i]);
						}
						if(this.hasRight) {
							tmp2 += this.buildRightNode(id+'_'+i, children[i]);
						}
						this.curNodes[id+'_'+i] = children[i];
						this.curNodes[id]['CHILDREN'][id+'_'+i] = true;
					}
					tmp1 += '</ul>';
					nodeChildren.innerHTML = tmp1;
				} else {
					for(i=0; i<children.length; i++) {
						children[i].PARENT = id;
						if(this.hasRight) {
							tmp2 += this.buildRightNode(id+'_'+i, children[i]);
						}
						this.curNodes[id+'_'+i] = children[i];
						this.curNodes[id]['CHILDREN'][id+'_'+i] = true;
					}
				}
				if(this.hasRight) {
					document.getElementById(this.widgetId+'_navright').innerHTML = tmp2;
				}
				for(i=0; i<children.length; i++) {
					if(this.showLeftFile || (typeof children[i]['BROWSE'] != 'undefined' && children[i]['BROWSE']>0 && document.getElementById(id + '_' + i))) {
						document.getElementById(id + '_' + i).path = children[i]['PATH'];
						document.getElementById(id + '_' + i).printpath = children[i]['PRINTPATH'];
					}
					if(this.hasSelection && typeof this.curSelNodes[id+'_'+i] != 'undefined') {
						this.delFromSelection(id+'_'+i);
						this.switchSelection(id+'_'+i);
					}
				}
				var nodeSel = document.getElementById(id+'_sel');
				if(this.hasSelection && nodeSel && ((typeof nodeSel.checked != 'undefined' && nodeSel.checked) || (typeof nodeSel.disabled != 'undefined' && nodeSel.disabled))) {
					this.disableChildren(this.curNodes[id]['CHILDREN']);
				}
			} catch(err) {
				alert(err);
			}
		},
		onLoadSuccess: function(obj, result) {
			var i, j, item;
			var curBrowseable;
			var children = [];
			var childrenNode, imgNode;
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					try {
						if(typeof result.data != 'undefined' && typeof result.data.item != 'undefined') {
							var reg = new RegExp(this.restrictos, 'g');
							for(i in result.data.item) {
								if(obj.restrictos != '' &&
									(
										typeof result.data.item[i].ISDIR != 'undefined' &&
										result.data.item[i].ISDIR == 'h' &&
										typeof result.data.item[i].OSFAMILLY != 'undefined' &&
										result.data.item[i].OSFAMILLY != obj.restrictos
									)
								) {
									continue;
								}
								if(typeof result.data.item[i].FULLNAME != 'undefined' && typeof result.data.item[i].NOM != 'undefined' && result.data.item[i].NOM != '..') {
									curBrowseable = false;
									if(typeof result.data.item[i].BROWSEABLE != 'undefined') {
										curBrowseable = true;
									}
									if(typeof result.data.item[i].UID == 'undefined' || typeof result.data.item[i].GID == 'undefined') {
										result.data.item[i].OWNERSHIP = '';
									} else {
										result.data.item[i].OWNERSHIP = result.data.item[i].UID+'/'+result.data.item[i].GID;
									}
									if(typeof result.data.item[i].MODE == 'undefined') {
										result.data.item[i].MODE = '';
									}
									item = {};
									item['PATH'] = result.data.item[i].FULLNAME;
									item['PRINTPATH'] = result.data.item[i].FULLPATH;
									item['NAME'] = result.data.item[i].NOM;
									item['SHORTNAME'] = result.data.item[i].SHORTNOM;
									item['BROWSE'] = curBrowseable;
									item['ICON'] = result.data.item[i].ICON;
									item['BKDATE_DISP'] = result.data.item[i].BKDATE_DISP;
									item['FILEINFO'] = result.data.item[i].FILEINFO;
									item['MODE'] = result.data.item[i].MODE;
									item['OWNERSHIP'] = result.data.item[i].OWNERSHIP;
									item['FSIZE'] = result.data.item[i].FSIZE;
									item['MDATE'] = result.data.item[i].MDATE;
									if(obj.selParam != '' && typeof result.data.item[i][obj.selParam] != 'undefined') {
										item[obj.selParam] = true;
									}
									children.push(item);
								}
							}
						}
						if(children.length == 0) {
							childrenNode = document.getElementById(obj.curId+'_children');
							if(childrenNode) {
								childrenNode.loaded = false;
							}
							if(obj.curId == obj.widgetId+'_'+obj.rootId && obj.autoLoad) {
								if(obj.warnIfEmptyTarget != '' && obj.warnIfEmpty != '' && document.getElementById(obj.warnIfEmptyTarget)) {
									document.getElementById(obj.warnIfEmptyTarget).innerHTML = '<div style="text-align: center; color: red; font-weight: bold;">'+obj.warnIfEmpty+'</div>';
								}
							}
							var reg = new RegExp('^..../../.. ..:..:.. E........ ..ARKNAV_LIST: (.*)$');
							if(parseInt(result.status) > 0 && result.message.match(reg)) {
								alert(result.message.replace(reg, '$1'));
							}
						}
						imgNode = document.getElementById(obj.curId+'_img');
						if(imgNode) {
							document.getElementById(obj.curId+'_img').src = '/images/expand-open2.gif';
						}
						obj.populateChildren(obj.curId, children, obj.preserveLeft);
						delete obj.preserveLeft;
					} catch(err) {
						alert(err);
					}
				}
			}
		},
		onLoadError: function(obj, result) {
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					obj.populateChildren(obj.curId, [], obj.preserveLeft);
					delete obj.preserveLeft;
				}
			}
		},
		fetchChildren: function(id, preserveLeft) {
			var path;
			var node = document.getElementById(id);
			if(id == this.widgetId+'_'+this.rootId) {
				if(typeof node.path == 'undefined') {
					path = 'Root';
				} else {
					path = node.path;
				}
			} else {
				path = node.path;
			}
			var source = {};
			var obj = this;
			var params = {};
			var baseNode;
			if	(
					typeof obj.controller != 'undefined' && obj.controller != '' &&
					typeof obj.action != 'undefined' && obj.action != '' &&
					typeof obj.getNextAction != 'undefined' && obj.getNextAction != ''
				) {
				obj.curId = id;
				obj.preserveLeft = preserveLeft;
				source.dataUrl = arkeia.baseUrl + '/'+obj.controller+'/'+obj.action;
				source.getNext = arkeia.baseUrl + '/'+obj.controller+'/'+obj.getNextAction;
				source.abortUrl = arkeia.baseUrl + '/newnavigator/jsonAbortTrans';
				obj.dataProvider = new arkeia.widget.ArkeiaDataProvider(source);
				params['PATH'] = path;
				baseNode = document.getElementById(obj.hasBase);
				if(obj.hasBase != '' && baseNode && baseNode.options[baseNode.selectedIndex].value != 'local') {
					params['BASE'] = baseNode.options[baseNode.selectedIndex].value;
				}
				if(obj.automaticplugin != '') {
					params['FORCE_PLUGIN'] = obj.automaticplugin;
				}
				obj.dataProvider.loadMultipleResult(obj, obj.onLoadSuccess, params);
				obj.dataProvider.onLoadError = obj.onLoadError;
			}
		}
	}
);
