dojo.provide('arkeia.widget.ArkeiaRaid');
//dojo.require('arkeia.widget.ArkeiaListener');
dojo.require('arkeia.widget.ArkeiaButton');
dojo.require('arkeia.widget.ArkeiaDataProvider');
//dojo.require('arkeia.widget.ArkeiaInfo');


dojo.widget.defineWidget(
    // widget name and class
    'arkeia.widget.ArkeiaRaid',

    // renderer
    'html',

    // superclass
    dojo.widget.HtmlWidget,

    // init function
    function () {
        this.eventNames={};
        //this._data = [];
    },
    
    {
        _myname: 'ArkeiaRaid',
        widgetsInTemplate: true,
        model: '',
        alert: 0,
        version: 1,
        controller: 'raid',
        action: 'jsonGetResultAll',
        dataUrl: '',
        cssStyle: '',
        templatePath: dojo.uri.moduleUri('arkeia/widget', 'ArkeiaRaid.html'),
        loading: '',
        _lastDatas: {},
        _tArray: [],
        _newArray: {},
        _buttons: [],
        _forms: [],
        eventNamesDefault: {
            arkeiaRaidError: 'arkeiaRaidError',
            arkeiaInfoData: 'arkeiaInfoData',
            arkeiaAddData: 'arkeiaAddData',
            afterLoad: 'afterLoad',
            beforeLoad: 'beforeLoad'
        },

        initialize: function() {
            var name;
            this.loading = arkeia.lang.getMsg('Loading');
            this.params = {};
            this.dataUrl = arkeia.baseUrl + '/' + this.controller + '/' + this.action;
            this.getNext = arkeia.baseUrl + '/' + this.controller + '/jsonGetNextResult';
            for (name in this.eventNamesDefault) {
                if (dojo.lang.isUndefined(this.eventNames[name])) {
                    this.eventNames[name] = this.widgetId + '/' + this.eventNamesDefault[name];
                }
            }
        },

        postCreate: function(args, frag) {
            //this._buttons.push(dojo.widget.byId(this.widget + 'newArraySubmit'));
            var dpClass = arkeia.widget.ArkeiaDataProvider;
            var textInfos = arkeia.lang.getMsg('Loading');
            // show general Infos
            textInfos += '<br>';
            textInfos += arkeia.lang.getMsg('app_raid_infos');
            //textInfos += '<br>';
            //textInfos += arkeia.lang.getMsg('app_raid_infos_force');
            this.innerRaid.innerHTML = textInfos;
            // publish before load event
            dojo.event.topic.publish(this.widgetId + '/' + this.eventNames.beforeLoad, {});
            // load datas
            this.dataProvider = new dpClass(this);
            this.dataProvider.loadRemoteData(this, this.onArkeiaInfoData, null);
        },

        destroy: function() {
            dojo.debug(this + " destroy");
            dojo.event.topic.publish(this.widgetId + '/arkeiaParentDestroy', {source: this});
            var listsToDelete = [];
            var listToDelete = [];
            var deleteAfter = false;
            var node;
            if (this.dataProvider) {
                this.dataProvider.destroy();
            }
            /*
            while (this._buttons.length) {
                this._buttons.shift().destroy();
            }
            while (this._forms.length) {
                this._forms.shift().destroy();
            }
            if (this.innerArrays.childNodes && this.innerArrays.childNodes.length) {
                listsToDelete.push(this.innerArrays);
            }
            if (this.innerWait.childNodes && this.innerWait.childNodes.length) {
                listsToDelete.push(this.innerWait);
            }
            if (this._newArray.formNode && this._newArray.formNode.childNodes && this._newArray.formNode.childNodes.length) {
                listsToDelete.push(this._newArray.formNode);
            }
            while (listsToDelete.length) {
                listToDelete = listsToDelete.shift();
                deleteAfter = false;
                while (listsToDelete.length) {
                    node = listToDelete.firstChild;
                    if (node.childNodes && node.childNodes.length) {
                        listsToDelete.push(node);
                        deleteAfter = true;
                    } else {
                        listToDelete.removeChild(node);
                        delete node;
                    }
                }
                if (deleteAfter) {
                    listsToDelete.push(listToDelete);
                }
            }
            */
            //this._newArray.form.destroy();
            this._buttons = [];
            this._forms = [];
            this._tArray = [];
            this._newArray = {};
            return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

        onArkeiaRaidError: function(error, errorMsg) {
            var node = {
                form: {},
                inputRaid: {},
                inputSlot: {},
                container: {},
                cancel: {},
                submit: {},
                dialog: {}
            };
            switch (error) {
            case '2' :
                break;
            case '6' : // EXISTS
                node.form = document.createElement('form');
                node.inputRaid = document.createElement('input');
                node.inputSlot = document.createElement('input');
                node.container = document.createElement('div');
                node.cancel = document.createElement('button');
                node.submit = dojo.widget.createWidget(
                    "arkeia:ArkeiaButton", 
                    {
                        caption: arkeia.lang.getMsg('app_raid_action_force'),
                        widgetId: 'submit_useForce',
                        myformid: 'form_useForce',
                        baseUrl: arkeia.baseUrl,
                        controller: 'appliance',
                        action: 'jsonRaidAddDiskByForce',
                        nextUrl: 'appliance/raid',
                        style: 'width:40px'
                    }
                );
                node.dialog = dojo.widget.createWidget(
                    "Dialog", 
                    {
                        widgetId: 'dialog_useForce'
                    }
                );
                node.form.setAttribute('name', 'form_useForce');
                node.form.setAttribute('id', 'form_useForce');
                node.inputRaid.setAttribute('type', 'hidden');
                node.inputRaid.setAttribute('name', 'RaidNo');
                node.inputRaid.setAttribute('value', this.tryAddDisk.RaidNo);
                node.inputSlot.setAttribute('type', 'hidden');
                node.inputSlot.setAttribute('name', 'DiskNo');
                node.inputSlot.setAttribute('value', this.tryAddDisk.DiskNo);
                node.form.appendChild(node.inputRaid);
                node.form.appendChild(node.inputSlot);
                node.form.appendChild(node.cancel);
                node.form.appendChild(node.submit);
                node.container.innerHTML = errorMsg;
                node.dialog.containerNode.appendChild(node.form);
                node.dialog.setCloseControl(node.submit);
                node.dialog.show();
                node.cancel.focus();
                break;
            default:
                break;
            }
        },

        onArkeiaAddData: function(_this, dataReceived) {
            _this.onArkeiaInfoData(_this, dataReceived);
        },

        onArkeiaInfoData: function(_this, dataReceived) {
            dojo.debug(this + 'dataReceived');
            var fulldatas = dojo.json.evalJson(dataReceived);
            var datas = {};
            if (fulldatas.local) {
                dojo.debug(_this + 'local');
                fulldatas = fulldatas.local;
            }
            if (!dojo.lang.isString(fulldatas.STATUS)) {
                fulldatas.STATUS = fulldatas.STATUS[0];
                fulldatas.MESSAGE = fulldatas.MESSAGE[0];
            }
            if (fulldatas.STATUS !== '0') {
                if ((fulldatas.STATUS === '12') && (fulldatas.MESSAGE === '2')) {
                    dojo.debug(_this + " getNext...");
                    //_this.dataProvider.loadRemoteData(_this, _this.onArkeiaInfoData, null);
                    _this.dataProvider.getNext(_this, _this.onArkeiaRaidReceiveData, fulldatas);
                    _this.innerWait.appendChild(document.createTextNode(arkeia.lang.getMsg('app_raid_wait_synchro')));
                } else {
                    dojo.debug(_this + " Error...");
                    //_this.onArkeiaRaidError(fulldatas.STATUS, fulldatas.MESSAGE);
                    arkeia.layout.display_message(fulldatas.MESSAGE);
                }
            } else {
                _this.setDisabled(false);
                _this._lastDatas = fulldatas;
                if (fulldatas.PARAM2[0]) {
                    fulldatas.PARAM2 = fulldatas.PARAM2[0];
                }
                arkeia.layout.display_message(fulldatas.MESSAGE);
                dojo.event.topic.publish(_this + '/arkeiaInfoData', null);
                dojo.event.topic.publish(_this + '/afterLoad', null);
                _this.populateData(fulldatas.PARAM2);
            }
        },

        cleanStatus: function (status) {
            switch (status) {
            case 'READ-AUTO':
            case 'CLEAN':
            case 'WRITE-PENDING':
            case 'ACTIVE':
                return 'OK';
            default:
                return status;
            }
        },

        setDisabled: function (status) {
            // block any action while previous not fully received
        },

        _array_search: function (array, value) {

            var result = -1;

            for(i in array) {
                if(parseInt(i) == value) {
                    result = i;
                    break;
                }
            }

            return result;

        },

        populateData: function(datas) {

            dojo.debug(this + 'onArkeiaInfoData');

            var i = 0;
            var j = 1;
            var k = 0;
            var textInfos = '';
            var diskId = 0;
            var diskAction = 'jsonRaidRemoveDisk';

            var node = {
                ct_table: {}, // <table>
                ct_tbody: {}, // <tbody>
                ct_tr: {}, // <tr>
                ct_td: {}, // <td>
                table: {}, // <table>
                tbody: {}, // <tbody>
                rowTitles: {}, // <tr>
                rowSlotStatus: {}, // <tr>
                rowSlotAction: {}, // <tr>
                colArrayInfos: {}, // <td>
                colAction: {}, // <td>
                form: {}, // <form> (widget)
                input: {}, // <input>
                button: {} // button (widget)
            };

            while (this.innerWait.childNodes && this.innerWait.childNodes.length) {
                this.innerWait.removeChild(this.innerWait.firstChild);
            }

            while (this.innerRaid.childNodes && this.innerRaid.childNodes.length) {
                this.innerRaid.removeChild(this.innerRaid.firstChild);
            }

            this.model = datas.MODEL;
            this.version = datas.VERSION;
            this.nb_arrays = datas.NB_ARRAYS;
            this.nb_slots_left = datas.NB_SLOTS_LEFT;
            this.nb_slots_raid = datas.NB_SLOTS_RAID;
            this.array = datas.ARRAY;

            this.diskName = 'DISK '; // "DISK" is written in static because it must be written as on the appliance
            this.tAlertColors = ['green', 'orange', 'red'];

            this.actions = {
                A: 'AddDisk',
                R: 'RemoveDisk',
                S: 'RemoveBadDisk',
                C: 'CreateArray',
                N: 'NoAction'
            };

            textInfos += '<br>';
            textInfos += arkeia.lang.getMsg('app_raid_infos');
            this.innerRaid.innerHTML = textInfos;

            if (this._tArray.length > 0) {
                if (!this._tArray[0].table) {
                    this._tArray = [];
                }
            }

            this._tArray = [];

            this.populateDataStruct(node);


            if(this._array_search(this.array, 0) != -1) {
		    for (i=0; i < this.nb_arrays; i += 1) {
			    this.populateDataArrayStruct(node, i);
			    for (j in this.array[i].SLOT) {
				    this.populateDataArrayDisk(node, i, j);
			    }

		    }
	    }

		if(this.version == 1 && this.nb_slots_left > 2) {
			this.has3arrays = true;
		} else {
			this.has3arrays = false;
		}

	    if (this.nb_slots_left) {

                this.populateDataArrayStruct(node, i, true);

                if(this._array_search(this.array, 0) != -1) {

                    for (j in this.array[(i-1)].SLOT) {

                        this.populateDataNewArray(node, i, j);

                    }

                } else {

                    if(this._array_search(this.array, 1) != -1) {

                        for (j in this.array[(i+1)].SLOT) {

                            this.populateDataNewArray(node, i, j);

                        }

                        this.populateDataArrayStruct(node, i);

                        for (j in this.array[i].SLOT) {

                            this.populateDataArrayDisk(node, i, j);

                        }

                    }

                }

			if(this.has3arrays) {

				this.makinsensitive = true;

				i++;

                this.populateDataArrayStruct(node, i, true);

                if(this._array_search(this.array, 0) != -1) {

                    for (j in this.array[(i-1)].SLOT) {

                        this.populateDataNewArray(node, i, j);

                    }

                } else {

                    if(this._array_search(this.array, 2) != -1) {

                        for (j in this.array[(i+1)].SLOT) {

                            this.populateDataNewArray(node, i, j);

                        }

                        this.populateDataArrayStruct(node, i);

                        for (j in this.array[i].SLOT) {

                            this.populateDataArrayDisk(node, i, j);

                        }

                    }

                }

			}

	    }

        },

       checkRaid5: function() {

            var result = false;

            if(parseInt(this.version) == 5) {

                result = true;

            }

            return result;

        },

        checkVersion500: function() {

            var result = false;

            if(parseInt(this.model) == 500) {

                result = true;

            }

            return result;

        },

       checkVersion310: function() {

            var result = false;

            if(parseInt(this.model) == 310) {

                result = true;

            }

            return result;

        },

        populateDataStruct: function(node) {

            if(this.checkRaid5()) {

                this.base_width = 800;
                this.base_width_unit = 'px';

            } else {

                this.base_width = 600;
                this.base_width_unit = 'px';

            }

            this.backgroundColor = '#e3e9ee';

            node.ct_table = document.createElement('table');

            if(document.all) {
                node.ct_table.style.setAttribute('cssText', 'width:' + this.base_width + this.base_width_unit + '; height: 100%; text-align:center;');
            } else {
                node.ct_table.setAttribute('style', 'width:' + this.base_width + this.base_width_unit + '; height: 100%; text-align:center;');
            }

            this.innerArrays.appendChild(node.ct_table);

            node.ct_tbody = document.createElement('tbody');
            node.ct_table.appendChild(node.ct_tbody);

            node.ct_tr = document.createElement('tr');
            node.ct_tbody.appendChild(node.ct_tr);

            if(this.checkRaid5() && (this.nb_arrays == 2 || this.nb_slots_left == (this.nb_slots_raid / 2))) {

                node.ct_td1 = document.createElement('td');

            if(document.all) {
                node.ct_td1.style.setAttribute('cssText', 'width:' + (this.base_width / 2) + this.base_width_unit + '; height: 100%; text-align:center;');
            } else {
                node.ct_td1.setAttribute('style', 'width:' + (this.base_width / 2) + this.base_width_unit + '; height: 100%; text-align:center;');
            }

                node.ct_tr.appendChild(node.ct_td1);
                node.ct_td2 = document.createElement('td');

                if(document.all) {
                    node.ct_td2.style.setAttribute('cssText', 'width:' + (this.base_width / 2) + this.base_width_unit + '; height: 100%; text-align:center;');
                } else {
                    node.ct_td2.setAttribute('style', 'width:' + (this.base_width / 2) + this.base_width_unit + '; height: 100%; text-align:center;');
                }

                node.ct_tr.appendChild(node.ct_td2);

            } else {

                node.ct_td = document.createElement('td');

                if(document.all) {
                    node.ct_td.style.setAttribute('cssText', 'width:' + this.base_width + this.base_width_unit + '; height: 100%; text-align:center;');
                } else {
                    node.ct_td.setAttribute('style', 'width:' + this.base_width + this.base_width_unit + '; height: 100%; text-align:center;');
                }

                node.ct_tr.appendChild(node.ct_td);

            }

        },

        populateDataArrayStruct: function(node, i, newarray) {

            if(typeof newarray == 'undefined') {

                newarray = false;

            }

            if (!this._tArray[i]) {

                this._tArray[i] = { slot: [] };

                if(this.checkRaid5() && (this.nb_arrays == 2 || this.nb_slots_left == (this.nb_slots_raid / 2))) {

                    if(i == 0) {

                        node.ct_td1.appendChild(document.createElement('br'));

                    } else {

                        node.ct_td2.appendChild(document.createElement('br'));

                    }

                } else {

                    node.ct_td.appendChild(document.createElement('br'));

                }

                // define HTML table
                node.table = document.createElement('table');
                this._tArray[i].table = node.table;

                if(!newarray) {
    
                    dojo.html.setClass(node.table, 'raidArray');

                } else {

                    dojo.html.setClass(node.table, 'raidNewArray');

                }

                if(this.checkRaid5() && (this.nb_arrays == 2 || this.nb_slots_left == (this.nb_slots_raid / 2))) {

                    if(document.all) {
                        node.table.style.setAttribute('cssText', 'width:' + (this.base_width / 2) + this.base_width_unit + '; text-align:center;');
                    } else {
                        node.table.setAttribute('style', 'width:' + (this.base_width / 2) + this.base_width_unit + '; text-align:center;');
                    }

                    if(i == 0) {

                        node.ct_td1.appendChild(node.table);

                    } else {

                        node.ct_td2.appendChild(node.table);

                    }

                } else {

                    if(document.all) {
                        node.table.style.setAttribute('cssText', 'width:' + this.base_width + this.base_width_unit + '; text-align:center;');
                    } else {
                        node.table.setAttribute('style', 'width:' + this.base_width + this.base_width_unit + '; text-align:center;');
                    }

                    node.ct_td.appendChild(node.table);

                }

                node.tbody = document.createElement('tbody');
                node.table.appendChild(node.tbody);

                // defines HTML titles rows 
                node.rowTitles = document.createElement('tr');

                if(newarray) {

                    if(document.all) {
                        node.rowTitles.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                    } else {
                        node.rowTitles.setAttribute('style', 'padding: 0px; border-width: 0px;');
                    }

                }

                node.tbody.appendChild(node.rowTitles);

                // Array Infos container : receive Name, Status and Size container for this Array
                node.colArrayInfos = document.createElement('td');

                if(this.checkRaid5()) {

                    node.colArrayInfos.setAttribute('rowSpan', 9);

                } else {

                    node.colArrayInfos.setAttribute('rowSpan', 3);

                }

                if(!newarray) {

                    if(document.all) {
                        node.colArrayInfos.style.setAttribute('cssText', 'width:' + (this.base_width / 10) + this.base_width_unit + '; height: 100%; text-align: center; background-color: ' + this.backgroundColor + ';');
                    } else {
                        node.colArrayInfos.setAttribute('style', 'width:' + (this.base_width / 10) + this.base_width_unit + '; height: 100%; text-align: center; background-color: ' + this.backgroundColor + ';');
                    }

                } else {

                    if(document.all) {
                        node.colArrayInfos.style.setAttribute('cssText', 'width: 100%; height: 100%; text-align: center; padding: 0px; border-right-width: 0px; background-color: ' + this.backgroundColor + ';');
                    } else {
                        node.colArrayInfos.setAttribute('style', 'width: 100%; height: 100%; text-align: center; padding: 0px; border-right-width: 0px; background-color: ' + this.backgroundColor + ';');
                    }

                }

                node.rowTitles.appendChild(node.colArrayInfos);

                // defines HTML slot status rows 
                node.rowSlotStatus = document.createElement('tr');

                if(newarray) {

                    if(document.all) {
                        node.rowSlotStatus.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                    } else {
                        node.rowSlotStatus.setAttribute('style', 'padding: 0px; border-width: 0px;');
                    }

                }

                node.tbody.appendChild(node.rowSlotStatus);

                // defines HTML slot action rows 
                node.rowSlotAction = document.createElement('tr');

                if(newarray) {

                    if(document.all) {
                        node.rowSlotAction.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                    } else {
                        node.rowSlotAction.setAttribute('style', 'padding: 0px; border-width: 0px;');
                    }

                }

                node.tbody.appendChild(node.rowSlotAction);

                // Array Name container
                this._tArray[i].name = document.createElement('strong');
                node.colArrayInfos.appendChild(this._tArray[i].name);
                node.colArrayInfos.appendChild(document.createElement('br'));
                // Array Status container
                this._tArray[i].status = document.createElement('strong');
                node.colArrayInfos.appendChild(this._tArray[i].status);
                // Array Size container
                this._tArray[i].size = document.createElement('div');
                node.colArrayInfos.appendChild(this._tArray[i].size);

                if(this.checkRaid5()) {

                    // defines HTML titles rows 2
                    node.rowTitles2 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowTitles2.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowTitles2.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowTitles2);

                    // defines HTML slot status rows 2
                    node.rowSlotStatus2 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowSlotStatus2.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowSlotStatus2.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowSlotStatus2);

                    // defines HTML slot action rows 2
                    node.rowSlotAction2 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowSlotAction2.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowSlotAction2.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowSlotAction2);

                    // defines HTML titles rows 3
                    node.rowTitles3 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowTitles3.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowTitles3.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowTitles3);

                    // defines HTML slot status rows 3
                    node.rowSlotStatus3 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowSlotStatus3.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowSlotStatus3.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowSlotStatus3);

                    // defines HTML slot action rows 3
                    node.rowSlotAction3 = document.createElement('tr');

                    if(newarray) {

                        if(document.all) {
                            node.rowSlotAction3.style.setAttribute('cssText', 'padding: 0px; border-width: 0px;');
                        } else {
                            node.rowSlotAction3.setAttribute('style', 'padding: 0px; border-width: 0px;');
                        }

                    }

                    node.tbody.appendChild(node.rowSlotAction3);

                }

                if(!newarray) {

                    this._tArray[i].name.innerHTML = arkeia.lang.getMsg('app_raid_array') + i;
                    this._tArray[i].status.innerHTML = this.cleanStatus(this.array[i].STATUS);
                    this._tArray[i].status.style.color = this.tAlertColors[this.array[i].ALERT];
                    this._tArray[i].size.innerHTML = this.array[i].SIZE;

                } else {

                    this._tArray[i].name.innerHTML += arkeia.lang.getMsg('app_raid_array') + i + '<br />';

                    if(this._array_search(this.array, 0) != -1) {

						if(this.has3arrays) {
							var x = this.nb_slots_raid - (this.nb_slots_left - (2*(i-1))) + 1;
							var y = x + 1;
						} else {
							var x = ((this.nb_slots_raid - this.nb_slots_left) + 1);
							var y = this.nb_slots_raid;							
						}

                        for(x; x<=y; x++) {

                            this._tArray[i].name.innerHTML += this.diskName + x;

                            if(x<y) {

                                this._tArray[i].name.innerHTML += ', ';

                            }

                        }

                    } else {

						if(this.has3arrays) {
							var x = this.nb_slots_raid - (this.nb_slots_left - (2*(i-1))) + 1;
							var y = x + 1;
						} else {
							var x = 1;
							var y = (this.nb_slots_raid - this.nb_slots_left);
						}

                        for(x; x<=y; x++) {

                            this._tArray[i].name.innerHTML += this.diskName + x;

                            if(x<y) {

                                this._tArray[i].name.innerHTML += ', ';

                            }

                        }

                    }

                    this._tArray[i].form = dojo.widget.createWidget(
                        "arkeia:ArkeiaForm", 
                        {
                            id: this.widgetId + 'newArrayForm'+i,
                            widgetId: this.widgetId + 'newArrayForm'+i
                        }
                    );

                    this._forms.push(this._tArray[i].form);
                    this._tArray[i].name.appendChild(this._tArray[i].form.domNode);

                    // RAID VERSION
                    this._tArray[i].form_RaidVer = document.createElement('input');
                    this._tArray[i].form_RaidVer.setAttribute('type', 'hidden');
                    this._tArray[i].form_RaidVer.setAttribute('name', 'RaidVer');
                    this._tArray[i].form_RaidVer.setAttribute('value', this.version);
                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_RaidVer);
                    // ARRAY ID
                    this._tArray[i].form_RaidNo = document.createElement('input');
                    this._tArray[i].form_RaidNo.setAttribute('type', 'hidden');
                    this._tArray[i].form_RaidNo.setAttribute('name', 'RaidNo');
                    this._tArray[i].form_RaidNo.setAttribute('value', i);
                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_RaidNo);
                    // DISK 1 ID
                    this._tArray[i].form_DiskNo = document.createElement('input');
                    this._tArray[i].form_DiskNo.setAttribute('type', 'hidden');
                    this._tArray[i].form_DiskNo.setAttribute('name', 'DiskNo');

                    if(this._array_search(this.array, 0) != -1) {

						if(this.has3arrays) {
							this._tArray[i].form_DiskNo.setAttribute('value', (this.nb_slots_raid - (this.nb_slots_left - (2*(i-1)))) + 1);
						} else {
							this._tArray[i].form_DiskNo.setAttribute('value', (this.nb_slots_raid - this.nb_slots_left) + 1);
						}

                    } else {

                        this._tArray[i].form_DiskNo.setAttribute('value', 1);

                    }

                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_DiskNo);
                    // DISK 2 ID
                    this._tArray[i].form_DiskNo2 = document.createElement("input");
                    this._tArray[i].form_DiskNo2.setAttribute('type', 'hidden');
                    this._tArray[i].form_DiskNo2.setAttribute('name', 'DiskNo2');

					if(this.has3arrays) {
						 this._tArray[i].form_DiskNo2.setAttribute('value', ((this.nb_slots_raid - (this.nb_slots_left - (2*(i-1))))) + 2);
					} else {

                    if(this._array_search(this.array, 0) != -1) {

                        this._tArray[i].form_DiskNo2.setAttribute('value', this.nb_slots_raid);

                    } else {

                        this._tArray[i].form_DiskNo2.setAttribute('value', (this.nb_slots_raid - this.nb_slots_left));

                    }

					}

                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_DiskNo2);
                    // USE FORCE
                    this._tArray[i].form_useForce = document.createElement('div');
                    //this._newArray.formNode.appendChild(this._newArray.useForce);
                    this._tArray[i].form_useForce.appendChild(document.createTextNode('('));
                    node.useForce = document.createElement('input');
                    node.useForce.setAttribute('type', 'checkbox');
                    node.useForce.setAttribute('name', 'USE_FORCE');
                    node.useForce.setAttribute('value', 'on');
                    node.useForce.style.width = '10px';
                    this._tArray[i].form_useForce.appendChild(node.useForce);
                    // LABEL FOR USE FORCE
                    this._tArray[i].form_useForce.appendChild(document.createTextNode(arkeia.lang.getMsg('app_raid_action_force')));
                    this._tArray[i].form_useForce.appendChild(document.createTextNode(')'));
                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_useForce);

                    this._tArray[i].form_button = dojo.widget.createWidget(
                        "arkeia:ArkeiaButton", 
                        {
                            caption: arkeia.lang.getMsg('app_raid_action_CreateArray'),
                            widgetId: this.widgetId + 'newArraySubmit'+1,
                            myformid: this.widgetId + 'newArrayForm'+i,
                            controller: this.controller,
                            action: 'jsonRaidCreateArray',
                            nextUrl: 'appliance/raid'
                        }
                    );

					if(typeof this.makinsensitive != 'undefined') {
						this._tArray[i].form_button.setDisabled(true);
					}

                    dojo.html.setStyleAttributes(this._tArray[i].form_button.domNode, 'width: 50px;');

                    this._buttons.push(node.button);
                    this._tArray[i].form.domNode.appendChild(this._tArray[i].form_button.domNode);

                }

            }

        },

        populateDataArrayDisk: function(node, i, j) {

            if (!this._tArray[i].slot[j]) {

                this._tArray[i].slot[j] = {};

                // Disk Name container
                this._tArray[i].slot[j].colName = document.createElement('td');

                if(this.checkRaid5()) {

                    if(document.all) {
                        this._tArray[i].slot[j].colName.style.setAttribute('cssText', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 50px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                    } else {
                        this._tArray[i].slot[j].colName.setAttribute('style', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 50px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                    }

		    if (this.checkRaid5()) {
				if(this.checkVersion310()) {
					if(j == 1 || j == 2) {
						node.rowTitles.appendChild(this._tArray[i].slot[j].colName);
					}
					if(j == 3 || j == 4) {
						node.rowTitles2.appendChild(this._tArray[i].slot[j].colName);
					}
					if(j == 5 || j == 6) {
						node.rowTitles3.appendChild(this._tArray[i].slot[j].colName);
					}
				} else {
					if((j-1)%3 == 0) {
						node.rowTitles.appendChild(this._tArray[i].slot[j].colName);
					}
					if((j-1)%3 == 1) {
						node.rowTitles2.appendChild(this._tArray[i].slot[j].colName);
					}
					if((j-1)%3 == 2) {
						node.rowTitles3.appendChild(this._tArray[i].slot[j].colName);
					}
				}
		    }
		} else {

                    if(document.all) {
                        this._tArray[i].slot[j].colName.style.setAttribute('cssText', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 70px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                    } else {
                        this._tArray[i].slot[j].colName.setAttribute('style', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 70px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                    }

                    node.rowTitles.appendChild(this._tArray[i].slot[j].colName);

                }

                // Disk Status container
                this._tArray[i].slot[j].colStatus = document.createElement('td');

                if(document.all) {
                    this._tArray[i].slot[j].colStatus.style.setAttribute('cssText', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; text-align: center; background-color: ' + this.backgroundColor + ';');
                } else {
                    this._tArray[i].slot[j].colStatus.setAttribute('style', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; text-align: center; background-color: ' + this.backgroundColor + ';');
                }

                if(this.checkRaid5()) {
			if(this.checkVersion310()) {
				if(j == 1 || j == 2) {
					node.rowSlotStatus.appendChild(this._tArray[i].slot[j].colStatus);
				}
				if(j == 3 || j == 4) {
					node.rowSlotStatus2.appendChild(this._tArray[i].slot[j].colStatus);
				}
				if(j == 5 || j == 6) {
					node.rowSlotStatus3.appendChild(this._tArray[i].slot[j].colStatus);
				}
			} else {
				if((j-1)%3 == 0) {
					node.rowSlotStatus.appendChild(this._tArray[i].slot[j].colStatus);
				}
				if((j-1)%3 == 1) {
					node.rowSlotStatus2.appendChild(this._tArray[i].slot[j].colStatus);
				}
				if((j-1)%3 == 2) {
					node.rowSlotStatus3.appendChild(this._tArray[i].slot[j].colStatus);
				}
			}
		} else {
			node.rowSlotStatus.appendChild(this._tArray[i].slot[j].colStatus);
		}

                // Disk Action container
                node.colAction = document.createElement('td');

                if(document.all) {
                    node.colAction.style.setAttribute('cssText', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 40px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                } else {
                    node.colAction.setAttribute('style', 'width:' + ((this.base_width - (this.base_width / 10)) / 2) + this.base_width_unit + '; height: 40px; text-align: center; padding: 0px; background-color: ' + this.backgroundColor + ';');
                }

                // NO ACTION
                this._tArray[i].slot[j].noAction = document.createElement('div');
                this._tArray[i].slot[j].noAction.innerHTML = arkeia.lang.getMsg('app_raid_action_none');
                this._tArray[i].slot[j].noAction.style.display = 'none';
                node.colAction.appendChild(this._tArray[i].slot[j].noAction);

                // FORM
                node.formAction = dojo.widget.createWidget(
                    "arkeia:ArkeiaForm", 
                    {
                        id: 'Array' + i + 'Slot' + j + 'ActionForm',
                        widgetId: 'Array' + i + 'Slot' + j + 'ActionForm'
                    }
                );

                this._forms.push(node.formAction);
                this._tArray[i].slot[j].formAction = node.formAction.domNode;
                node.colAction.appendChild(this._tArray[i].slot[j].formAction);

                // ARRAY ID
                this._tArray[i].slot[j].RaidNo = document.createElement("input");
                this._tArray[i].slot[j].RaidNo.setAttribute('type', 'hidden');
                this._tArray[i].slot[j].RaidNo.setAttribute('name', 'RaidNo');
                this._tArray[i].slot[j].formAction.appendChild(this._tArray[i].slot[j].RaidNo);

                // DISK ID
                this._tArray[i].slot[j].DiskNo = document.createElement('input');
                this._tArray[i].slot[j].DiskNo.setAttribute('type', 'hidden');
                this._tArray[i].slot[j].DiskNo.setAttribute('name', 'DiskNo');
                this._tArray[i].slot[j].formAction.appendChild(this._tArray[i].slot[j].DiskNo);

                // SUBMIT (ADD/REMOVE)
                this._tArray[i].slot[j].button = document.createElement('span');
                this._tArray[i].slot[j].formAction.appendChild(this._tArray[i].slot[j].button);

                // USE FORCE
                // TODO: do not show this option by default but only if failed without it in a warning box
                this._tArray[i].slot[j].useForce = document.createElement('div');
                this._tArray[i].slot[j].useForce.appendChild(document.createTextNode('('));
                node.input = document.createElement('input');
                node.input.setAttribute('type', 'checkbox');
                node.input.setAttribute('name', 'USE_FORCE');
                node.input.setAttribute('value', 'on');
                node.input.style.width = '10px';
                this._tArray[i].slot[j].useForce.appendChild(node.input);

                // LABEL FOR USE FORCE
                this._tArray[i].slot[j].useForce.appendChild(document.createTextNode(arkeia.lang.getMsg('app_raid_action_force')));
                this._tArray[i].slot[j].useForce.appendChild(document.createTextNode(')'));
                this._tArray[i].slot[j].formAction.appendChild(this._tArray[i].slot[j].useForce);

                if(this.checkRaid5()) {
			if(this.checkVersion310()) {
				if(j == 1 || j == 2) {
					node.rowSlotAction.appendChild(node.colAction);
				}
				if(j == 3 || j == 4) {
					node.rowSlotAction2.appendChild(node.colAction);
				}
				if(j == 5 || j == 6) {
					node.rowSlotAction3.appendChild(node.colAction);
				}
			} else {
				if((j-1)%3 == 0) {
					node.rowSlotAction.appendChild(node.colAction);
				}
				if((j-1)%3 == 1) {
					node.rowSlotAction2.appendChild(node.colAction);
				}
				if((j-1)%3 == 2) {
					node.rowSlotAction3.appendChild(node.colAction);
				}
			}
		} else {

                    node.rowSlotAction.appendChild(node.colAction);

                }

                // NAME
                this._tArray[i].slot[j].colName.innerHTML = '<img src="images/Artichow/edgefort_disk.php?model='+this.model+'&name=' + this.diskName + this.array[i].SLOT[j].ID + '" style="float: none; border: 0px" alt="" />';
                // STATUS
                this._tArray[i].slot[j].colStatus.innerHTML = arkeia.lang.getMsg('app_raid_status') + this.array[i].SLOT[j].STATUS;
                this._tArray[i].slot[j].colStatus.style.color = this.tAlertColors[this.array[i].SLOT[j].ALERT];
                // ACTION
                if (this.array[i].SLOT[j].ACTION === 'N') {

                    this._tArray[i].slot[j].noAction.style.display = 'block';
                    this._tArray[i].slot[j].formAction.style.display = 'none';
                    this._tArray[i].slot[j].useForce.style.display = 'none';

                } else {

                    this._tArray[i].slot[j].noAction.style.display = 'none';
                    this._tArray[i].slot[j].formAction.style.display = 'block';
                    this._tArray[i].slot[j].useForce.style.display = (this.array[i].SLOT[j].ACTION === 'A') ? 'block' : 'none';
                    this._tArray[i].slot[j].RaidNo.setAttribute('value', this.array[i].ID);
                    this._tArray[i].slot[j].DiskNo.setAttribute('value', this.array[i].SLOT[j].ID);

                    node.buttonAction = dojo.widget.byId('Array' + i + 'Slot' + j + 'ActionSubmit');

                    if (node.buttonAction) {
                        node.buttonAction.destroy();
                    }

                    node.buttonAction = dojo.widget.createWidget(
                        "arkeia:ArkeiaButton", 
                        {
                            caption: arkeia.lang.getMsg('app_raid_action_' + this.actions[this.array[i].SLOT[j].ACTION]),
                            widgetId: 'Array' + i + 'Slot' + j + 'ActionSubmit',
                            myformid: 'Array' + i + 'Slot' + j + 'ActionForm',
                            controller: this.controller,
                            action: 'jsonRaid' + this.actions[this.array[i].SLOT[j].ACTION],
                            nextUrl: 'appliance/raid'
                        }
                    );

                    dojo.html.setStyleAttributes(node.buttonAction.domNode, 'width: 125px;');

                    this._buttons.push(node.buttonAction);
                    this._tArray[i].slot[j].button.appendChild(node.buttonAction.domNode);

                }

            }

        },

        populateDataNewArray: function(node, i, j) {

            if (!this._tArray[i].slot[j]) {

                this._tArray[i].slot[j] = {};

                this._tArray[i].slot[j].colName = document.createElement('td');

                if(this.checkRaid5()) {

                    if(document.all) {
                        node.colAction.style.setAttribute('cssText', 'height: 50px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                    } else {
                        node.colAction.setAttribute('style', 'height: 50px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                    }

                    if((j-1)%3 == 0) {
                        node.rowTitles.appendChild(this._tArray[i].slot[j].colName);
                    }
                    if((j-1)%3 == 1) {
                        node.rowTitles2.appendChild(this._tArray[i].slot[j].colName);
                    }
                    if((j-1)%3 == 2) {
                        node.rowTitles3.appendChild(this._tArray[i].slot[j].colName);
                    }

                } else {

                    if(document.all) {
                        this._tArray[i].slot[j].colName.setAttribute('cssText', 'height: 70px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                    } else {
                        this._tArray[i].slot[j].colName.setAttribute('style', 'height: 70px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                    }

                    node.rowTitles.appendChild(this._tArray[i].slot[j].colName);

                }

                this._tArray[i].slot[j].colStatus = document.createElement('td');

                if(document.all) {
                    this._tArray[i].slot[j].colStatus.setAttribute('cssText', 'text-align: center; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                } else {
                    this._tArray[i].slot[j].colStatus.setAttribute('style', 'text-align: center; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                }

                if(this.checkRaid5()) {

                    if((j-1)%3 == 0) {
                        node.rowSlotStatus.appendChild(this._tArray[i].slot[j].colStatus);
                    }
                    if((j-1)%3 == 1) {
                        node.rowSlotStatus2.appendChild(this._tArray[i].slot[j].colStatus);
                    }
                    if((j-1)%3 == 2) {
                        node.rowSlotStatus3.appendChild(this._tArray[i].slot[j].colStatus);
                    }

                } else {

                    node.rowSlotStatus.appendChild(this._tArray[i].slot[j].colStatus);

                }

                this._tArray[i].slot[j].colAction = document.createElement('td');

                if(document.all) {
                    this._tArray[i].slot[j].colAction.setAttribute('cssText', 'height: 40px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                } else {
                    this._tArray[i].slot[j].colAction.setAttribute('style', 'height: 40px; text-align: center; padding: 0px; width: 0px; border-width: 0px; background-color: ' + this.backgroundColor + ';');
                }

                if(this.checkRaid5()) {

                    if((j-1)%3 == 0) {
                        node.rowSlotAction.appendChild(this._tArray[i].slot[j].colAction);
                    }
                    if((j-1)%3 == 1) {
                        node.rowSlotAction2.appendChild(this._tArray[i].slot[j].colAction);
                    }
                    if((j-1)%3 == 2) {
                        node.rowSlotAction3.appendChild(this._tArray[i].slot[j].colAction);
                    }

                } else {

                    node.rowSlotAction.appendChild(this._tArray[i].slot[j].colAction);

                }

            }

        }

    }

);
