dojo.provide("arkeia.widget.ArkeiaTextbox");
dojo.require("dojo.widget.Textbox");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
// class
	"arkeia.widget.ArkeiaTextbox",

// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.Textbox],
		
// member variables/functions
	{
		valueField: "",
		disabled: false,
        password: false,
		width: "",
        resetOnData: false,
        transformData: '',
		type: 'text',
		listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],

		initialize: function() {
			dojo.debug(this + " Initialize");
			this.listenedArkeiaParents=[];
			if (this.disabled)
				this.disable();
			dojo.debug(this + " Initialized");
		},

        postCreate: function(args, frag) {
            var t;
            if (this.width != "") {
                this.textbox.style.width = this.width + 'px';
            }
            if (this.password !== false && this.password !== 'false') {
                this.textbox.style.appearance = 'password';
            }
            if (this.listened) {
                t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            }
            dojo.debug(this + " created");
        },

        transformData: function(_this, data) {
             // transform data for printing
            return data;
        },

        onArkeiaListSelect: function(message)
        {
            this.onArkeiaInfoData(message);
        },

		onArkeiaInfoData: function(message) {
            if(this.resetOnData) {
                this.setValue('');
            }
			if (this.valueField && message.data) {
                var _this = this;
                if (_this.transformData) {
                    message.data = _this.transformData(_this, message.data);
                }
				this.value = message.data[this.valueField];
				if (typeof(this.value) == 'undefined')
					this.value = '';
				this.textbox.value = this.value;
				this.filter();
			}
		},

	    setValue: function(value) {
		this.value = value;
		this.textbox.value = this.value;
                this.filter();
	    },

		enable:function(){
			this.disabled = false;
			this.textbox.removeAttribute("disabled");
		},

		disable: function(){
			this.disabled = true;
			this.textbox.setAttribute("disabled",true);
		}
	}
);
