dojo.provide("arkeia.widget.ArkeiaTitlePane");
dojo.require("dojo.widget.TitlePane");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaTitlePane",

    // superclass
    dojo.widget.TitlePane,

  // properties and methods
  {
    postCreate: function(){
        arkeia.widget.ArkeiaTitlePane.superclass.postCreate.apply(this, arguments);
        this.labelNode.setAttribute("open",this.open);
    },
    onLabelClick: function() {
        // summary: callback when label is clicked
        if (this.open) {
            dojo.lfx.wipeOut(this.containerNode, 250).play();
            this.open=false;
        } else {
            dojo.lfx.wipeIn(this.containerNode, 250).play();
            this.open=true;
        }
        this.labelNode.setAttribute("open",this.open);

	}
  }
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaReportContentPane",

    // superclass
    dojo.widget.ContentPane,

  // properties and methods
  {
	baseUrl: arkeia.baseUrl,
	profileCtl: 'report_profile_ctl',
	currentProfile: false,
	currentView: 'backup',
	isIndexed: false,
	currentFilter: '',
	timeStamp: 0,
	loadingMessage: '',
	currentY: '',
	currentX: '',
	hasXY: false,
	stateXY: false,
	Yctl: '',
	Xctl: '',
	getCleanHref: function() {
		var parts = this.href.split('?');
		return parts[0];
	},
	setProfile: function(profile, setY, setX, columns) {
		this.currentProfile = profile;
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentView != 'backup') {
			url += '&showonlytree=1';
		}
		if(this.currentFilter != '') {
			url += '&treefilter='+this.currentFilter;
		}
		if(this.hasXY) {
			if(!this.stateXY) {
				var _this = this;
				var dataUrl = this.baseUrl + '/report/jsonbackupgraphgetxy?profile='+profile;
				var getNext = this.baseUrl + '/report/jsonGetNextResult';
				var abortUrl = this.baseUrl + '/report/jsonAbortTrans';
				this._launchtrans(_this, _this.catchGetXY, dataUrl, getNext, abortUrl);
				return;
			} else {
				this.stateXY = false;
			}
		}
		if(typeof setY != 'undefined') {
			this.currentY = setY;
		}
		if(typeof setX != 'undefined') {
			this.currentX = setX;
		}
		if(typeof columns != 'undefined') {
			dojo.widget.byId(this.Yctl).setNewData(columns, this.currentY);
			dojo.widget.byId(this.Xctl).setNewData(columns, this.currentX);
		}
		if(this.currentY != '') {
			url += '&currentY='+this.currentY;
		}
		if(this.currentX != '') {
			url += '&currentX='+this.currentX;
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	switchView: function(view) {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(view) {
			this.currentView = 'tree';
			url += '&showonlytree=1';
		} else {
			this.currentView = 'backup';
		}
		if(this.currentFilter != '') {
			url += '&treefilter='+this.currentFilter;
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	applyFilter: function(filter) {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentView != 'backup') {
			url += '&showonlytree=1';
		}
		if(filter != '') {
			this.currentFilter = filter;
			url += '&treefilter='+filter;
		} else {
			this.currentFilter = '';
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
		return false;
	},
	setY: function(Y) {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		this.currentY = Y;
		url += '&currentY='+this.currentY;
		if(this.currentX != '') {
			url += '&currentX='+this.currentX;
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
		return false;
	},
	setX: function(X) {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentY != '') {
			url += '&currentY='+this.currentY;
		}
		this.currentX = X;
		url += '&currentX='+this.currentX;
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
		return false;
	},
	catchGetXY: function(obj, result) {
        if(result) {
			obj.stateXY = true;
			obj.setProfile(obj.currentProfile, result.data.setY, result.data.setX, result.data.columns);
        }
	},
	reloaddata: function() {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentView != 'backup') {
			url += '&showonlytree=1';
		}
		if(this.currentFilter != '') {
			url += '&treefilter='+this.currentFilter;
		}
		if(this.currentY != '') {
			url += '&currentY='+this.currentY;
		}
		if(this.currentX != '') {
			url += '&currentX='+this.currentX;
		}
		url += '&refresh';
		var date = new Date;
		this.timeStamp = date.getTime();
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	setReportUrl: function(params) {
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentView != 'backup') {
			url += '&showonlytree=1';
		}
		if(this.currentFilter != '') {
			url += '&treefilter='+this.currentFilter;
		}
		if(this.currentY != '') {
			url += '&currentY='+this.currentY;
		}
		if(this.currentX != '') {
			url += '&currentX='+this.currentX;
		}
		if(typeof params != 'undefined') {
			url += '&'+params;
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	monitorJob: function(controller, action) {
		var _this = this;
		var dataUrl = this.baseUrl + '/'+controller+'/'+action;
		var getNext = this.baseUrl + '/'+controller+'/jsonGetNextResult';
		var abortUrl = this.baseUrl + '/'+controller+'/jsonAbortTrans';
		this._launchtrans(_this, _this.catchMonitorJob, dataUrl, getNext, abortUrl);
	},
	catchMonitorJob: function(obj, result) {
        if(result) {
            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
            } else {
				display_result('', '', result.VIEW);
			}
        }
	},
	catchIndex: function(obj, result) {
        if(result) {
            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
				var date = new Date;
				var cur = date.getTime();
				if(cur > obj.startIndex+3000) {
					obj._setContent(arkwui_lang_get_msg('report_indexing_wait'));
				}
            } else {
				obj.isIndexed = true;
				obj._prepareForShow();
			}
        }
	},
	loadTrees: function(num) {
		this.lastloadtreesnum = num;
		var _this = this;
		var dataUrl = this.baseUrl + '/report/jsonReportLoadTrees?num='+num;
		var getNext = this.baseUrl + '/report/jsonReportLoadTreesGetNextResult';
		var abortUrl = this.baseUrl + '/report/jsonAbortTrans';
		this._launchtrans(_this, _this.catchLoadTrees, dataUrl, getNext, abortUrl);
		return;
	},
	catchLoadTrees: function(obj, result) {
        if(result) {
            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
            } else {
				var node = document.getElementById('report_detail_trees_'+obj.lastloadtreesnum);
				node.innerHTML = result.data;
			}
        }
	},
	_prepareForShow: function() {
		if ( this.isLoaded ){
			return;
		}
		if(!this.isIndexed) {
			var date = new Date;
			this.startIndex = date.getTime();
			var _this = this;
			var dataUrl = this.baseUrl + '/report/jsonReportIndexLog?profile='+dojo.widget.byId(this.profileCtl).getSelectedValue();
			var getNext = this.baseUrl + '/report/jsonReportIndexLogGetNextResult';
			var abortUrl = this.baseUrl + '/report/jsonAbortTrans';
			this._launchtrans(_this, _this.catchIndex, dataUrl, getNext, abortUrl);
			return;
		}
		if ( dojo.lang.isFunction(this.handler)) {
			this._runHandler();
		} else if ( this.href != "" ) {
			this._downloadExternalContent(this.href, this.cacheContent && !this.refreshOnShow);
		}
	},
    _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {
        var source = new Object;
        var DpClass = arkeia.widget.ArkeiaDataProvider;
        source.dataUrl = dataUrl;
        source.getNext = getNext;
        source.abortUrl = abortUrl;
		obj.dataProvider = new DpClass(source);
        obj.dataProvider.loadMultipleResult(obj, callback, null);
        obj.dataProvider.onLoadError = obj.onLoadError;
    }
  }
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaReportGraphContentPane",

    // superclass
    dojo.widget.ContentPane,

  // properties and methods
  {
	baseUrl: arkeia.baseUrl,
	profileCtl: 'report_profile_ctl',
	currentProfile: false,
	isIndexed: false,
	timeStamp: 0,
	loadingMessage: '',
	currentY: '',
	currentX: '',
	currentMonth: '',
	currentYear: '',
	Yctl: '',
	Xctl: '',
	period: 0,
	opt: 0,
	has3d: 1,
	getCleanHref: function() {
		var parts = this.href.split('?');
		return parts[0];
	},
	getCurrentHref: function() {
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(!this.currentProfile) {
			this.currentProfile = dojo.widget.byId(this.profileCtl).getSelectedValue();
		}
		var url = this.getCleanHref()+'?profile=' + this.currentProfile;
		if(this.currentY != '') {
			url += '&currentY='+this.currentY;
		}
		if(this.currentX != '') {
			url += '&currentX='+this.currentX;
		}
		if(this.currentMonth != '') {
			url += '&currentMonth='+this.currentMonth;
		}
		if(this.currentYear != '') {
			url += '&currentYear='+this.currentYear;
		}
		url += '&period='+this.period;
		url += '&opt='+this.opt;
		url += '&3d='+this.has3d;
		if(typeof this.zoom != 'undefined') {
			delete this.zoom;
			delete this.graphimgsrc;
			document.getElementById('zoomoutimg').src = '/images/arrow_del_10x10_disabled.gif';
		}
		//if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		//}
		url += '&timeStamp='+this.timeStamp;
		return url;
	},
	setCurrentImgSrc: function(opt, value) {
		var parts, argsraw, tmp, arg, i;
		this.graphimgsrc = document.getElementById('reportgraphimg').src;
		parts = this.graphimgsrc.split('?');
		if(parts.length == 2) {
			argsraw = parts[1].split('&');
			tmp = [];
			arg;
			for(i=0; i<argsraw.length; i++) {
				arg = argsraw[i].split('=');
				if(arg[0] != opt) {
					tmp.push(argsraw[i]);
				}
			}
			parts[1] = tmp.join('&');
		}
		this.graphimgsrc = parts.join('?') + '&' + opt + '=' + value;
		document.getElementById('reportgraphimg').src = this.graphimgsrc;
	},
	setProfile: function(profile, setY, setX, columns) {
		this.currentProfile = profile;
		if(typeof setY != 'undefined') {
			this.currentY = setY;
		}
		if(typeof setX != 'undefined') {
			this.currentX = setX;
		}
		this.setUrl(this.getCurrentHref());
	},
	setY: function(Y) {
		this.currentY = Y;
		this.setUrl(this.getCurrentHref());
		return false;
	},
	setX: function(X) {
		this.currentX = X;
		this.setUrl(this.getCurrentHref());
		return false;
	},
	setPeriod: function(period) {
		this.period = period;
		this.setUrl(this.getCurrentHref());
		return false;
	},
	setMonthYear: function(year, month) {
		this.currentYear = year;
		this.currentMonth = month;
		this.setUrl(this.getCurrentHref());
		return false;
	},
	set3d: function(has3d) {
		this.has3d = has3d;
		this.setCurrentImgSrc('3d', (this.has3d)?'1':'0');
		return false;
	},
	setZoom: function() {
		this.setCurrentImgSrc('zoom', (100-this.zoom));
		return false;
	},
	setOpt: function(opt) {
		this.opt = opt;
		this.setUrl(this.getCurrentHref());
		return false;
	},
	reloaddata: function() {
		var date = new Date;
		this.timeStamp = date.getTime();
		this.setUrl(this.getCurrentHref());
	},
	setReportUrl: function(params) {
		var url = this.getCurrentHref();
		if(typeof params != 'undefined') {
			url += '&'+params;
		}
		this.setUrl(url);
	},
	getAllSavepacks: function() {
		var ctrl = document.getElementById('inputs_ctrl');
		var tmp = {};
		var id;
		for(var i=0; i<ctrl.childNodes.length; i++) {
			id = ctrl.childNodes[i].id.replace('check_', '');
			tmp[id] = document.getElementById(ctrl.childNodes[i].id).checked;
		}
		return tmp;
	},
	setSavepacks: function() {
		var svpks = this.getAllSavepacks();
		var result = '';
		var partial = false;
		for(i in svpks) {
			if(svpks[i]) {
				result += '&svpks[]=' + i;
			} else {
				partial = true;
			}
		}
		if(result != '') {
			var url = this.getCurrentHref();
			if(partial) {
				url += result;
			}
			this.setUrl(url);
		}
	},
	selectAllSavepacks: function() {
		var svpks = this.getAllSavepacks();
		var result = '';
		for(i in svpks) {
			if(!svpks[i]) {
				document.getElementById('checkimage_'+i).onclick();
			}
		}
	},
	deSelectAllSavepacks: function() {
		var svpks = this.getAllSavepacks();
		var result = '';
		for(i in svpks) {
			if(svpks[i]) {
				document.getElementById('checkimage_'+i).onclick();
			}
		}
	},
	inverSelectionSavepacks: function() {
		var svpks = this.getAllSavepacks();
		var result = '';
		for(i in svpks) {
			document.getElementById('checkimage_'+i).onclick();
		}
	},
	monitorJob: function(controller, action) {
		var _this = this;
		var dataUrl = this.baseUrl + '/'+controller+'/'+action;
		var getNext = this.baseUrl + '/'+controller+'/jsonGetNextResult';
		var abortUrl = this.baseUrl + '/'+controller+'/jsonAbortTrans';
		this._launchtrans(_this, _this.catchMonitorJob, dataUrl, getNext, abortUrl);
	},
	catchMonitorJob: function(obj, result) {
        if(result) {
            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
            } else {
				display_result('', '', result.VIEW);
			}
        }
	},
	catchIndex: function(obj, result) {
        if(result) {
            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
				var date = new Date;
				var cur = date.getTime();
				if(cur > obj.startIndex+3000) {
					obj._setContent(arkwui_lang_get_msg('report_indexing_wait'));
				}
            } else {
				obj.isIndexed = true;
				obj._prepareForShow();
			}
        }
	},
	_prepareForShow: function() {
		if ( this.isLoaded ){
			return;
		}
		if(!this.isIndexed) {
			var date = new Date;
			this.startIndex = date.getTime();
			var _this = this;
			var dataUrl = this.baseUrl + '/report/jsonReportIndexLog?profile='+dojo.widget.byId(this.profileCtl).getSelectedValue();
			var getNext = this.baseUrl + '/report/jsonReportIndexLogGetNextResult';
			var abortUrl = this.baseUrl + '/report/jsonAbortTrans';
			this._launchtrans(_this, _this.catchIndex, dataUrl, getNext, abortUrl);
			return;
		}
		if ( dojo.lang.isFunction(this.handler)) {
			this._runHandler();
		} else if ( this.href != "" ) {
			this._downloadExternalContent(this.href, this.cacheContent && !this.refreshOnShow);
		}
	},
    _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {
        var source = new Object;
        var DpClass = arkeia.widget.ArkeiaDataProvider;
        source.dataUrl = dataUrl;
        source.getNext = getNext;
        source.abortUrl = abortUrl;
		obj.dataProvider = new DpClass(source);
        obj.dataProvider.loadMultipleResult(obj, callback, null);
        obj.dataProvider.onLoadError = obj.onLoadError;
    }
  }
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaReportProfilesContentPane",

    // superclass
    [dojo.widget.ContentPane, arkeia.widget.ArkeiaListener],

  // properties and methods
  {
	baseUrl: arkeia.baseUrl,
	jobtype: 0,
	profile_id: '',
        realDataUrl: '',
        timeStamp: 0,
        tab: '',
        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],

        initialize: function() {
            this.listenedArkeiaParents=[];
        },

        postCreate: function() {
	    if (this.listened) {
	        var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
	        this.listenArkeiaParent(t);
	    }

            //this.dataProvider.searchLimit = 512; /* nombre de choix affiche au maximum */

	    if (typeof this.dataProvider != undefined) {

		    var _dataProvider = this.dataProvider;
		    var _this = this;
		    this.dataProvider.setData = function (pdata)
			    {
				    _this.lastmessage = pdata;
				    _dataProvider._data = pdata;
				    globalCache.put_cache(_dataProvider, _this, pdata);
				    if(pdata.length > 0 && _this.setDisplay != '') {
					    document.getElementById(_this.setDisplay).style.display = _this.setDisplayType;
				    }
				    _this.onArkeiaInfoLoaded();
			    };
	    }
	  },

	onArkeiaListSelect: function(message) {
	    this.onArkeiaInfoData(message);
	},

 	onArkeiaInfoData: function(message) {
		  this.jobtype = parseInt(message.data.REPROF_TYPE);
		  this.profile_id = message.data.REPROFID;
		  this.setProfilesUrl('jobtype='+this.jobtype+'&profile_id='+this.profile_id);
	},

	getCleanHref: function() {
		var parts = this.href.split('?');
		return parts[0];
	},
	reloaddata: function() {
		var url = this.getCleanHref()+'?';
		url += '&refresh';
		var date = new Date;
		this.timeStamp = date.getTime();
		if(this.tab != '') {
			url += '&tab='+this.tab;
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	setProfilesUrl: function(params) {
		var url = this.getCleanHref()+'?';
		if(typeof params != 'undefined') {
			url += params;
		}
		if(!this.timeStamp) {
			var date = new Date;
			this.timeStamp = date.getTime();
		}
		if(this.tab != '') {
			url += '&tab='+this.tab;
		}
		url += '&timeStamp='+this.timeStamp;
		this.setUrl(url);
	},
	_launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {
		  var source = new Object;
		  var DpClass = arkeia.widget.ArkeiaDataProvider;
		  source.dataUrl = dataUrl;
		  source.getNext = getNext;
		  source.abortUrl = abortUrl;
		  obj.dataProvider = new DpClass(source);
		  obj.dataProvider.loadMultipleResult(obj, callback, null);
		  obj.dataProvider.onLoadError = obj.onLoadError;
	}
  }
);

dojo.widget.defineWidget(
	// widget name and class
	"arkeia.widget.ArkeiaRestorationpluginContentPane",

	// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.ContentPane],

	// init function
	function(){
		this.eventNames={};
		this._data =[];
		this._lastId = null;
	},
  
	// properties and methods
	{
		baseUrl: arkeia.baseUrl,
		//listenArkeiaParentEvents: ['arkeiaInfoData','arkeiaListSelect'],
		eventNamesDefault: {
			arkeiaInfoData: 'arkeiaInfoData'/*,
			beforeLoad: 'beforeLoad',
			afterLoad: 'afterLoad'*/
		},
		listened: "",
		controller: '',
		startaction: '',
		abortaction:'',
		answeraction:'',
		stataction: '',
		vstverifaction: '',
		getnextaction: 'jsonGetNextResult',
		timeStamp: 0,
		step: 1,
		loadingMessage: '',
		initialize: function() {
			this.listenedArkeiaParents = [];
			for(var name in this.eventNamesDefault) {
				if (dojo.lang.isUndefined(this.eventNames[name])) {
					this.eventNames[name] = this.widgetId+'/'+this.eventNamesDefault[name];
				}
			}
		},
		newDataInfo: function(_this, data, appid) {
			if (data['local'] != undefined) {
				data = data['local'];
			}
			//_this._data[_this._lastId] = data;
			var eventName = _this.eventNames.arkeiaInfoData;
			dojo.event.topic.publish(eventName, { data: data, appid: appid });
			return;
		},
		newResult: function(_this, message) {
			//dojo.event.topic.publish(_this.eventNames.beforeLoad, {});
			if (message.data) {
				if (message.data2) {
					message.data['PARAM3'] = message.data2;
				}
				_this.newDataInfo(_this, message.data, message.appid);
			} else {
				dojo.event.topic.publish(_this.eventNames.arkeiaInfoData, {});
			}
			//dojo.event.topic.publish(_this.eventNames.afterLoad, {});
		},
		onArkeiaInfoData: function(message) {
		},
		getCleanHref: function() {
			var parts = this.href.split('?');
			return parts[0];
		},
		getCurrentHref: function() {
			var url = this.getCleanHref();
			var date = new Date;
			this.timeStamp = date.getTime();
			url += '?timeStamp='+this.timeStamp;
			return url;
		},
		urlencode: function(str) {
			str = (str+'').toString();
			return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
		},
		_utf8_encode : function (string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";
			for (var n = 0; n < string.length; n++) {
				var c = string.charCodeAt(n);
				if (c < 128) {
					utftext += String.fromCharCode(c);
				} else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				} else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}
			}
			return utftext;
		},
		_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
		_base64_encode : function (input) {
			var output = "";
			var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
			var i = 0;
			input = this._utf8_encode(input);
			while (i < input.length) {
				chr1 = input.charCodeAt(i++);
				chr2 = input.charCodeAt(i++);
				chr3 = input.charCodeAt(i++);
				enc1 = chr1 >> 2;
				enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
				enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
				enc4 = chr3 & 63;
				if (isNaN(chr2)) {
					enc3 = enc4 = 64;
				} else if (isNaN(chr3)) {
					enc4 = 64;
				}
				output = output +
				this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
				this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
			}
			return output;
		},
		_downloadExternalContent: function(url, useCache) {
			this.abort();
			this._handleDefaults(this.loadingMessage, "onDownloadStart");
			var self = this;
			var params = {
				url: url,
				mimetype: "text/html",
				handler: function(type, data, xhr){
					delete self._ioBindObj;
					if(type=="load"){
						self.onDownloadEnd.call(self, url, data);
					}else{
						var e = {
							responseText: xhr.responseText,
							status: xhr.status,
							statusText: xhr.statusText,
							responseHeaders: xhr.getAllResponseHeaders(),
							text: "Error loading '" + url + "' (" + xhr.status + " "+  xhr.statusText + ")"
						};
						self._handleDefaults.call(self, e, "onDownloadError");
						self.onLoad();
					}
				}
			}
			if(typeof this._usePost != 'undefined' && typeof this._usePostParams != 'undefined' && this._usePost) {
				params['method'] = 'POST';
				params['content'] = this._usePostParams;
			}
			this._ioBindObj = dojo.io.bind(
				this._cacheSetting(params, useCache)
			);
		},
		setPostUrl: function(url, opts, noEnc) {
			this.href = url;
			this.setOpt(opts, noEnc, true);
		},
		setOpt: function(opts, noEnc, usePost) {
			if(typeof usePost != 'undefined') {
				this._usePost = true;
				this._usePostParams = this.setupPostOp(opts, noEnc);
				this.setUrl(this.getCurrentHref());
				this._usePost = false;
			} else {
				this.setUrl(this.getCurrentHref() + this.setupGetOp(opts, noEnc));
			}
			return false;
		},
		setupGetOp: function(opts, noEnc) {
			var urlpart = '';
			for(var i in opts) {
				if(typeof opts[i] == 'object') {
					for(var j in opts[i]) {
						if(typeof noEnc == 'undefined') {
							urlpart += '&' + i + '[]=' + this.urlencode(this._base64_encode(opts[i][j]));
						} else {
							urlpart += '&' + i + '[]=' + opts[i][j];
						}
					}
				} else {
					if(typeof noEnc == 'undefined') {
						urlpart += '&' + i + '=' + this.urlencode(this._base64_encode(opts[i]));
					} else {
						urlpart += '&' + i + '=' + opts[i];
					}
				}
			}
			return urlpart;
		},
		setupPostOp: function(opts, noEnc) {
			var params = {};
			for(var i in opts) {
				if(typeof opts[i] == 'object') {
					for(var j in opts[i]) {
						if(typeof noEnc == 'undefined') {
							params[i+'['+j+']'] = this.urlencode(this._base64_encode(opts[i][j]));
						} else {
							params[i+'['+j+']'] = opts[i][j];
						}
					}
				} else {
					if(typeof noEnc == 'undefined') {
						params[i] = this.urlencode(this._base64_encode(opts[i]));
					} else {
						params[i] = opts[i];
					}
				}
			}
			return params;
		},
		onLoad: function() {
			if(typeof this.selectFirst != 'undefined') {
				arkeia.layout.restoreplugin.onclickbkpcpt(this.selectFirst);
			}
		},
		cancelVerif: function(params) {
			var popup;
			popup = dojo.widget.byId('generic_popup');
			popup.hide();
		},
		startVstVerif: function(params) {
			if	(
					this.controller != '' &&
					this.vstverifaction &&
					typeof params.TYPE != 'undefined' &&
					typeof params.PATH != 'undefined' &&
					typeof params.NAME != 'undefined' &&
					params.INPUTFROM != 'undefined'
				) {
				var _this = this;
				var dataUrl = this.baseUrl + '/'+this.controller+'/'+this.vstverifaction;
				var getNext = this.baseUrl + '/'+this.controller+'/'+this.getnextaction;
				var abortUrl = this.baseUrl + '/'+this.controller+'/jsonAbortTrans';
				_this.curTYPE = params.TYPE;
				_this.curPATH = params.PATH;
				_this.curNAME = params.NAME;
				_this.curINPUTFROM = params.INPUTFROM;
				this._launchtrans(_this, _this.catchtartVstVerif, dataUrl, getNext, abortUrl, params);
				if(document.getElementById('popupnavrstplugmessage')) {
					document.getElementById('popupnavrstplugmessage').innerHTML = '<div style="text-align: center; color: green; font-weight: bold;">'+arkwui_lang_get_msg('rst_plugin_error_vstpopupverifwait')+'</div>';
				}
			}
		},
		catchtartVstVerif: function(obj, result) {
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					if(typeof result.data != 'undefined') {
						var nextType, nextKey;
						switch(obj.curTYPE) {
							case 'CT':
								if(typeof result.data.ISVCENTER != 'undefined' && parseInt(result.data.ISVCENTER) == 1) {
									nextType = 'CP';
									nextKey = 'COMPUTER_ROOT';
								} else {
									nextType = 'PL';
									nextKey = 'POOL_ROOT';
								}
							break;
							case 'CP':
								nextType = 'PL';
								nextKey = 'POOL_ROOT';
							break;
							case 'PL':
								nextType = 'DS';
								nextKey = 'DATASTORE_ROOT';
							break;
						}
						try {
							var input_ct, input_ct_real, input_ct_label;
							var input_cp, input_cp_real, input_cp_label, input_cp_start;
							var input_pl, input_pl_real, input_pl_label, input_pl_start;
							var input_ds, input_ds_real, input_ds_label, input_ds_start;
							switch(obj.curTYPE) {
								case 'CT':
									input_ct = document.getElementById('ct'+obj.curINPUTFROM+obj.curTYPE);
									input_ct_label = document.getElementById(obj.curINPUTFROM+obj.curTYPE);
									input_ct_real = document.getElementById(obj.curINPUTFROM+obj.curTYPE+'_real');
									input_ct_label.value = '';
									input_ct_real.value = '';
									input_cp = document.getElementById('ct'+obj.curINPUTFROM+'CP');
									input_cp_label = document.getElementById(obj.curINPUTFROM+'CP');
									input_cp_real = document.getElementById(obj.curINPUTFROM+'CP'+'_real');
									input_cp_start = document.getElementById(obj.curINPUTFROM+'CP'+'_start');
									input_cp.style.display = 'none';
									input_cp_label.value = '';
									input_cp_real.value = '';
									input_cp_start.value = '';
									input_pl = document.getElementById('ct'+obj.curINPUTFROM+'PL');
									input_pl_label = document.getElementById(obj.curINPUTFROM+'PL');
									input_pl_real = document.getElementById(obj.curINPUTFROM+'PL'+'_real');
									input_pl_start = document.getElementById(obj.curINPUTFROM+'PL'+'_start');
									input_pl.style.display = 'none';
									input_pl_label.value = '';
									input_pl_real.value = '';
									input_pl_start.value = '';
									input_ds = document.getElementById('ct'+obj.curINPUTFROM+'DS');
									input_ds_label = document.getElementById(obj.curINPUTFROM+'DS');
									input_ds_real = document.getElementById(obj.curINPUTFROM+'DS'+'_real');
									input_ds_start = document.getElementById(obj.curINPUTFROM+'DS'+'_start');
									input_ds.style.display = 'none';
									input_ds_label.value = '';
									input_ds_real.value = '';
									input_ds_start.value = '';
								break;

								case 'CP':
									input_cp = document.getElementById('ct'+obj.curINPUTFROM+obj.curTYPE);
									input_cp_label = document.getElementById(obj.curINPUTFROM+obj.curTYPE);
									input_cp_real = document.getElementById(obj.curINPUTFROM+obj.curTYPE+'_real');
									input_cp_label.value = '';
									input_cp_real.value = '';
									input_pl = document.getElementById('ct'+obj.curINPUTFROM+'PL');
									input_pl_label = document.getElementById(obj.curINPUTFROM+'PL');
									input_pl_real = document.getElementById(obj.curINPUTFROM+'PL'+'_real');
									input_pl_start = document.getElementById(obj.curINPUTFROM+'PL'+'_start');
									input_pl.style.display = 'none';
									input_pl_label.value = '';
									input_pl_real.value = '';
									input_pl_start.value = '';
									input_ds = document.getElementById('ct'+obj.curINPUTFROM+'DS');
									input_ds_label = document.getElementById(obj.curINPUTFROM+'DS');
									input_ds_real = document.getElementById(obj.curINPUTFROM+'DS'+'_real');
									input_ds_start = document.getElementById(obj.curINPUTFROM+'DS'+'_start');
									input_ds.style.display = 'none';
									input_ds_label.value = '';
									input_ds_real.value = '';
									input_ds_start.value = '';
								break;

								case 'PL':
									input_pl = document.getElementById('ct'+obj.curINPUTFROM+obj.curTYPE);
									input_pl_label = document.getElementById(obj.curINPUTFROM+obj.curTYPE);
									input_pl_real = document.getElementById(obj.curINPUTFROM+obj.curTYPE+'_real');
									input_pl_label.value = '';
									input_pl_real.value = '';
								break;

								case 'DS':
									input_ds = document.getElementById('ct'+obj.curINPUTFROM+obj.curTYPE);
									input_ds_label = document.getElementById(obj.curINPUTFROM+obj.curTYPE);
									input_ds_real = document.getElementById(obj.curINPUTFROM+obj.curTYPE+'_real');
									input_ds_label.value = '';
									input_ds_real.value = '';
								break;
							}
							var cur, curreal, nextct, nextstart, popup;
							popup = dojo.widget.byId('generic_popup');
							cur = document.getElementById(obj.curINPUTFROM+obj.curTYPE);
							curreal = document.getElementById(obj.curINPUTFROM+obj.curTYPE+'_real');
							cur.value = obj.curNAME;
							cur.parentNode.setAttribute('title', obj.curNAME);
							curreal.value = obj.curPATH;
							nextct = document.getElementById('ct'+obj.curINPUTFROM+nextType);
							if(nextType != 'DS') {
								nextstart = document.getElementById(obj.curINPUTFROM+nextType+'_start');
								nextstart.value = result.data[nextKey];
							}
							nextct.style.display = '';
							popup.hide();
							if(nextType == 'PL') {
								var dsct = document.getElementById('ct'+obj.curINPUTFROM+'DS');
								var dsstart = document.getElementById(obj.curINPUTFROM+'DS_start');
								dsct.style.display = '';
								dsstart.value = obj.curPATH;
							}
						} catch(err) {
							alert(err);
						}
					} else {
						var error_message;
						switch(obj.curTYPE) {
							case 'CT':
								error_message = arkwui_lang_get_msg('rst_plugin_error_vstpopupverifctfail');
							break;
							case 'CP':
								error_message = arkwui_lang_get_msg('rst_plugin_error_vstpopupverifcpfail');
							break;
							case 'PL':
								error_message = arkwui_lang_get_msg('rst_plugin_error_vstpopupverifplfail');
							break;
						}
						if(document.getElementById('popupnavrstplugmessage')) {
							document.getElementById('popupnavrstplugmessage').innerHTML = '<div style="text-align: center; color: red; font-weight: bold;">'+error_message+'</div>';
						}
					}
				}
			}
		},
		setDataStore: function(obj) {
			var cur, curreal, popup;
			popup = dojo.widget.byId('generic_popup');
			cur = document.getElementById(obj.INPUTFROM+'DS');
			curreal = document.getElementById(obj.INPUTFROM+'DS_real');
			curreal.value = obj.NAME;
			cur.value = obj.NAME;
			popup.hide();
		},
		startJob: function(params) {
			if(this.controller != '' && this.startaction != '') {
				var _this = this;
				var dataUrl = this.baseUrl + '/'+this.controller+'/'+this.startaction;
				var getNext = this.baseUrl + '/'+this.controller+'/'+this.getnextaction;
				var abortUrl = this.baseUrl + '/'+this.controller+'/jsonAbortTrans';
				this._launchtrans(_this, _this.catchStartJob, dataUrl, getNext, abortUrl, params);
				/*
				//This is for debug purpose if you want to use this, comment out the launchtrans line above and tune the jobid and port lines below
				var result = {
					'status': 0,
					'message': '1970\/01\/01 00:00:00 I00020028 01THIS_IS_DEBUG: This is only for debug purpose don\'t panic!',
					'last': 1,
					'data': '4c1146ce', //jobid
					'data2': '1028' //port
				}
				this.catchStartJob(_this, result);
				*/
			}
		},
		abortJob: function() {
			if(this.controller != '' && this.abortaction != '' && typeof this.jobid != 'undefined' && typeof this.port != 'undefined') {
				if(confirm(arkwui_lang_get_msg('rst_plugin_monitoring_abortconfirm'))) {
					var _this = this;
					var dataUrl = this.baseUrl + '/'+this.controller+'/'+this.abortaction;
					var getNext = this.baseUrl + '/'+this.controller+'/'+this.getnextaction;
					var abortUrl = this.baseUrl + '/'+this.controller+'/jsonAbortTrans';
					this._launchtrans(_this, _this.catchAbortJob, dataUrl, getNext, abortUrl, {'jobid':this.jobid, 'port':this.port});
				}
			}
			return;
		},
		answer: function() {
			if(this.controller != '' && this.abortaction != '' && typeof this.jobid != 'undefined' && typeof this.port != 'undefined') {
				var _this = this;
				var dataUrl = this.baseUrl + '/'+this.controller+'/'+this.answeraction;
				var getNext = this.baseUrl + '/'+this.controller+'/'+this.getnextaction;
				var abortUrl = this.baseUrl + '/'+this.controller+'/jsonAbortTrans';
				var monitor_drive_ask_dest = dojo.widget.byId('monitor_drive_ask_dest');
				var monitor_drive_ask_drvid = dojo.widget.byId('monitor_drive_ask_drvid');
				var drvnum = monitor_drive_ask_dest.getSelectedValue();
				var drvid = monitor_drive_ask_drvid.getSelectedValue();
				this._launchtrans(_this, _this.catchAnswerJob, dataUrl, getNext, abortUrl, {'jobid':this.jobid, 'port':this.port, 'drvnum': drvnum, 'drvid': drvid});
			}
			return;
		},
		catchAnswerJob: function(obj, result) {
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					//nothing to do
				}
			}
		},
		catchStartJob: function(obj, result) {
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					if(typeof result.data != 'undefined' && typeof result.data2 != 'undefined') {
						var prevbutton = document.getElementById('prevbutton');
						var nextbutton = document.getElementById('nextbutton');
						var submitbutton = document.getElementById('submitbutton');
						var gs3 = document.getElementById('groupstep3');
						var gs4 = document.getElementById('groupstep4');
						prevbutton.style.display = 'none';
						submitbutton.style.display = 'none';
						gs3.style.display = 'none';
						gs4.style.display = '';
						var vmbiCt = document.getElementById('ct_monitor_ins_speed');
						var vmbaCt = document.getElementById('ct_monitor_avg_speed');
						var vmbpCt = document.getElementById('ct_monitor_progression');
						if(vmbiCt && vmbaCt && vmbpCt) {
							setTimeout('dojo.widget.createWidget(\'arkeia:ArkeiaViewMeterBar\', {widgetId: \'monitor_ins_speed\', unitValue: arkwui_lang_get_msg(\'bkp_showbkp_speed_KB_s\')}, document.getElementById(\'ct_monitor_ins_speed\'), \'child\');', 100);
							setTimeout('dojo.widget.createWidget(\'arkeia:ArkeiaViewMeterBar\', {widgetId: \'monitor_avg_speed\', unitValue: arkwui_lang_get_msg(\'bkp_showbkp_speed_KB_s\')}, document.getElementById(\'ct_monitor_avg_speed\'), \'child\');', 100);
							setTimeout('dojo.widget.createWidget(\'arkeia:ArkeiaViewMeterBar\', {widgetId: \'monitor_progression\', unitValue: \'%\'}, document.getElementById(\'ct_monitor_progression\'), \'child\');', 100);
						}
						obj.jobid = result.data;
						obj.port = result.data2;
						obj.lastResult = result;
						setTimeout('dojo.widget.byId(\''+obj.widgetId+'\').delayedcatchStartJob();', 1000);
					}
				}
			}
		},
		delayedcatchStartJob: function() {
			var obj = this;
			var result = obj.lastResult;
			if(typeof result.data != 'undefined' && typeof result.data2 != 'undefined') {
				if(arkeia.layout.restoreplugin.statinfoinitialize(obj.widgetId)) {
					obj.addWhenDestroy = arkeia.layout.restoreplugin.statinfodestroy;
					obj.statJob({'jobid':obj.jobid, 'port': obj.port});
				}
			}
		},
		statJob: function(params) {
			if(this.controller != '' && this.stataction) {
				var _this = this;
				var dataUrl = this.baseUrl + '/'+this.controller+'/'+this.stataction;
				var getNext = this.baseUrl + '/'+this.controller+'/'+this.getnextaction;
				var abortUrl = this.baseUrl + '/'+this.controller+'/jsonAbortTrans';
				this._launchtrans(_this, _this.catchStatJob, dataUrl, getNext, abortUrl, params);
			}
		},
		changeUnits: function() {
			var units = dojo.widget.byId('monitor_change_unit');
			var unitValue = units.getSelectedValue();
			var monitor_ins_speed = dojo.widget.byId('monitor_ins_speed');
			var monitor_avg_speed = dojo.widget.byId('monitor_avg_speed');
			monitor_ins_speed.unitValue = unitValue;
			monitor_avg_speed.unitValue = unitValue;
		},
		catchStatJob: function(obj, result) {
			if(result) {
				if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
					//getNext
				} else {
					try {
						var tmp;
						if(typeof result.data2 != 'undefined' && typeof result.data2.ID_PORT != 'undefined') {
							var monitor_time = document.getElementById('monitor_time');
							obj.newResult(obj, result);
							tmp = result.data2.ID_PORT.split('_');
							if(!monitor_time) {
								return;
							}
							setTimeout('dojo.widget.byId(\''+obj.widgetId+'\').statJob({\'jobid\':\''+tmp[0]+'\', \'port\': \''+tmp[1]+'\'});', 3000);
							//server
							var monitor_server = document.getElementById('monitor_server');
							var radio_machine = document.getElementById('radio_pluginmachine');
							if(monitor_server && radio_machine) {
								monitor_server.value = radio_machine.value;
							}
							//time
							if(typeof result.data.BK_TIME != 'undefined') {
								if(monitor_time) {
									var usage_h = parseInt(result.data.BK_TIME / 3600);
									var usage_m = parseInt(result.data.BK_TIME % 3600);
									var usage_s = parseInt(usage_m % 60);
									usage_m = parseInt(usage_m / 60);
									monitor_time.value=(usage_h < 10 ? '0' : '') + usage_h + "h " + (usage_m < 10 ? '0' : '') + usage_m + "m " + (usage_s < 10 ? '0' : '') + usage_s + 's';
								}
							}
							//rst amount
							if(typeof result.data.BK_DSK_SIZ != 'undefined') {
								var monitor_rst_amount = document.getElementById('monitor_rst_amount');
								if(monitor_rst_amount) {
									monitor_rst_amount.value = result.data.BK_DSK_SIZ + ' MB';
								}
							}
							//instant speed
							if(typeof result.data.BK_DSK_INS != 'undefined') {
								var monitor_ins_speed = dojo.widget.byId('monitor_ins_speed');
								if(monitor_ins_speed) {
									monitor_ins_speed.setValue(result.data.BK_DSK_INS);
								}
							}
							//average speed
							if(typeof result.data.BK_DSK_AVG != 'undefined') {
								var monitor_avg_speed = dojo.widget.byId('monitor_avg_speed');
								if(monitor_avg_speed) {
									monitor_avg_speed.setValue(result.data.BK_DSK_AVG);
								}
							}
							//STEPS
							if(typeof result.data.STEPS != 'undefined') {
								var monitor_steps = document.getElementById('monitor_steps');
								var step_status;
								var step_message;
								if(monitor_steps) {
									monitor_steps.innerHTML = '';
									for(i in result.data.STEPS) {
										step_status = parseInt(result.data.STEPS[i].substr(0, 1));
										step_message = result.data.STEPS[i].substr(2);
										switch(step_status) {
											case 0:
												monitor_steps.innerHTML += '<div style="border: 1px #ffffff solid; background-color:#D3E0EF;"><img src="/images/ajax-loader.gif" style="border: none; margin:0px;" />&nbsp;'+step_message+'</div>';
											break;
											case 1:
												monitor_steps.innerHTML += '<div style="border: 1px #ffffff solid; background-color:#D3E0EF;"><img src="/images/success.png" style="border: none; margin:0px;" />&nbsp;'+step_message+'</div>';
											break;
											case 2:
												monitor_steps.innerHTML += '<div style="border: 1px #ffffff solid; background-color:#D3E0EF;"><img src="/images/alerts.png" style="border: none; margin:0px;" />&nbsp;'+step_message+'</div>';
											break;
											default:
												monitor_steps.innerHTML += step_message;
										}
									}
								}
							}
							if(typeof result.data.item != 'undefined') {
								var monitor_drive_ask = document.getElementById('monitor_drive_ask');
								var monitor_drive_ask_dest = dojo.widget.byId('monitor_drive_ask_dest');
								var monitor_progression = dojo.widget.byId('monitor_progression');
								var drvasks = [];
								var drvinfo = '';
								var tot_siz = 100;
								var cur_siz_inst = 0;
								var cur_siz_total = 0;
								var cur_siz_perc = 0;
								if(typeof result.data.item[0] != 'undefined') {
									for(var i in result.data.item) {
										//DRV ASK
										if(typeof result.data.item[i].DRV_ASK != 'undefined') {
											drvasks.push([result.data.item[i].DRV_INFO, result.data.item[i].DRV_ASK]);
											if(drvinfo == '') {
												drvinfo = result.data.item[i].DRV_INFO;
											}
										}
										//progression bar
										if(monitor_progression && typeof result.data.item[i].FLOW_TOT_SIZE != 'undefined') {
											cur_siz_inst = parseInt(result.data.item[i].FLOW_DSK_SIZ);
											cur_siz_total = parseInt(result.data.item[i].FLOW_TOT_SIZE);
											if(cur_siz_inst != 0 && cur_siz_total != 0) {
												cur_siz_perc = (100 * cur_siz_inst) / cur_siz_total;
												monitor_progression.setPercentValue(cur_siz_perc);
											}
										}
									}
									//DRV ASK COMMIT
									if(monitor_drive_ask_dest && drvinfo != '' && monitor_drive_ask.style.display == 'none') {
										monitor_drive_ask.style.display = '';
										monitor_drive_ask_dest.setNewData(drvasks, drvinfo);
									}
									if(drvinfo == '' && monitor_drive_ask.style.display != 'none') {
										monitor_drive_ask.style.display = 'none';
									}
								} else {
									//progression bar
									if(monitor_progression && typeof result.data.item.FLOW_TOT_SIZE != 'undefined') {
										cur_siz_inst = parseInt(result.data.item.FLOW_DSK_SIZ);
										cur_siz_total = parseInt(result.data.item.FLOW_TOT_SIZE);
										if(cur_siz_inst != 0 && cur_siz_total != 0) {
											cur_siz_perc = (100 * cur_siz_inst) / cur_siz_total;
											monitor_progression.setPercentValue(cur_siz_perc);
										}
									}
									//DRV ASK
									if(typeof result.data.item.DRV_ASK != 'undefined') {
										drvasks.push([result.data.item.DRV_INFO, result.data.item.DRV_ASK]);
										if(drvinfo == '') {
											drvinfo = result.data.item.DRV_INFO;
										}
									}
									//DRV ASK COMMIT
									if(monitor_drive_ask_dest && drvinfo != '' && monitor_drive_ask.style.display == 'none') {
										monitor_drive_ask.style.display = '';
										monitor_drive_ask_dest.setNewData(drvasks, drvinfo);
									}
									if(drvinfo == '' && monitor_drive_ask.style.display != 'none') {
										monitor_drive_ask.style.display = 'none';
									}
								}
							}
						}
					} catch(err) {
						alert(err);
					}
				}
			}
		},
		_prepareForShow: function() {
			if ( this.isLoaded ){
				return;
			}
			if ( dojo.lang.isFunction(this.handler)) {
				this._runHandler();
			} else if ( this.href != "" ) {
				this._downloadExternalContent(this.href, this.cacheContent && !this.refreshOnShow);
			}
		},
		_launchtrans: function(obj, callback, dataUrl, getNext, abortUrl, params) {
			var source = new Object;
			var DpClass = arkeia.widget.ArkeiaDataProvider;
			source.dataUrl = dataUrl;
			source.getNext = getNext;
			source.abortUrl = abortUrl;
			obj.dataProvider = new DpClass(source);
			obj.dataProvider.loadMultipleResult(obj, callback, params);
			obj.dataProvider.onLoadError = obj.onLoadError;
		},
		addWhenDestroy: function(widgetId){
		},
		destroy: function(){
		    if (this.timeoutId) clearTimeout(this.timeoutId);
		    this.timer = 0;
		    if (this.dataProvider) this.dataProvider.destroy();
		    dojo.event.topic.publish(this.widgetId + "/arkeiaParentDestroy", { source: this } );
		    this.addWhenDestroy(this.widgetId);
		    return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
		}
	}
);

dojo.widget.defineWidget(
	// widget name and class
	"arkeia.widget.ArkeiaBaseContentPane",

	// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.ContentPane],

	// init function
	function(){
		this.eventNames={};
		this._data =[];
		this._lastId = null;
	},
  
	// properties and methods
	{
		baseUrl: arkeia.baseUrl,
		eventNamesDefault: {arkeiaInfoData: 'arkeiaInfoData'},
		listened: "",
		controller: '',
		timeStamp: 0,
		loadingMessage: '',
		initialize: function() {
			this.listenedArkeiaParents = [];
			for(var name in this.eventNamesDefault) {
				if (dojo.lang.isUndefined(this.eventNames[name])) {
					this.eventNames[name] = this.widgetId+'/'+this.eventNamesDefault[name];
				}
			}
		},
		newDataInfo: function(_this, data, appid) {
			if (data['local'] != undefined) {
				data = data['local'];
			}
			var eventName = _this.eventNames.arkeiaInfoData;
			dojo.event.topic.publish(eventName, { data: data, appid: appid });
			return;
		},
		newResult: function(_this, message) {
			if (message.data) {
				if (message.data2) {
					message.data['PARAM3'] = message.data2;
				}
				_this.newDataInfo(_this, message.data, message.appid);
			} else {
				dojo.event.topic.publish(_this.eventNames.arkeiaInfoData, {});
			}
		},
		onArkeiaInfoData: function(message) {
		},
		getCleanHref: function() {
			var parts = this.href.split('?');
			return parts[0];
		},
		getCurrentHref: function() {
			var url = this.getCleanHref();
			var date = new Date;
			this.timeStamp = date.getTime();
			url += '?timeStamp='+this.timeStamp;
			return url;
		},
		urlencode: function(str) {
			str = (str+'').toString();
			return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
		},
		_utf8_encode : function (string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";
			for (var n = 0; n < string.length; n++) {
				var c = string.charCodeAt(n);
				if (c < 128) {
					utftext += String.fromCharCode(c);
				} else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				} else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}
			}
			return utftext;
		},
		_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
		_base64_encode : function (input) {
			var output = "";
			var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
			var i = 0;
			input = this._utf8_encode(input);
			while (i < input.length) {
				chr1 = input.charCodeAt(i++);
				chr2 = input.charCodeAt(i++);
				chr3 = input.charCodeAt(i++);
				enc1 = chr1 >> 2;
				enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
				enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
				enc4 = chr3 & 63;
				if (isNaN(chr2)) {
					enc3 = enc4 = 64;
				} else if (isNaN(chr3)) {
					enc4 = 64;
				}
				output = output +
				this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
				this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
			}
			return output;
		},
		_downloadExternalContent: function(url, useCache) {
			this.abort();
			this._handleDefaults(this.loadingMessage, "onDownloadStart");
			var self = this;
			var params = {
				url: url,
				mimetype: "text/html",
				handler: function(type, data, xhr){
					delete self._ioBindObj;
					if(type=="load"){
						self.onDownloadEnd.call(self, url, data);
					}else{
						var e = {
							responseText: xhr.responseText,
							status: xhr.status,
							statusText: xhr.statusText,
							responseHeaders: xhr.getAllResponseHeaders(),
							text: "Error loading '" + url + "' (" + xhr.status + " "+  xhr.statusText + ")"
						};
						self._handleDefaults.call(self, e, "onDownloadError");
						self.onLoad();
					}
				}
			}
			if(typeof this._usePost != 'undefined' && typeof this._usePostParams != 'undefined' && this._usePost) {
				params['method'] = 'POST';
				params['content'] = this._usePostParams;
			}
			this._ioBindObj = dojo.io.bind(
				this._cacheSetting(params, useCache)
			);
		},
		setPostUrl: function(url, opts, noEnc) {
			this.href = url;
			this.setOpt(opts, noEnc, true);
		},
		setOpt: function(opts, noEnc, usePost) {
			if(typeof usePost != 'undefined') {
				this._usePost = true;
				this._usePostParams = this.setupPostOp(opts, noEnc);
				this.setUrl(this.getCurrentHref());
				this._usePost = false;
			} else {
				this.setUrl(this.getCurrentHref() + this.setupGetOp(opts, noEnc));
			}
			return false;
		},
		setupGetOp: function(opts, noEnc) {
			var urlpart = '';
			for(var i in opts) {
				if(typeof opts[i] == 'object') {
					for(var j in opts[i]) {
						if(typeof noEnc == 'undefined') {
							urlpart += '&' + i + '[]=' + this.urlencode(this._base64_encode(opts[i][j]));
						} else {
							urlpart += '&' + i + '[]=' + opts[i][j];
						}
					}
				} else {
					if(typeof noEnc == 'undefined') {
						urlpart += '&' + i + '=' + this.urlencode(this._base64_encode(opts[i]));
					} else {
						urlpart += '&' + i + '=' + opts[i];
					}
				}
			}
			return urlpart;
		},
		setupPostOp: function(opts, noEnc) {
			var params = {};
			for(var i in opts) {
				if(typeof opts[i] == 'object') {
					for(var j in opts[i]) {
						if(typeof noEnc == 'undefined') {
							params[i+'['+j+']'] = this.urlencode(this._base64_encode(opts[i][j]));
						} else {
							params[i+'['+j+']'] = opts[i][j];
						}
					}
				} else {
					if(typeof noEnc == 'undefined') {
						params[i] = this.urlencode(this._base64_encode(opts[i]));
					} else {
						params[i] = opts[i];
					}
				}
			}
			return params;
		},
		_prepareForShow: function() {
			if ( this.isLoaded ){
				return;
			}
			if ( dojo.lang.isFunction(this.handler)) {
				this._runHandler();
			} else if ( this.href != "" ) {
				this._downloadExternalContent(this.href, this.cacheContent && !this.refreshOnShow);
			}
		},
		_launchtrans: function(obj, callback, dataUrl, getNext, abortUrl, params) {
			var source = new Object;
			var DpClass = arkeia.widget.ArkeiaDataProvider;
			source.dataUrl = dataUrl;
			source.getNext = getNext;
			source.abortUrl = abortUrl;
			obj.dataProvider = new DpClass(source);
			obj.dataProvider.loadMultipleResult(obj, callback, params);
			obj.dataProvider.onLoadError = obj.onLoadError;
		},
		addWhenDestroy: function(widgetId){
		},
		destroy: function(){
		    if (this.timeoutId) clearTimeout(this.timeoutId);
		    this.timer = 0;
		    if (this.dataProvider) this.dataProvider.destroy();
		    dojo.event.topic.publish(this.widgetId + "/arkeiaParentDestroy", { source: this } );
		    this.addWhenDestroy(this.widgetId);
		    return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
		}
	}
);
