dojo.provide("arkeia.widget.ArkeiaTreeLDAP");
//require statements
dojo.require("dojo.gfx.matrix");
dojo.require("dojo.gfx.svg");
dojo.require("dojo.event.common");
dojo.require("dojo.html.layout");
dojo.require("dojo.html.style");
dojo.require("dojo.widget.Slider");
dojo.require("dojo.widget.Checkbox");
dojo.require("dojo.widget.Form");
dojo.require("arkeia.widget.ArkeiaListener");
dojo.require("arkeia.widget.ArkeiaTextbox");
dojo.require("arkeia.widget.ArkeiaList");

var glthis = null;

dojo.widget.defineWidget(
	// widget name and class
	"arkeia.widget.ArkeiaTreeLDAP",
	
	// renderer
	"html|svg",
	
	// superclass
	dojo.widget.HtmlWidget,
	
	//init function
	function(){},
	
	//properties and methods
	{
		scaling : 1,
		width: 1000,
		height: 1000,
		bgcolor: '#FFFFFF',
		linecolor: '#AAAAAA',
		node_height: 50, 
		node_width: 50,
		node_fontSize: 12,
		node_visibility: "visible",
		templatePath: dojo.uri.moduleUri("arkeia.widget", "ArkeiaTreeLDAP.html"),
		widgetsInTemplate: true,
		templateCssPath: dojo.uri.moduleUri("arkeia.widget", "ArkeiaTreeLDAP.css"),
		treeMode: 'Browse',
		
		/* used to get remote data */
		baseUrl: "",
		
		/* global no changes in html variables */
		base_dn : '',
		filter : '(objectClass=*)',
		new_base_dn : '',
		new_filter : '(objectClass=*)',
		scope : '',
		new_scope : '',
		contextApplianceName : null,
		contextApplianceId : null,
		filter_tab : null,
		node : {},
		size : {},
		surface : null,
		g : null,
		m : null,
		matrix : null,
		matrix_zoom : null,
		initial_matrix : null,
		gNodeTab : {},
		gNodeCounter : 0,
		NodeAttrTab: {},
		/* stock tree before draw */
		xmlRepresentation : null,
		/* draw defines space coords */
		bg : null,
		define_x : 0,
		define_y : 0,
		move : null,
		last_position : null,
		container : null,
		container_position : null,
		surface_size : null,
		tab_image: null,
		level: 0,
		finishedDeleteApplianceAjax : 0,
		nbDeleteAppliance : 0,
		finishedDeleteUserAjax : 0,
		nbDeleteUser : 0,
		hasRole: 0,
		is_default_ldap: 0,
		tmp_data: {},
		tmp_node_type: '',
		
		loadData: function(dn, filter) {
			var params={
				dn: dn,
				filter: filter
			};
			this.Search_dataProvider.loadSynchroData(this, this.loadDataCallback, params);
		},
		loadManagerAddApplianceData: function() {
			var params={
				dn: 'ou=Users,dc=arkeia,dc=com',
				filter: '*'
			};
			this.Search_dataProvider.loadSynchroData(this, this.loadManagerAddApplianceDataCallback, params);
		},
		loadManagerAddApplianceDataCallback: function(_this, data_trans, is_callback) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			if (is_callback != undefined || (data_trans && data_trans.length > 0)) {
				var node = _this.getClickedNode();
			
				if (node && (node.node_type == '0' || node.node_type == '1')) {
					var data = '<div dojoType="ContentPane" href="'+_this.baseUrl+'/ldap/helpaddappliance"></div>';
					data += '<h2>'+arkwui_lang_get_msg('treeldap_menu_add_appliance')+'</h2><br>';
					data += '<form dojoType="arkeia:ArkeiaForm" id="addApplianceForm">';

					//Name: CN
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_name')+'</b></span>';
					data += '<span style="width:35%;"><input type="text" name="cn"/></span>';
					data += '</div>';
					
					//ApplianceIp
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_ip')+'</b></span>';
					data += '<span style="width:65%;"><input type="text" name="applianceIp"/></span>';
					data += '</div>';

					if (_this.is_default_ldap != undefined &&
					    _this.is_default_ldap == '1') {
						//Managers
						data += '<div>';
						data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_manager')+'</b></span>';
						data += '<span style="width:65%;"></span>';
						data += '</div>';

						if (data_trans[0]['item']['RN'] != undefined) {
							data += '<div style="height: 25px;">';
							data += '<span style="width:35%;" class="attr_name"></span>';
							data += '<span style="width:65%;">';
							data += '<input name="chk_'+data_trans[0]['item']['RN']+',ou=Users,dc=arkeia,dc=com" type="checkbox" dojoType="arkeia:ArkeiaCheckbox" />&nbsp;&nbsp;'+data_trans[0]['item']['DISPLAYNAME']+'</span>';
							data += '</div>';
						}
						else {
							for (var i in data_trans[0]['item']) {
								data += '<div style="height: 25px;">';
								data += '<span style="width:35%;" class="attr_name"></span>';
								data += '<span style="width:65%;">';
								data += '<input name="chk_'+data_trans[0]['item'][i]['RN']+',ou=Users,dc=arkeia,dc=com" type="checkbox" dojoType="arkeia:ArkeiaCheckbox" />&nbsp;&nbsp;'+data_trans[0]['item'][i]['DISPLAYNAME']+'</span>';
								data += '</div>';
							}
						}
					}
					else {
						data += '<b>'+_this.createHtmlAddField('manager', 'treeldap_manager', '')+'</b>';
					}

					//Arkeia root password
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name">'+arkwui_lang_get_msg('treeldap_arkeia_root_password')+'</span>';
					data += '<span style="width:65%;"><input type="password" name="appliancePassword"/></span>';
					data += '</div>';

					//Verify Arkeia root password
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name">'+arkwui_lang_get_msg('treeldap_verify_password')+'</span>';
					data += '<span style="width:65%;"><input type="password" name="verifpassword"/></span>';
					data += '</div>';

					//Appliance Port
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name">'+arkwui_lang_get_msg('treeldap_port')+'</span>';
					data += '<span style="width:65%;"><input type="text" name="appliancePort"/></span>';
					data += '</div>';

					//Locality is optionnal

					//default ldap = Yes and User edit.
					//Add blank fields if we don't exist
					if (_this.is_default_ldap != undefined &&
					    _this.is_default_ldap == '1') {
						data += '<div style="height: 15px;">';
						data += '</div>';
						data += '<div>';
						data += '<div class="advanced_title" id="advanced" onclick="onTreeLdapLabelClick(\'advanced\');" open="false">'+arkwui_lang_get_msg('treeldap_menu_optional_properties')+'</div>';
						data += '<div id="TreeLdapHide" style="display: none;">';
						data += '<div style="height: 15px;">';
						data += '</div>';
						data += _this.createHtmlAddField('l', 'treeldap_location', '');
						data += '</div>';
						data += '</div>';
					}
					else {
						data += _this.createHtmlAddField('l', 'treeldap_location', '');
					}
					data +=	'<input type="hidden" name="node" value="'+node.id+'"/>';
					
					//Arkeia button
					data += '<div style="height: 25px;">';
					data += '</div>';
					data += '<div style="height: 25px;">';
					data += '<span style="width:35%;" class="attr_name"></span>';
					data += '<span style="width:65%;"><input dojoType="arkeia:ArkeiaButton" type="button" onClick="getValuesAddApplianceForm();" caption="'+arkwui_lang_get_msg('treeldap_menu_add_appliance')+'" class="ArkButton" myformid="addApplianceForm" /></span>';
					data += '</div>';

					data += '</form>';
					
					_this.createPopupWindow('addAppliance', arkwui_lang_get_msg('treeldap_menu_add_appliance'), data);
				}
				else {
					alert(arkwui_lang_get_msg('treeldap_no_add_node_here'));
				}
			}
		},
		loadManagerGetApplianceData: function(_this) {
			var params={
				dn: 'ou=Users,dc=arkeia,dc=com',
				filter: '*'
			};
			_this.Search_dataProvider.loadSynchroData(_this, _this.loadManagerGetApplianceDataCallback, params);
		},
		loadManagerGetApplianceDataCallback: function(_this, data, is_callback) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			if (is_callback != undefined || (data && data.length > 0)) {
				var node = _this.getClickedNode();
				if (node) {
					var html = '<div dojoType="ContentPane" href="'+_this.baseUrl+'/ldap/helpmodifyattr"></div>';
					switch (_this.tmp_node_type) {
						case '2':
							var title = arkwui_lang_get_msg('treeldap_edit_appliance');
							break;
						case '3':
							var title = arkwui_lang_get_msg('treeldap_edit_user');
							break;
						case '4':
							var title = arkwui_lang_get_msg('treeldap_edit_role');
							break;
						default:
							var title = arkwui_lang_get_msg('treeldap_menu_node_attributes');
							break;
					}
					if (_this.hasRole != 1) {
						title = arkwui_lang_get_msg('treeldap_menu_node_attributes');
					}
					html += '<h2>'+title+'</h2>';
					html += '<br><form dojoType="arkeia:ArkeiaForm" id="getAttributesForm">'+
						'<input type="hidden" name="node" value="'+node.id+'"/>';
					var dn = _this.createDN(node);

					//Values we don't want anymore
					if (_this.is_default_ldap != undefined &&
					    _this.is_default_ldap == '1') {
						delete _this.tmp_data['objectClass'];
						delete _this.tmp_data['givenName'];
						delete _this.tmp_data['sn'];
						delete _this.tmp_data['ou'];
						delete _this.tmp_data['applianceId'];
					}

					//Always display Common Name (cn) on first line
					if (_this.tmp_data['cn'] != undefined) {
						html += '<div style="height: 25px;">';
						html += '<span style="width:35%;" class="attr_name">';
						html += _this.NodeAttrTab['cn'];
						html += '</span>';
						html += '<span style="width:65%;" >';
						html += _this.tmp_data['cn'];
						html += '</span>';
						html += '</div>';
						delete _this.tmp_data['cn'];
					}
					//For users display Username in second
					if (_this.tmp_data['uid'] != undefined) {
						html += '<div style="height: 25px;">';
						html += '<span style="width:35%;" class="attr_name">';
						html += _this.NodeAttrTab['uid'];
						html += '</span>';
						html += '<span style="width:65%;" >';
						html += '<input type="text" name="uid" id="uid" value="'+_this.tmp_data['uid']+'" />';
						html += '</span>';
						html += '</div>';
						delete _this.tmp_data['uid'];
					}
					//For appliances display Appliance Ip in second
					if (_this.tmp_data['applianceIp'] != undefined) {
						html += '<div style="height: 25px;">';
						html += '<span style="width:35%;" class="attr_name">';
						html += _this.NodeAttrTab['applianceIp'];
						html += '</span>';
						html += '<span style="width:65%;" >';
						html += '<input type="text" name="applianceIp" id="applianceIp" value="'+_this.tmp_data['applianceIp']+'" />';
						html += '</span>';
						html += '</div>';
						delete _this.tmp_data['applianceIp'];
					}

					//Advanced parameters
					var advanced_html = '';
					//default ldap = Yes and User edit.
					//Add blank fields if we don't exist
					if (_this.is_default_ldap != undefined &&
					    _this.is_default_ldap == '1') {
						advanced_html += '<div>';
						advanced_html += '<div class="advanced_title" id="advanced" onclick="onTreeLdapLabelClick(\'advanced\');" open="false">'+arkwui_lang_get_msg('treeldap_menu_optional_properties')+'</div>';
						advanced_html += '<div id="TreeLdapHide" style="display: none;">';
						advanced_html += '<div style="height: 15px;">';
						advanced_html += '</div>';
						if (_this.tmp_node_type == '3') {
							if (_this.tmp_data['mail'] == undefined) {
								advanced_html += _this.createHtmlAddField('mail', 'treeldap_email', '');
							}
							if (_this.tmp_data['title'] == undefined) {
								advanced_html += _this.createHtmlAddField('title', 'treeldap_title', '');
							}
							if (_this.tmp_data['departmentNumber'] == undefined) {
								advanced_html += _this.createHtmlAddField('departmentNumber', 'treeldap_department', '');
							}
						}
						if (_this.tmp_node_type == '4') {
							if (_this.tmp_data['description'] == undefined) {
								advanced_html += _this.createHtmlAddField('description', 'treeldap_description', '');
							}
						}
						if (_this.tmp_node_type == '3' || _this.tmp_node_type == '2') {
							if (_this.tmp_data['l'] == undefined) {
								advanced_html += _this.createHtmlAddField('l', 'treeldap_location', '');
							}
						}
					}

					var tmp_html = '';
					var readonly = '';
					var noAdd = false;
					var i = 0;
					var disp_appliancePassword = false;

					if (_this.tmp_node_type == '2') {
						disp_appliancePassword = true;
					}
					
					for (var param in _this.tmp_data) {
						if (param != '__className') {
							if (param == 'applianceId' || param == 'cn' || param == 'ou' 
							    || param == 'objectClass' || param == 'manager' || 
							    param == 'uniqueMember') {
								if ((param == 'manager' || param == 'uniqueMember') && 
								    _this.is_default_ldap != undefined &&
								    _this.is_default_ldap == '1') {
									readonly = 'disabled';
								}
								if (param != 'manager' && param != 'uniqueMember') {
									readonly = 'disabled';
								}
							}
							if (param == 'applianceIp' || param == 'appliancePort' || 
							    param == 'appliancePassword' || param == 'uid' || 
							    param == 'cn' || param == 'ou' || param == 'applianceId' ||
							    param == 'objectClass' || param == 'manager' || 
							    param == 'uniqueMember') {
								if ((param == 'manager' || param == 'uniqueMember') && 
								    _this.is_default_ldap != undefined &&
								    _this.is_default_ldap == '1') {
									noAdd = true;
								}
								if (param != 'manager' && param != 'uniqueMember') {
									noAdd = true;
								}
							}
							if (param == 'appliancePassword') {
								disp_appliancePassword = false;
							}
							var human_name = _this.NodeAttrTab[param];
							//dojo.debug("PARAM:"+param+" human_name:"+human_name);
							if (human_name == undefined) { 
								human_name = param;
							}
							if (isArray(_this.tmp_data[param]) == true) {
								var value = {};
								value[param] = [];
								var j = 0;
								if (_this.is_default_ldap != undefined &&
								    _this.is_default_ldap == '1' &&
								    (param == 'manager' || param == 'uniqueMember')) {
									//Managers or UniqueMember
									html += '<div>';
									html += '<span style="width:35%;" class="attr_name">';
									html += human_name+'</span>';
									html += '<span style="width:65%;" >';
									html += '</span>';
									html += '</div>';

									
									if (data[0]['item']['RN'] != undefined) {
										html += '<div style="height: 25px;">';
										html += '<span style="width:35%;" class="attr_name"></span>';
										html += '<span style="width:65%;" >';
										html += '<input name="chk_'+param+'_'+data[0]['item']['RN']+',ou=Users,dc=arkeia,dc=com" type="checkbox" dojoType="arkeia:ArkeiaCheckbox" ';
										for (var param2 in _this.tmp_data[param]) {
											if (_this.tmp_data[param][param2] == 
											    data[0]['item']['RN']+
											    ',ou=Users,dc=arkeia,dc=com') {
												html += 'checked="checked" ';
											}
										}
										html += '/>&nbsp;&nbsp;'+data[0]['item']['DISPLAYNAME'];
										html += '</span>';
										html += '</div>';
									}
									else {
										for (var k in data[0]['item']) {
											html += '<div style="height: 25px;">';
											html += '<span style="width:35%;" class="attr_name"></span>';
											html += '<span style="width:65%;" >';
											html += '<input name="chk_'+param+'_'+data[0]['item'][k]['RN']+',ou=Users,dc=arkeia,dc=com" type="checkbox" dojoType="arkeia:ArkeiaCheckbox" ';
											
											for (var param2 in _this.tmp_data[param]) {
												if (_this.tmp_data[param][param2] == 
												    data[0]['item'][k]['RN']+
												    ',ou=Users,dc=arkeia,dc=com') {
													html += 'checked="checked" ';
												}
											}
											html += '/>&nbsp;&nbsp;'+data[0]['item'][k]['DISPLAYNAME'];
											html += '</span>';
											html += '</div>';
										}
									}
								}
								else {
									tmp_html += '<div style="height: 15px;">';
									tmp_html += '<span style="width:35%;" class="attr_name">';
									tmp_html += human_name+'</span>';

									var l = 0;
									for (var param2 in _this.tmp_data[param]) {
										if (l == 0) {
											tmp_html += '<span id="span_'+param+'" style="width:65%;" >';
											tmp_html += _this.tmp_data[param][param2];
											tmp_html += '&nbsp;&nbsp;';
											if (readonly == '' && _this.hasRole == 1) {
												tmp_html += '<img src="'+_this.baseUrl+'/images/arrow_delete_12x12.gif" id="remove_'+param+'" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeSingleValue(\''+param+'\', -1, \''+_this.tmp_data[param][param2]+'\')" />';
											}
											tmp_html += '</span>';
											tmp_html += '</div>';
											l++;
											tmp_html += '<div id="div_'+param+'">';
										}
										else {
											tmp_html += '<div id="div_'+param+'_'+j+'">';
											tmp_html += '<div style="height: 15px;">';
											tmp_html += '<span style="width:35%;" class="attr_name">';
											tmp_html += '</span>';
											tmp_html += '<span style="width:65%;" >';
											tmp_html += _this.tmp_data[param][param2];
											tmp_html += '&nbsp;&nbsp;';
											if (readonly == '' && _this.hasRole == 1) {
												tmp_html += '<img src="'+_this.baseUrl+'/images/arrow_delete_12x12.gif" id="remove_'+param+'" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeSingleValue(\''+param+'\', '+j+', \''+_this.tmp_data[param][param2]+'\')" />';
											}
											tmp_html += '</span>';
											tmp_html += '</div>';
											tmp_html += '</div>';
										}
										value[param][j++] = _this.tmp_data[param][param2];
									}
									tmp_html += '</div>';
									if ((readonly == '' || noAdd == false) && _this.hasRole == 1) {
										//To add fields
										tmp_html += '<div style="height: 15px;">';
										tmp_html += '<span style="width:35%;" class="attr_name">';
										tmp_html += '</span>';
										tmp_html += '<span style="width:65%;">';
										tmp_html += '<input type="text" name="add_'+param+'" id="add_'+param+'" value="'+arkwui_lang_get_msg('treeldap_param_add')+'" style="font-size:12px;width:8em;height:13px;" onfocus="add_checkparam(\'add_'+param+'\', \'focus\')" onblur="add_checkparam(\'add_'+param+'\', \'blur\')"/>';
										tmp_html += '&nbsp;&nbsp;';
										tmp_html += '<img src="'+_this.baseUrl+'/images/arrow_build_vtl_16x16.gif" id=\'link_add_'+param+'\' height="10" width="10" style="cursor:pointer;cursor:hand;" onClick="addExistingMultipleValues(\''+param+'\', '+j+', \''+_this.baseUrl+'\');" />';
										tmp_html += '</span>';
										tmp_html += '</div>';
										
										tmp_html += '<div style="height: 15px;">';
										var res = dojo.json.serialize(value);
										tmp_html += '<input type="hidden" name="res_'+param+'" id="res_'+param+'" value=\''+res+'\' />';
										tmp_html += '</div>';
									}
								}
								if (param == 'mail' || param == 'title' || param == 'l' ||
								    param == 'departmentNumber' || param == 'description') {
									advanced_html += tmp_html;
								}
								else {
									html += tmp_html;
								}
								tmp_html = '';
							}
							else {
								//dojo.debug("PARAM: "+param+" _this.tmp_data[param]: "+_this.tmp_data[param]);
								if (_this.is_default_ldap != undefined &&
								    _this.is_default_ldap == '1' && 
								    (param == 'manager' || param == 'uniqueMember')) {
									tmp_html += '<div>';
									tmp_html += '<span style="width:35%;" class="attr_name">'+human_name+'</span>';
									tmp_html += '<span style="width:65%;" >';
									tmp_html += '</span>';
									tmp_html += '</div>';

									if (data[0]['item']['RN'] != undefined) {
										tmp_html += '<div style="height: 25px;">';
										tmp_html += '<span style="width:35%;" class="attr_name"></span>';
										tmp_html += '<span style="width:65%;" >';
										tmp_html += '<input type="checkbox" name="chk_'+param+'_'+data[0]['item']['RN']+',ou=Users,dc=arkeia,dc=com" dojoType="arkeia:ArkeiaCheckbox" ';
										if (_this.tmp_data[param] == data[0]['item']['RN']+
										    ',ou=Users,dc=arkeia,dc=com') {
											tmp_html += 'checked="checked" ';
										}
										tmp_html += '/>&nbsp;&nbsp;'+data[0]['item']['DISPLAYNAME'];
										tmp_html += '</span>';
										tmp_html += '</div>';
									}
									else {
										for (var j in data[0]['item']) {
											tmp_html += '<div style="height: 25px;">';
											tmp_html += '<span style="width:35%;" class="attr_name"></span>';
											tmp_html += '<span style="width:65%;" >';
											tmp_html += '<input type="checkbox" name="chk_'+param+'_'+data[0]['item'][j]['RN']+',ou=Users,dc=arkeia,dc=com" dojoType="arkeia:ArkeiaCheckbox" ';
											if (_this.tmp_data[param] == data[0]['item'][j]['RN']+
											    ',ou=Users,dc=arkeia,dc=com') {
												tmp_html += 'checked="checked" ';
											}
											tmp_html += '/>&nbsp;&nbsp;'+data[0]['item'][j]['DISPLAYNAME'];
											tmp_html += '</span>';
											tmp_html += '</div>';
										}
									}
								}
								else {
									if (readonly != '' || noAdd == false) {
										if (readonly != '') {
											tmp_html += '<div style="height: 25px;">';
										}
										if (noAdd == false) {
											tmp_html += '<div style="height: 15px;">';
										}								
										tmp_html += '<span style="width:35%;" class="attr_name">';
										tmp_html += human_name+'</span>';
										tmp_html += '<span id="span_'+param+'" style="width:65%;" >';
										tmp_html += _this.tmp_data[param];
									}
									if (readonly == '' && noAdd == true) {
										tmp_html += '<div style="height: 25px;">';
										tmp_html += '<span style="width:35%;" class="attr_name">';
										tmp_html += human_name+'</span>';
										tmp_html += '<span id="span_'+param+'" style="width:65%;" >';
										tmp_html += '<input type="text" name="'+param+'" id="'+param+'" value="'+_this.tmp_data[param]+'" />';
									}
									tmp_html += '&nbsp;&nbsp;';
									if (readonly == '' && noAdd == false && _this.hasRole == 1) {
										tmp_html += '<img src="'+_this.baseUrl+'/images/arrow_delete_12x12.gif" id="remove_'+param+'" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeSingleValue(\''+param+'\', -1, \''+_this.tmp_data[param]+'\')" />';
									}
									tmp_html += '</span>';
									tmp_html += '</div>';
								}
								if (noAdd == false && readonly == '' && _this.hasRole == 1) {
									var value = {};
									value[param] = [];
									value[param][0] = _this.tmp_data[param];

									tmp_html += '<div id="div_'+param+'"></div>';
									//To add fields
									tmp_html += '<div style="height: 15px;">';
									tmp_html += '<span style="width:35%;" class="attr_name">';
									tmp_html += '</span>';
									tmp_html += '<span style="width:65%;">';
									tmp_html += '<input type="text" name="add_'+param+'" id="add_'+param+'" value="'+arkwui_lang_get_msg('treeldap_param_add')+'" style="font-size:12px;width:8em;height:13px;" onfocus="add_checkparam(\'add_'+param+'\', \'focus\')" onblur="add_checkparam(\'add_'+param+'\', \'blur\')"/>';
									tmp_html += '&nbsp;&nbsp;';
									tmp_html += '<img src="'+_this.baseUrl+'/images/arrow_build_vtl_16x16.gif" id=\'link_add_'+param+'\' height="10" width="10" style="cursor:pointer;cursor:hand;" onClick="addExistingMultipleValues(\''+param+'\', 0, \''+_this.baseUrl+'\');" />';
									tmp_html += '</span>';
									tmp_html += '</div>';

									tmp_html += '<div style="height: 15px;">';
									var res = dojo.json.serialize(value);	 				
									tmp_html += '<input type="hidden" name="res_'+param+'" id="res_'+param+'" value=\''+res+'\' />';
									tmp_html += '</div>';
								}
								i++;
							}
						}
						readonly = '';
						noAdd = false;
						if (param == 'mail' || param == 'title' || param == 'l' ||
						    param == 'departmentNumber' || param == 'description') {
							advanced_html += tmp_html;
						}
						else {
							html += tmp_html;
						}
						tmp_html = '';
					}
					if (disp_appliancePassword == true && _this.hasRole == 1) {
						html += '<div style="height: 25px;">';
						html += '<span style="width:35%;" class="attr_name">';
						html += _this.NodeAttrTab['appliancePassword'];
						html += '</span>';
						html += '<span style="width:65%;" >';
						html += '<input type="text" name="appliancePassword" id="appliancePassword_0" />';
						html += '</span>';
						html += '</div>';
					}
					if (_this.hasRole == 1) {
						html += '<div style="height: 15px;"></div>';

						advanced_html += '</div>';
						advanced_html += '</div>';

						html += advanced_html;

						//Arkeia button
						html += '<div style="height: 25px;">';
						html += '</div>';
						html += '<div style="height: 25px;">';
						html += '<span style="width:35%;" class="attr_name"></span>';
						html += '<span style="width:65%;" ><input dojoType="arkeia:ArkeiaButton" type="button" onClick="getValuesGetAttributesForm();" caption="'+arkwui_lang_get_msg('treeldap_modify_attributes')+'" class="ArkButton" myformid="getAttributesForm" /></span>';
						html += '</div>';
					}
					html +=	'</form>';
					_this.tmp_node_type = '';
					_this.createPopupWindow('nodeAttributes', title, html);
				}
			}
		},
		loadDataOnClick: function(dn, filter, pos_x, pos_y, bak_Img) {
			var params={
				dn: dn,
				filter: filter
			};
			
			var ClickCallback = function(_this, data) {
				if (data && data.length > 0) {
					_this.xmlRepresentation = [];
					var alone = true;
					for (var i in data[0]['item']) {
						if (i == 0) {
							alone = false;
						}
						if (alone == true) {
							break;
						}
						_this.xmlRepresentation[i] = {
							RN: data[0]['item'][i]['RN'],
							DISPLAYNAME: data[0]['item'][i]['DISPLAYNAME'], 
							TYPE: data[0]['item'][i]['TYPE'],
							GUID: data[0]['item'][i]['GUID']
						};
					}
					if (alone == true) {
						_this.xmlRepresentation[0] = {
							RN: data[0]['item']['RN'],
							DISPLAYNAME: data[0]['item']['DISPLAYNAME'], 
							TYPE: data[0]['item']['TYPE'],
							GUID: data[0]['item']['GUID']
						};
					}
					_this.drawNewLevelLDAP(pos_x, pos_y, bak_Img);
					_this.xmlRepresentation = null;
					_this.erase_all_lines();
					_this.replaceTreeCorrectly(bak_Img);
				}
			};
			this.Search_dataProvider.loadSynchroData(this, ClickCallback, params);
		},
		loadContextData: function(_this, base_dn, filter, scope) {
			var params={
				base_dn: base_dn,
				filter: filter,
				scope: scope
			};
			_this.new_scope = scope;
			_this.new_base_dn = base_dn;
			_this.new_filter = filter;
			_this.SetContext_dataProvider.loadSynchroData(this, this.loadSetContextDataCallback, params);
		},
		loadSetContextDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			if (data["param0"] == "0") {
				//dojo.debug("serialize:"+dojo.json.serialize(data["param2"]));
				if (data["param2"] == '') {
					_this.contextApplianceName = null;
					_this.contextApplianceId = null;
					_this.filter = _this.new_filter;
					_this.base_dn = _this.new_base_dn;
					_this.scope = _this.new_scope;
					_this.new_filter = '(objectClass=*)';
					_this.hasRole = 0;
					return ;
				}
				
				_this.filter = _this.new_filter;
				_this.base_dn = _this.new_base_dn;
				_this.scope = _this.new_scope;
				_this.new_filter = '(objectClass=*)';
				
				_this.contextApplianceName = null;
				_this.contextApplianceId = null;
				_this.hasRole = data["param2"]["HAS_ROLE"];
				_this.is_default_ldap = data["param2"]["IS_DEFAULT_LDAP"];
				//dojo.debug("AS_ROLE:"+_this.hasRole);
				if (data["param2"]["item"]) {
					_this.contextApplianceName = [];
					_this.contextApplianceId = [];
					if (data["param2"]["item"]["APPLIANCE_NAME"]) {
						_this.contextApplianceName[0] = data["param2"]["item"]["APPLIANCE_NAME"];
						_this.contextApplianceId[0] = data["param2"]["item"]["APPLIANCE_GUID"];
					} else {
						for (var i in data["param2"]['item']) {
							_this.contextApplianceName[i] = data["param2"]["item"][i]["APPLIANCE_NAME"];
							_this.contextApplianceId[i] = data["param2"]["item"][i]["APPLIANCE_GUID"];
						}
					}
				} 
			} else {
				if (data["param0"] != "12") {
					_this.contextApplianceName = null;
					_this.contextApplianceId = null;
					display_alert_msg(data["param1"]);
				}
			}
		},
		loadDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */

			_this.xmlRepresentation = [];
			_this.xmlRepresentation[0] = { 
				RN: data[0]['RN'],
				DISPLAYNAME: data[0]['DISPLAYNAME'], 
				TYPE: data[0]['TYPE'],
				GUID: data[0]['GUID'],
				childs: new Array()
			};
			for (var i in data[0]['item']) {
				_this.xmlRepresentation[0].childs[i] = {
					RN: data[0]['item'][i]['RN'],
					DISPLAYNAME: data[0]['item'][i]['DISPLAYNAME'], 
					TYPE: data[0]['item'][i]['TYPE'],
					GUID: data[0]['item'][i]['GUID']
				};
			}
			_this.new_base_dn = _this.xmlRepresentation[0].RN;
			_this.new_filter = _this.filter;
			_this.scope = _this.new_scope;
			_this.loadContextData(_this, _this.new_base_dn, _this.new_filter, _this.new_scope);
			
			_this.drawTreeLDAP();
			_this.initial_matrix = _this.m.translate(_this.matrix.x, _this.matrix.y);
			_this.g.setTransform(_this.initial_matrix);
			_this.sliders.style.visibility = "visible";
			_this.xmlRepresentation = null;
			
		},
		connectApplianceData: function(dn) {
			var options = {
				dn: dn
			};
			this.connectAppliance_dataProvider.loadSynchroData(this, this.connectApplianceDataCallback, options);
			// this.connectApplianceDataCallback(this, null);
		},
		connectApplianceDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */

			if (data['param0'] == 0) {
				var http = document.location.href.split(":");
				if (data['param2']['HTTP_PORT'] == undefined || 
				    data['param2']['HTTP_PORT'] == '80') {
					var href = http[0]+'://'+data['param2']['APPLIANCE_IP'];
				}
				else {
					var href = 'http://'+data['param2']['APPLIANCE_IP']+':'+data['param2']['HTTP_PORT'];
				}
				href += '/login/autoLogin';

				/* Create form for autologin */
				var newdiv = document.createElement('div');
				var divIdName = 'LoginDialogContent';
				newdiv.setAttribute('id',divIdName);
				newdiv.innerHTML = '<form name="login_form" id="login_form" method="post" action="'+href+'"><input type="hidden" name="username" id="username" value="'+data['param2']['APPLIANCE_LOGIN']+'" /> <input type="hidden" name="password" id="password" value="'+data['param2']['APPLIANCE_PASSWORD']+'" />';
				document.body.appendChild(newdiv);
				var login_form = document.getElementById('login_form');
				my_form = eval(login_form);
				my_form.target = '_blank';
				my_form.submit();
				newdiv.innerHTML = '';
			}
			else {
				if (data["param0"] != 12) {
					display_alert_msg(data['param1']);
				}
			}
		},
		addApplianceData: function(dn, params) {
			for (var param in params) {
				if (params[param] == undefined) {
					params[param] = "";
				}
			}
			var serialize_params = dojo.json.serialize(params);

			var options = {
				dn: dn,
				params: serialize_params
			};
			this.AddAppliance_dataProvider.loadSynchroData(this, this.addApplianceDataCallback, options);
		},
		addApplianceDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			var node = null;

			if (data['param0'] == 0) {
				for (var j = 0; j < _this.level; j++) {
					var id_level = 'img_'+j;
					for (var i = 0; i < _this.gNodeTab[id_level]; i++) {
						var img = 'img_'+ j + '-' + i;
						if (_this.gNodeTab[img].state_node && _this.gNodeTab[img].state_node.clickedNode == true) {
							node = _this.gNodeTab[img];
						}
					}
				}
				if (node) {
					_this.remove_nodes(node, -1);
				    _this.displayOnClick(node);
				}
				_this.loadContextData(_this, _this.base_dn, _this.filter, _this.scope);
			}
			else {
				if (data["param0"] != 12) {
					display_alert_msg(data['param1']);
				}
			}
		},
		addUserData: function(dn, params) {
			for (var param in params) {
				if (params[param] == undefined) {
					params[param] = "";
				}
			}
			var serialize_params = dojo.json.serialize(params);

			var options = {
				dn: dn,
				params: serialize_params
			};
			this.AddUser_dataProvider.loadSynchroData(this, this.addUserDataCallback, options);
		},
		addUserDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			var node = null;
			
			if (data['param0'] == 0) {
				for (var j = 0; j < _this.level; j++) {
					var id_level = 'img_'+j;
					for (var i = 0; i < _this.gNodeTab[id_level]; i++) {
						var img = 'img_'+ j + '-' + i;
						if (_this.gNodeTab[img].state_node && _this.gNodeTab[img].state_node.clickedNode == true) {
							node = _this.gNodeTab[img];
						}
					}
				}
				if (node) {
					_this.remove_nodes(node, -1);
				    _this.displayOnClick(node);
				}
			}
			else {
				if (data["param0"] != 12) {
					display_alert_msg(data['param1']);
				}
			}
		},
		modifyAttributesData: function(dn, params) {
			for (var param in params) {
				if (params[param] == undefined) {
					params[param] = "";
				}
			}
			var serialize_params = dojo.json.serialize(params);

			var options = {
				dn: dn,
				params: serialize_params
			};
			this.ModifyAttributes_dataProvider.loadSynchroData(this, this.modifyAttributesDataCallback, options);
		},
		modifyAttributesDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 * because this function is called as a callback.
			 */
			if (data['param0'] != 0 && data['param0'] != 12) {
				display_alert_msg(data['param1']);
			}
			else {
				dojo.event.topic.publish("arkeiaFinishedNodeAttributesModification", null);
			}
		},
		deleteApplianceData: function(dn) {
			var params={
				dn: dn
			};
			this.DeleteAppliance_dataProvider.loadSynchroData(this, this.deleteApplianceDataCallback, params);
		},
		deleteApplianceDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 */
			 _this.finishedDeleteApplianceAjax++;
			 if (data['param0'] == 0) {
			 	var nodes = null;
			 	if ((nodes = _this.testTreeSelectMode('removeAppliance', arkwui_lang_get_msg('treeldap_menu_remove_appliance'), '2')) == false) {
					return ;
				}
			 }
			 else {
				if (data["param0"] != 12) {
					display_alert_msg(data['param1']);
				}
			 }
			 /* We have deleted all appliances, so send event and reload tree in correct
			  * place
			  */
			 if (_this.finishedDeleteApplianceAjax >= _this.nbDeleteAppliance) {
			 	dojo.event.topic.publish("arkeiaFinishedDeleteAppliance", null);
			 }
		},
		deleteUserData: function(dn) {
			var params={
				dn: dn
			};
			this.DeleteUser_dataProvider.loadSynchroData(this, this.deleteUserDataCallback, params);
		},
		deleteUserDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 */
			 _this.finishedDeleteUserAjax++;
			 if (data['param0'] == 0) {
			 	var nodes = null;
			 	if ((nodes = _this.testTreeSelectMode('removeUser', arkwui_lang_get_msg('treeldap_menu_remove_user'), '3')) == false) {
					return ;
				}
			 }
			 else {
				if (data["param0"] != 12) {
					display_alert_msg(data['param1']);
				}
			 }
			 /* We have deleted all users, so send event and reload tree in correct
			  * place
			  */
			 if (_this.finishedDeleteUserAjax >= _this.nbDeleteUser) {
			 	dojo.event.topic.publish("arkeiaFinishedDeleteUser", null);
			 }
		},
		getAttributesData: function(dn, node_type) {
			var params={
				dn: dn
			};
			this.tmp_node_type = node_type;
			this.GetAttributes_dataProvider.loadSynchroData(this, this.getAttributesDataCallback, params);
		},
		getAttributesDataCallback: function(_this, data) {
			/* Be carefull to use _this instead of this here, 
			 */
			if ((_this.is_default_ldap == undefined ||
			    _this.is_default_ldap != '1') && data) {
				_this.tmp_data = data;
				_this.loadManagerGetApplianceDataCallback(_this, null, true);
			}
			else {
				if (data) {
					_this.tmp_data = data;
					_this.loadManagerGetApplianceData(_this);
				}
			}
			// _this.tmp_node_type = '';
		},
		initialize:function(args, frag) {
			this.Search_dataUrl = this.baseUrl + "/Ldap/jsonSearch";
			this.AddAppliance_dataUrl = this.baseUrl + "/Ldap/jsonAddAppliance";
			this.DeleteAppliance_dataUrl = this.baseUrl + "/Ldap/jsonDeleteAppliance";
			this.DeleteUser_dataUrl = this.baseUrl + "/Ldap/jsonDeleteUser";
			this.GetAttributes_dataUrl = this.baseUrl + "/Ldap/jsonGetAttributes";
			this.SetContext_dataUrl = this.baseUrl + "/Ldap/jsonSetContext";
			this.AddUser_dataUrl = this.baseUrl + "/Ldap/jsonAddUser";
			this.ModifyAttributes_dataUrl = this.baseUrl + "/Ldap/jsonModifyAttributes";
			this.connectAppliance_dataUrl = this.baseUrl + "/Ldap/jsonConnectAppliance";

			this.xmlRepresentation = [];
            var options = {};
 
            options.dataUrl = this.Search_dataUrl;
            var dpClass = arkeia.widget.ArkeiaDataProvider;
			this.Search_dataProvider = new dpClass(options);

			options.dataUrl = this.AddAppliance_dataUrl;
			this.AddAppliance_dataProvider = new dpClass(options);
		
			options.dataUrl = this.DeleteAppliance_dataUrl;
			this.DeleteAppliance_dataProvider = new dpClass(options);
		
			options.dataUrl = this.DeleteUser_dataUrl;
			this.DeleteUser_dataProvider = new dpClass(options);

			options.dataUrl = this.SetContext_dataUrl;
            var dpClass = arkeia.widget.ArkeiaDataProvider;
			this.SetContext_dataProvider = new dpClass(options);

			options.dataUrl = this.AddUser_dataUrl;
			this.AddUser_dataProvider = new dpClass(options);
			
			options.dataUrl = this.GetAttributes_dataUrl;
			this.GetAttributes_dataProvider = new dpClass(options);

			options.dataUrl = this.ModifyAttributes_dataUrl;
			this.ModifyAttributes_dataProvider = new dpClass(options);

			options.dataUrl = this.connectAppliance_dataUrl;
			this.connectAppliance_dataProvider = new dpClass(options);

			
			/* initialize Text in template html */
			this.ZoomText.innerHTML = arkwui_lang_get_msg('treeldap_zoom');
			/* (<span dojoAttachPoint="scaleValue">1.000</span>) */
			this.TreeModeText.innerHTML = arkwui_lang_get_msg('treeldap_tree_mode');
			this.BrowseText.innerHTML = arkwui_lang_get_msg('treeldap_browse');
			this.SelectText.innerHTML = arkwui_lang_get_msg('treeldap_select');

			this.m = dojo.gfx.matrix;
			this.define_x = 140;
			this.define_y = 100;
			glthis = this;

			this.size = {
					width : this.width,
					height : this.height
			};
			this.node = {
				height: this.node_height, 
				width: this.node_width, 
				fontSize: this.node_fontSize
			};
			
			this.matrix_zoom = {
					x: this.define_x,
					y: this.define_y
			};
			this.tab_image = [];
			this.tab_image[0] = [];
			this.tab_image[1] = [];
			this.tab_image[2] = [];
			this.tab_image[3] = [];
			this.tab_image[4] = [];

			this.tab_image[0].normal = this.baseUrl+'/images/home.png';
			this.tab_image[1].normal = this.baseUrl+'/images/ou.png';
			this.tab_image[2].normal = this.baseUrl+'/images/appliance.png';
			this.tab_image[3].normal = this.baseUrl+'/images/user.png';
			this.tab_image[4].normal = this.baseUrl+'/images/group.png';

			this.tab_image[0].active = this.baseUrl+'/images/home_select.png';
			this.tab_image[1].active = this.baseUrl+'/images/ou_select.png';
			this.tab_image[2].active = this.baseUrl+'/images/appliance_select.png';
			this.tab_image[3].active = this.baseUrl+'/images/user_select.png';
			this.tab_image[4].active = this.baseUrl+'/images/group_select.png';

			this.NodeAttrTab['givenName'] = arkwui_lang_get_msg('treeldap_firstname');
			this.NodeAttrTab['sn'] = arkwui_lang_get_msg('treeldap_lastname');
			this.NodeAttrTab['cn'] = arkwui_lang_get_msg('treeldap_commonname');
			this.NodeAttrTab['uid'] = arkwui_lang_get_msg('treeldap_userid');
			this.NodeAttrTab['mail'] = arkwui_lang_get_msg('treeldap_email');
			this.NodeAttrTab['title'] = arkwui_lang_get_msg('treeldap_title');
			this.NodeAttrTab['l'] = arkwui_lang_get_msg('treeldap_location');
			this.NodeAttrTab['departmentNumber'] = arkwui_lang_get_msg('treeldap_department');

			this.NodeAttrTab['applianceIp'] = '<b>'+arkwui_lang_get_msg('treeldap_ip')+'</b>';
			this.NodeAttrTab['manager'] = '<b>'+arkwui_lang_get_msg('treeldap_manager')+'</b>';
			this.NodeAttrTab['uniqueMember'] = '<b>'+arkwui_lang_get_msg('treeldap_uniquemember')+'</b>';
			this.NodeAttrTab['appliancePort'] = arkwui_lang_get_msg('treeldap_port');
			this.NodeAttrTab['appliancePassword'] = arkwui_lang_get_msg('treeldap_arkeia_root_password');
			this.NodeAttrTab['ou'] = arkwui_lang_get_msg('treeldap_ou');
			this.NodeAttrTab['applianceId'] = arkwui_lang_get_msg('treeldap_id');
			this.NodeAttrTab['uid'] = '<b>'+arkwui_lang_get_msg('treeldap_user_id')+'</b>';
			this.NodeAttrTab['description'] = arkwui_lang_get_msg('treeldap_description');
		},
		postCreate:function(args, frag) {
			this.container = this.gfx_holder;
			this.container_position = dojo.html.abs(this.container);
			this.surface = dojo.gfx.createSurface(this.container, this.size.width, this.size.height);
	
			this.bg = this.surface.createRect({x: 0, y: 0, width: this.size.width, height: this.size.height}).setFill(this.bgcolor);
		
			this.surface_size = this.surface.getDimensions();
			this.surface_size.width  = parseInt(this.surface_size.width);
			this.surface_size.height = parseInt(this.surface_size.height);
	
			this.g = this.surface.createGroup();
		    dojo.event.connect(this.scalingSlider, "onValueChanged", this, "scalingEvent");
			dojo.event.connect(this.container, 'onmousedown', this, "handleMouseDown");
			dojo.event.connect(this.container, 'ondblclick', this, "handledblClick");
			//dojo.event.connect(this.container, 'onmouseover', this, "handleMouseOver");
			dojo.event.connect(this.container, 'onmousemove', this, "handleMouseMove");
			dojo.event.connect(this.container, 'onmouseup', this, "handleMouseUp");
			
			/* Tree Mode */
			dojo.event.connect(this.BrowseRadioButton, "onClick", this, "BrowseEvent");
			dojo.event.connect(this.SelectRadioButton, "onClick", this, "SelectEvent");
			
			/* Menu */
			dojo.event.connect(this.nodeAttributes, "onClick", this, "nodeAttributesEvent");
			dojo.event.connect(this.addAppliance, "onClick", this, "addApplianceEvent");
			dojo.event.connect(this.removeAppliance, "onClick", this, "removeApplianceEvent");
			dojo.event.connect(this.addUser, "onClick", this, "addUserEvent");
			dojo.event.connect(this.changeUserPassword, "onClick", this, "changeUserPasswordEvent");
			dojo.event.connect(this.removeUser, "onClick", this, "removeUserEvent");
			dojo.event.connect(this.setContext, "onClick", this, "setContextEvent");
			dojo.event.connect(this.connectAppliance, "onClick", this, "connectApplianceEvent");
			dojo.event.connect(this.advancedSearch, "onClick", this, "advancedSearchEvent");
			
			/* Event of the end of delete appliance. Exec a reload */
			dojo.event.topic.subscribe("arkeiaFinishedDeleteAppliance", this, "onArkeiaFinishedDeleteAppliance");

			/* Event of the end of delete user. Exec a reload */
			dojo.event.topic.subscribe("arkeiaFinishedDeleteUser", this, "onArkeiaFinishedDeleteUser");
			
			/* Event of the end of node attributes modification. Reopen the window */
			dojo.event.topic.subscribe("arkeiaFinishedNodeAttributesModification", this, "onArkeiaFinishedNodeAttributesModification");

			this.loadData("", "*");
			
			this.nodeAttributes.setNewCaption(arkwui_lang_get_msg('treeldap_menu_node_attributes'), true);
			this.nodeAttributes.collapse();
			this.addAppliance.setNewCaption(arkwui_lang_get_msg('treeldap_menu_add_appliance'), true);
			this.addAppliance.collapse();
			this.removeAppliance.setNewCaption(arkwui_lang_get_msg('treeldap_menu_remove_appliance'), true);
			this.removeAppliance.collapse();
			this.addUser.setNewCaption(arkwui_lang_get_msg('treeldap_menu_add_user'), true);
			this.addUser.collapse();
			this.changeUserPassword.setNewCaption(arkwui_lang_get_msg('treeldap_menu_change_user_password'), true);
			this.changeUserPassword.collapse();
			this.removeUser.setNewCaption(arkwui_lang_get_msg('treeldap_menu_remove_user'), true);
			this.removeUser.collapse();
			this.setContext.setNewCaption(arkwui_lang_get_msg('treeldap_menu_set_selected_context'), true);
			this.setContext.collapse();
			this.connectAppliance.setNewCaption(arkwui_lang_get_msg('treeldap_menu_connect_selected_appliance'), true);
			this.connectAppliance.collapse();

			this.advancedSearch.setNewCaption(arkwui_lang_get_msg('treeldap_menu_advanced_search'), true);
			this.advancedSearch.expand();
			
			this.new_scope = 3;
			this.scope = 3;
		},
		drawTreeLDAP:function() {
			var id_father = null;
			var id_child = null;
			var nb_node_brothers = 0;
			var nb_node_childs = 0;
			var x1 = 0;
			var x2 = 0;
			var total_node_childs = 0;

			nb_node_brothers = this.xmlRepresentation.length;
			//dojo.debug("nb_node_brothers:"+nb_node_brothers);
			for (var i = 0; i < nb_node_brothers; i++) {
				if (this.xmlRepresentation[i].childs) {
					nb_node_childs = this.xmlRepresentation[i].childs.length;
				}
				//dojo.debug("nb_node_childs:"+nb_node_childs);
				if (nb_node_brothers == 1 || i == 0) {
					if (nb_node_childs) {
						x1 = ((this.define_x * (nb_node_childs - 1)) / 2);
					}
					else {
						x1 = 0;
					}
				}
				else {
					if (nb_node_childs) {
						x1 = ((this.define_x * (nb_node_childs - 1)) / 2);
						x1 += x2 + this.define_x;
					}
					else {
						if (x2 == 0) {
							x1 = x1 + this.define_x;
						}
						else {
							x1 = (x2 + this.define_x * 2);
						}
					}
				}
				// x1: middle of childs, y: 0
				var max_pos_x = x1 + (this.define_x * ((nb_node_brothers - 1)  / 2));
				var min_pos_x = x1 - (this.define_x * ((nb_node_brothers - 1)  / 2));
				id_father = this.makeNode(x1, 0, i, min_pos_x, max_pos_x, this.xmlRepresentation[i].GUID, this.xmlRepresentation[i].TYPE, this.xmlRepresentation[i].DISPLAYNAME, this.xmlRepresentation[i].RN, true, this.tab_image[this.xmlRepresentation[i].TYPE].normal, this.tab_image[this.xmlRepresentation[i].TYPE].active);
		
				// DEBUG
				//dojo.debug("["+i+"], text: "+this.tab_image[this.xmlRepresentation[i].TYPE]+", x: "+x1+", y:"+0);
		
				// Childs
				for (var j = 0; j < nb_node_childs; j++) {
					if (!(i == 0 && j == 0)) {
						x2 += this.define_x;
					}
					if (nb_node_childs == 1) {
						// If number of childs = 1, x:child = x:father
						id_child = this.makeNode(x1, this.define_y, x1, x1, this.xmlRepresentation[i].childs[j].GUID, this.xmlRepresentation[i].childs[j].TYPE, this.xmlRepresentation[i].childs[j].DISPLAYNAME, this.xmlRepresentation[i].childs[j].RN, true, this.tab_image[this.xmlRepresentation[i].childs[j].TYPE].normal, this.tab_image[this.xmlRepresentation[i].childs[j].TYPE].active);
					}
					else {
						// For all number of childs
						var max_pos_x = x2 + (this.define_x * ((nb_node_brothers - 1)  / 2));
						var min_pos_x = x2 - (this.define_x * ((nb_node_brothers - 1)  / 2));

						id_child = this.makeNode(x2, this.define_y, j, min_pos_x, max_pos_x, this.xmlRepresentation[i].childs[j].GUID, this.xmlRepresentation[i].childs[j].TYPE, this.xmlRepresentation[i].childs[j].DISPLAYNAME, this.xmlRepresentation[i].childs[j].RN, true, this.tab_image[this.xmlRepresentation[i].childs[j].TYPE].normal, this.tab_image[this.xmlRepresentation[i].childs[j].TYPE].active);
					}
					// DEBUG
					//dojo.debug("["+i+"]["+j+"], text: "+xmlRepresentation[i].childs[j].text+", x: "+x2 * j+", y:"+y2);
					
					// Add relations to draw lines
					this.gNodeTab[id_father].relation_add(id_child);
					this.gNodeTab[id_child].father_id = id_father;
				}
				total_node_childs += j;
			}
			if (i == 1) {
				this.matrix_zoom = {
					x: x1 + this.define_x,
					y: this.define_y
				};
			}
			else {
				this.matrix_zoom = {
					x: x1 - ((nb_node_brothers * this.define_x) / 2),
					y: this.define_y / 2
				};
			}
			this.matrix = {
				x: this.define_x,
				y: this.define_y
			};
			this.makeLine();
		},
		makeLine:function() {
			var k = 0;
			var i = 0;
			var j = 0;
			var id;
			var relations = null;

			for (; k < this.level; k++) {
				var id_level = "img_" + k;
				for (i = 0; i < this.gNodeTab[id_level]; i++) {
					id = "img_" + k + '-' + i;
					relations = this.gNodeTab[id].relation_get();
					var center1 = {
						x: this.gNodeTab[id].pos_x,
						y: this.gNodeTab[id].pos_y
					};
					if (relations) {
						for (j = 0; j < this.gNodeTab[id].relations_count; j++) {
							if (this.gNodeTab[relations[j]].node_rect) {
								var center2 = {
									x: this.gNodeTab[relations[j]].pos_x,
									y: this.gNodeTab[relations[j]].pos_y
								};
								if (this.gNodeTab[relations[j]].state_node.visibility == 'visible') {
									this.gNodeTab[relations[j]].node_line = this.connect_line({x:center1.x, y:center1.y}, {x:center2.x, y:center2.y});
									this.gNodeTab[relations[j]].node_line.getEventSource().setAttribute('style', "visibility: "+this.gNodeTab[relations[j]].state_node.visibility+";");
									this.gNodeTab[relations[j]].node_img.getEventSource().setAttribute('style', "visibility: "+this.gNodeTab[relations[j]].state_node.visibility+";");
									this.gNodeTab[relations[j]].node_text.getEventSource().setAttribute('style', "visibility: "+this.gNodeTab[relations[j]].state_node.visibility+";");
								}
							}
						}
					}
				}
			}
		},
		connect_line:function(node_top, node_bottom) {
				var aLine = this.g.createLine({ x1: node_top.x + this.node.width/2, y1: node_top.y + this.node.height, x2: node_bottom.x + this.node.width/2, y2: node_bottom.y });
				aLine.setStroke({color: this.linecolor, width: 2});
				aLine.moveToBack();
				return (aLine);
		},
		updateMatrix:function(dx, dy) {
			if(this.g){
				if (this.initial_matrix) {
					this.initial_matrix.xx = this.scaling;
					this.initial_matrix.yy = this.scaling;
				}
				this.g.setTransform([{dx: dx, dy: dy}, this.m.scaleAt(this.scaling, this.matrix_zoom.x, this.matrix_zoom.y), this.initial_matrix]);
			}
		},
		makeText:function(surface, text, font, fill, stroke) {
			var t = this.surface.createText(text);
			//if(font)   t.setFont(font);
			if(fill)   t.setFill(fill);
			if(stroke) t.setStroke(stroke);
			placeAnchor(this.surface, text.x, text.y);
			return t;		
		},
		makeNode:function(pos_x, pos_y, nb_line, min_pos_x, max_pos_x, guid, node_type, node_text, node_rn, state, normal_image, active_image) {
			var tmp = (pos_y / this.define_y) + 1;
			if (tmp > this.level) {
					this.level = tmp;
			}
			var gImg = this.g.createImage({width:this.node.width, height:this.node.height, src: normal_image}).applyTransform({dx: pos_x, dy: pos_y});
			var gRect = this.g.createRect({x:pos_x, y:pos_y, width:this.node.width, height:this.node.height});
			if (state == true && active_image) {
					var sNode = new State_node(normal_image, active_image, false);
					sNode.visibility = this.node_visibility;
					dojo.html.setClass(gImg.getEventSource(), "clickable");
			}
			//Set id of this image
			var level = pos_y / this.define_y;
			var id = "img_" + level + '-' + nb_line;
			if (typeof(this.gNodeTab['img_'+level]) == 'undefined') {
				this.gNodeTab['img_'+level] = 1;
			}
			else {
				this.gNodeTab['img_'+level] += 1;
			}
			gImg.getEventSource().setAttribute('imgid', id);
			//Set Text
			var text = node_text;
			if (level) {
				if (text.length > 15) {
					text = text.substr(0, 15);
					text += "...";
				}
			}
			var aText = this.g.createText({x:(pos_x + this.node.width / 2), y: (pos_y + this.node.fontSize + (this.node.height)), text: text, align: "middle"});
			aText.setFill("#000000");
			//aText.setFont({/*family: "fixed",*/ family: "sans-serif"/*, size: this.node.fontSize + "px"*//*, weight: "bold"*/});
			aText.setFont({ family: "Arial", size: this.node.fontSize + "px", weight: "bold" });
			aText.getEventSource().setAttribute('id', id);
			
			//Fill class Tab
			if (state == true && active_image) {
				this.gNodeTab[id] = new Node(id, node_text, guid, node_type, gImg, gRect, aText, node_rn, pos_x, pos_y, min_pos_x, max_pos_x, sNode);
			}
			else {
				this.gNodeTab[id] = new Node(id, node_text, guid, node_type, gImg, gRect, aText, node_rn, pos_x, pos_y, min_pos_x, max_pos_x);
			}
			return (id);
		},
		getObjectLDAP:function(event, name) {
			var id = event.target.getAttribute(name);
			var s  = id ? this.gNodeTab[id] : null;
			if (!s) {
				return id;
			}
			return s;
		},
		scalingEvent:function(value) {
			this.scaling = Math.exp(Math.LN2 * (value - 1));
			//this.scaleValue.innerHTML = this.scaling.toFixed(3);
			this.updateMatrix(0, 0);
		},
		BrowseEvent:function() {
			this.treeMode = 'Browse';
			this.erase_all_clicked_nodes();
		},
		SelectEvent:function() {
			this.treeMode = 'Select';
		},		
		selectNodes:function(node, click) {
			if (click == true) {
				node.node_img.getEventSource().setAttribute('href', node.state_node.normal_image);
				node.state_node.clicked = false;
			}	
			else {
				if (node.state_node.visibility == 'visible') {
					node.node_img.getEventSource().setAttribute('href', node.state_node.active_image);
					node.state_node.clicked = true;
				}
			}
		},
		/* RETURN:	0: Selected root
		 * 		1: Selected group(ou)
		 * 		2: Selected appliances
		 * 		3: Selected users
		 */
		displayMenu:function(node, click) {
			this.addAppliance.collapse();
			this.nodeAttributes.collapse();
			this.removeAppliance.collapse();
			this.addUser.collapse();
			this.changeUserPassword.collapse();
			this.removeUser.collapse();
			this.setContext.collapse();
			this.connectAppliance.collapse();
			
			switch (node.node_type) {
				case '0':
					if (this.hasRole == 1) {
						if (this.is_default_ldap == undefined ||
						    this.is_default_ldap != '1') {
							this.addAppliance.expand();
							this.addUser.expand();
						}
					}
					this.setContext.expand();
					break;
			        case '1':
					if (this.hasRole == 1) {
						this.addAppliance.expand();
						this.addUser.expand();
					}
					this.setContext.expand();
					break;
				case '2':
					this.nodeAttributes.expand();
					if (this.hasRole == 1) {
						this.removeAppliance.expand();
						this.connectAppliance.expand();
					}
					this.setContext.expand();
					break;
				case '3':
					this.nodeAttributes.expand();
					if (this.hasRole == 1) {
						this.changeUserPassword.expand();
						this.removeUser.expand();
					}
					break;
				case '4':
					this.nodeAttributes.expand();
					break;
				default:
					break;
			}
		},
		unselectClickedNode:function() {
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					if (this.gNodeTab[img].state_node && this.gNodeTab[img].state_node.clickedNode == true) {
						this.gNodeTab[img].state_node.clickedNode = false;
					}
				}
			}
		},
		getClickedNode:function() {
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					if (this.gNodeTab[img].state_node && this.gNodeTab[img].state_node.clickedNode == true && 
						this.gNodeTab[img].state_node.clicked == true) {
						return (this.gNodeTab[img]);
					}
				}
			}
			return (null);
		},
		unselectAllNodes:function(node) {
			if (node && node.node_type == '2') {
				for (var j = 0; j < this.level; j++) {
					var id_level = 'img_'+j;
					for (var i = 0; i < this.gNodeTab[id_level]; i++) {
						var img = 'img_'+ j + '-' + i;
						if (this.gNodeTab[img].state_node && this.gNodeTab[img].node_type != '2') {
							this.gNodeTab[img].state_node.clickedNode = false;
							this.gNodeTab[img].node_img.getEventSource().setAttribute('href', this.gNodeTab[img].state_node.normal_image);
							this.gNodeTab[img].state_node.clicked = false;
						}
					}
				}
			}
			else {
				for (var j = 0; j < this.level; j++) {
					var id_level = 'img_'+j;
					for (var i = 0; i < this.gNodeTab[id_level]; i++) {
						var img = 'img_'+ j + '-' + i;
						if (this.gNodeTab[img].state_node) {
							if (node) {
								if (this.gNodeTab[img].id != node.id) {
									this.gNodeTab[img].state_node.clickedNode = false;
									this.gNodeTab[img].node_img.getEventSource().setAttribute('href', this.gNodeTab[img].state_node.normal_image);
									this.gNodeTab[img].state_node.clicked = false;
								}
							}
							else {
								this.gNodeTab[img].state_node.clickedNode = false;
								this.gNodeTab[img].node_img.getEventSource().setAttribute('href', this.gNodeTab[img].state_node.normal_image);
								this.gNodeTab[img].state_node.clicked = false;
							}
						}
					}
				}
				if (this.filter_tab != null) {
					this.filter_tab['|'] = null;
					this.filter_tab['|'] = [];
					this.createNewFilter();
				}
			}
		},
		createNewFilter:function() {
			this.new_filter = '';
			if (this.filter_tab['|'].length == 0) {
				this.new_filter = '(objectClass=*)'
				return ;
			}
			if (this.filter_tab['|'].length == 1 && this.filter_tab['|'][0] != '') {
				this.new_filter = '('+this.filter_tab['|'][0]+')';
			}
			else {
				for (var i = 0; i < this.filter_tab['|'].length; i++) {
					if (i == 0 && this.filter_tab['|'][i] != '') {
						this.new_filter += '(|('+this.filter_tab['|'][i]+')';
					}
					else {
						if (this.filter_tab['|'][i] != '') {
							this.new_filter += '('+this.filter_tab['|'][i]+')';
						}
					}
				}
				if (i && this.new_filter != '') {
					this.new_filter += ')';
				}
			}
		},
		handleMouseDown:function(event) {
			var Img = this.getObjectLDAP(event, 'imgid');

			if (Img && Img.state_node && this.treeMode == 'Browse') {
				if (Img.node_type != '0') {
					this.displayOnClick(Img);
				}
				dojo.event.browser.stopEvent(event);
				return ;
			}
			if (Img && Img.state_node && this.treeMode == 'Select') {
				if (Img.state_node.clicked == false) {
					this.unselectClickedNode();
					Img.state_node.clickedNode = true;
				}
				this.unselectAllNodes(Img);
				this.selectNodes(Img, Img.state_node.clicked);
				this.createFilter(Img);
				this.createNewFilter();

				this.displayMenu(Img, Img.state_node.clicked);
				dojo.event.browser.stopEvent(event);
				return ;
			}
			
			if (this.bg) {
				this.last_position = {
				   x: event.clientX,
				   y: event.clientY
				};
				this.move = 1;
				//dojo.debug(this.scaling);
			 }
			 dojo.event.browser.stopEvent(event);
		},
		handledblClick:function(event) {
			var Img = this.getObjectLDAP(event, 'imgid');

			if (Img && Img.state_node && this.treeMode == 'Browse') {
				dojo.event.browser.stopEvent(event);
				return ;
			}
			if (Img && Img.state_node && this.treeMode == 'Select') {
				var dn = this.createDN(Img);
				
				this.selectNodes(Img, Img.state_node.clicked);
				this.createFilter(Img);
				this.createNewFilter();

				this.displayMenu(Img, Img.state_node.clicked);

				if (Img.node_type != '0' && Img.node_type != '1') {
					this.getAttributesData(dn, Img.node_type);
				}
				dojo.event.browser.stopEvent(event);
				return ;
			}			
			if (this.bg) {
				this.last_position = {
				   x: event.clientX,
				   y: event.clientY
				};
				this.move = 1;
				//dojo.debug(this.scaling);
			 }
			 dojo.event.browser.stopEvent(event);
		},
		handleMouseMove:function(event) {
			if(!this.move) return;

			var x = this.last_position.x - event.clientX;
			var y = this.last_position.y - event.clientY;
			this.updateMatrix(-x, -y);
			this.matrix.x += x;
			this.matrix.y += y;
			dojo.event.browser.stopEvent(event);
		},
		handleMouseUp:function(event) {
			this.move = null;
			this.initial_matrix = this.g.getTransform();
			this.initial_matrix.xx = this.scaling;
			this.initial_matrix.yy = this.scaling;
			dojo.event.browser.stopEvent(event);
		},
		createFilter:function(node) {
			var selected = null;
			if (this.filter_tab == null) {
				this.filter_tab = [];
				this.filter_tab['|'] = [];
				this.filter_tab['&'] = [];
				this.filter_tab['!'] = [];
			}
			selected = this.testTreeSelectMode(null, null, '-1');
			/* delete a node from filter_tab */
			if (node.state_node.clicked == false && node.node_type == '2') {
				var filter = [];
				filter['|'] = [];
				var j = 0;
				for (var i = 0; i < this.filter_tab['|'].length; i++) {
					if (this.filter_tab['|'][i] != ('applianceId='+node.guid)) {
						filter['|'][j++] = this.filter_tab['|'][i];
					}
				}
				this.filter_tab['|'] = filter['|'];
				return ;
			}
			/* one clicked node */
			if (selected.length == 1 && node.state_node.clicked == true) {
				var dn = this.createDN(node);
				if (node.node_type == '2') {
					this.new_scope = 1;
					this.filter_tab['|'][this.filter_tab['|'].length] = "applianceId=" + node.guid;
				} else {
					this.new_scope = 3;
				}
				this.new_base_dn = dn;
				return ;
			}
			/* more than one clicked node */
			if (selected.length > 1 /*&& node.state_node.clicked == true */) {
				if (node.node_type != '2') {
					/*
					var nb = 0;
					if (node.state_node.clicked == false) {
						var up_node = null;
						for (var i = 0; i < selected.length; i++) {
							if (!up_node) {
								up_node = selected[i];
							}
							else {
								if (up_node.pos_y > selected[i].pos_y) {
									up_node = selected[i];
								}
							}
						}
						node = up_node;
					}
					for (var i = 0; i < selected.length; i++) {
							if (selected[i].node_type != '2') {
								nb++;
							}
					}
					if (nb == 1) {
						this.new_scope = 3;
						this.new_base_dn = this.createDN(node);
						this.new_filter = '(objectClass=*)';
						return ;
					}
					*/
					//alert("cannot set context selection invalid.");
					return ;
				}
				var same_line = true;
				for (var i = 0; i < selected.length; i++) {
					if ((node.pos_y < selected[i].pos_y || node.pos_y > selected[i].pos_y) ||
						node.father_id != selected[i].father_id) {
						same_line = false;
					}
				}
				if (same_line == true) {
					//var dn = this.createDN(node);
					this.new_scope = 3;
					switch (node.node_type) {
						case '0':
							//this.filter_tab['|'][this.filter_tab['|'].length] = ":dn:=*,"+dn;
							break;
						case '1':
							//this.filter_tab['|'][this.filter_tab['|'].length] = ":dn:=*,"+dn;
							break;
						case '2':
							this.filter_tab['|'][this.filter_tab['|'].length] = "applianceId="+node.guid;
							this.new_scope = 2;
							break;
						case '3':
							return ;
					}
					this.new_filter = '';
					this.new_base_dn = this.createDN(this.gNodeTab[node.father_id]);
				}
				else {
					var root_node = null;
					for (var j = 0; j < this.level; j++) {
						var id_level = 'img_'+j;
						for (var i = 0; i < this.gNodeTab[id_level]; i++) {
							var img = 'img_'+ j + '-' + i;
							if (this.gNodeTab[img].node_type == '0') {
								root_node = this.gNodeTab[img];
								break;
							}
						}
						if (root_node) {
							break;
						}
					}
					if (root_node) {
						this.new_base_dn = root_node.node_rn;
					}
					this.new_scope = 3;
					switch (node.node_type) {
						case '0':
							//this.filter_tab['|'][this.filter_tab['|'].length] = ":dn:=*,"+dn;
							break;
						case '1':
							//this.filter_tab['|'][this.filter_tab['|'].length] = ":dn:=*,"+dn;
							break;
						case '2':
							this.filter_tab['|'][this.filter_tab['|'].length] = "applianceId="+node.guid;
							break;
						case '3':
							break;
					}
				}
				return ;
			}
		},
		getTreeReload:function(Img) {
			var dnToSend = "";
			var pos_x = 0;
			var pos_y = 0;
			var bak_Img = Img;
			
			if (Img.relations_count == 0 || Img.deleted_childs != true) {
				dnToSend = this.createDN(Img);
				/* Call ajax with dnToSend and get tabresult */
				pos_x = Img.pos_x;
				pos_y = Img.pos_y + this.define_y;
				this.loadDataOnClick(dnToSend, "*", pos_x, pos_y, bak_Img);
			}
			else {
				this.xmlRepresentation = null;
				this.erase_all_lines();
				this.replaceTreeCorrectly(bak_Img);
			}
			return (true);
		},
		createDN:function(node) {
			var dnConcat = [];
			var dnToSend = "";
			var i = 1;
			
			dnConcat[0] = node.node_rn;
			while (node.father_id) {
				node = this.gNodeTab[node.father_id];
				dnConcat[i++] = node.node_rn;
			}
			for (i = 0; i < dnConcat.length; i++) {
				if (i == (dnConcat.length - 1)) {
					dnToSend += dnConcat[i];
				}
				else {
					dnToSend += dnConcat[i] + ',';
				}
			}
			return (dnToSend);
		},
		searchVisibleChildsNode:function(node) {
			var relations = node.relation_get();
			
			for (var i = 0; i < node.relations_count; i++) {
				if (this.gNodeTab[relations[i]].state_node.visibility == 'visible') {
					return true;
				}
			}
			return false;
		},
		replaceTreeCorrectly:function(current) {
			var cur_max_pos_x = current.max_pos_x;
			var cur_min_pos_x = current.min_pos_x;
			var cur_pos_y = current.pos_y + this.define_y;
			var cur_level = (cur_pos_y / this.define_y);
			var cur_center = current.pos_x;
			var id_level = "img_"+cur_level;
			var sign = 1;
			
			for (var i = 0; i < this.gNodeTab[id_level]; i++) {
				var id = id_level+'-'+i;
				
				if (this.gNodeTab[id].father_id != current.id) {
					/* DEBUG */
					/*
					dojo.debug("cur_text:"+current.text+" node_text:"+this.gNodeTab[id].text);
					dojo.debug("cur_max_pos_x:"+cur_max_pos_x+" cur_min_pos_x:"+cur_min_pos_x);
					dojo.debug("gnodetab_text:"+this.gNodeTab[id].text+" max_pos_x:"+this.gNodeTab[id].max_pos_x+" min_pos_x:"+this.gNodeTab[id].min_pos_x);
					*/
					/* Left or right move */
					if (this.gNodeTab[this.gNodeTab[id].father_id].pos_x < cur_center) {
						sign = -1;
					}
					else {
						sign = 1;
					}
					/* Check collision */
					if ((this.gNodeTab[id].max_pos_x >= cur_min_pos_x && 
						this.gNodeTab[id].max_pos_x <= cur_max_pos_x) ||
						(this.gNodeTab[id].min_pos_x >= cur_min_pos_x &&
						this.gNodeTab[id].min_pos_x <= cur_max_pos_x) ||
						(this.gNodeTab[id].min_pos_x <= cur_min_pos_x &&
						this.gNodeTab[id].max_pos_x >= cur_max_pos_x) ||
						(this.gNodeTab[id].min_pos_x - this.define_x < cur_max_pos_x &&
						this.gNodeTab[id].min_pos_x - this.define_x > cur_min_pos_x) ||
						(this.gNodeTab[id].max_pos_x + this.define_x > cur_min_pos_x && 
						this.gNodeTab[id].max_pos_x + this.define_x < cur_max_pos_x)) {
						/* Move */
						var father_node = this.gNodeTab[this.gNodeTab[id].father_id];
						if (this.searchVisibleChildsNode(this.gNodeTab[father_node.id]) == true) {
							if (sign == 1) {
								var decal = (cur_max_pos_x - this.gNodeTab[id].min_pos_x) + this.define_x;
							}
							else {
								var decal = (this.gNodeTab[id].max_pos_x - cur_min_pos_x) + this.define_x;
							}
							decal = Math.abs(decal);
							//dojo.debug("DECAL:"+decal);
							
							father_node.node_img.applyTransform({dx: sign * decal, dy: 0});
							father_node.node_text.applyTransform({dx: sign * decal, dy: 0});
							father_node.node_rect.applyTransform({dx: sign * decal, dy: 0});
							if (father_node.decal == false) {
								father_node.decal = decal;
								father_node.sign = sign;
							}
							else {
								father_node.decal += sign * decal;
							}
							//dojo.debug("father_node decal:"+father_node.decal+" father_node.sign:"+father_node.sign);
							
							if (father_node.node_line != null) {
								this.g.remove(father_node.node_line);
								father_node.node_line = null;
							}
	
							this.decalBrothers(father_node, current, sign, decal);
							
							father_node.pos_x  += sign * decal;
							father_node.max_pos_x  += sign * decal;
							father_node.min_pos_x  += sign * decal;
							
							this.decalChilds(father_node.id, this.gNodeTab[id], sign, decal);
						}
					}
				}
			}
			this.makeLine();
		},
		decalFathers:function(node, current, sign, decal) {
			while (node.father_id) {
				//dojo.debug("decalFathers !!! TEXT:"+node.text+" min_pos_x:"+node.min_pos_x+" max_pos_x:"+node.max_pos_x+" pos_x:"+node.pos_x);
				if (node.relations_count) {
					
					var max_pos_x = this.gNodeTab[node.relations[0]].max_pos_x/* + sign * decal*/;
					var min_pos_x = this.gNodeTab[node.relations[0]].min_pos_x/* + sign * decal*/;
					var pos_x = node.pos_x/* + sign * decal*/;
					
					var new_pos_x = (max_pos_x - min_pos_x) / 2;
					if (node.moved == false) {
						/*
						dojo.debug("sign:"+sign+" decal:"+decal);
						dojo.debug("new_pos_x:"+new_pos_x);
						dojo.debug("node.pos_x:"+node.pos_x);
						*/
						this.decalBrothers(node, current, sign, decal);
						this.moveNode(node, sign, decal);
						node.moved = true;
					}
				}
				node = this.gNodeTab[node.father_id];
			}
		},
		decalBrothers:function(father_node, current, sign, decal) {
			var level = (father_node.pos_y / this.define_y);
			var id_level = 'img_'+level;
			
			//dojo.debug("father_text:"+father_node.text);
			for (var i = 0; i < this.gNodeTab[id_level]; i++) {
				var id = id_level+'-'+i;
				
				if (this.gNodeTab[id].id != father_node.id &&
					this.gNodeTab[id].id != current.id) {
					/*
					dojo.debug("sign:"+sign);
					dojo.debug("this.gNodeTab[id].text:"+this.gNodeTab[id].text);
					dojo.debug("this.gNodeTab[id].pos_x:"+this.gNodeTab[id].pos_x);
					dojo.debug("father_node.pos_x:"+father_node.pos_x);
					*/
					if (sign == -1 && this.gNodeTab[id].pos_x <= father_node.pos_x) {
						this.moveNode(this.gNodeTab[id], sign, decal);
						this.decalFathers(this.gNodeTab[this.gNodeTab[id].father_id], this.gNodeTab[id], sign, decal);
						this.decalChilds(id, father_node, sign, decal);
					}
					if (sign == 1 && this.gNodeTab[id].pos_x >= father_node.pos_x) {
						this.moveNode(this.gNodeTab[id], sign, decal);
						this.decalFathers(this.gNodeTab[this.gNodeTab[id].father_id], this.gNodeTab[id], sign, decal);
						this.decalChilds(id, father_node, sign, decal);
					}
				}
			}
			for (var i = 0; i < this.gNodeTab[id_level]; i++) {
				var id = id_level+'-'+i;
				
				this.gNodeTab[id].moved = false;
			}
		},
		moveNode:function(node, sign, decal) {
			node.node_img.applyTransform({dx: sign * decal, dy: 0});
			node.node_text.applyTransform({dx: sign * decal, dy: 0});
			node.node_rect.applyTransform({dx: sign * decal, dy: 0});
		
			node.pos_x  += sign * decal;
			node.max_pos_x  += sign * decal;
			node.min_pos_x  += sign * decal;

			if (node.node_line != null) {
				this.g.remove(node.node_line);
				node.node_line = null;
			}

		},
		decalChilds:function(id, current, sign, decal) {
			var relations = this.gNodeTab[id].relation_get();

			for (var i = 0; i < this.gNodeTab[id].relations_count; i++) {
				this.gNodeTab[relations[i]].node_img.applyTransform({dx: sign * decal, dy: 0});
				this.gNodeTab[relations[i]].node_text.applyTransform({dx: sign * decal, dy: 0});
				this.gNodeTab[relations[i]].node_rect.applyTransform({dx: sign * decal, dy: 0});
				
				this.gNodeTab[relations[i]].pos_x  += sign * decal;
				this.gNodeTab[relations[i]].max_pos_x  += sign * decal;
				this.gNodeTab[relations[i]].min_pos_x  += sign * decal;

				if (this.gNodeTab[relations[i]].node_line != null) {
					this.g.remove(this.gNodeTab[relations[i]].node_line);
					this.gNodeTab[relations[i]].node_line = null;
				}

				if (this.gNodeTab[relations[i]].relations_count) {
					this.decalChilds(this.gNodeTab[relations[i]].id, current, sign, decal);
				}
			}
		},
		drawNewLevelLDAP:function(pos_x, pos_y, father_node) {
			var nb_node_brothers = this.xmlRepresentation.length;

			switch(nb_node_brothers) {
				case 0:
					return ;
				case 1:
					var level = (pos_y / this.define_y);
					var id_level = "img_" + level;
					if (typeof(this.gNodeTab[id_level]) == 'undefined') {
						var nb = 0;
					}
					else {
						var nb = this.gNodeTab[id_level];
					}
					var id = this.makeNode(pos_x, pos_y, nb, (pos_x - (this.define_x / 2)), (pos_x + (this.define_x / 2)), this.xmlRepresentation[0].GUID, this.xmlRepresentation[0].TYPE, this.xmlRepresentation[0].DISPLAYNAME, this.xmlRepresentation[0].RN, true, this.tab_image[this.xmlRepresentation[0].TYPE].normal, this.tab_image[this.xmlRepresentation[0].TYPE].active);
					father_node.relation_add(id);
					father_node.max_pos_x += this.define_x;
					this.gNodeTab[id].father_id = father_node.id;
					break ;
				default:
					var max_pos_x = pos_x + (this.define_x * ((nb_node_brothers - 1)  / 2));
					var min_pos_x = pos_x - (this.define_x * ((nb_node_brothers - 1)  / 2));
					father_node.max_pos_x = max_pos_x;
					father_node.min_pos_x = min_pos_x;
					//dojo.debug("MIN_POS_X:"+min_pos_x+" MAX_POS_X:"+max_pos_x);
					var level = (pos_y / this.define_y);
					var id_level = "img_" + level;
					if (typeof(this.gNodeTab[id_level]) == 'undefined') {
						var nb = 0;
					}
					else {
						var nb = this.gNodeTab[id_level];
					}
					pos_x = pos_x - (this.define_x * ((nb_node_brothers - 1)  / 2));
					for (var i = 0; i < nb_node_brothers; i++) {
						var id = this.makeNode(pos_x, pos_y, nb, min_pos_x, max_pos_x, this.xmlRepresentation[i].GUID, this.xmlRepresentation[i].TYPE, this.xmlRepresentation[i].DISPLAYNAME, this.xmlRepresentation[i].RN, true, this.tab_image[this.xmlRepresentation[i].TYPE].normal, this.tab_image[this.xmlRepresentation[i].TYPE].active);
						father_node.relation_add(id);
						this.gNodeTab[id].father_id = father_node.id;
						pos_x += this.define_x;
						nb++;
					}
					break ;
			}
		},
		displayOnClick:function(Img) {
			/* hide show node */
			//dojo.debug("relation:"+Img.relations_count+" delect_childs:"+Img.deleted_childs);
			var ok = false;
			if (Img.relations_count || Img.deleted_childs != false) {
				for (var i = 0; i < Img.relations_count; i++) {
					switch (this.gNodeTab[Img.relations[i]].state_node.visibility) {
						case 'hidden':
							var visibility = 'visible';
							ok = true;
							break;
						case 'visible':
							var visibility = 'hidden';
							ok = true;
							break;
						default:
							break;
					}
					if (ok == true) {
						break;
					}
				}
				if (ok == true) {
					//dojo.debug("OK TRUE");
					this.hideChilds(Img, visibility, -1);
					this.erase_all_lines();
					this.replaceTreeCorrectly(Img);
					this.replaceWithHide(Img);
				}
			}
			/* Load new level and replace nodes */
			if (ok == false) {
				//dojo.debug("OK FALSE");
				this.getTreeReload(Img);
			}
		},
		hideChilds:function(node, visibility, type) {
			var relations = node.relation_get();
			var remove = false;
			
			if (visibility == 'delete') {
				remove = true;
				visibility = 'hidden';
				if (type == -1) {
					node.node_img.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					if (node.node_line != null) {
						node.node_line.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					}
					node.node_text.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					node.state_node.visibility = 'delete';
				}
				if (type == node.node_type && node.state_node.clicked == true) {
					node.node_img.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					if (node.node_line != null) {
						node.node_line.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					}
					node.node_text.getEventSource().setAttribute('style', "visibility: "+visibility+";");
					node.state_node.visibility = 'delete';
				}
			}
			
			if (node.relations_count) {
				for (var i = 0; i < node.relations_count; i++) {
					if (this.gNodeTab[relations[i]].state_node.visibility != 'delete') {
						if (type == -1) { 
							this.gNodeTab[relations[i]].node_img.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							if (this.gNodeTab[relations[i]].node_line != null) {
								this.gNodeTab[relations[i]].node_line.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							}
							this.gNodeTab[relations[i]].node_text.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							if (remove != false) {
								this.gNodeTab[relations[i]].state_node.visibility = 'delete';
								this.hideChilds(this.gNodeTab[relations[i]], 'delete', type);
							}
							else {
								this.gNodeTab[relations[i]].state_node.visibility = visibility;
								this.hideChilds(this.gNodeTab[relations[i]], visibility, type);
							}
						}
						if (this.gNodeTab[relations[i]].node_type == type && 
							this.gNodeTab[relations[i]].state_node.clicked == true) {
							this.gNodeTab[relations[i]].node_img.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							if (this.gNodeTab[relations[i]].node_line != null) {
								this.gNodeTab[relations[i]].node_line.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							}
							this.gNodeTab[relations[i]].node_text.getEventSource().setAttribute('style', "visibility: "+visibility+";");
							if (remove != false) {
								this.gNodeTab[relations[i]].state_node.visibility = 'delete';
								this.hideChilds(this.gNodeTab[relations[i]], 'delete', type);
							}
							else {
								this.gNodeTab[relations[i]].state_node.visibility = visibility;
								this.hideChilds(this.gNodeTab[relations[i]], visibility, type);
							}
						}
					}
				}
			}
		},
		replaceWithHide:function(current) {
			/*
			dojo.debug("current node text:"+current.text);
			if (current.decal != false) {
				dojo.debug("current node decal:"+current.decal+" current node sign:"+current.sign);
				if (current.father_id) {
					this.decalBrothers(this.gNodeTab[current.father_id], current, -current.sign, current.decal);
					//current.sign = false;
					//current.decal = false;
				}
			}
			*/
			return ;
		},
		eraseTreeLDAP:function() {
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					
					if (this.gNodeTab[img].node_img) {
						this.g.remove(this.gNodeTab[img].node_img);
					}
					if (this.gNodeTab[img].node_rect) {
						this.g.remove(this.gNodeTab[img].node_rect);
					}
					if (this.gNodeTab[img].node_line) {
						this.g.remove(this.gNodeTab[img].node_line);
						this.gNodeTab[img].node_line = null;
					}
					if (this.gNodeTab[img].node_text) {
						this.g.remove(this.gNodeTab[img].node_text);
					}
				}
			}
		},
		erase_all_lines:function() {
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					if (this.gNodeTab[img].node_line) {
						this.g.remove(this.gNodeTab[img].node_line);
						this.gNodeTab[img].node_line = null;
					}
				}
			}
		},
		erase_all_clicked_nodes:function() {
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					if (this.gNodeTab[img].state_node && this.gNodeTab[img].state_node.clicked == true) {
						this.gNodeTab[img].node_img.getEventSource().setAttribute('href', this.gNodeTab[img].state_node.normal_image);
						this.gNodeTab[img].state_node.clicked = false;
						this.gNodeTab[img].state_node.clickedNode = false;
					}
				}
			}
			this.addAppliance.collapse();
			this.nodeAttributes.collapse();
			this.removeAppliance.collapse();
			this.addUser.collapse();
			this.changeUserPassword.collapse();
			this.removeUser.collapse();
			this.setContext.collapse();
			this.connectAppliance.collapse();
		},
		remove_nodes:function(node, type) {
			var relations = node.relation_get();
			
			if (node.relations_count) {
				for (var i = 0; i < node.relations_count; i++) {
					this.remove_one_node(this.gNodeTab[relations[i]], -1);
					this.gNodeTab[relations[i]].deleted_childs = true;
				}
			}
		},
		remove_one_node:function(node, type) {
			this.hideChilds(node, 'delete', type);
			this.replaceWithHide(node);
			return ;
		},
		createPopupWindow:function(popup_id, title, data){
			var popupWindow = dojo.widget.byId(popup_id);
		    if (popupWindow) {
			    popupWindow.show();
				return true;
		    }
		    var properties = {
				style: "top: 100px; left:300px; width: 640px; height: 600px;",
				title: title,
			    hasShadow: true,
			    resizable: false,
				displayMinimizeAction: false,
				displayMaximizeAction: true,
				displayCloseAction:    true,
				executeScripts:        true,
				titleHeight: "20",
				id: popup_id
		    };
		    var popup_div = document.createElement("div");
		    popup_div.id = "popup_div";
		    popup_div.style.width = "640px";
		    popup_div.style.height = "600px";
		    popup_div.style.left = "300px";
		    popup_div.style.top = "100px";
		    document.body.appendChild(popup_div);
		    var popupWindow = dojo.widget.createWidget("FloatingPane", properties, popup_div);
		    popupWindow.setContent(data);
		},
		testTreeSelectMode:function(popup_id, title, type) {
			var selected = [];
			var nb = 0;
			for (var j = 0; j < this.level; j++) {
				var id_level = 'img_'+j;
				for (var i = 0; i < this.gNodeTab[id_level]; i++) {
					var img = 'img_'+ j + '-' + i;
					if (this.gNodeTab[img].state_node && this.gNodeTab[img].state_node.visibility == 'visible' &&
						this.gNodeTab[img].state_node.clicked == true) {
						
						if (this.gNodeTab[img].node_type == type || type == '-1') {
							selected[nb] = this.gNodeTab[img];
							nb++;
						}
					}
				}
			}
			if (nb == 0) {
				if (title == null) {
					return (false);
				}
				var data = arkwui_lang_get_msg('treeldap_no_node_selected');
				this.createPopupWindow(popup_id, title, data);
				return (false);
			}
			return (selected);
		},
		nodeAttributesEvent:function() {
			var node = this.getClickedNode();
			
			if (node) {
				var dn = this.createDN(node);
				this.getAttributesData(dn, node.node_type);
			}
		},
		changeUserPasswordEvent:function() {
			var node = this.getClickedNode();
			
			if (node) {
				var dn = this.createDN(node);
				var data = '<div dojoType="ContentPane" href="'+this.baseUrl+'/ldap/helpchangeuserpassword"></div>';

				data += '<h2>'+arkwui_lang_get_msg('treeldap_menu_change_user_password')+'</h2><br>';
				data += '<br><form dojoType="arkeia:ArkeiaForm" id="changeUserPasswordForm">';
				
				//User Password: userPassword
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_password')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="password" name="userPassword"/>';
				data += '</span>';
				data += '</div>';

				//Verify User Password: verifpassword
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_verify_password')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="password" name="verifpassword"/>';
				data += '</span>';
				data += '</div>';

				data += '<input type="hidden" name="node" value="'+node.id+'"/>';

				//Arkeia button
				data += '<div style="height: 25px;">';
				data += '</div>';
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"></span>';
				data += '<span style="width:65%;" ><input dojoType="arkeia:ArkeiaButton" type="button" onClick="getValuesChangeUserPasswordForm();" caption="'+arkwui_lang_get_msg('treeldap_menu_change_user_password')+'" class="ArkButton" myformid="changeUserPasswordForm" /></span>';
				data += '</div>';
				
				data += '</form>';

				this.createPopupWindow('nodeAttributes', arkwui_lang_get_msg('treeldap_menu_change_user_password'), data);
			}
		},
		addApplianceEvent:function() {
			if (this.is_default_ldap == undefined ||
			    this.is_default_ldap != '1') {
				this.loadManagerAddApplianceDataCallback(this, null, true);
			}
			else {
				this.loadManagerAddApplianceData();
			}
		},
		addApplianceButtonEvent:function(params, nodeId) {
			var popupWindow = dojo.widget.byId('addAppliance');
			if (popupWindow) {
		        popupWindow.closeWindow();
		    }
		    
		    /* AJAX to add appliance */
		    var dn = this.createDN(this.gNodeTab[nodeId]);
		    this.addApplianceData(dn, params);
		},
		addUserEvent:function() {
			var node = this.getClickedNode();

			if (node && (node.node_type == '0' || node.node_type == '1')) {
				var data = '<div dojoType="ContentPane" href="'+this.baseUrl+'/ldap/helpadduser"></div>';
				data += '<h2>'+arkwui_lang_get_msg('treeldap_menu_add_user')+'</h2>';
				data += '<br><form dojoType="arkeia:ArkeiaForm" id="addUserForm">';

				//Common Name: CN
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_commonname')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="text" name="cn"/>';
				data += '</span>';
				data += '</div>';

				//User Id: uid
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_user_id')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="text" name="uid"/>';
				data += '</span>';
				data += '</div>';

				//User Password: userPassword
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_password')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="password" name="userPassword"/>';
				data += '</span>';
				data += '</div>';

				//Verify User Password: verifpassword
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_verify_password')+'</b></span>';
				data += '<span style="width:65%;" >';
				data += '<input type="password" name="verifpassword"/>';
				data += '</span>';
				data += '</div>';

				data += '<input type="hidden" name="node" value="'+node.id+'"/>';

				//default ldap = Yes and User edit.
				//Add blank fields if we don't exist
				if (this.is_default_ldap != undefined &&
				    this.is_default_ldap == '1') {
					data += '<div style="height: 15px;">';
					data += '</div>';
					data += '<div>';
					data += '<div class="advanced_title" id="advanced" onclick="onTreeLdapLabelClick(\'advanced\');" open="false">'+arkwui_lang_get_msg('treeldap_menu_optional_properties')+'</div>';
					data += '<div id="TreeLdapHide" style="display: none;">';
					data += '<div style="height: 15px;">';
					data += '</div>';
					data += this.createHtmlAddField('mail', 'treeldap_email', '');
					data += this.createHtmlAddField('title', 'treeldap_title', '');
					data += this.createHtmlAddField('l', 'treeldap_location', '');
					data += this.createHtmlAddField('departmentNumber', 'treeldap_department', '');
					data += '</div>';
					data += '</div>';
				}
				else {
					data += this.createHtmlAddField('mail', 'treeldap_email', '');
					data += this.createHtmlAddField('title', 'treeldap_title', '');
					data += this.createHtmlAddField('l', 'treeldap_location', '');
					data += this.createHtmlAddField('departmentNumber', 'treeldap_department', '');
				}
				
				//Arkeia button
				data += '<div style="height: 25px;">';
				data += '</div>';
				data += '<div style="height: 25px;">';
				data += '<span style="width:35%;" class="attr_name"></span>';
				data += '<span style="width:65%;" ><input dojoType="arkeia:ArkeiaButton" type="button" onClick="getValuesAddUserForm();" caption="'+arkwui_lang_get_msg('treeldap_menu_add_user')+'" class="ArkButton" myformid="addUserForm" /></span>';
				data += '</div>';

				data += '</form>';
				
				this.createPopupWindow('addUser', arkwui_lang_get_msg('treeldap_menu_add_user'), data);
			}
			else {
				alert(arkwui_lang_get_msg('treeldap_no_add_node_here'));
			}
		},
		addUserButtonEvent:function(params, nodeId) {
			var popupWindow = dojo.widget.byId('addUser');
			if (popupWindow) {
		        popupWindow.closeWindow();
		    }
		    var dn = this.createDN(this.gNodeTab[nodeId]);
		    /* AJAX to add an user */
   		    this.addUserData(dn, params);
		},
		modifyAttributesButtonEvent:function(params, nodeId) {
			var popupWindow = dojo.widget.byId('nodeAttributes');
			if (popupWindow) {
		        popupWindow.closeWindow();
		    }
		    var dn = this.createDN(this.gNodeTab[nodeId]);
		    /* AJAX to add an user */
   		    this.modifyAttributesData(dn, params);
		},
		removeApplianceEvent:function() {
			var selected = null;
			if ((selected = this.testTreeSelectMode('removeAppliance', arkwui_lang_get_msg('treeldap_menu_remove_appliance'), '2')) == false) {
				return ;
			}
			
			if (confirm(arkwui_lang_get_msg('treeldap_remove_appliance')) == true) {
				var father_nodes = [];
				for (var i = 0; i < selected.length; i++) {
					/* AJAX to remove appliance */
					var dn = this.createDN(selected[i]);
				    this.deleteApplianceData(dn);
				}
				this.nbDeleteAppliance = i;
			}
		},
		onArkeiaFinishedDeleteAppliance:function() {
			var selected = null;
			if ((selected = this.testTreeSelectMode(null, null, '2')) == false) {
				return ;
			}
			
			var father_nodes = [];
			for (var i = 0; i < selected.length; i++) {		    
			    var find_already = false;
			    /* delete node selected from filter */
			    if (this.filter_tab) {
				    var filter = null;
				    filter = [];
					filter['|'] = [];
					var l = 0;
					for (var k = 0; k < this.filter_tab['|'].length; k++) {
						if (this.filter_tab['|'][k] != ('applianceId='+selected[i].guid)) {
							filter['|'][l++] = this.filter_tab['|'][k];
						}
					}
					if (this.filter_tab['|'].length != filter['|'].length) {
						this.filter_tab['|'] = filter['|'];
						this.createNewFilter();
						this.filter = this.new_filter;
						if (this.scope == 1) {
							var root_node = null;
							for (var j = 0; j < this.level; j++) {
								var id_level = 'img_'+j;
								for (var i = 0; i < this.gNodeTab[id_level]; i++) {
									var img = 'img_'+ j + '-' + i;
									if (this.gNodeTab[img].node_type == '0') {
										root_node = this.gNodeTab[img];
										break;
									}
								}
								if (root_node) {
									break;
								}
							}
							if (root_node) {
								this.base_dn = root_node.node_rn;
							}
							this.scope = 3;
						}
					}
			    }
			    
			    for (var j = 0; j < father_nodes.length; j++) {
			    	if (selected[i].father_id == father_nodes[j].id) {
			    		find_already = true;
			    	}
			    }
			    if (find_already == false) {
			    	father_nodes[father_nodes.length] = this.gNodeTab[selected[i].father_id];
			    }
			}
			for (var i = 0; i < father_nodes.length; i++) {
				this.remove_nodes(father_nodes[i], -1);
				this.displayOnClick(father_nodes[i]);
			}
			this.nbDeleteAppliance = 0;
			this.finishedDeleteApplianceAjax = 0;
			this.loadContextData(this, this.base_dn, this.filter, this.scope);
		},
		removeUserEvent:function() {
			var selected = null;
			if ((selected = this.testTreeSelectMode('removeUser', arkwui_lang_get_msg('treeldap_menu_remove_user'), '3')) == false) {
				return ;
			}
			
			if (confirm(arkwui_lang_get_msg('treeldap_remove_user')) == true) {
				for (var i = 0; i < selected.length; i++) {
					/* AJAX to remove appliance */
					var dn = this.createDN(selected[i]);
					this.deleteUserData(dn);
				}
				this.nbDeleteUser = i;
			}
		},
		onArkeiaFinishedNodeAttributesModification:function() {
			//this.nodeAttributesEvent();
		},
		onArkeiaFinishedDeleteUser:function() {
			var selected = null;
			if ((selected = this.testTreeSelectMode(null, null, '3')) == false) {
				return ;
			}
			
			var father_nodes = [];
			for (var i = 0; i < selected.length; i++) {
			    var find_already = false;
			    for (var j = 0; j < father_nodes.length; j++) {
			    	if (selected[i].father_id == father_nodes[j].id) {
			    		find_already = true;
			    	}
			    }
			    if (find_already == false) {
			    	father_nodes[father_nodes.length] = this.gNodeTab[selected[i].father_id];
			    }
			}
			for (var i = 0; i < father_nodes.length; i++) {
				this.remove_nodes(father_nodes[i], -1);
				this.displayOnClick(father_nodes[i]);
			}
			this.nbDeleteUser = 0;
			this.finishedDeleteUserAjax = 0;
		},
		setContextEvent:function() {
			/* Check if only appliance are selected */
			var selected = null;
			if ((selected = this.testTreeSelectMode(null, null, '-1')) == false) {
				return ;
			}
			var nb = 0;
			for (var i = 0; i < selected.length; i++) {
				if (selected[i].node_type != '2') {
					nb++;
				}
			}
			if (nb > 1) {
				alert(arkwui_lang_get_msg('treeldap_incorrect_selected_context'));
				return ;
			}
			if (nb) {
				this.filter_tab['|'] = null;
				this.filter_tab['|'] = [];
			}
			this.createNewFilter();
			this.loadContextData(this, this.new_base_dn, this.new_filter, this.new_scope);
		},
		connectApplianceEvent:function() {
			/* Check if only appliance are selected */
			var selected = null;
			if ((selected = this.testTreeSelectMode(null, null, '2')) == false) {
				return ;
			}
			var nb = 0;
			var appliance;
			for (var i = 0; i < selected.length; i++) {
				if (selected[i].node_type == '2') {
					nb++;
					appliance = selected[i];
				}
			}
			if (nb > 1) {
				alert(arkwui_lang_get_msg('treeldap_incorrect_selected_appliance'));
				return ;
			}
			/* AJAX to get appliance infos */
			var dn = this.createDN(appliance);
			
			this.connectApplianceData(dn);
		},
		advancedSearchEvent:function() {
			var data = '<div dojoType="ContentPane" href="'+this.baseUrl+'/ldap/helpcontext"></div>';
			data += '<h2>'+arkwui_lang_get_msg('treeldap_menu_advanced_search')+'</h2><br>';
			data += '<form dojoType="arkeia:ArkeiaForm" id="advancedSearchForm">';

			//Base dn: base_dn
			data += '<div style="height: 25px;">';
			data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_base_dn')+'</b></span>';
			data += '<span style="width:65%;" >';
			data += '<input type="text" name="base_dn" value="'+this.base_dn+'"/>';
			data += '</span>';
			data += '</div>';
			
			//Filter: filter
			data += '<div style="height: 25px;">';
			data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_filter')+'</b></span>';
			data += '<span style="width:65%;" >';
			data += '<input type="text" name="filter" value="'+this.filter+'"/>';
			data += '</span>';
			data += '</div>';

			//Scope: scope
			data += '<div style="height: 25px;">';
			data += '<span style="width:35%;" class="attr_name"><b>'+arkwui_lang_get_msg('treeldap_scope')+'</b></span>';
			data += '<span style="width:65%;" >';
			data += '<select name="scope">';
			data += '<option value="base">'+arkwui_lang_get_msg('treeldap_base')+'</option>';
			if (this.scope == 2) {
				data += '<option value="one_level" selected>'+arkwui_lang_get_msg('treeldap_one_level')+'</option>';
			}
			else {
				data += '<option value="one_level">'+arkwui_lang_get_msg('treeldap_one_level')+'</option>';
			}
			if (this.scope == 3) {
				data += '<option value="subtree" selected>'+arkwui_lang_get_msg('treeldap_subtree')+'</option>';
			}
			else {
				data += '<option value="subtree">'+arkwui_lang_get_msg('treeldap_subtree')+'</option>';
			}
			data += '</select>';
			data += '</span>';
			data += '</div>';

			//Appliance list
			data += '<div style="height: 25px;">';
			data += '<span style="width:35%;" class="attr_name"></span>';
			data += '<span style="width:65%;" >';
			data += '<div style="width:70%">';
			data += '<div dojoType="arkeia:ArkeiaList" widgetId="ApplianceList" ';
			data += 'columns="[{field: \'Appliance_Name\', label: \''+
				arkwui_lang_get_msg('treeldap_appliance_name')+'\'}]" valueField="Appliance_Name" valueId="valueId" msgmode=false scrollDown="true">';
			data += '</div>';
			data += '</span>';
			data += '</div>';
			
			//Arkeia button
			data += '<div style="height: 25px;">';
			data += '</div>';
			data += '<div style="height: 25px;">';
			data += '<span style="width:35%;" class="attr_name"></span>';
			data += '<span style="width:65%;" ><input dojoType="arkeia:ArkeiaButton" type="button" onClick="getValuesAdvancedSearchForm();" caption="'+arkwui_lang_get_msg('treeldap_set_context')+'" class="ArkButton" myformid="advancedSearchForm" /></span>';
			data += '</div>';

   			data += '</form>';

			this.createPopupWindow('advancedSearch', arkwui_lang_get_msg('treeldap_menu_advanced_search'), data);
			var list = dojo.widget.byId('ApplianceList');
			var ListAppliance = [];
			if (this.contextApplianceName) {
				for (var i = 0; i < this.contextApplianceName.length; i++) {
					ListAppliance[i] = { 
			    		'Appliance_Name': this.contextApplianceName[i]
					};
				}
				list.addDataRange(list, ListAppliance);
			} else {
				list.addDataRange(list, [{'Appliance_Name': this.ApplianceName}]);
			}
		},
		/* Code for multiple properties and prop val unknown field by user */
		createHtmlAddField:function(firstBoxName, propValue, propBoxName) {
			var data = '<div style="height: 15px;">';

			data += '<span style="width:35%;" class="attr_name">';
			data += arkwui_lang_get_msg(propValue);
			data += '</span>';

			data += '<span style="width:65%;" id="span_'+firstBoxName+'">';
			data += '<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>';
			data += '</span>';
			data += '</div>';
			
			if (propBoxName == undefined) {
				propBoxName = '';
			}
			data += '<div id="div_'+firstBoxName+'"></div>';
			
			data += '<div style="height: 15px;">';
			data += '<span style="width:35%;" class="attr_name">';
			data += '</span>';
			data += '<span style="width:65%;">';
			data += '<input type="text" name="add_'+firstBoxName+'" id="add_'+firstBoxName+'" value="'+arkwui_lang_get_msg('treeldap_param_add')+'" style="font-size:12px;width:8em;height:13px;" onfocus="add_checkparam(\'add_'+firstBoxName+'\', \'focus\')" onblur="add_checkparam(\'add_'+firstBoxName+'\', \'blur\')"/>';
			data += '&nbsp;&nbsp;';
			data += '<img src="'+this.baseUrl+'/images/arrow_build_vtl_16x16.gif" id=\'link_add_'+firstBoxName+'\' height="10" width="10" style="cursor:pointer;cursor:hand;" onClick="addMultipleValues(\''+firstBoxName+'\', \''+propBoxName+'\', \''+this.baseUrl+'\');" />';
			data += '</span>';
			data += '</div>';
	
			data += '<div style="height: 15px;">';
			data += '<input type="hidden" name="res_'+firstBoxName+'" id="res_'+firstBoxName+'"/>';
			data += '</div>';

			return (data);
		}
	}
);

function getValuesAddApplianceForm() {
	this.obj = dojo.widget.byId('addApplianceForm').getValues();
	if (this.obj["cn"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_name'));
		return (false);
	}
	if (this.obj["applianceIp"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_ip'));
		return (false);
	}
	if (this.obj["manager"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_manager'));
		return (false);
	}

	var valid = true;
	var ip = this.obj["applianceIp"].split(".");
	if(ip.length != 4) {
		valid = false;
	}
	else {
		for (i = 0; i < ip.length; i++) {
			if (isNaN(ip[i])==true || ip[i] > 255 || ip[i] < 0) {
				valid = false;
			}
		}
	}
	if (valid == false) {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_ip'));
		return (false);
	}
	if (this.obj["appliancePort"] != '') {
		var intCharCode;
		for (var i = 0; i < this.obj["appliancePort"].length; i++) {
			intCharCode = this.obj["appliancePort"].charCodeAt(i);
			if (!((intCharCode >= 48 && intCharCode <= 57))) {
				alert(arkwui_lang_get_msg('treeldap_validate_appliance_port'));
				return false;
			}
		}
	}
	if (this.obj["appliancePassword"] != this.obj["verifpassword"]) {
		alert(arkwui_lang_get_msg('treeldap_validate_user_password'));
		return (false);
	}
	var params = {};
	var tab = null;
	var tab_manager = {'manager' : new Array };
	var i = 0;
	var noManagers = true;
	var tab_tmp = {};

	for (var param in this.obj) {
		//dojo.debug("PARAM: "+param+" this.obj[param]: "+this.obj[param]);
		if (param.substr(0, 4) != 'add_' && param.substr(0, 4) != 'new_' && 
		    param.substr(0, 4) != 'chk_' && param != 'verifpassword' && 
		    param != 'father_dn' && param != 'node') {
			if (this.obj[param] != '') {
				if (param.substr(0, 4) == 'res_') {
					tab_tmp = dojo.json.evalJson(this.obj[param]);
					if (tab_tmp[param.substr(4)].length == 0) {
						params[param.substr(4)] = '';
					}
					else {
						params[param.substr(4)] = tab_tmp[param.substr(4)];
					}
					tab_tmp = {};
				}
				else {
					params[param] = this.obj[param];
				}
			}
		}
		if (param.substr(0, 4) == 'chk_') {
			//Check checked managers
			noManagers = false;
			tab_manager['manager'][i] = param.substr(4);
			i++;
		}
	}
	if (noManagers == true && (params['manager'] == '' || params['manager'] == undefined)) {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_manager'));
		return ;
	}
 	if (tab_manager['manager'].length > 0) {
		params['manager'] = tab_manager['manager'];
 	}
	glthis.addApplianceButtonEvent(params, this.obj["node"]);
}

function getValuesChangeUserPasswordForm() {
	this.obj = dojo.widget.byId('changeUserPasswordForm').getValues();
	//dojo.debug("GETVALUES:"+dojo.json.serialize(this.obj));
	
	if (this.obj["userPassword"] != this.obj["verifpassword"]) {
		alert(arkwui_lang_get_msg('treeldap_validate_user_password'));
		return (false);
	}
	if (this.obj["userPassword"] == '') {
		alert(arkwui_lang_get_msg('treeldap_empty_user_password'));
		return (false);
	}
	var params = {};
	for (var param in this.obj) {
		if (param != 'verifpassword' && param != 'father_dn' &&	param != 'node') {
			if (this.obj[param] != '') {
				params[param] = this.obj[param];
			}
		}
	}
	
	glthis.modifyAttributesButtonEvent(params, this.obj["node"]);
}

function getValuesAddUserForm() {
	this.obj = dojo.widget.byId('addUserForm').getValues();
	//dojo.debug("GETVALUES:"+dojo.json.serialize(this.obj));
	
	if (this.obj["cn"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_user_no_cn'));
		return (false);
	}
	//Last Name = Common Name
	this.obj["sn"] = this.obj["cn"];
	if (this.obj["res_mail"] != '') {
		var res_mail = dojo.json.evalJson(this.obj["res_mail"]);
		for (var mail in res_mail["mail"]) {
			var ret = emailCheck(res_mail["mail"][mail]);
			if (ret == false) return (false);
		}
	}
	if (this.obj["userPassword"] != this.obj["verifpassword"]) {
		alert(arkwui_lang_get_msg('treeldap_validate_user_password'));
		return (false);
	}
	if (this.obj["userPassword"] == '') {
		alert(arkwui_lang_get_msg('treeldap_empty_user_password'));
		return (false);
	}
	var params = {};
	var tab_tmp = {};
	for (var param in this.obj) {
		if (param.substr(0, 4) != 'add_' && param.substr(0, 4) != 'new_' &&
			param != 'verifpassword' && param != 'father_dn' && param != 'node') {
			if (this.obj[param] != '') {
				if (param.substr(0, 4) == 'res_') {
					tab_tmp = dojo.json.evalJson(this.obj[param]);
					if (tab_tmp[param.substr(4)].length == 0) {
						params[param.substr(4)] = '';
					}
					else {
						params[param.substr(4)] = tab_tmp[param.substr(4)];
					}
					tab_tmp = {};
				}
				else {
					params[param] = this.obj[param];
				}
			}
		}
	}
	glthis.addUserButtonEvent(params, this.obj["node"]);
}

function getValuesGetAttributesForm() {
	this.obj = dojo.widget.byId('getAttributesForm').getValues();

	if (this.obj["cn"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_name'));
		return (false);
	}
	if (this.obj["applianceIp"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_ip'));
		return (false);
	}
	if (this.obj["manager"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_manager'));
		return (false);
	}

	var params = {};
	var res = '';
	var noManagers = true;
	var is_appliance = false;
	var i = 0;
	var tmp_str = new Array;
	var tab_manager = {'manager' : new Array, 'uniqueMember' : new Array };
	var tab_tmp = {};

	for (var param in this.obj) {
		if (param == 'applianceId') {
			is_appliance = true;
		}
		if (param.substr(0, 4) != 'new_' && param.substr(0, 4) != 'add_' && 
		    param != 'cn' && param != 'ou' && param != 'objectClass' && 
		    param != 'applianceId' && param != 'node' && param != 'dn' && 
		    param.substr(0, 4) != 'chk_') {
			if (this.obj[param] != '') {
				if (param.substr(0, 4) == 'res_') {
					tab_tmp = dojo.json.evalJson(this.obj[param]);
					if (tab_tmp[param.substr(4)].length == 0) {
						params[param.substr(4)] = '';
					}
					else {
						params[param.substr(4)] = tab_tmp[param.substr(4)];
					}
					tab_tmp = {};
				}
				else {
					params[param] = this.obj[param];
				}
			}
		}
		//Appliance Password can be empty !
		if (param == 'appliancePassword' && this.obj[param] == '') {
			params[param] = '';
		}
		if (param.substr(0, 4) == 'chk_') {
			var underscore = 0;

			noManagers = false;
			tmp_str = param.split("_");

			for (var j = 0; j < param.length; j++) {
				if (underscore == 2) {
					break ;
				}
				if (param[j] == '_') {
					underscore++;
				}
			}
			tab_manager[tmp_str[1]][i] = param.substr(j);
			i++;
		}
	}
	if (noManagers == true && is_appliance == true && 
	    (params['manager'] == '' || params['manager'] == undefined)) {
		alert(arkwui_lang_get_msg('treeldap_validate_appliance_no_manager'));
		return ;
	}
	if (noManagers == false && tab_manager[tmp_str[1]].length > 0) {
		params[tmp_str[1]] = tab_manager[tmp_str[1]];
	}
	//dojo.debug("SERIALIZE PARAMS:"+dojo.json.serialize(params));
	glthis.modifyAttributesButtonEvent(params, this.obj["node"]);
	return ;
}

function getValuesAdvancedSearchForm() {
	this.obj = dojo.widget.byId('advancedSearchForm').getValues();
	if (this.obj["base_dn"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_search_base_dn'));
		return (false);
	}
	if (this.obj["filter"] == '') {
		alert(arkwui_lang_get_msg('treeldap_validate_search_filter'));
		return (false);
	}
	var scope = 3;
	switch (this.obj["scope"]) {
		case 'subtree':
			scope = 3;
			break;
		case 'base':
			scope = 1;
			break;
		case 'one_level':
			scope = 2;
			break;
		
	}
	//dojo.debug('this.obj["base_dn"]:'+this.obj["base_dn"]+' this.obj["scope"]:'+scope+' this.obj["filter"]:'+this.obj["filter"]);
	var popupWindow = dojo.widget.byId('advancedSearch');
	if (popupWindow) {
		popupWindow.closeWindow();
	}
	glthis.unselectAllNodes(null);
	glthis.loadContextData(glthis, this.obj["base_dn"], this.obj["filter"], scope);
}

function addExistingMultipleValues(BoxName, num, baseUrl) {
	var value = dojo.byId('add_' + BoxName).value;
	dojo.byId('add_' + BoxName).value = arkwui_lang_get_msg('treeldap_param_add');
	if (value != '') {
		if (dojo.byId('span_' + BoxName).innerHTML == ('<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>')) {
			dojo.byId('span_' + BoxName).innerHTML = value+'&nbsp;&nbsp;'+
				'<img src="'+baseUrl+'/images/arrow_delete_12x12.gif" id="remove" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeSingleValue(\''+BoxName+'\', -1, \''+value+'\');" />';
		}
		else {
			var elm = dojo.byId('div_'+BoxName);
			num++;
			dojo.byId('link_add_'+BoxName).setAttribute("onclick", 'addExistingMultipleValues(\''+BoxName+'\', '+num+', \''+baseUrl+'\');');
			num--;
			elm.innerHTML += '<div id="div_'+BoxName+'_'+num+'">'+
				'<div style="height:15px;">'+
				'<span style="width:35%;" class="attr_name"></span>'+
				'<span style="width:65%;">'+
				value+'&nbsp;&nbsp;'+
				'<img src="'+baseUrl+'/images/arrow_delete_12x12.gif" id="remove" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeSingleValue(\''+BoxName+'\', '+num+', \''+value+'\');" />'+
				'</span>'+
				'</div>'+
				'</div>';
		}
		var res = dojo.byId('res_'+BoxName);
		var data = {};
		if (res.value != '') {
			data = dojo.json.evalJson(res.value);
			data[BoxName][data[BoxName].length] = value;
			res.value = dojo.json.serialize(data);
		}
		else {
			data[BoxName] = [];
			data[BoxName][0] = value;
			res.value = dojo.json.serialize(data);
		}
	}
}

function addMultipleValues(firstBoxName, propBoxName, baseUrl) {
	var value = dojo.byId('add_'+firstBoxName).value;
	if (value != '') {
		dojo.byId('add_'+firstBoxName).value = '';
		var elm = dojo.byId('div_'+firstBoxName);
		var elm_span = dojo.byId('span_'+firstBoxName);
		var res = dojo.byId('res_'+firstBoxName);
		var data = {};

		if (elm_span.innerHTML == ('<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>')) {
			elm_span.innerHTML = value+'&nbsp;&nbsp;'+
				'<img src="'+baseUrl+'/images/arrow_delete_12x12.gif" id="remove" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeMultipleValues(\''+firstBoxName+'\', \''+value+'\', true);" />';
		}
		else {
			elm.innerHTML += '<div id="'+firstBoxName+'_'+value+'">'+
				'<div style="height: 15px;">'+
				'<span style="width:35%;" class="attr_name"></span>'+
				'<span style="width:65%;">'+
				value+'&nbsp;&nbsp;'+
				'<img src="'+baseUrl+'/images/arrow_delete_12x12.gif" id="remove" style="cursor:pointer;cursor:hand;" width="10" height="10" onclick="removeMultipleValues(\''+firstBoxName+'\', \''+value+'\', false);" />'+
				'</span>'+
				'</div>'+
				'</div>';
		}

		if (res.value != '') {
			data = dojo.json.evalJson(res.value);
			data[firstBoxName][data[firstBoxName].length] = value;
			res.value = dojo.json.serialize(data);
		}
		else {
			data[firstBoxName] = [];
			data[firstBoxName][0] = value;
			res.value = dojo.json.serialize(data);
		}
	}
}

function removeMultipleValues(firstBoxName, firstBoxValue, firstBox) {
	var res = dojo.byId('res_' + firstBoxName);
	var data = dojo.json.evalJson(res.value);
	var newdata = {};
	var i = 0;
	var elm_div = dojo.byId('div_'+firstBoxName);
	var elm_span = dojo.byId('span_'+firstBoxName);

	newdata[firstBoxName] = [];
	for (var param in data[firstBoxName]) {
		if (data[firstBoxName][param] != firstBoxValue) {
			newdata[firstBoxName][i++] = data[firstBoxName][param];
		}
	}
	if (newdata[firstBoxName].length == 0) {
		elm_div.innerHTML = '';
		if (elm_span.innerHTML == '') {
			elm_span.innerHTML = '<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>';
		}
	}
	res.value = dojo.json.serialize(newdata);

	if (firstBox == true) {
		if (elm_div.innerHTML != '') {
			elm_span.innerHTML = '';
		}
		else {
			elm_span.innerHTML = '<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>';
		}
	}
	else {
		var elm = dojo.byId(firstBoxName + '_' + firstBoxValue);
		if (elm) elm.innerHTML = '';
	}
}

function removeSingleValue(BoxName, num, value) {
	if (num == -1) {
		var byId = dojo.byId('span_'+BoxName);
	}
	else {
		var byId = dojo.byId('div_'+BoxName+'_'+num);
	}
	if (byId) {
		byId.innerHTML = '';
				
		var res = dojo.byId('res_'+BoxName);
		var data = dojo.json.evalJson(res.value);
		var newdata = {};
		newdata[BoxName] = [];
		var i = 0;
		for (var param in data[BoxName]) {
			if (data[BoxName][param] != value) {
				newdata[BoxName][i++] = data[BoxName][param];
			}
		}
		if (newdata[BoxName].length == 0) {
			if (num == -1 || dojo.byId('span_'+BoxName).innerHTML == '') {
				dojo.byId('span_'+BoxName).innerHTML = '<i>'+arkwui_lang_get_msg('treeldap_empty_value')+'</i>';
			}
		}
		res.value = dojo.json.serialize(newdata);
	}
}

function add_checkparam(id, even) {
    var byId;
    var param_add;
    
    byId = dojo.byId(id);
    if (!byId) {
	    return false;
    }
    param_add = arkeia.lang.getMsg('treeldap_param_add');

    if (even === 'focus') {
	    if (byId.value === param_add) {
		    byId.value = '';
	    }
	    return (true);
    }
    if (even === 'blur') {
	    if (byId.value === '') {
		    byId.value = param_add;
	    }
    }
    return (true);
}

function onTreeLdapLabelClick(id) {
    var byId;
    
    byId = dojo.byId(id);
    if (!byId) {
	    return false;
    }
    var open = byId.getAttribute("open");
    if (open == "true") {
	    byId.setAttribute("open", "false");
	    dojo.lfx.wipeOut("TreeLdapHide", 250).play();
    }
    else {
	    byId.setAttribute("open", "true");
	    dojo.lfx.wipeIn("TreeLdapHide", 250).play();
    }
    return (true);
}

function emailCheck(emailStr) {
	/* The following pattern is used to check if the entered e-mail address
	   fits the user@domain format.  It also is used to separate the username
	   from the domain. */
	var emailPat = /^(.+)@(.+)$/;
	/* The following string represents the pattern for matching all special
	   characters.  We don't want to allow special characters in the address. 
	   These characters include ( ) < > @ , ; : \ " . [ ]    */
	var specialChars = "\\(\\)<>@,;:\\\\\\\"\\.\\[\\]";
	/* The following string represents the range of characters allowed in a 
	   username or domainname.  It really states which chars aren't allowed. */
	var validChars = "\[^\\s" + specialChars + "\]";
	/* The following pattern applies if the "user" is a quoted string (in
	   which case, there are no rules about which characters are allowed
	   and which aren't; anything goes).  E.g. "jiminy cricket"@disney.com
	   is a legal e-mail address. */
	var quotedUser = "(\"[^\"]*\")";
	/* The following pattern applies for domains that are IP addresses,
	   rather than symbolic names.  E.g. joe@[123.124.233.4] is a legal
	   e-mail address. NOTE: The square brackets are required. */
	var ipDomainPat = /^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/;
	/* The following string represents an atom (basically a series of
	   non-special characters.) */
	var atom = validChars + '+';
	/* The following string represents one word in the typical username.
	   For example, in john.doe@somewhere.com, john and doe are words.
	   Basically, a word is either an atom or quoted string. */
	var word = "(" + atom + "|" + quotedUser + ")";
	// The following pattern describes the structure of the user
	var userPat = new RegExp("^" + word + "(\\." + word + ")*$");
	/* The following pattern describes the structure of a normal symbolic
	   domain, as opposed to ipDomainPat, shown above. */
	var domainPat = new RegExp("^" + atom + "(\\." + atom +")*$");
	
	
	/* Finally, let's start trying to figure out if the supplied address is
	   valid. */
	
	/* Begin with the coarse pattern to simply break up user@domain into
	   different pieces that are easy to analyze. */
	var matchArray = emailStr.match(emailPat);
	if (matchArray == null) {
	  /* Too many/few @'s or something; basically, this address doesn't
	     even fit the general mould of a valid e-mail address. */
		alert(arkwui_lang_get_msg('treeldap_validate_user_email_1'));
		return false;
	}
	var user = matchArray[1];
	var domain = matchArray[2];
	
	// See if "user" is valid 
	if (user.match(userPat) == null) {
	    // user is not valid
	    alert(arkwui_lang_get_msg('treeldap_validate_user_email_2'));
	    return false;
	}
	
	/* if the e-mail address is at an IP address (as opposed to a symbolic
	   host name) make sure the IP address is valid. */
	var IPArray = domain.match(ipDomainPat);
	if (IPArray != null) {
	    // this is an IP address
		  for (var i = 1; i <= 4; i++) {
		    if (IPArray[i] > 255) {
		        alert(arkwui_lang_get_msg('treeldap_validate_user_email_3'));
				return false;
		    }
	    }
	    return true;
	}
	
	// Domain is symbolic name
	var domainArray = domain.match(domainPat);
	if (domainArray == null) {
		alert(arkwui_lang_get_msg('treeldap_validate_user_email_4'));
	    return false;
	}
	
	/* domain name seems valid, but now make sure that it ends in a
	   three-letter word (like com, edu, gov) or a two-letter word,
	   representing country (uk, nl), and that there's a hostname preceding 
	   the domain or country. */
	
	/* Now we need to break up the domain to get a count of how many atoms
	   it consists of. */
	var atomPat = new RegExp(atom,"g");
	var domArr = domain.match(atomPat);
	var len = domArr.length;
	if (domArr[domArr.length-1].length < 2 || 
	    domArr[domArr.length-1].length > 3) {
	   // the address must end in a two letter or three letter word.
	   alert(arkwui_lang_get_msg('treeldap_validate_user_email_5'));
	   return false;
	}
	
	// Make sure there's a host name preceding the domain.
	if (len < 2) {
	   alert(arkwui_lang_get_msg('treeldap_validate_user_email_6'));
	   return false;
	}
	
	// If we've gotten this far, everything's valid!
	return true;
}

function display_alert_msg(msg)
{
	var msg_sp = msg.split(" ");
	var new_msg = '';
	for (var i = 4; i < msg_sp.length; i++) {
		if (i != 4) {
			new_msg += ' ';
		}
		new_msg += msg_sp[i];
	}
	alert(new_msg);
}


/*
 * Class State node
 */

function State_node(normal_image, active_image, clicked)
{
	this.normal_image = normal_image;
	this.active_image = active_image;
	/* Node is clicked ? */
	this.clicked = clicked;
	/* is this the node we click on ? */
	this.clickedNode = false;
	this.visibility = null;
}

/*
 * Class Node
 */
function Node(id, text, guid, node_type, node_img, node_rect, node_text, node_rn, pos_x, pos_y, min_pos_x, max_pos_x, state_node)
{
	this.id = id;
	this.node_img = node_img;
	this.node_rect = node_rect;
	this.node_text = node_text;
	this.node_rn = node_rn;
	this.node_line = null;
	this.node_type = node_type;
	this.guid = guid;
	this.text = text;
	if (state_node) {
		this.state_node = state_node;
	}
	else {
		this.state_node = 0;
	}
	this.father_id = null;
	this.relations = {};
	this.relations_count = 0;
	this.deleted_childs = false;
	/*
	this.brothers = {};
	this.brothers_count = 0;
	*/
	this.pos_x = pos_x;
	this.pos_y = pos_y;
	this.min_pos_x = min_pos_x;
	this.max_pos_x = max_pos_x;
	this.moved = false;
	
	/* REPLACE WITH HIDE */
	this.decal = false;
	this.sign = false;
	
	this.relation_add = Add_relation;
	this.relation_get = Get_relations;
}

function Add_relation(id)
{
		this.relations[this.relations_count++] = id;
		this.relations[this.relations_count] = null;
}

function Get_relations()
{
	return (this.relations);
}

function isArray(variable)
{
	return variable instanceof Array;
}

function isObject(variable)
{
	return variable instanceof Object;
}

/* Not used now but maybe... */
/*
var SaveLastRect = null;

function handleMouseOver(event)
{
	var Rect = getObjectLDAP(event, 'rectid');
	var bgid = getObjectLDAP(event, 'bgid');
	if (bgid && SaveLastRect) {
		if (SaveLastRect.getFill() != "#ff0000") {
			SaveLastRect.setFill(node.bgColor);
			SaveLastRect = null;
		}
		return ;
	}
	if (Rect) {
		if (SaveLastRect && SaveLastRect.getFill() == "#0000ff") {
			SaveLastRect.setFill(node.bgColor);
		}
		SaveLastRect = Rect;
		if (Rect.getFill() != "#ff0000") {
			Rect.setFill("#0000ff");
		}
	}
	dojo.event.browser.stopEvent(event);
}
*/
