dojo.provide("arkeia.widget.ArkeiaButton");
dojo.require("dojo.widget.Button");
dojo.require("arkeia.widget.ArkeiaDataProvider");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaButton",

    // superclass
    dojo.widget.Button,
             
    // member variables/functions
    {
       
        caption: "validate",
        action: "",
        controller: "",
        baseUrl: "",
        myformid: "nodefined",
        sendUrl: "",
        nextUrl: "",
        nextAction: "", /* if nextAction == 'nothing' do nothing :) */
        nextActionController: "",
        nextActionSendResult: false,
        getNext: "",
        listeners: [],
	subForms: '',

        eventNamesDefault: {
            arkeiaAddData: "arkeiaAddData",
            beforeLoad: "beforeLoad",
            afterLoad: "afterLoad"
        },
        initialize: function() {
            dojo.debug(this + " Initialize"+this.myformid);
            this.params = new Array();
            if (this.sendUrl == "")
                this.sendUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
            dojo.debug(this + " Initialize sendUrl: " + this.sendUrl);
            if (this.nextUrl == "")
                this.nextUrl = this.controller +"/summary";
            this.nextActionController = (this.nextActionController == '' ? this.controller : this.nextActionController);
            if (this.nextAction != '' && this.nextAction != 'nothing')
                this.nextAction = this.baseUrl + "/" + this.nextActionController +"/" + this.nextAction;
            dojo.debug(this + " Initialize nextUrl: " + this.nextUrl);
            dojo.debug(this + " Initialize nextAction: " + this.nextAction);
            this.getNext = this.baseUrl + "/" + this.controller +"/jsonGetNext";
            dojo.debug(this + " Initialize getNext: " + this.getNext);
            this.eventNames={};
            for(var name in this.eventNamesDefault) {
                if (dojo.lang.isUndefined(this.eventNames[name])) {
                    this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
                    dojo.debug(this + "event: " + this.eventNames[name]);
                }
            }
        },

        postCreate: function(args, frag) {
            dojo.debug(this + " postCreate ...");

            var source = this.getFragNodeRef(frag);
             if (!source.dataUrl) 
                 source.dataUrl = this.sendUrl;
             if (!source.getNext) 
                 source.getNext = this.getNext;
             if (this.nextAction != '' && this.nextAction != 'nothing')
                 source.nextAction = this.nextAction;
             var dpClass = arkeia.widget.ArkeiaDataProvider;
             this.dataSender = new dpClass(source);

             var _this = this;
             dojo.lang.forEach(this.listeners,
                function(elem){
                    dojo.debug(_this + "got one listener");
                    var t = dojo.lang.isString(elem) ? dojo.widget.byId(elem) : elem;
                    t.listenArkeiaParent(_this)
                }
             );
        },

        /**
         * publish destruction event so that any listeners should stop listening
         */
        destroy: function(){
                dojo.debug(this + " destroy");
                dojo.event.topic.publish(this.widgetId + "/arkeiaParentDestroy", { source: this } );
                return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

        newResult: function(_this, message) 
        {
            if (message.VIEW) {
                display_result(_this.nextUrl, '', message.VIEW);
                return;
            }
            dojo.debug(_this + " newResult message: " + dojo.json.serialize(message));
            if (message.last) {
                //dojo.event.topic.publish(_this.eventNames.afterLoad, {});
                if (message.status!= undefined && message.status != '0' && message.status != '12') { /* error */
                    _this.setDisabled(false);
					return;
                } 
                if (_this.nextAction != '') {
                    dojo.debug(_this + " nextAction = " + _this.nextAction);
                    if (_this.nextAction != 'nothing') {
                        dojo.debug(_this + " nextAction: " + _this.nextAction + " data: " + dojo.json.serialize(message.data));
                        if (_this.nextActionSendResult) {
                            var msg = {};
                            msg['PARAM2'] = message.data;
                            if (message.data2) msg['PARAM3'] = message.data2;
                            _this.dataSender.nextAction(_this, _this.newResult, msg);
                        } else {
                            _this.dataSender.nextAction(_this, _this.newResult, _this.obj);
                        }
                    } else {
                        _this.setDisabled(false);
                    }
                } else {
                    dojo.debug(_this + " nextUrl: " + _this.nextUrl);
                    setTimeout("display_result('"+_this.nextUrl+"')", 2000);
                }
            }
        },

        returnRequest: function(_this, data)
        {
            dojo.debug(_this + " returnRequest ...");
            dojo.debug(_this + " data : " + dojo.json.serialize(data));
            if (data['local'] != undefined) {
                data = data['local'];
                //dojo.debug(_this + " new local data : " + dojo.json.serialize(data));
            }
            if (data['STATUS'] == undefined) {
                display_result(_this.nextUrl, '', data);
            }

            if (data['STATUS'] != '0') { /* error */
                if ((data['STATUS'] == '12') && (data['MESSAGE'] == '2')) {
                    dojo.debug(_this + " returnRequest getNext...");
                    _this.dataSender.getNext(_this, _this.returnRequest, data);
                } else {
                    _this.setDisabled(false);
                    display_message(data['MESSAGE']);
                }
            } else {
                var eventName = _this.eventNames.arkeiaAddData;
                var msgs = new Array();
                for(var msg in data["MESSAGE"]) {
                    dojo.debug(_this + " msg: " + dojo.json.serialize(msg) 
                                + " data: " + data["MESSAGE"][msg]);
                    var message = data["MESSAGE"][msg];
                    var item = {};
                    item["NAME"] = message;
                    msgs.push(item);
                    dojo.event.topic.publish(eventName, { data: msgs[msg] });
                }

                dojo.debug(_this + " msgs: " + msgs);
                if (data['FORCE_ALERT']) {
                    alert(arkwui_lang_get_msg('js_alert_start_info_msg')+clean_DSP_MSG(data['MESSAGE']));
                } else {
                    if (data['LAST'] == 0) {
                        _this.dataSender.getNext(_this, _this.returnRequest, data);
                    } else {
                        if (_this.nextAction != '') {
                            dojo.debug(_this + " nextAction = " + _this.nextAction);
                            if (_this.nextAction != 'nothing') {
                                dojo.debug(_this + " nextAction: " + _this.nextAction + " data: " + dojo.json.serialize(data));
                                if (_this.nextActionSendResult) {
                                    _this.dataSender.nextAction(_this, _this.returnRequest, data);
                                } else {
                                    _this.dataSender.nextAction(_this, _this.returnRequest, _this.obj);
                                }
                            } else {
                                dojo.debug(_this + " nothing for nextAction");
                                display_message(data['MESSAGE']);
                                _this.setDisabled(false);
                            }
                        } else {
                            dojo.debug(_this + " nextUrl: " + _this.nextUrl);
                            setTimeout("display_result('"+_this.nextUrl+"')", 2000);
                        }
                    }
                }
            }
        },

        onClick: function () {
            dojo.debug(this + " onClick");
            dojo.debug(this + " myformid:" + this.myformid + " subForms: "+this.subForms);
            this.obj = dojo.widget.byId(this.myformid).getValues();
	    if (this.subForms != '')
		{
		    Forms = this.subForms.split(',');
		    for (var i in Forms)
			{
			    if (dojo.widget.byId(Forms[i])) {
				values = dojo.widget.byId(Forms[i]).getValues();
				for (var key in values)
				    this.obj[key] = values[key];
			    } else {
				dojo.debug(this + ' onClick subForums: cant find form : '+Forms[i]);
			    }
			}
		}
            dojo.debug(this + " Object is: " + dojo.json.serialize(this.obj));
            this.params = this.obj;
            dojo.event.topic.publish(this.eventNames.beforeLoad, {});
            this.dataSender.loadMultipleResult(this,this.newResult, this.params);
            //this.dataSender.sendData(this, this.returnRequest, this.params);
            /*       disable button */
            this.setDisabled(true);
        }
    }
);
