<?php
/*
 * Created on 05 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'Zend/Acl.php';
require_once 'Zend/Acl/Role.php';
require_once 'Zend/Acl/Resource.php';

class Arkeia_Acl extends Zend_Acl 
{
	public function __construct()
	{
		//parent::__construct();

		$this->add(new Zend_Acl_Resource('index'));
		$this->add(new Zend_Acl_Resource('resources'));
		$this->add(new Zend_Acl_Resource('nodes'));
		$this->add(new Zend_Acl_Resource('backup'));
		$this->add(new Zend_Acl_Resource('d2d2t'));
		$this->add(new Zend_Acl_Resource('restoration'));
		$this->add(new Zend_Acl_Resource('monitor'));
		$this->add(new Zend_Acl_Resource('report'));
		$this->add(new Zend_Acl_Resource('journal'));
		$this->add(new Zend_Acl_Resource('hardware'));
		$this->add(new Zend_Acl_Resource('user'));
		$this->add(new Zend_Acl_Resource('ldap'));
		$this->add(new Zend_Acl_Resource('license'));
		$this->add(new Zend_Acl_Resource('job'));
		$this->add(new Zend_Acl_Resource('login'));
		$this->add(new Zend_Acl_Resource('navigator'));
		$this->add(new Zend_Acl_Resource('appliance'));
		$this->add(new Zend_Acl_Resource('soap'));

		$this->addRole(new Zend_Acl_role('guest'));
		$this->addRole(new Zend_Acl_role('CONNECTED'),'guest');
		$this->addRole(new Zend_Acl_role('USER'),'guest');
		$this->addRole(new Zend_Acl_role('user'),'USER');
		$this->addRole(new Zend_Acl_role('OPERATOR'),'USER');
		$this->addRole(new Zend_Acl_role('ADMINISTRATOR'),'OPERATOR');

//		$this->allow('guest');
		$this->allow('guest','index');
		$this->allow('guest','resources');
		$this->allow('guest','login');
		$this->allow('guest','soap');
		$this->allow('CONNECTED', 'ldap');
		$this->allow('USER', 'restoration');
		$this->allow('USER', 'navigator');
		$this->allow('USER', 'report');
		$this->allow('USER', 'journal');
		$this->allow('USER', 'ldap');
		$this->allow('USER', 'job');
		$this->allow('USER', 'backup');
		$this->deny('USER', 'backup', array('index', 'summary', 'interactive'));
		$this->allow('OPERATOR', 'backup');
		$this->allow('OPERATOR', 'd2d2t');
		$this->deny('OPERATOR', 'd2d2t', array('index', 'summary'));
		$this->allow('ADMINISTRATOR', 'd2d2t');
		$this->allow(null, null, array('jsonGetAllNameId', 'jsonGetAllTapeNameId', 'jsonGetAllVtlNameId', 'jsonGetSomeNameId', 'jsonGetAllNameIdNoScratch', 
                                       'jsonGetOneNameId', 'jsonGetNext', 'jsonGetNextResult'));
		$this->allow('ADMINISTRATOR');
	}
}
?>
