<?php 

class BrowserDetect {
	public $infos;
	public function __construct() {
		$this->infos = $this->_exec();
	}
	private function _exec() {
		$browser_name = '';
		$browser_number = '';
		$bua = (isset($_SERVER['HTTP_USER_AGENT']))?strtolower($_SERVER['HTTP_USER_AGENT']) : '';
		$a_browser_types = array(
			array('opera', true, 'op'),
			array('msie', true, 'ie'),
			array('konqueror', true, 'konq'),
			array('safari', true, 'saf'),
			array('webkit', true, 'webkit'),
			array('firefox', true, 'firefox'),
			array('gecko', true, 'moz'),
			array('mozilla/4', false, 'ns4'),
			array('other', false, 'other')
		);
		$i_count = count($a_browser_types);
		for ($i = 0; $i < $i_count; $i++) {
			$s_browser = $a_browser_types[$i][0];
			$b_dom = $a_browser_types[$i][1];
			$browser_name = $a_browser_types[$i][2];
			if (stristr($bua, $s_browser))  {
				if ( $browser_name == 'moz' ) {
					$s_browser = 'rv';
				}
				$browser_number = $this->_version($bua, $s_browser);
				break;
			}
		}
		$a_browser_info = array('name'=>$browser_name, 'number'=>$browser_number, 'agent'=>$bua);
		return $a_browser_info;
	}
	private function _version($bua, $search_string) {
		$string_length = 8;
		$browser_number = '';
		$start_pos = strpos($bua, $search_string);
		$start_pos += strlen($search_string) + 1;
		for ($i = $string_length; $i > 0; $i--) {
			if(is_numeric( substr( $bua, $start_pos, $i))) {
				$browser_number = substr($bua, $start_pos, $i);
				break;
			}
		}
		return $browser_number;
	}
}

$BrowserDetect = new BrowserDetect;
